import React from 'react';
import { DeviceKind } from '../../../apis/DeviceKind';
import { ViewLayoutEvent } from '../../../events';
import View from '../../../primitives/View';
import { ModalProps } from '../types';
declare type Props = ModalProps;
declare type Layout = {
    height: number;
    width: number;
} | null;
declare function Modal({ children, hideHeader, onRequestClose, visible, placement, title, renderFooter, }: Props): JSX.Element;
export default Modal;
export declare const ModalContentContainer: import("styled-components").StyledComponent<React.ComponentType<React.ClassAttributes<HTMLDivElement> & React.HTMLAttributes<HTMLDivElement> & {
    accessibilityLabel?: string | undefined;
    onLayout?: ((event: ViewLayoutEvent) => void) | undefined;
    ref?: ((instance: HTMLElement | null) => void) | React.RefObject<HTMLElement> | null | undefined;
    testID?: string | undefined;
}>, any, {
    $deviceKind: DeviceKind;
    $layout: Layout;
    $placement: {
        type: "dropdown";
        align: "left";
        top: number;
        left: number;
        height: number;
        width: number;
    } | {
        type: "dropdown";
        align: "right";
        top: number;
        right: number;
        height: number;
        width: number;
    } | {
        type: "fullscreen";
    } | undefined;
}, never>;
export declare const ModalTitleContainer: import("styled-components").StyledComponent<typeof View, any, {}, never>;
