import React from 'react';
import { FormStateAndHelpers, FormStateAndHelpersAndActions, Values } from '../../primitives/Form/FormState/types';
import { ModalProps } from '../Modal/types';
declare type RequiredProps = {
    onRequestClose: () => void;
};
declare type OptionalProps = {
    children?: React.ReactNode | ((formStateAndActions: FormStateAndHelpersAndActions) => React.ReactNode);
    contentContainerStyle?: any;
    initialValues?: Values;
    onDelete?: ((values: Values) => any) | null;
    onSubmit?: ((values: Values) => any) | null;
    onCancel?: ((values: Values) => any) | null;
    placement?: ModalProps['placement'];
    submitButtonText?: string | ((formState: FormStateAndHelpers) => string);
    testID?: string;
    title?: string;
    visible?: boolean;
};
declare type Props = RequiredProps & OptionalProps;
declare function ModalForm({ children, contentContainerStyle, initialValues, onDelete, onRequestClose, onSubmit, placement, submitButtonText, testID, title, visible, onCancel, }: Props): JSX.Element;
export default ModalForm;
