import React from 'react';
import FlatList from '../../../primitives/FlatList';
import { Option, SelectProps, renderOptionType } from '../types';
declare type Props = {
    focusedOption: Option;
    focusedOptionRef?: (ref: HTMLDivElement, isFocused: boolean) => void;
    getItemLayout?: SelectProps['getDropdownItemLayout'];
    isSearchable?: boolean;
    labelKey: string;
    listRef?: React.Ref<typeof FlatList>;
    noResults: React.ReactNode;
    onEndReached?: () => void;
    onEndReachedThreshold?: number;
    onInputBlur: (event: any) => void;
    onInputChange: (searchText: string) => void;
    onItemFocus?: (option: Option, event: React.SyntheticEvent<HTMLDivElement>, index: number) => void;
    onItemSelect: (option: Option, event: React.SyntheticEvent<HTMLDivElement>, index: number) => void;
    options: Array<Option>;
    renderOption?: renderOptionType;
    searchText: string;
    selectedOptions: Array<Option>;
    testID?: string;
    valueKey: string;
};
declare function Menu({ focusedOption, focusedOptionRef, getItemLayout, isSearchable, listRef, labelKey, noResults, onEndReached, onEndReachedThreshold, onInputBlur, onInputChange, onItemFocus, onItemSelect, options, renderOption, searchText, selectedOptions, testID, valueKey, }: Props): JSX.Element;
export default Menu;
