/// <reference types="react" />
export declare type TouchableViewProps = {
    /**
     * Overrides the text that's read by the screen reader when the user interacts with the element.
     */
    accessibilityLabel?: string;
    activeOpacity?: number;
    children?: React.ReactNode;
    /**
     * Delay in ms, from onPressIn, before onLongPress is called. Default is 500ms.
     */
    delayLongPress?: number;
    /**
     * If true, disable all interactions for this component.
     */
    disabled?: boolean;
    onLongPress?: () => void;
    onPress?: () => void;
    onPressIn?: () => void;
    onPressOut?: () => void;
    style?: any;
    /**
     * Used to locate this view in end-to-end tests.
     */
    testID?: string;
    tooltip?: string;
};
