import _regeneratorRuntime from "@babel/runtime/regenerator";

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

import ExecutionEnvironment from 'exenv';
import * as React from 'react';
import ReactDOM from 'react-dom';
import styled from 'styled-components';
import OverlayContainer from '../../../primitives/Overlay/Overlay.web/OverlayContainer';
import { convertOptions, validateOptions } from '../helpers';
import AlertDialog from './AlertDialog';
import { jsx as _jsx } from "react/jsx-runtime";

var Alert = /*#__PURE__*/function () {
  function Alert() {
    _classCallCheck(this, Alert);
  }

  _createClass(Alert, null, [{
    key: "alert",
    value: function () {
      var _alert = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee(_options) {
        var options, el;
        return _regeneratorRuntime.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                if (ExecutionEnvironment.canUseDOM) {
                  _context.next = 2;
                  break;
                }

                return _context.abrupt("return");

              case 2:
                options = convertOptions(_options);
                validateOptions(options);
                el = document.createElement('div');
                document.body && document.body.appendChild(el);
                return _context.abrupt("return", new Promise(function (resolve) {
                  ReactDOM.render( /*#__PURE__*/_jsx(StyledOverlayContainer, {
                    children: /*#__PURE__*/_jsx(AlertDialog, _objectSpread(_objectSpread({}, options || defaultOptions), {}, {
                      onDismiss: function onDismiss(result) {
                        document.body && document.body.removeChild(el);
                        resolve(result);
                      }
                    }))
                  }), el);
                }));

              case 7:
              case "end":
                return _context.stop();
            }
          }
        }, _callee);
      }));

      function alert(_x) {
        return _alert.apply(this, arguments);
      }

      return alert;
    }()
  }]);

  return Alert;
}();

export default Alert;
var StyledOverlayContainer = styled(OverlayContainer).withConfig({
  displayName: "Alert__StyledOverlayContainer",
  componentId: "cygtoo-0"
})(["display:flex;align-items:center;justify-content:center;"]);
var defaultOptions = {
  confirm: {
    text: 'OK'
  }
};