import invariant from 'fbjs/lib/invariant';
import isPlainObject from 'lodash/isPlainObject';
import isString from 'lodash/isString';
export var validateOptions = function validateOptions(options) {
  invariant(!!options, 'Alert: options is required');
  invariant(!options.actions || isPlainObject(options.actions), 'Alert: options.actions must be an object with confirm, cancel and neutral buttons');
};
export var convertOptions = function convertOptions(options) {
  if (isString(options)) {
    return {
      message: options,
      actions: {
        confirm: {
          text: 'OK'
        }
      }
    };
  }

  return options;
}; ///