import React from 'react';
import { jsx as _jsx } from "react/jsx-runtime";
// 240-479 pixels
export function getDeviceKindByWidth(width) {
  if (width >= 992) return 'desktop';
  if (width >= 768) return 'tablet';
  if (width >= 480) return 'large-phone';
  return 'phone';
}
var DeviceKindContext = /*#__PURE__*/React.createContext(undefined);
export function DeviceKindProvider(_ref) {
  var children = _ref.children,
      value = _ref.value;
  return /*#__PURE__*/_jsx(DeviceKindContext.Provider, {
    value: value,
    children: children
  });
}
export function useDeviceKind() {
  var deviceKind = React.useContext(DeviceKindContext);
  return deviceKind;
}