var _templateObject, _templateObject2;

function _taggedTemplateLiteral(strings, raw) { if (!raw) { raw = strings.slice(0); } return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }

import * as React from 'react';
import Colors from '../../apis/Colors';
import { styled } from '../../apis/Style';
import Text from '../../primitives/Text';
import View from '../../primitives/View';
import Badge from '../Badge';
import Icon from '../Icon';
import { SizeToRadius, getInitials } from './helpers';
import { jsx as _jsx } from "react/jsx-runtime";
import { jsxs as _jsxs } from "react/jsx-runtime";
export default function Avatar(_ref) {
  var _ref$backgroundColor = _ref.backgroundColor,
      backgroundColor = _ref$backgroundColor === void 0 ? Colors.GREY : _ref$backgroundColor,
      className = _ref.className,
      icon = _ref.icon,
      style = _ref.style,
      badge = _ref.badge,
      testID = _ref.testID,
      _ref$name = _ref.name,
      name = _ref$name === void 0 ? '?' : _ref$name,
      _ref$size = _ref.size,
      size = _ref$size === void 0 ? 'medium' : _ref$size;
  return /*#__PURE__*/_jsxs(AvatarContainer, {
    $avatarBgColor: backgroundColor,
    className: className,
    $size: size,
    style: style,
    testID: testID,
    children: [icon ? /*#__PURE__*/_jsx(Icon, {
      name: icon,
      color: "white",
      size: size
    }) : /*#__PURE__*/_jsx(StyledText, {
      $size: size,
      children: getInitials(name)
    }), badge && /*#__PURE__*/_jsx(Badge, {
      number: badge
    })]
  });
}
var AvatarContainer = styled(View)(_templateObject || (_templateObject = _taggedTemplateLiteral(["\n  align-items: center;\n  justify-content: center;\n  background-color: ", ";\n  border-radius: ", "px;\n  height: ", "px;\n  width: ", "px;\n"])), function (_ref2) {
  var $avatarBgColor = _ref2.$avatarBgColor;
  return $avatarBgColor;
}, function (_ref3) {
  var $size = _ref3.$size;
  return SizeToRadius[$size];
}, function (_ref4) {
  var $size = _ref4.$size;
  return 2 * SizeToRadius[$size];
}, function (_ref5) {
  var $size = _ref5.$size;
  return 2 * SizeToRadius[$size];
});
var StyledText = styled(Text)(_templateObject2 || (_templateObject2 = _taggedTemplateLiteral(["\n  font-size: ", "px;\n  color: white;\n"])), function (_ref6) {
  var $size = _ref6.$size;
  return SizeToRadius[$size];
});