function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

import React from 'react';
import ActivityIndicator from '../../primitives/ActivityIndicator';
import { getFocusedTextColor } from './helpers';
import { SpinnerContainer } from './styles';
import { jsx as _jsx } from "react/jsx-runtime";

var ButtonSpinner = function ButtonSpinner(_ref) {
  var hasDisabledStyle = _ref.hasDisabledStyle,
      type = _ref.type;
  var styleProps = {
    hasDisabledStyle: hasDisabledStyle,
    type: type
  };
  return /*#__PURE__*/_jsx(SpinnerContainer, _objectSpread(_objectSpread({}, styleProps), {}, {
    children: /*#__PURE__*/_jsx(ActivityIndicator, {
      color: getFocusedTextColor(styleProps)
    })
  }));
};

export default ButtonSpinner;