import styled, { css } from 'styled-components';
import Text from '../../primitives/Text';
import View from '../../primitives/View';
import Icon from '../Icon';
import { getBackgroundColor, getBorderColor, getTextColor } from './helpers';
export var buttonContainerStyle = css(["flex-direction:row;align-items:center;justify-content:center;border-radius:4px;height:32px;background-color:", ";border-color:", ";border-style:solid;border-width:1px;padding-left:", "px;padding-right:", "px;"], function (props) {
  return getBackgroundColor(props);
}, function (props) {
  return getBorderColor(props);
}, function (_ref) {
  var icon = _ref.icon,
      text = _ref.text;
  return icon && text ? 8 : text ? 16 : 0;
}, function (_ref2) {
  var text = _ref2.text;
  return text ? 16 : 0;
});
export var buttonTextStyle = css(["font-size:14px;color:", ";"], function (props) {
  return props.loading ? 'transparent' : getTextColor(props);
});
export var ButtonLabel = styled(Text).withConfig({
  displayName: "common-styles__ButtonLabel",
  componentId: "sc-5635y3-0"
})(["", ";"], buttonTextStyle);
export var SpinnerContainer = styled(View).withConfig({
  displayName: "common-styles__SpinnerContainer",
  componentId: "sc-5635y3-1"
})(["position:absolute;top:0;bottom:0;left:0;right:0;align-items:center;justify-content:center;border-radius:4px;"]);
export var StyledIcon = styled(Icon).withConfig({
  displayName: "common-styles__StyledIcon",
  componentId: "sc-5635y3-2"
})(["", ";"], buttonTextStyle);