function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

import React from 'react';
import styled from 'styled-components';
import ButtonSpinner from './ButtonSpinner';
import { ButtonLabel, StyledIcon, buttonContainerStyle } from './styles';
import { jsx as _jsx } from "react/jsx-runtime";
import { jsxs as _jsxs } from "react/jsx-runtime";

var createButton = function createButton(containerComponent, getContainerProps) {
  var StyledContainer = styled(containerComponent).withConfig({
    displayName: "createButton__StyledContainer",
    componentId: "sc-1ti3i60-0"
  })(["", ";"], buttonContainerStyle);

  function Button(props) {
    var className = props.className,
        disabled = props.disabled,
        icon = props.icon,
        iconStyle = props.iconStyle,
        loading = props.loading,
        onPress = props.onPress,
        style = props.style,
        textStyle = props.textStyle,
        testID = props.testID,
        text = props.text,
        _props$type = props.type,
        type = _props$type === void 0 ? 'primary' : _props$type;
    var styleProps = {
      // pass the original value of `disabled` so that we know if button is
      // disabled because it's loading
      hasDisabledStyle: disabled,
      loading: loading,
      type: type
    };

    var containerStyleProps = _objectSpread(_objectSpread({}, styleProps), {}, {
      className: className,
      icon: icon,
      style: style,
      text: text
    });

    return /*#__PURE__*/_jsxs(StyledContainer, _objectSpread(_objectSpread(_objectSpread({}, getContainerProps && getContainerProps(props) || {}), containerStyleProps), {}, {
      disabled: disabled || loading,
      onPress: onPress,
      testID: testID,
      children: [icon && /*#__PURE__*/_jsx(StyledIcon, _objectSpread(_objectSpread({}, styleProps), {}, {
        name: icon,
        style: iconStyle
      })), text && /*#__PURE__*/_jsx(ButtonLabel, _objectSpread(_objectSpread({}, styleProps), {}, {
        style: textStyle,
        children: text
      })), loading && /*#__PURE__*/_jsx(ButtonSpinner, _objectSpread({}, styleProps))]
    }));
  }

  return Button;
};

export default createButton;