import Colors from '../../apis/Colors';
export var getFocusedBackgroundColor = function getFocusedBackgroundColor(_ref) {
  var type = _ref.type;

  switch (type) {
    case 'primary':
      return '#FF9333';

    case 'secondary':
      return '#F2F1F1';

    case 'tertiary':
      return 'white';

    case 'destructive':
      return Colors.RED;

    default:
      return '#FF9333';
  }
};
export var getBackgroundColor = function getBackgroundColor(_ref2) {
  var hasDisabledStyle = _ref2.hasDisabledStyle,
      loading = _ref2.loading,
      type = _ref2.type;

  if (hasDisabledStyle) {
    return '#B3B3B3';
  }

  if (loading) {
    return getFocusedBackgroundColor({
      type: type
    });
  }

  switch (type) {
    case 'primary':
      return Colors.ORANGE;

    case 'secondary':
      return 'transparent';

    case 'tertiary':
      return 'transparent';

    case 'destructive':
      return 'transparent';

    default:
      return Colors.ORANGE;
  }
};
export var getFocusedBorderColor = function getFocusedBorderColor(_ref3) {
  var type = _ref3.type;

  switch (type) {
    case 'primary':
      return getFocusedBackgroundColor({
        type: type
      });

    case 'secondary':
      return getFocusedBackgroundColor({
        type: type
      });

    case 'tertiary':
      return '#DDDBDA';

    case 'destructive':
      return getFocusedBackgroundColor({
        type: type
      });

    default:
      return getFocusedBackgroundColor({
        type: type
      });
  }
};
export var getBorderColor = function getBorderColor(_ref4) {
  var hasDisabledStyle = _ref4.hasDisabledStyle,
      loading = _ref4.loading,
      type = _ref4.type;

  if (hasDisabledStyle) {
    return '#B3B3B3';
  }

  if (loading) {
    return getFocusedBorderColor({
      type: type
    });
  }

  switch (type) {
    case 'primary':
      return getBackgroundColor({
        type: type
      });

    case 'secondary':
      return '#DDDBDA';

    case 'tertiary':
      return getBackgroundColor({
        type: type
      });

    case 'destructive':
      return Colors.RED;

    default:
      return getBackgroundColor({
        type: type
      });
  }
};
export var getTextColor = function getTextColor(_ref5) {
  var hasDisabledStyle = _ref5.hasDisabledStyle,
      type = _ref5.type;

  if (hasDisabledStyle) {
    return 'white';
  }

  switch (type) {
    case 'primary':
      return 'white';

    case 'secondary':
      return Colors.BLUE;

    case 'tertiary':
      return Colors.BLUE;

    case 'destructive':
      return Colors.RED;

    default:
      return 'white';
  }
};
export var getFocusedTextColor = function getFocusedTextColor(_ref6) {
  var hasDisabledStyle = _ref6.hasDisabledStyle,
      type = _ref6.type;

  if (hasDisabledStyle) {
    return 'white';
  }

  switch (type) {
    case 'primary':
      return 'white';

    case 'secondary':
      return Colors.BLUE;

    case 'tertiary':
      return Colors.BLUE;

    case 'destructive':
      return 'white';

    default:
      return 'white';
  }
};
export var getActiveBackgroundColor = function getActiveBackgroundColor(_ref7) {
  var type = _ref7.type;

  switch (type) {
    case 'primary':
      return '#E36A00';

    case 'secondary':
      return Colors.BLUE;

    case 'tertiary':
      return Colors.BLUE;

    case 'destructive':
      return getFocusedBackgroundColor({
        type: type
      });

    default:
      return '#E36A00';
  }
};
export var getActiveBorderColor = function getActiveBorderColor(_ref8) {
  var type = _ref8.type;

  switch (type) {
    case 'primary':
      return getActiveBackgroundColor({
        type: type
      });

    case 'secondary':
      return '#0031AC';

    case 'tertiary':
      return '#0031AC';

    case 'destructive':
      return getFocusedBorderColor({
        type: type
      });

    default:
      return getActiveBackgroundColor({
        type: type
      });
  }
};
export var getActiveTextColor = function getActiveTextColor(_ref9) {
  var type = _ref9.type;
  return 'white';
};