function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { if (typeof Symbol === "undefined" || !(Symbol.iterator in Object(arr))) return; var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

import * as React from 'react';
import styled from 'styled-components';
import Picker from '../../../internals/ColorPicker';
import { hexAToRGBA } from '../../../internals/ColorPicker/utils';
import Text from '../../../primitives/Text';
import TouchableView from '../../../primitives/TouchableView';
import View from '../../../primitives/View';
import Button from '../../Button';
import Icon from '../../Icon';
import Modal from './Modal';
import { jsx as _jsx } from "react/jsx-runtime";
import { jsxs as _jsxs } from "react/jsx-runtime";

var ColorPicker = function ColorPicker(_ref) {
  var _hexAToRGBA, _color$hex, _color$hex2;

  var _ref$hex = _ref.hex,
      hex = _ref$hex === void 0 ? '#0000' : _ref$hex,
      onClose = _ref.onClose,
      className = _ref.className,
      testID = _ref.testID;

  var _React$useState = React.useState(false),
      _React$useState2 = _slicedToArray(_React$useState, 2),
      active = _React$useState2[0],
      setActive = _React$useState2[1];

  var _React$useState3 = React.useState((_hexAToRGBA = hexAToRGBA(hex)) !== null && _hexAToRGBA !== void 0 ? _hexAToRGBA : {}),
      _React$useState4 = _slicedToArray(_React$useState3, 2),
      color = _React$useState4[0],
      setColor = _React$useState4[1];

  var close = function close() {
    return setActive(false);
  };

  return /*#__PURE__*/_jsxs(React.Fragment, {
    children: [/*#__PURE__*/_jsx(TouchableView, {
      className: className,
      onPress: function onPress() {
        setActive(true);
      },
      testID: testID,
      children: /*#__PURE__*/_jsx(Icon, {
        name: "color-lens",
        color: (_color$hex = color === null || color === void 0 ? void 0 : color.hex) !== null && _color$hex !== void 0 ? _color$hex : '#000'
      })
    }), active ? /*#__PURE__*/_jsxs(Modal, {
      onRequestClose: close,
      visible: active,
      children: [/*#__PURE__*/_jsx(Picker, {
        color: color,
        onChange: function onChange(value) {
          return setColor(value);
        }
      }), /*#__PURE__*/_jsxs(Footer, {
        children: [/*#__PURE__*/_jsx(Preview, {
          children: /*#__PURE__*/_jsx(PreviewColor, {
            $color: (_color$hex2 = color === null || color === void 0 ? void 0 : color.hex) !== null && _color$hex2 !== void 0 ? _color$hex2 : '#0000',
            children: (color === null || color === void 0 ? void 0 : color.a) === 0 ? /*#__PURE__*/_jsx(TransparentPreviewColor, {
              children: /*#__PURE__*/_jsx(Text, {
                style: {
                  lineHeight: 30
                },
                children: "transparent"
              })
            }) : null
          })
        }), /*#__PURE__*/_jsx(FooterButton, {
          type: "tertiary",
          text: "Cancel",
          onPress: function onPress() {
            return setActive(false);
          }
        }), /*#__PURE__*/_jsx(FooterButton, {
          type: "primary",
          text: "OK",
          onPress: function onPress() {
            onClose === null || onClose === void 0 ? void 0 : onClose(color);
            setActive(false);
          }
        })]
      })]
    }) : null]
  });
};

export default ColorPicker;
var Footer = styled(View).withConfig({
  displayName: "ColorPickernative__Footer",
  componentId: "sc-1jzi1en-0"
})(["background-color:#fafafa;align-items:center;flex-direction:row;justify-content:flex-end;padding:8px;padding-top:16px;"]);
var FooterButton = styled(Button).withConfig({
  displayName: "ColorPickernative__FooterButton",
  componentId: "sc-1jzi1en-1"
})(["margin-left:8px;"]);
var Preview = styled(View).withConfig({
  displayName: "ColorPickernative__Preview",
  componentId: "sc-1jzi1en-2"
})(["flex-grow:1;height:30px;"]);
var PreviewColor = styled(View).withConfig({
  displayName: "ColorPickernative__PreviewColor",
  componentId: "sc-1jzi1en-3"
})(["background-color:", ";position:absolute;top:0px;left:0px;right:0px;bottom:0px;"], function (_ref2) {
  var $color = _ref2.$color;
  return "".concat($color);
});
var TransparentPreviewColor = styled(View).withConfig({
  displayName: "ColorPickernative__TransparentPreviewColor",
  componentId: "sc-1jzi1en-4"
})(["background-color:#fff;width:100%;height:100%;line-height:30px;align-items:center;"]);