function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { if (typeof Symbol === "undefined" || !(Symbol.iterator in Object(arr))) return; var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

import * as React from 'react';
import styled from 'styled-components';
import Picker from '../../../internals/ColorPicker';
import { hexAToRGBA } from '../../../internals/ColorPicker/utils';
import { Popover } from '../../../internals/Popover.web';
import { DivTouchableViewBase } from '../../../internals/web/TouchableViewBase';
import View from '../../../primitives/View';
import Button from '../../Button';
import Icon from '../../Icon';
import { jsx as _jsx } from "react/jsx-runtime";
import { jsxs as _jsxs } from "react/jsx-runtime";

var ColorPicker = function ColorPicker(_ref) {
  var _hexAToRGBA, _color$hex, _color$hex2;

  var _ref$hex = _ref.hex,
      hex = _ref$hex === void 0 ? '#0000' : _ref$hex,
      onClose = _ref.onClose,
      className = _ref.className,
      testID = _ref.testID;

  var _React$useState = React.useState(false),
      _React$useState2 = _slicedToArray(_React$useState, 2),
      active = _React$useState2[0],
      setActive = _React$useState2[1];

  var containerRef = React.useRef(null);

  var _React$useState3 = React.useState((_hexAToRGBA = hexAToRGBA(hex)) !== null && _hexAToRGBA !== void 0 ? _hexAToRGBA : {}),
      _React$useState4 = _slicedToArray(_React$useState3, 2),
      color = _React$useState4[0],
      setColor = _React$useState4[1];

  return /*#__PURE__*/_jsxs(React.Fragment, {
    children: [/*#__PURE__*/_jsx(TriggerContainer, {
      ref: containerRef,
      className: className,
      onClick: function onClick() {
        return setActive(true);
      },
      testID: testID,
      children: /*#__PURE__*/_jsx(Icon, {
        name: "color-lens",
        color: (_color$hex = color === null || color === void 0 ? void 0 : color.hex) !== null && _color$hex !== void 0 ? _color$hex : '#000'
      })
    }), active ? /*#__PURE__*/_jsxs(Popover, {
      anchorEl: containerRef.current,
      onRequestClose: function onRequestClose() {
        return setActive(false);
      },
      visible: true,
      children: [/*#__PURE__*/_jsx(Picker, {
        color: color,
        onChange: function onChange(value) {
          return setColor(value);
        }
      }), /*#__PURE__*/_jsxs(Footer, {
        children: [/*#__PURE__*/_jsxs(Preview, {
          children: [/*#__PURE__*/_jsx(Checkerboard, {}), /*#__PURE__*/_jsx(PreviewColor, {
            $color: (_color$hex2 = color === null || color === void 0 ? void 0 : color.hex) !== null && _color$hex2 !== void 0 ? _color$hex2 : '#0000'
          })]
        }), /*#__PURE__*/_jsx(FooterButton, {
          type: "tertiary",
          text: "Cancel",
          onPress: function onPress() {
            return setActive(false);
          }
        }), /*#__PURE__*/_jsx(FooterButton, {
          type: "primary",
          text: "OK",
          onPress: function onPress() {
            onClose === null || onClose === void 0 ? void 0 : onClose(color);
            setActive(false);
          }
        })]
      })]
    }) : null]
  });
};

var TriggerContainer = styled(DivTouchableViewBase).withConfig({
  displayName: "ColorPickerweb__TriggerContainer",
  componentId: "dvd2sk-0"
})([""]);
export default ColorPicker;
var Footer = styled(View).withConfig({
  displayName: "ColorPickerweb__Footer",
  componentId: "dvd2sk-1"
})(["background-color:#fafafa;align-items:center;flex-direction:row;justify-content:flex-end;padding:32px 8px 8px 8px;"]);
var FooterButton = styled(Button).withConfig({
  displayName: "ColorPickerweb__FooterButton",
  componentId: "dvd2sk-2"
})(["margin-left:8px;"]);
var Preview = styled(View).withConfig({
  displayName: "ColorPickerweb__Preview",
  componentId: "dvd2sk-3"
})(["flex-grow:1;height:30px;"]);
var PreviewColor = styled(View).withConfig({
  displayName: "ColorPickerweb__PreviewColor",
  componentId: "dvd2sk-4"
})(["background-color:", ";position:absolute;top:0px;left:0px;right:0px;bottom:0px;transition:background-color 0.2s;box-shadow:inset 0px 2px 1px -1px rgba(0,0,0,0.2),inset 0px 1px 1px 0px rgba(0,0,0,0.14),inset 0px 1px 3px 0px rgba(0,0,0,0.12);"], function (_ref2) {
  var $color = _ref2.$color;
  return "".concat($color);
});
var Checkerboard = styled.div.withConfig({
  displayName: "ColorPickerweb__Checkerboard",
  componentId: "dvd2sk-5"
})(["background-position:0px 0px,10px 10px;background-size:20px 20px;background-image:linear-gradient( 45deg,#eee 25%,transparent 25%,transparent 75%,#eee 75%,#eee 100% ),linear-gradient(45deg,#eee 25%,white 25%,white 75%,#eee 75%,#eee 100%);position:absolute;top:0px;left:0px;right:0px;bottom:0px;"]);