function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (typeof call === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

import moment from 'moment';
import * as React from 'react';
import { DatePickerIOS } from 'react-native';
import PickerNative from '../../../internals/Picker.native';
import { DEFAULT_DATE_DISPLAY_FORMAT, DEFAULT_DATE_VALUE_FORMAT } from '../constants';
import { PlaceholderText, ValueText } from '../StyledComponents';
import { jsx as _jsx } from "react/jsx-runtime";

var getDefaultDate = function getDefaultDate() {
  return new Date();
};

var DatePicker = /*#__PURE__*/function (_React$Component) {
  _inherits(DatePicker, _React$Component);

  var _super = _createSuper(DatePicker);

  function DatePicker(props) {
    var _this;

    _classCallCheck(this, DatePicker);

    _this = _super.call(this, props);

    _this._capturePickerRef = function (ref) {
      _this._picker = ref;
    };

    _this._onDateChange = function (date) {
      _this.setState({
        selectedDate: date
      });
    };

    _this._renderPopup = function () {
      return /*#__PURE__*/_jsx(DatePickerIOS, {
        date: _this.state.selectedDate || getDefaultDate(),
        mode: "date",
        onDateChange: _this._onDateChange
      });
    };

    _this._renderValue = function () {
      var _this$props = _this.props,
          displayFormat = _this$props.displayFormat,
          placeholder = _this$props.placeholder,
          value = _this$props.value,
          valueFormat = _this$props.valueFormat;
      var date = moment(value || '', valueFormat);
      var dateStr = date.isValid() ? date.format(displayFormat) : '';

      if (!dateStr) {
        return /*#__PURE__*/_jsx(PlaceholderText, {
          children: placeholder
        });
      }

      return /*#__PURE__*/_jsx(ValueText, {
        children: dateStr
      });
    };

    _this._selectDate = function (date) {
      var _this$props2 = _this.props,
          onValueChange = _this$props2.onValueChange,
          valueFormat = _this$props2.valueFormat;

      _this.blur();

      _this.setState({
        selectedDate: date
      });

      if (onValueChange) {
        var dateMoment = moment(date);

        if (dateMoment.isValid()) {
          onValueChange(dateMoment.format(valueFormat));
        } else {
          onValueChange(null);
        }
      }
    };

    var _this$props3 = _this.props,
        _value = _this$props3.value,
        _valueFormat = _this$props3.valueFormat;
    var initialDate = moment(_value || '', _valueFormat);

    if (!initialDate.isValid()) {
      initialDate = moment();
    }

    _this.state = {
      selectedDate: initialDate.toDate()
    };
    return _this;
  }

  _createClass(DatePicker, [{
    key: "blur",
    value: function blur() {
      this._picker && this._picker.blur();
    }
  }, {
    key: "focus",
    value: function focus() {
      this._picker && this._picker.focus();
    }
  }, {
    key: "render",
    value: function render() {
      var _this2 = this;

      var _this$props4 = this.props,
          accessibilityLabel = _this$props4.accessibilityLabel,
          autoFocus = _this$props4.autoFocus,
          clearable = _this$props4.clearable,
          clearValueText = _this$props4.clearValueText,
          onBlur = _this$props4.onBlur,
          onFocus = _this$props4.onFocus,
          readOnly = _this$props4.readOnly,
          renderDropdownIcon = _this$props4.renderDropdownIcon,
          style = _this$props4.style,
          testID = _this$props4.testID;
      var styleProps = {
        style: style
      };
      var props = {
        accessibilityLabel: accessibilityLabel,
        autoFocus: autoFocus,
        clearable: clearable,
        clearValueText: clearValueText,
        onBlur: onBlur,
        onClear: function onClear() {
          return _this2._selectDate(null);
        },
        onConfirm: function onConfirm() {
          return _this2._selectDate(_this2.state.selectedDate || getDefaultDate());
        },
        onFocus: onFocus,
        readOnly: readOnly,
        ref: this._capturePickerRef,
        renderDropdownIcon: renderDropdownIcon,
        renderPopup: this._renderPopup,
        renderValue: this._renderValue,
        testID: testID
      };
      return /*#__PURE__*/_jsx(PickerNative, _objectSpread(_objectSpread({}, styleProps), props));
    }
  }]);

  return DatePicker;
}(React.Component);

DatePicker.defaultProps = {
  clearable: true,
  clearValueText: 'Clear value',
  displayFormat: DEFAULT_DATE_DISPLAY_FORMAT,
  readOnly: false,
  valueFormat: DEFAULT_DATE_VALUE_FORMAT
};
DatePicker.displayName = 'DatePicker';
export default DatePicker;