function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { if (typeof Symbol === "undefined" || !(Symbol.iterator in Object(arr))) return; var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

import * as React from 'react';
import View from '../../primitives/View';
import Icon from '../Icon'; // Note that this is not the Modal we export. It has a slide animation on native.

import Modal from './Modal';
import { ActionRow, BackLink, Label, LinkContainer, LinkInner, ModalContainer } from './StyledComponents.native';
import { jsx as _jsx } from "react/jsx-runtime";
import { jsxs as _jsxs } from "react/jsx-runtime";
export default function Dropdown(_ref) {
  var actions = _ref.actions,
      _ref$icon = _ref.icon,
      icon = _ref$icon === void 0 ? 'more-vert' : _ref$icon,
      children = _ref.children,
      _ref$iconColor = _ref.iconColor,
      iconColor = _ref$iconColor === void 0 ? 'black' : _ref$iconColor;

  var _React$useState = React.useState(false),
      _React$useState2 = _slicedToArray(_React$useState, 2),
      active = _React$useState2[0],
      setActive = _React$useState2[1];

  var close = function close() {
    return setActive(false);
  };

  var renderAction = function renderAction(action) {
    return /*#__PURE__*/_jsxs(ActionRow, {
      onPress: function onPress() {
        close();
        action.onPress();
      },
      children: [action.icon && /*#__PURE__*/_jsx(Icon, {
        name: action.icon
      }), /*#__PURE__*/_jsx(Label, {
        children: action.label
      })]
    }, action.label);
  };

  return /*#__PURE__*/_jsxs(LinkContainer, {
    children: [/*#__PURE__*/_jsx(LinkInner, {
      onPress: function onPress() {
        return setActive(true);
      },
      children: children || /*#__PURE__*/_jsx(Icon, {
        name: icon,
        color: iconColor
      })
    }), /*#__PURE__*/_jsx(Modal, {
      onRequestClose: close,
      visible: active,
      children: /*#__PURE__*/_jsxs(ModalContainer, {
        children: [/*#__PURE__*/_jsx(BackLink, {
          onPress: close,
          children: /*#__PURE__*/_jsx(View, {
            pointerEvents: 'none',
            children: /*#__PURE__*/_jsx(Icon, {
              name: "arrow-back-ios"
            })
          })
        }), actions.map(renderAction)]
      })
    })]
  });
}