function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { if (typeof Symbol === "undefined" || !(Symbol.iterator in Object(arr))) return; var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

import * as React from 'react';
import Icon from '../Icon'; // Note that this is not the Modal we export. It has a slide animation on native.

import Modal from './Modal';
import { ActionRow, BackLink, Label, WebContainer } from './StyledComponents.web';
import { jsx as _jsx } from "react/jsx-runtime";
import { jsxs as _jsxs } from "react/jsx-runtime";
export default function Dropdown(_ref) {
  var actions = _ref.actions,
      _ref$icon = _ref.icon,
      icon = _ref$icon === void 0 ? 'more-vert' : _ref$icon,
      align = _ref.align,
      _ref$width = _ref.width,
      width = _ref$width === void 0 ? 300 : _ref$width,
      children = _ref.children,
      _ref$iconColor = _ref.iconColor,
      iconColor = _ref$iconColor === void 0 ? 'black' : _ref$iconColor,
      testID = _ref.testID;

  var _React$useState = React.useState(false),
      _React$useState2 = _slicedToArray(_React$useState, 2),
      active = _React$useState2[0],
      setActive = _React$useState2[1];

  var _React$useState3 = React.useState({}),
      _React$useState4 = _slicedToArray(_React$useState3, 2),
      modalPlacement = _React$useState4[0],
      setModalPlacement = _React$useState4[1];

  var containerRef = React.useRef(null);

  var updatePlacement = function updatePlacement() {
    if (containerRef && containerRef.current) {
      var dims = containerRef.current.getBoundingClientRect();
      var left = Math.max(dims.left, 5);
      var right = Math.max(window.innerWidth - (dims.left + dims.width), 5);

      var _align = align || (left < right * 2 ? 'left' : 'right');

      if (_align === 'left') {
        right = null;

        if (left + width > window.innerWidth) {
          // the left position cannot be too high, it should not push the dropdown over the edge of the screen
          left = window.innerWidth - (width + 5);
        }
      } else {
        left = null;

        if (right + width > window.innerWidth) {
          // the right position cannot be too high, it should not push the dropdown over the edge of the screen
          right = window.innerWidth - (width + 5);
        }
      }

      var top = dims.bottom + 3;
      var height = actions.length * 40;

      if (top + height + 10 > window.innerHeight) {
        top = window.innerHeight - height - 10;
      }

      setModalPlacement({
        type: 'dropdown',
        top: top,
        height: height,
        width: width,
        align: _align,
        left: left,
        right: right
      });
    }
  };

  React.useEffect(function () {
    updatePlacement();
  }, [active]);

  var close = function close() {
    return setActive(false);
  };

  var renderAction = function renderAction(action) {
    return /*#__PURE__*/_jsxs(ActionRow, {
      onPress: function onPress() {
        close();
        action.onPress();
      },
      children: [action.icon && /*#__PURE__*/_jsx(Icon, {
        name: action.icon
      }), /*#__PURE__*/_jsx(Label, {
        children: action.label
      })]
    }, action.label);
  };

  return /*#__PURE__*/_jsxs(WebContainer, {
    "data-testid": testID,
    children: [/*#__PURE__*/_jsx("div", {
      style: {
        display: 'inline-block',
        cursor: 'pointer',
        padding: '0px 5px'
      },
      onClick: function onClick() {
        return setActive(true);
      },
      ref: containerRef,
      children: children || /*#__PURE__*/_jsx(Icon, {
        name: icon,
        color: iconColor
      })
    }), active ? /*#__PURE__*/_jsxs(Modal, {
      onRequestClose: close,
      placement: modalPlacement,
      visible: true,
      hideHeader: true,
      children: [/*#__PURE__*/_jsx(BackButton, {
        onPress: close
      }), actions.map(renderAction)]
    }) : null]
  });
}

var BackButton = function BackButton(_ref2) {
  var onPress = _ref2.onPress;
  return /*#__PURE__*/_jsx(BackLink, {
    onPress: onPress,
    children: /*#__PURE__*/_jsx(Icon, {
      name: "arrow-back-ios"
    })
  });
};