var _templateObject;

function _taggedTemplateLiteral(strings, raw) { if (!raw) { raw = strings.slice(0); } return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

import React from 'react';
import { styled } from '../../apis/Style';
import TouchableView from '../../primitives/TouchableView';
import Icon from '../Icon';
import { jsx as _jsx } from "react/jsx-runtime";

var IconButton = function IconButton(_ref) {
  var className = _ref.className,
      color = _ref.color,
      disabled = _ref.disabled,
      name = _ref.name,
      onPress = _ref.onPress,
      style = _ref.style,
      tooltip = _ref.tooltip,
      size = _ref.size,
      testID = _ref.testID;
  var iconProps = {
    color: color,
    name: name,
    size: size
  };
  return /*#__PURE__*/_jsx(StyledTouchableView, {
    className: className,
    disabled: disabled,
    onPress: onPress,
    style: style,
    tooltip: tooltip,
    size: size,
    testID: testID || "iconButton-".concat(name),
    children: /*#__PURE__*/_jsx(Icon, _objectSpread({}, iconProps))
  });
};

export default IconButton;
var StyledTouchableView = styled(TouchableView)(_templateObject || (_templateObject = _taggedTemplateLiteral(["\n  ", ";\n"])), function (_ref2) {
  var size = _ref2.size;
  var containerSizeString;
  var sizes = {
    small: 16,
    medium: 32,
    large: 48
  }; // If use input is number then use number
  // Else if use input is nothing return default 16, and the container should be 24x24 to keep a space between two Icons
  // If user input small, medium or large then return the relevent one

  if (typeof size === 'number' && Number.isFinite(size) && size > 0) {
    containerSizeString = size;
  } else if (size === 'small' || size === 'medium' || size === 'large') {
    containerSizeString = sizes[size];
  } else {
    return "height: 24px;\n              width: 24px;";
  }

  return "height: ".concat(containerSizeString, "px;\n          width: ").concat(containerSizeString, "px;");
});