var _templateObject, _templateObject2, _templateObject3, _templateObject4;

function _taggedTemplateLiteral(strings, raw) { if (!raw) { raw = strings.slice(0); } return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }

import * as React from 'react';
import { styled } from '../../apis/Style';
import TouchableView from '../../primitives/TouchableView';
import View from '../../primitives/View';
import Badge from '../Badge';
import Icon from '../Icon';
import SubHeading from '../SubHeading';
import { jsx as _jsx } from "react/jsx-runtime";
import { jsxs as _jsxs } from "react/jsx-runtime";

var IconCard = function IconCard(_ref) {
  var icon = _ref.icon,
      color = _ref.color,
      badge = _ref.badge,
      _ref$size = _ref.size,
      size = _ref$size === void 0 ? 'small' : _ref$size,
      testID = _ref.testID,
      text = _ref.text,
      onPress = _ref.onPress,
      style = _ref.style;
  var sizes = {
    small: 40,
    medium: 80,
    large: 120
  };
  return /*#__PURE__*/_jsxs(Container, {
    $size: sizes[size],
    onPress: onPress,
    style: style,
    testID: testID,
    children: [/*#__PURE__*/_jsxs(StyledView, {
      $color: color,
      $size: sizes[size],
      children: [badge && /*#__PURE__*/_jsx(Badge, {
        number: badge
      }), /*#__PURE__*/_jsx(StyledIcon, {
        name: icon !== null && icon !== void 0 ? icon : '',
        color: color && 'white',
        $size: sizes[size]
      })]
    }), text && /*#__PURE__*/_jsx(StyledSubHeading, {
      children: text
    })]
  });
};

export default IconCard;
var Container = styled(TouchableView)(_templateObject || (_templateObject = _taggedTemplateLiteral(["\n  align-items: center;\n  width: ", ";\n  margin: ", ";\n"])), function (_ref2) {
  var $size = _ref2.$size;
  return $size ? "".concat($size, "px") : '40px';
}, function (_ref3) {
  var $size = _ref3.$size;
  return $size ? "".concat($size / 10, "px") : '8px';
});
var StyledSubHeading = styled(SubHeading)(_templateObject2 || (_templateObject2 = _taggedTemplateLiteral([""])));
var StyledView = styled(View)(_templateObject3 || (_templateObject3 = _taggedTemplateLiteral(["\n  padding: 8px;\n  border-radius: 3px;\n  width: 100%;\n  height: ", ";\n  background: ", ";\n  display: flex;\n  align-items: center;\n  justify-content: center;\n  margin: 8px;\n"])), function (_ref4) {
  var $size = _ref4.$size;
  return "".concat($size, "px");
}, function (_ref5) {
  var $color = _ref5.$color;
  return $color || '#D8D8D8';
});
var StyledIcon = styled(Icon)(_templateObject4 || (_templateObject4 = _taggedTemplateLiteral(["\n  width: ", ";\n  font-size: ", ";\n"])), function (_ref6) {
  var $size = _ref6.$size;
  return $size ? "".concat($size * 2 / 5, "px") : '16px';
}, function (_ref7) {
  var $size = _ref7.$size;
  return $size ? "".concat($size / 3, "px") : '14px';
});