function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { if (typeof Symbol === "undefined" || !(Symbol.iterator in Object(arr))) return; var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

import chunk from 'lodash/chunk';
import React, { useMemo, useState } from 'react';
import styled from 'styled-components';
import MateriIcon from '../../../../../glyphmaps/MaterialIcons.json';
import TextField from '../../../../components/input-fields/TextField';
import FlatList from '../../../../primitives/FlatList';
import View from '../../../../primitives/View';
import IconButton from '../../../IconButton';
import Modal from '../../../Modal';
import { jsx as _jsx } from "react/jsx-runtime";
import { jsxs as _jsxs } from "react/jsx-runtime";
var iconList = Object.keys(MateriIcon);

var IconModal = function IconModal(_ref) {
  var modalVisable = _ref.modalVisable,
      setModalVisable = _ref.setModalVisable,
      setIconName = _ref.setIconName;
  var ARRAY_SIZE = 23;

  var _useState = useState(''),
      _useState2 = _slicedToArray(_useState, 2),
      input = _useState2[0],
      setInput = _useState2[1]; // filter the list and generate 2D array for flatList


  var resultArray = useMemo(function () {
    return chunk(iconList.filter(function (icon) {
      return input ? icon.includes(input) : true;
    }), ARRAY_SIZE);
  }, [input]);
  return /*#__PURE__*/_jsx(Modal, {
    onRequestClose: function onRequestClose() {
      return setModalVisable(false);
    },
    visible: modalVisable,
    title: "Please choose your Icon",
    children: /*#__PURE__*/_jsxs(IconsContainer, {
      children: [/*#__PURE__*/_jsx(TextField, {
        value: input,
        onValueChange: setInput,
        placeholder: "Type to search Icon",
        reserveErrorSpace: false
      }), /*#__PURE__*/_jsx(FlatListContainer, {
        children: /*#__PURE__*/_jsx(FlatList, {
          horizontal: false,
          data: resultArray,
          renderItem: function renderItem(_ref2) {
            var item = _ref2.item;
            return /*#__PURE__*/_jsx(FlatListRow, {
              children: item.map(function (icon) {
                return /*#__PURE__*/_jsx(IconButton, {
                  name: icon,
                  onPress: function onPress() {
                    setIconName(icon);
                    setModalVisable(false);
                  },
                  tooltip: icon
                }, icon);
              })
            }, item[0]);
          }
        })
      })]
    })
  });
};

var IconsContainer = styled(View).withConfig({
  displayName: "IconModal__IconsContainer",
  componentId: "sc-1qhr86a-0"
})(["padding:0px 8px;"]);
var FlatListContainer = styled(View).withConfig({
  displayName: "IconModal__FlatListContainer",
  componentId: "sc-1qhr86a-1"
})(["align-items:center;height:145px;"]);
var FlatListRow = styled(View).withConfig({
  displayName: "IconModal__FlatListRow",
  componentId: "sc-1qhr86a-2"
})(["flex-direction:row;"]);
export default IconModal;