function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { if (typeof Symbol === "undefined" || !(Symbol.iterator in Object(arr))) return; var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

import React, { useMemo, useState } from 'react';
import styled from 'styled-components';
import MateriIcon from '../../../../../glyphmaps/MaterialIcons.json';
import { useDebouncedInputProps } from '../../../../internals/hooks/useDebouncedInputProps';
import View from '../../../../primitives/View';
import TextField from '../../../input-fields/TextField';
import Modal from '../../../Modal';
import { IconList } from './IconList';
import { jsx as _jsx } from "react/jsx-runtime";
import { jsxs as _jsxs } from "react/jsx-runtime";
var iconList = Object.keys(MateriIcon);

var IconModal = function IconModal(_ref) {
  var modalVisable = _ref.modalVisable,
      setModalVisable = _ref.setModalVisable,
      setIconName = _ref.setIconName;

  var _useState = useState(''),
      _useState2 = _slicedToArray(_useState, 2),
      input = _useState2[0],
      setInput = _useState2[1];

  var selectedIcons = useMemo(function () {
    return iconList.filter(function (icon) {
      return input ? icon.includes(input) : true;
    });
  }, [input]);
  var textFieldProps = useDebouncedInputProps({
    onValueChange: setInput,
    value: input
  });
  return /*#__PURE__*/_jsx(Modal, {
    onRequestClose: function onRequestClose() {
      return setModalVisable(false);
    },
    visible: modalVisable,
    title: "Please choose your Icon",
    children: /*#__PURE__*/_jsxs(IconsContainer, {
      children: [/*#__PURE__*/_jsx(TextField, _objectSpread(_objectSpread({}, textFieldProps), {}, {
        placeholder: "Type to search Icons",
        reserveErrorSpace: false
      })), /*#__PURE__*/_jsx(IconList, {
        onSelect: function onSelect(icon) {
          setIconName(icon);
          setModalVisable(false);
        },
        selectedIcons: selectedIcons
      })]
    })
  });
};

var IconsContainer = styled(View).withConfig({
  displayName: "IconModalweb__IconsContainer",
  componentId: "sc-9ib51d-0"
})(["padding:0px 8px;"]);
export default IconModal;