function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { if (typeof Symbol === "undefined" || !(Symbol.iterator in Object(arr))) return; var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

import * as React from 'react';
import Colors from '../../apis/Colors';
import { useDeviceKind } from '../../apis/DeviceKind';
import { Popover } from '../../internals/Popover.web';
import Icon from '../Icon';
import { Context, useMenuContext } from './MenuContext';
import { ActionRow, MenuItemIcon, MenuItemLabel, PopoverContentContainer, TriggerContainer } from './StyledComponents.web';
import { jsx as _jsx } from "react/jsx-runtime";
import { jsxs as _jsxs } from "react/jsx-runtime";
export default function Menu(_ref) {
  var align = _ref.align,
      children = _ref.children,
      className = _ref.className,
      _ref$icon = _ref.icon,
      icon = _ref$icon === void 0 ? 'menu' : _ref$icon,
      _ref$iconColor = _ref.iconColor,
      iconColor = _ref$iconColor === void 0 ? Colors.BLACK : _ref$iconColor,
      _ref$maxHeight = _ref.maxHeight,
      maxHeight = _ref$maxHeight === void 0 ? 150 : _ref$maxHeight,
      maxWidth = _ref.maxWidth,
      _ref$minWidth = _ref.minWidth,
      minWidth = _ref$minWidth === void 0 ? 120 : _ref$minWidth,
      testID = _ref.testID,
      trigger = _ref.trigger,
      triggerStyle = _ref.triggerStyle;

  var _React$useState = React.useState(false),
      _React$useState2 = _slicedToArray(_React$useState, 2),
      active = _React$useState2[0],
      setActive = _React$useState2[1];

  var containerRef = React.useRef(null);
  var deviceKind = useDeviceKind();

  var close = function close() {
    return setActive(false);
  };

  var open = function open() {
    return setActive(false);
  };

  var getPopoverPlacement = function getPopoverPlacement(anchorRect, popupContentRect) {
    var right = anchorRect.left - popupContentRect.width + anchorRect.width;
    var distanceFromRight = window.innerWidth - anchorRect.left - anchorRect.width;

    var _align = align || (anchorRect.left < distanceFromRight * 2 ? 'left' : 'right');

    return {
      top: anchorRect.bottom,
      left: _align === 'left' ? anchorRect.left : right
    };
  };

  return /*#__PURE__*/_jsxs(Context.Provider, {
    value: {
      open: open,
      close: close,
      active: active
    },
    children: [/*#__PURE__*/_jsx(TriggerContainer, {
      ref: containerRef,
      className: className,
      onClick: function onClick() {
        return setActive(true);
      },
      testID: testID,
      style: triggerStyle,
      children: typeof trigger === 'function' ? trigger(open, close, active) : trigger || /*#__PURE__*/_jsx(Icon, {
        name: icon,
        color: iconColor
      })
    }), active ? /*#__PURE__*/_jsx(Popover, {
      anchorEl: containerRef.current,
      onRequestClose: function onRequestClose() {
        return setActive(false);
      },
      placement: getPopoverPlacement,
      visible: true,
      children: /*#__PURE__*/_jsx(PopoverContentContainer, {
        $minWidth: minWidth,
        $maxWidth: maxWidth,
        $maxHeight: maxHeight,
        $deviceKind: deviceKind,
        children: children
      })
    }) : null]
  });
}

var Item = function Item(_ref2) {
  var children = _ref2.children,
      icon = _ref2.icon,
      numberOfLines = _ref2.numberOfLines,
      _onPress = _ref2.onPress;
  var context = useMenuContext();
  return /*#__PURE__*/_jsx(ActionRow, {
    onPress: function onPress() {
      context.close();
      _onPress === null || _onPress === void 0 ? void 0 : _onPress();
    },
    children: typeof children === 'string' ? /*#__PURE__*/_jsxs(React.Fragment, {
      children: [icon ? /*#__PURE__*/_jsx(MenuItemIcon, {
        name: icon
      }) : null, /*#__PURE__*/_jsx(MenuItemLabel, {
        numberOfLines: numberOfLines,
        $hasIcon: !!icon,
        children: children
      })]
    }) : children
  });
};

Menu.Item = Item;