function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (typeof call === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

import * as React from 'react';
import { SafeAreaView } from 'react-native';
import styled from 'styled-components';
import Overlay from '../../../primitives/Overlay';
import Text from '../../../primitives/Text';
import { ModalFormHeader, ModalFormTitleText } from '../../ModalForm/FormBody/FormBody.native';
import { ModalFormHeaderCancelButton, ModalFormTitleContainer } from '../../ModalForm/StyledComponents';
import { jsx as _jsx } from "react/jsx-runtime";
import { jsxs as _jsxs } from "react/jsx-runtime";

var Modal = /*#__PURE__*/function (_React$Component) {
  _inherits(Modal, _React$Component);

  var _super = _createSuper(Modal);

  function Modal() {
    _classCallCheck(this, Modal);

    return _super.apply(this, arguments);
  }

  _createClass(Modal, [{
    key: "render",
    value: function render() {
      var _this$props = this.props,
          children = _this$props.children,
          onRequestClose = _this$props.onRequestClose,
          visible = _this$props.visible,
          title = _this$props.title,
          hideHeader = _this$props.hideHeader;
      return /*#__PURE__*/_jsx(Overlay, {
        onPress: onRequestClose,
        visible: visible,
        children: /*#__PURE__*/_jsxs(ModalOuterContainer, {
          children: [title || !hideHeader ? /*#__PURE__*/_jsxs(ModalFormHeader, {
            children: [/*#__PURE__*/_jsx(ModalFormHeaderCancelButton, {
              onPress: onRequestClose
            }), /*#__PURE__*/_jsx(ModalFormTitleContainer, {
              children: /*#__PURE__*/_jsx(ModalFormTitleText, {
                children: title
              })
            })]
          }) : null, /*#__PURE__*/_jsx(ModalSafeArea, {
            children: /*#__PURE__*/_jsx(ModalContentContainer, {
              children: children
            })
          })]
        })
      });
    }
  }]);

  return Modal;
}(React.Component);

Modal.defaultProps = {
  hideHeader: false
};
export default Modal;
var ModalOuterContainer = styled.SafeAreaView.withConfig({
  displayName: "Modal__ModalOuterContainer",
  componentId: "xqv4ld-0"
})(["flex:1;"]);
var ModalSafeArea = styled.View.withConfig({
  displayName: "Modal__ModalSafeArea",
  componentId: "xqv4ld-1"
})(["flex:1;"]);
var ModalContentContainer = styled.View.withConfig({
  displayName: "Modal__ModalContentContainer",
  componentId: "xqv4ld-2"
})(["background-color:white;position:absolute;top:0;bottom:0;left:0;right:0;"]);