var _templateObject, _templateObject2;

function _taggedTemplateLiteral(strings, raw) { if (!raw) { raw = strings.slice(0); } return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }

import React from 'react';
import { View } from 'react-native';
import { KeyboardAwareScrollView } from 'react-native-keyboard-aware-scroll-view';
import styled from 'styled-components';
import { FormConfigContext } from '../../../primitives/Form/Form.native/FormConfigContext';
import Text from '../../../primitives/Text';
import Button from '../../Button';
import { ModalFormHeaderCancelButton, ModalFormHeaderSubmitButton, ModalFormTitleContainer, modalFormContentStyle, modalFormMobileHeaderContainerStyle, modalFormMobileHeaderStyle, modalFormMobileTitleTextStyle } from '../StyledComponents';
import { jsx as _jsx } from "react/jsx-runtime";
import { jsxs as _jsxs } from "react/jsx-runtime";

var FormBody = function FormBody(_ref) {
  var children = _ref.children,
      contentContainerStyle = _ref.contentContainerStyle,
      onCancel = _ref.onCancel,
      onDelete = _ref.onDelete,
      onSubmit = _ref.onSubmit,
      _ref$submitButtonText = _ref.submitButtonText,
      submitButtonText = _ref$submitButtonText === void 0 ? 'Submit' : _ref$submitButtonText,
      testID = _ref.testID,
      title = _ref.title;
  return /*#__PURE__*/_jsx(FormConfigContext.Provider, {
    value: {
      onSubmit: onSubmit
    },
    children: /*#__PURE__*/_jsxs(StyledForm, {
      testID: testID,
      children: [/*#__PURE__*/_jsxs(ModalFormHeader, {
        children: [/*#__PURE__*/_jsx(ModalFormHeaderCancelButton, {
          onPress: onCancel
        }), /*#__PURE__*/_jsx(ModalFormHeaderSubmitButton, {
          text: submitButtonText
        }), /*#__PURE__*/_jsx(ModalFormTitleContainer, {
          children: /*#__PURE__*/_jsx(ModalFormTitleText, {
            children: title
          })
        })]
      }), /*#__PURE__*/_jsxs(ModalFormContent, {
        contentContainerStyle: contentContainerStyle,
        extraScrollHeight: 100,
        children: [children, onDelete && /*#__PURE__*/_jsx(ModalFormDeleteButton, {
          onPress: onDelete,
          text: "Delete"
        })]
      })]
    })
  });
};

export default FormBody;
var StyledForm = styled(View).withConfig({
  displayName: "FormBodynative__StyledForm",
  componentId: "sc-1c0pb26-0"
})(["flex:1;"]);
export var ModalFormTitleText = styled(Text).attrs(function (props) {
  return {
    numberOfLines: 2
  };
}).withConfig({
  displayName: "FormBodynative__ModalFormTitleText",
  componentId: "sc-1c0pb26-1"
})(["", ";"], modalFormMobileTitleTextStyle);
var ModalFormHeaderContainer = styled.SafeAreaView(_templateObject || (_templateObject = _taggedTemplateLiteral(["\n  ", ";\n"])), modalFormMobileHeaderContainerStyle);
var ModalFormHeaderInnerContainer = styled.View(_templateObject2 || (_templateObject2 = _taggedTemplateLiteral(["\n  ", ";\n"])), modalFormMobileHeaderStyle);
export var ModalFormHeader = function ModalFormHeader(_ref2) {
  var children = _ref2.children;
  return /*#__PURE__*/_jsx(ModalFormHeaderContainer, {
    children: /*#__PURE__*/_jsx(ModalFormHeaderInnerContainer, {
      children: children
    })
  });
};
var ModalFormContent = styled(KeyboardAwareScrollView).withConfig({
  displayName: "FormBodynative__ModalFormContent",
  componentId: "sc-1c0pb26-2"
})(["", ";"], modalFormContentStyle);
var ModalFormDeleteButton = styled(Button).attrs(function (props) {
  return {
    type: 'destructive'
  };
}).withConfig({
  displayName: "FormBodynative__ModalFormDeleteButton",
  componentId: "sc-1c0pb26-3"
})([""]);