import 'jest-styled-components';
import 'react-testing-library/cleanup-after-each';
import React from 'react';
import { fireEvent, render } from 'react-testing-library';
import SubmitButton from '../../SubmitButton';
import ModalForm from '..';
import { jsx as _jsx } from "react/jsx-runtime";
test('should not trigger submit of the outer form when inner form is submitted', function () {
  var handleOuterSubmit = jest.fn();
  var handleInnerSubmit = jest.fn();

  var _render = render( /*#__PURE__*/_jsx(ModalForm, {
    onRequestClose: function onRequestClose() {},
    onSubmit: handleOuterSubmit,
    testID: "outer",
    visible: true,
    children: /*#__PURE__*/_jsx(ModalForm, {
      onRequestClose: function onRequestClose() {},
      onSubmit: handleInnerSubmit,
      testID: "inner",
      visible: true,
      children: /*#__PURE__*/_jsx(SubmitButton, {
        testID: "submit",
        text: "Submit"
      })
    })
  })),
      getByTestId = _render.getByTestId;

  var submitButton = getByTestId('submit');
  expect(submitButton).toBeTruthy();
  fireEvent.click(submitButton);
  expect(handleInnerSubmit).toHaveBeenCalledTimes(1);
  expect(handleOuterSubmit).toHaveBeenCalledTimes(0);
});