import _regeneratorRuntime from "@babel/runtime/regenerator";

var _templateObject, _templateObject2, _templateObject3, _templateObject4, _templateObject5;

function _taggedTemplateLiteral(strings, raw) { if (!raw) { raw = strings.slice(0); } return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { if (typeof Symbol === "undefined" || !(Symbol.iterator in Object(arr))) return; var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

import React from 'react';
import { styled } from '../../apis/Style';
import Text from '../../primitives/Text';
import View from '../../primitives/View';
import Button from '../Button';
import Modal from '../Modal';
import SubmitButton from '../SubmitButton';
import { BodyContainer, footerStyle, headingStyle } from './styles';
import { jsx as _jsx } from "react/jsx-runtime";
import { jsxs as _jsxs } from "react/jsx-runtime";
export default function ModalWizard(_ref) {
  var startFromStep = _ref.startFromStep,
      onFinish = _ref.onFinish,
      onRequestClose = _ref.onRequestClose,
      screens = _ref.screens,
      submitButtonText = _ref.submitButtonText,
      _ref$canSubmit = _ref.canSubmit,
      canSubmit = _ref$canSubmit === void 0 ? true : _ref$canSubmit,
      placement = _ref.placement,
      _ref$visible = _ref.visible,
      visible = _ref$visible === void 0 ? true : _ref$visible,
      testID = _ref.testID;

  var _React$useState = React.useState({
    step: startFromStep || 0,
    submitting: false,
    formValues: {}
  }),
      _React$useState2 = _slicedToArray(_React$useState, 2),
      state = _React$useState2[0],
      setState = _React$useState2[1];

  var isLastStep = state.step + 1 === screens.length;

  var handleSubmit = /*#__PURE__*/function () {
    var _ref2 = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee() {
      return _regeneratorRuntime.wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              setState(_objectSpread(_objectSpread({}, state), {}, {
                submitting: true
              }));

              if (!(typeof onFinish === 'function')) {
                _context.next = 4;
                break;
              }

              _context.next = 4;
              return onFinish();

            case 4:
              onRequestClose();

            case 5:
            case "end":
              return _context.stop();
          }
        }
      }, _callee);
    }));

    return function handleSubmit() {
      return _ref2.apply(this, arguments);
    };
  }();

  var renderCommonFooterButtons = function renderCommonFooterButtons() {
    return /*#__PURE__*/_jsxs(React.Fragment, {
      children: [state.step > 0 && /*#__PURE__*/_jsx(FooterButton, {
        type: "tertiary",
        text: "Back",
        onPress: function onPress() {
          return setState(function (_ref3) {
            var step = _ref3.step;
            return _objectSpread(_objectSpread({}, state), {}, {
              step: step - 1
            });
          });
        }
      }), /*#__PURE__*/_jsx(FooterButton, {
        type: "tertiary",
        text: "Cancel",
        onPress: onRequestClose
      })]
    });
  };

  var renderForm = function renderForm() {
    var currentScreen = screens[state.step]; // Make the form aware/controllable of steps

    var FormElement = currentScreen.render();
    var initialValues = state.formValues[state.step];
    return /*#__PURE__*/_jsx(FormElement.type, _objectSpread(_objectSpread({
      style: {
        flex: 1
      },
      initialValues: initialValues
    }, FormElement.props), {}, {
      onSubmit: /*#__PURE__*/function () {
        var _ref4 = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee2(filledFormValues) {
          return _regeneratorRuntime.wrap(function _callee2$(_context2) {
            while (1) {
              switch (_context2.prev = _context2.next) {
                case 0:
                  // save in state
                  setState(function (_ref5) {
                    var formValues = _ref5.formValues,
                        step = _ref5.step;

                    var updatedFormValues = _objectSpread({}, formValues);

                    updatedFormValues[state.step] = filledFormValues;
                    return _objectSpread(_objectSpread({}, state), {}, {
                      formValues: updatedFormValues,
                      step: isLastStep ? step : step + 1
                    });
                  }); // invoke user's onSubmit callback

                  _context2.next = 3;
                  return FormElement.props.onSubmit(filledFormValues);

                case 3:
                  // handling steps
                  if (isLastStep) {
                    handleSubmit();
                  }

                case 4:
                case "end":
                  return _context2.stop();
              }
            }
          }, _callee2);
        }));

        return function (_x) {
          return _ref4.apply(this, arguments);
        };
      }(),
      children: function children(formState) {
        return /*#__PURE__*/_jsxs(React.Fragment, {
          children: [/*#__PURE__*/_jsx(BodyContainer, {
            children: typeof FormElement.props.children === 'function' ? FormElement.props.children(formState) : FormElement.props.children
          }), /*#__PURE__*/_jsxs(Footer, {
            children: [renderCommonFooterButtons(), isLastStep ? /*#__PURE__*/_jsx(FormSubmitButton, {
              text: submitButtonText || 'Submit',
              type: "primary"
            }) : /*#__PURE__*/_jsx(FormSubmitButton, {
              text: "Next",
              type: "tertiary"
            })]
          })]
        });
      }
    }));
  };

  var renderNonForm = function renderNonForm() {
    return /*#__PURE__*/_jsxs(React.Fragment, {
      children: [/*#__PURE__*/_jsx(BodyContainer, {
        children: screens[state.step].render()
      }), /*#__PURE__*/_jsxs(Footer, {
        children: [renderCommonFooterButtons(), isLastStep ? /*#__PURE__*/_jsx(FooterButton, {
          type: "primary",
          text: submitButtonText || 'Submit',
          onPress: handleSubmit,
          loading: state.submitting,
          disabled: !canSubmit
        }) : /*#__PURE__*/_jsx(FooterButton, {
          type: "tertiary",
          text: "Next",
          onPress: function onPress() {
            return setState(function (_ref6) {
              var step = _ref6.step;
              return _objectSpread(_objectSpread({}, state), {}, {
                step: step + 1
              });
            });
          }
        })]
      })]
    });
  };

  var currentScreen = screens[state.step];
  return /*#__PURE__*/_jsxs(Modal, {
    visible: visible,
    onRequestClose: onRequestClose,
    placement: placement,
    hideHeader: true,
    "data-testid": testID,
    children: [/*#__PURE__*/_jsx(HeadingContainer, {
      children: /*#__PURE__*/_jsx(Heading, {
        children: currentScreen.title || 'Wizard'
      })
    }), currentScreen.isForm ? renderForm() : renderNonForm()]
  });
}
var HeadingContainer = styled(View)(_templateObject || (_templateObject = _taggedTemplateLiteral(["\n  align-items: center;\n  justify-content: center;\n  ", ";\n"])), headingStyle);
var Heading = styled(Text)(_templateObject2 || (_templateObject2 = _taggedTemplateLiteral(["\n  font-size: 18px;\n"])));
var Footer = styled(View)(_templateObject3 || (_templateObject3 = _taggedTemplateLiteral(["\n  background-color: #fafafa;\n  align-items: center;\n  flex-direction: row;\n  justify-content: flex-end;\n  ", ";\n"])), footerStyle);
var FooterButton = styled(Button)(_templateObject4 || (_templateObject4 = _taggedTemplateLiteral(["\n  margin-left: 16px;\n"])));
var FormSubmitButton = styled(SubmitButton)(_templateObject5 || (_templateObject5 = _taggedTemplateLiteral(["\n  margin-left: 16px;\n"])));