function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (typeof call === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

import * as React from 'react';
import { Text, TouchableOpacity, View } from 'react-native';
import Popup from '../../../internals/Picker.native/Popup';
import Icon from '../../Icon';
import Menu from './Menu';
import SearchBar from './SearchBar';
import SelectedOption from './SelectedOption';
import { Container, Control, ListContainer, ListEmptyContainer, MultiValueWrapper, OKText, Placeholder, PopupContentContainer, PopupText, PopupTopBar, PopupTouchableContainer } from './StyledComponents';
import { jsx as _jsx } from "react/jsx-runtime";
import { jsxs as _jsxs } from "react/jsx-runtime";

var Select = /*#__PURE__*/function (_React$Component) {
  _inherits(Select, _React$Component);

  var _super = _createSuper(Select);

  function Select() {
    var _this;

    _classCallCheck(this, Select);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _super.call.apply(_super, [this].concat(args));

    _this.blur = function () {
      var onBlur = _this.props.onBlur;

      _this._setPopupVisible(false);

      onBlur && onBlur();
    };

    _this.focus = function () {
      _this._openPicker();
    };

    _this.state = {
      inputValue: '',
      isOpen: false
    };

    _this._addValue = function (option) {
      var selectedOptions = _this._getSelectedOptions();

      _this._setValue(selectedOptions.concat(option));
    };

    _this._captureSearchInput = function (ref) {
      _this._searchInput = ref;
    };

    _this._blurSearchInput = function () {
      _this._searchInput && _this._searchInput.blur();
    };

    _this._clearValue = function () {
      _this._setValue([]);
    };

    _this._filterOptions = function (excludeOptions) {
      var _this$props = _this.props,
          filterOption = _this$props.filterOption,
          labelKey = _this$props.labelKey,
          valueKey = _this$props.valueKey;

      var filterValue = _this.state.inputValue.toLowerCase();

      var options = _this.props.options || [];
      var excludeValues;
      if (excludeOptions) excludeValues = excludeOptions.map(function (i) {
        return i[valueKey];
      });
      return options.filter(function (option) {
        if (excludeValues && excludeValues.indexOf(option[valueKey]) > -1) return false;
        if (filterOption) return filterOption(option, filterValue);
        if (!filterValue) return true;
        var labelTest = String(option[labelKey]).toLowerCase();
        return labelTest.indexOf(filterValue) >= 0;
      });
    };

    _this._getOptionFromValue = function (value) {
      var _this$props2 = _this.props,
          options = _this$props2.options,
          valueKey = _this$props2.valueKey;
      return Select._findOption(options, valueKey, value);
    };

    _this._getOptionLabel = function (option) {
      return option[_this.props.labelKey];
    };

    _this._getSelectedOptions = function () {
      var value = _this.props.value;
      var valueArray;

      if (Array.isArray(value)) {
        valueArray = value;
      } else {
        valueArray = [value];
      }

      return valueArray.map(_this._getOptionFromValue).filter(Boolean);
    };

    _this._getSelectState = function () {
      var _this$props3 = _this.props,
          clearable = _this$props3.clearable,
          isLoading = _this$props3.isLoading,
          multi = _this$props3.multi,
          readOnly = _this$props3.readOnly,
          searchable = _this$props3.searchable;

      var selectedOptions = _this._getSelectedOptions();

      var visibleOptions = _this._filterOptions();

      return {
        hasValue: selectedOptions.length > 0,
        isMulti: multi,
        isSingle: !multi,
        isClearable: clearable,
        isDisabled: readOnly,
        isLoading: isLoading,
        isOpen: _this.state.isOpen,
        isSearchable: searchable,
        selectedOptions: selectedOptions,
        visibleOptions: visibleOptions
      };
    };

    _this._onCancel = function () {
      _this.blur();
    };

    _this._onSearchBarInputChange = function (inputValue) {
      var onInputChange = _this.props.onInputChange;

      if (onInputChange) {
        onInputChange(inputValue, true);
      }

      _this.setState({
        inputValue: inputValue
      });
    };

    _this._openPicker = function () {
      var _this$props4 = _this.props,
          onFocus = _this$props4.onFocus,
          readOnly = _this$props4.readOnly;
      if (readOnly) return;

      _this._setPopupVisible(true);

      onFocus && onFocus();
    };

    _this._selectOption = function (option) {
      if (_this.props.multi) {
        _this._addValue(option);
      } else {
        _this._setValue([option]);
      }
    };

    _this._setPopupVisible = function (visible) {
      _this.setState({
        isOpen: visible
      });
    };

    _this._setValue = function (options) {
      var _this$props5 = _this.props,
          multi = _this$props5.multi,
          onValueChange = _this$props5.onValueChange,
          valueKey = _this$props5.valueKey;

      if (!multi) {
        _this.blur();
      }

      if (onValueChange) {
        var valueArray = options.map(function (option) {
          return option[valueKey];
        });

        var _value = multi ? valueArray : valueArray.length > 0 ? valueArray[0] : null;

        onValueChange(_value);
      }
    };

    _this._toggleOption = function (option) {
      var valueKey = _this.props.valueKey;

      var selectedOptions = _this._getSelectedOptions();

      if (selectedOptions.find(function (op) {
        return op[valueKey] === option[valueKey];
      })) {
        _this._setValue(selectedOptions.filter(function (op) {
          return op[valueKey] !== option[valueKey];
        }));
      } else {
        _this._selectOption(option);
      }
    };

    _this._renderClear = function () {
      var _this$props6 = _this.props,
          clearable = _this$props6.clearable,
          clearAllText = _this$props6.clearAllText,
          clearValueText = _this$props6.clearValueText,
          isLoading = _this$props6.isLoading,
          multi = _this$props6.multi,
          readOnly = _this$props6.readOnly,
          value = _this$props6.value;

      if (!clearable || value === undefined || value === null || multi && !value.length || readOnly || isLoading) {
        return null;
      }

      var label = multi ? clearAllText : clearValueText;
      return /*#__PURE__*/_jsx(TouchableOpacity, {
        onPress: _this._clearValue,
        children: /*#__PURE__*/_jsx(PopupText, {
          children: label
        })
      });
    };

    _this._renderConfirmButton = function () {
      if (!_this.props.multi) return null;
      return /*#__PURE__*/_jsx(TouchableOpacity, {
        onPress: _this.blur,
        children: /*#__PURE__*/_jsx(OKText, {
          children: "OK"
        })
      });
    };

    _this._renderDropdownIcon = function () {
      var renderDropdownIcon = _this.props.renderDropdownIcon;
      return renderDropdownIcon ? renderDropdownIcon() : /*#__PURE__*/_jsx(Icon, {
        name: "arrow-drop-down",
        style: {
          marginLeft: 10,
          fontSize: 16
        }
      });
    };

    _this._renderMenu = function (options, selectedOptions) {
      var _this$props7 = _this.props,
          labelKey = _this$props7.labelKey,
          multi = _this$props7.multi,
          noResultsText = _this$props7.noResultsText,
          onDropdownEndReached = _this$props7.onDropdownEndReached,
          onDropdownEndReachedThreshold = _this$props7.onDropdownEndReachedThreshold,
          renderOption = _this$props7.renderOption,
          valueKey = _this$props7.valueKey;
      var body = null;

      if (options.length > 0) {
        var handleSelect = multi ? _this._toggleOption : _this._selectOption;
        body = /*#__PURE__*/_jsx(Menu, {
          labelKey: labelKey,
          onEndReached: onDropdownEndReached,
          onEndReachedThreshold: onDropdownEndReachedThreshold,
          onItemSelect: handleSelect,
          options: options,
          renderOption: renderOption,
          selectedOptions: selectedOptions,
          valueKey: valueKey
        });
      } else if (noResultsText) {
        body = /*#__PURE__*/_jsx(ListEmptyContainer, {
          children: /*#__PURE__*/_jsx(PopupText, {
            children: noResultsText
          })
        });
      }

      return /*#__PURE__*/_jsx(ListContainer, {
        children: body
      });
    };

    _this._renderPopup = function (options, selectedOptions) {
      var searchable = _this.props.searchable;
      var popupHeight = searchable ? 359 : 259;
      return /*#__PURE__*/_jsx(Popup, {
        height: popupHeight,
        onRequestClose: _this._onCancel,
        show: _this.state.isOpen,
        testID: "select-popup-container",
        children: /*#__PURE__*/_jsx(PopupTouchableContainer, {
          activeOpacity: 1,
          onPress: _this._blurSearchInput,
          children: /*#__PURE__*/_jsxs(PopupContentContainer, {
            children: [/*#__PURE__*/_jsxs(PopupTopBar, {
              children: [/*#__PURE__*/_jsx(TouchableOpacity, {
                onPress: _this._onCancel,
                children: /*#__PURE__*/_jsx(PopupText, {
                  children: "Cancel"
                })
              }), /*#__PURE__*/_jsx(View, {
                style: {
                  flex: 1
                }
              }), _this._renderClear(), _this._renderConfirmButton()]
            }), _this._renderSearchBar(), _this._renderMenu(options, selectedOptions)]
          })
        })
      });
    };

    _this._renderSearchBar = function () {
      if (!_this.props.searchable) return null;
      return /*#__PURE__*/_jsx(SearchBar, {
        inputRef: _this._captureSearchInput,
        isLoading: _this.props.isLoading,
        onInputChange: _this._onSearchBarInputChange,
        searchText: _this.state.inputValue
      });
    };

    _this._renderSelectedValue = function (selectedOptions) {
      var _this$props8 = _this.props,
          labelKey = _this$props8.labelKey,
          multi = _this$props8.multi,
          placeholder = _this$props8.placeholder,
          valueKey = _this$props8.valueKey;

      if (selectedOptions.length === 0) {
        return /*#__PURE__*/_jsx(Placeholder, {
          children: placeholder
        });
      }

      if (multi) {
        return selectedOptions.map(function (option) {
          return /*#__PURE__*/_jsx(SelectedOption, {
            labelKey: labelKey,
            option: option,
            style: {
              marginRight: 8
            }
          }, "value-".concat(option[valueKey]));
        });
      }

      var option = selectedOptions[0];
      return /*#__PURE__*/_jsx(SelectedOption, {
        labelKey: labelKey,
        option: option
      });
    };

    return _this;
  }

  _createClass(Select, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      if (this.props.autoFocus) {
        this.focus();
      }
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props9 = this.props,
          accessibilityLabel = _this$props9.accessibilityLabel,
          style = _this$props9.style,
          testID = _this$props9.testID;

      var selectState = this._getSelectState();

      var selectedOptions = selectState.selectedOptions,
          visibleOptions = selectState.visibleOptions;
      var styleProps = {
        style: style
      };
      return /*#__PURE__*/_jsx(Container, _objectSpread(_objectSpread({}, styleProps), {}, {
        accessibilityLabel: accessibilityLabel,
        onPress: this.focus,
        testID: testID,
        children: /*#__PURE__*/_jsxs(Control, {
          children: [/*#__PURE__*/_jsx(MultiValueWrapper, {
            children: this._renderSelectedValue(selectedOptions)
          }), this._renderDropdownIcon(), this._renderPopup(visibleOptions, selectedOptions)]
        })
      }));
    }
  }]);

  return Select;
}(React.Component);

Select.defaultProps = {
  autoFocus: false,
  clearable: true,
  clearAllText: 'Clear all',
  clearValueText: 'Clear value',
  isLoading: false,
  labelKey: 'label',
  multi: false,
  noResultsText: 'No results found',
  placeholder: '',
  readOnly: false,
  searchable: true,
  valueKey: 'value'
};

Select._findOption = function (options, valueKey, value) {
  var valueType = typeof value;
  if (valueType !== 'string' && valueType !== 'number') return null;
  if (!options) return null;

  for (var i = 0; i < options.length; i++) {
    if (options[i][valueKey] === value) return options[i];
  }

  return null;
};

export default Select;