import React from 'react';
import styled from 'styled-components';
import { DivViewBase } from '../../../internals/web/ViewBase';
import ActivityIndicator from '../../../primitives/ActivityIndicator';
import Text from '../../../primitives/Text';
import TextInput from '../../../primitives/TextInput';
import View from '../../../primitives/View';
import Icon from '../../Icon';
import { jsx as _jsx } from "react/jsx-runtime";
import { jsxs as _jsxs } from "react/jsx-runtime";
export default function SearchBar(_ref) {
  var autoFocus = _ref.autoFocus,
      className = _ref.className,
      disabled = _ref.disabled,
      isLoading = _ref.isLoading,
      onInputBlur = _ref.onInputBlur,
      onInputChange = _ref.onInputChange,
      searchText = _ref.searchText,
      style = _ref.style;
  var inputRef = React.useRef(null);

  var handleContainerPress = function handleContainerPress() {
    var _inputRef$current;

    (_inputRef$current = inputRef.current) === null || _inputRef$current === void 0 ? void 0 : _inputRef$current.focus();
  };

  return /*#__PURE__*/_jsx(Container, {
    className: className,
    onClick: handleContainerPress,
    style: style,
    testID: "select-searchbar-container",
    children: /*#__PURE__*/_jsxs(InnerContainer, {
      children: [/*#__PURE__*/_jsx(IconContainer, {
        children: /*#__PURE__*/_jsx(Icon, {
          name: "search"
        })
      }), disabled ? /*#__PURE__*/_jsx(SearchText, {
        children: searchText
      }) : /*#__PURE__*/_jsx(StyledTextInput, {
        ref: inputRef,
        autoFocus: autoFocus,
        onBlur: onInputBlur,
        onValueChange: onInputChange,
        readOnly: disabled,
        testID: "select-searchbar-textinput",
        value: searchText
      }), /*#__PURE__*/_jsx(SpinnerContainer, {
        children: /*#__PURE__*/_jsx(ActivityIndicator, {
          animating: isLoading !== null && isLoading !== void 0 ? isLoading : false
        })
      })]
    })
  });
}
var Container = styled(DivViewBase).withConfig({
  displayName: "SearchBar__Container",
  componentId: "sc-1yo43dz-0"
})(["flex:none;background-color:#eee;padding:6px;"]);
var InnerContainer = styled(View).withConfig({
  displayName: "SearchBar__InnerContainer",
  componentId: "sc-1yo43dz-1"
})(["flex-direction:row;background-color:#fff;height:28px;border-width:0;border-radius:15px;"]);
var IconContainer = styled(View).withConfig({
  displayName: "SearchBar__IconContainer",
  componentId: "sc-1yo43dz-2"
})(["align-items:center;justify-content:center;background-color:transparent;position:absolute;top:0;bottom:0;left:8px;"]);
var SearchText = styled(Text).attrs({
  numberOfLines: 1
}).withConfig({
  displayName: "SearchBar__SearchText",
  componentId: "sc-1yo43dz-3"
})(["margin-left:32px;"]);
var SpinnerContainer = styled(View).withConfig({
  displayName: "SearchBar__SpinnerContainer",
  componentId: "sc-1yo43dz-4"
})(["align-items:center;justify-content:center;padding:0 10px;"]);
var StyledTextInput = styled(TextInput).withConfig({
  displayName: "SearchBar__StyledTextInput",
  componentId: "sc-1yo43dz-5"
})(["flex:1;font-size:14px;margin-left:32px;"]);