function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (typeof call === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

import * as React from 'react';
import styled from 'styled-components';
import Text from '../../../primitives/Text';
import { jsx as _jsx } from "react/jsx-runtime";
import { jsxs as _jsxs } from "react/jsx-runtime";

var SelectedOption = /*#__PURE__*/function (_React$Component) {
  _inherits(SelectedOption, _React$Component);

  var _super = _createSuper(SelectedOption);

  function SelectedOption() {
    var _this;

    _classCallCheck(this, SelectedOption);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _super.call.apply(_super, [this].concat(args));

    _this._onRemoveButtonClick = function (event) {
      event.preventDefault();
      event.stopPropagation();
      var _this$props = _this.props,
          onRemove = _this$props.onRemove,
          option = _this$props.option;
      onRemove && onRemove(option);
    };

    _this._onRemoveButtonTouchEnd = function (event) {
      // Check if the view is being dragged, In this case
      // we don't want to fire the click event (because the user only wants to scroll)
      if (_this._dragging) return; // Fire the mouse events

      _this._onRemoveButtonClick(event);
    };

    _this._onRemoveButtonTouchMove = function () {
      // Set a flag that the view is being dragged
      _this._dragging = true;
    };

    _this._onRemoveButtonTouchStart = function () {
      // Set a flag that the view is not being dragged
      _this._dragging = false;
    };

    _this._renderLabel = function () {
      var _this$props2 = _this.props,
          labelKey = _this$props2.labelKey,
          onRemove = _this$props2.onRemove,
          option = _this$props2.option,
          props = _objectWithoutProperties(_this$props2, ["labelKey", "onRemove", "option"]);

      return /*#__PURE__*/_jsxs(Label, _objectSpread(_objectSpread({}, props), {}, {
        "aria-selected": "true",
        role: "option",
        children: [option[labelKey], !!props.isMulti && /*#__PURE__*/_jsx(AriaOnly, {
          children: "\xA0"
        })]
      }));
    };

    _this._renderRemoveIcon = function () {
      var _this$props3 = _this.props,
          isDisabled = _this$props3.isDisabled,
          onRemove = _this$props3.onRemove;
      if (isDisabled || !onRemove) return null;
      return /*#__PURE__*/_jsx(Icon, {
        "aria-hidden": "true",
        onClick: _this._onRemoveButtonClick,
        onTouchEnd: _this._onRemoveButtonTouchEnd,
        onTouchMove: _this._onRemoveButtonTouchMove,
        onTouchStart: _this._onRemoveButtonTouchStart,
        children: "\xD7"
      });
    };

    return _this;
  }

  _createClass(SelectedOption, [{
    key: "render",
    value: function render() {
      var _this$props4 = this.props,
          labelKey = _this$props4.labelKey,
          onRemove = _this$props4.onRemove,
          option = _this$props4.option,
          props = _objectWithoutProperties(_this$props4, ["labelKey", "onRemove", "option"]);

      return /*#__PURE__*/_jsxs(Container, _objectSpread(_objectSpread({}, props), {}, {
        children: [this._renderRemoveIcon(), this._renderLabel()]
      }));
    }
  }]);

  return SelectedOption;
}(React.Component);

export default SelectedOption;
export var AriaOnly = styled.span.withConfig({
  displayName: "SelectedOption__AriaOnly",
  componentId: "zd1pql-0"
})(["display:inline-block;height:1px;width:1px;margin:-1px;clip:rect(0,0,0,0);overflow:hidden;float:left;"]);
var Container = styled.div.withConfig({
  displayName: "SelectedOption__Container",
  componentId: "zd1pql-1"
})(["&:not(:first-of-type){margin-left:5px;}", ";"], function (_ref) {
  var isDisabled = _ref.isDisabled,
      isMulti = _ref.isMulti;
  return isMulti ? "\n    background-color: #ebf5ff;\n    border-radius: 2px;\n    border: 1px solid #c2e0ff;\n    color: #007eff;\n    display: inline-block;\n    font-size: 0.85em;\n    vertical-align: top;\n    ".concat(isDisabled && "\n      background-color: #fcfcfc;\n      border: 1px solid #e3e3e3;\n      color: #333;\n    ", "\n  ") : "\n    display: flex;\n    align-items: center;\n    bottom: 0;\n    color: #aaa;\n    left: 0;\n    position: absolute;\n    right: 0;\n    top: 0;\n    max-width: 100%;\n    overflow: hidden;\n    text-overflow: ellipsis;\n    white-space: nowrap;\n  ";
});
var Icon = styled.span.withConfig({
  displayName: "SelectedOption__Icon",
  componentId: "zd1pql-2"
})(["display:inline-block;cursor:pointer;border-bottom-left-radius:2px;border-top-left-radius:2px;border-right:1px solid #c2e0ff;padding:0 5px;&:focus &:hover{background-color:#d8eafd;color:#0071e6;}&:active{:active{background-color:#c2e0ff;}}"]);
var Label = styled(Text).withConfig({
  displayName: "SelectedOption__Label",
  componentId: "zd1pql-3"
})(["", ";"], function (_ref2) {
  var isMulti = _ref2.isMulti;
  return isMulti && "\n    display: inline-block;\n    vertical-align: middle;\n    border-bottom-right-radius: 2px;\n    border-top-right-radius: 2px;\n    cursor: default;\n    padding: 0 5px;\n  ";
});