import styled, { css, keyframes } from 'styled-components';
import Text from '../../../primitives/Text';
import TextInputAutoSize from './TextInputAutoSize';
var spin = keyframes(["to{transform:rotate(1turn);}"]);
var spinRule = css(["", " 400ms infinite linear;"], spin);
export var Arrow = styled.span.withConfig({
  displayName: "StyledComponents__Arrow",
  componentId: "yw2zl5-0"
})(["border-color:#999 transparent transparent;border-style:solid;border-width:5px 5px 2.5px;display:inline-block;height:0;width:0;position:relative;", ";"], function (props) {
  return props.$isOpen && "\n    top: -2px;\n    border-color: transparent transparent #999;\n    border-width: 0 5px 5px;\n  ";
});
export var ArrowZone = styled.span.withConfig({
  displayName: "StyledComponents__ArrowZone",
  componentId: "yw2zl5-1"
})(["cursor:pointer;display:table-cell;position:relative;text-align:center;vertical-align:middle;width:25px;&:hover{", "{border-top-color:#666;}}", ";"], Arrow, function (props) {
  return props.isDisabled && "\n    cursor: default;\n    pointer-events: none;\n    opacity: 0.35;\n  ";
});
export var Clear = styled.span.withConfig({
  displayName: "StyledComponents__Clear",
  componentId: "yw2zl5-2"
})(["display:inline-block;font-size:1.15em;line-height:1;"]);
export var ClearZone = styled.span.withConfig({
  displayName: "StyledComponents__ClearZone",
  componentId: "yw2zl5-3"
})(["color:#999;cursor:pointer;display:table-cell;position:relative;text-align:center;vertical-align:middle;width:17px;&:hover{color:#d0021b;}"]);
export var Container = styled.div.withConfig({
  displayName: "StyledComponents__Container",
  componentId: "yw2zl5-4"
})(["font-size:14px;position:relative;"]);
export var Control = styled.div.withConfig({
  displayName: "StyledComponents__Control",
  componentId: "yw2zl5-5"
})(["cursor:default;display:table;height:100%;outline:none;overflow:hidden;position:relative;width:100%;&:focus{outline:none;}", " ", ";"], function (_ref) {
  var isOpen = _ref.isOpen;
  return isOpen && "\n    background: #fff;\n  ";
}, function (_ref2) {
  var isFocused = _ref2.isFocused,
      isOpen = _ref2.isOpen,
      isSearchable = _ref2.isSearchable;
  return isSearchable && (isOpen || isFocused) && "\n    cursor: text;\n  ";
});
var inputStyle = css(["height:100%;padding-right:10px;&:focus{outline:none;}"]);
export var FakeInput = styled.div.withConfig({
  displayName: "StyledComponents__FakeInput",
  componentId: "yw2zl5-6"
})(["", " border:0;width:1px;display:inline-block;"], inputStyle);
export var Input = styled(TextInputAutoSize).withConfig({
  displayName: "StyledComponents__Input",
  componentId: "yw2zl5-7"
})(["input{min-height:26px;width:100%;cursor:", ";font-size:inherit;", ";}", ";"], function (_ref3) {
  var isFocused = _ref3.isFocused;
  return isFocused ? 'text' : 'default';
}, function (_ref4) {
  var hasValue = _ref4.hasValue,
      isPseudoFocused = _ref4.isPseudoFocused;
  return hasValue && isPseudoFocused && "\n      opacity: 0;\n    ";
}, inputStyle);
export var Loading = styled.span.withConfig({
  displayName: "StyledComponents__Loading",
  componentId: "yw2zl5-8"
})(["animation:", ";width:16px;height:16px;box-sizing:border-box;border-radius:50%;border:2px solid #ccc;border-right-color:#333;display:inline-block;position:relative;vertical-align:middle;"], spinRule);
export var LoadingZone = styled.span.withConfig({
  displayName: "StyledComponents__LoadingZone",
  componentId: "yw2zl5-9"
})(["cursor:pointer;display:table-cell;position:relative;text-align:center;vertical-align:middle;width:16px;"]);
export var MenuInner = styled.div.withConfig({
  displayName: "StyledComponents__MenuInner",
  componentId: "yw2zl5-10"
})(["display:flex;flex-direction:column;max-height:198px;"]);
export var MenuOuter = styled.div.withConfig({
  displayName: "StyledComponents__MenuOuter",
  componentId: "yw2zl5-11"
})(["background-color:#fff;border:1px solid #ccc;box-sizing:border-box;margin-top:-1px;max-height:200px;position:absolute;top:100%;width:100%;z-index:1;-webkit-overflow-scrolling:touch;"]);
export var MultiValueWrapperOuter = styled.div.withConfig({
  displayName: "StyledComponents__MultiValueWrapperOuter",
  componentId: "yw2zl5-12"
})(["height:100%;"]);
export var ValueWrapper = styled.div.withConfig({
  displayName: "StyledComponents__ValueWrapper",
  componentId: "yw2zl5-13"
})(["height:100%;display:flex;flex-direction:row;align-items:center;"]);
export var MultiValueWrapper = styled(ValueWrapper).withConfig({
  displayName: "StyledComponents__MultiValueWrapper",
  componentId: "yw2zl5-14"
})(["flex-wrap:wrap;padding:6px 0;"]);
export var NoResults = styled(Text).withConfig({
  displayName: "StyledComponents__NoResults",
  componentId: "yw2zl5-15"
})(["color:#999;cursor:default;display:block;padding:8px 10px;"]);
export var Placeholder = styled(Text).withConfig({
  displayName: "StyledComponents__Placeholder",
  componentId: "yw2zl5-16"
})(["bottom:0;color:#aaa;height:100%;left:0;padding-right:10px;position:absolute;right:0;top:0;max-width:100%;overflow:hidden;text-overflow:ellipsis;white-space:nowrap;display:flex;align-items:center;"]);