function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (typeof call === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

import * as React from 'react';
import FlatList from '../../../primitives/FlatList';
import Menu from './Menu';
import SelectedOption from './SelectedOption';
import { Arrow, ArrowZone, Clear, ClearZone, Container, Control, FakeInput, Input, Loading, LoadingZone, MenuInner, MenuOuter, MultiValueWrapper, NoResults, Placeholder, ValueWrapper } from './StyledComponents';
import { jsx as _jsx } from "react/jsx-runtime";
import { createElement as _createElement } from "react";
import { jsxs as _jsxs } from "react/jsx-runtime";

var Select = /*#__PURE__*/function (_React$Component) {
  _inherits(Select, _React$Component);

  var _super = _createSuper(Select);

  function Select() {
    var _this;

    _classCallCheck(this, Select);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _super.call.apply(_super, [this].concat(args));

    _this.blur = function () {
      _this._input && _this._input.blur();
    };

    _this.focus = function () {
      _this._input && _this._input.focus();
    };

    _this.state = {
      inputValue: '',
      isFocused: false,
      isOpen: false,
      isPseudoFocused: false
    };

    _this._addValue = function (option) {
      var selectedOptions = _this._getSelectedOptions();

      var visibleOptions = _this._visibleOptions.filter(function (val) {
        return !val.disabled;
      });

      var lastValueIndex = visibleOptions.indexOf(option);

      _this._setValue(selectedOptions.concat(option));

      if (visibleOptions.length - 1 === lastValueIndex) {
        // the last option was selected; focus the second-last one
        _this._focusOption(visibleOptions[lastValueIndex - 1]);
      } else if (visibleOptions.length > lastValueIndex) {
        // focus the option below the selected one
        _this._focusOption(visibleOptions[lastValueIndex + 1]);
      }
    };

    _this._captureOptionRef = function (ref, isFocused) {
      if (isFocused) {
        _this._focused = ref;
      }
    };

    _this._clearValue = function () {
      _this._setValue([]);

      _this._handleInputValueChange('', true);

      _this.setState({
        isOpen: false,
        inputValue: ''
      }, _this.focus);
    };

    _this._closeMenu = function () {
      _this._handleInputValueChange('', false);

      _this.setState(function (prevState) {
        return {
          isOpen: false,
          isPseudoFocused: prevState.isFocused && !_this.props.multi,
          inputValue: ''
        };
      });

      _this._hasScrolledToOption = false;
    };

    _this._filterOptions = function (excludeOptions) {
      var _this$props = _this.props,
          filterOption = _this$props.filterOption,
          labelKey = _this$props.labelKey,
          valueKey = _this$props.valueKey;

      var filterValue = _this.state.inputValue.toLowerCase();

      var options = _this.props.options || [];
      var excludeValues;
      if (excludeOptions) excludeValues = excludeOptions.map(function (i) {
        return i[valueKey];
      });
      return options.filter(function (option) {
        if (excludeValues && excludeValues.indexOf(option[valueKey]) > -1) return false;
        if (filterOption) return filterOption(option, filterValue);
        if (!filterValue) return true;
        var labelTest = String(option[labelKey]).toLowerCase();
        return labelTest.indexOf(filterValue) >= 0;
      });
    };

    _this._focusAdjacentOption = function (dir) {
      var options = _this._visibleOptions.map(function (option, index) {
        return {
          option: option,
          index: index
        };
      }).filter(function (option) {
        return !option.option.disabled;
      });

      _this._scrollToFocusedOptionOnUpdate = true;

      if (!_this.state.isOpen) {
        var focusedOption = _this._focusedOption || (options.length ? options[dir === 'next' ? 0 : options.length - 1].option : null);

        _this.setState({
          isOpen: true,
          inputValue: '',
          focusedOption: focusedOption
        });

        return;
      }

      if (!options.length) return;
      var focusedIndex = -1;

      for (var i = 0; i < options.length; i++) {
        if (_this._focusedOption === options[i].option) {
          focusedIndex = i;
          break;
        }
      }

      if (dir === 'next' && focusedIndex !== -1) {
        focusedIndex = (focusedIndex + 1) % options.length;
      } else if (dir === 'previous') {
        if (focusedIndex > 0) {
          focusedIndex -= 1;
        } else {
          focusedIndex = options.length - 1;
        }
      } else if (dir === 'start') {
        focusedIndex = 0;
      } else if (dir === 'end') {
        focusedIndex = options.length - 1;
      } else if (dir === 'page_up') {
        var potentialIndex = focusedIndex - _this.props.pageSize;

        if (potentialIndex < 0) {
          focusedIndex = 0;
        } else {
          focusedIndex = potentialIndex;
        }
      } else if (dir === 'page_down') {
        var _potentialIndex = focusedIndex + _this.props.pageSize;

        if (_potentialIndex > options.length - 1) {
          focusedIndex = options.length - 1;
        } else {
          focusedIndex = _potentialIndex;
        }
      }

      if (focusedIndex === -1) {
        focusedIndex = 0;
      }

      _this.setState({
        focusedIndex: options[focusedIndex].index,
        focusedOption: options[focusedIndex].option
      });
    };

    _this._focusEndOption = function () {
      _this._focusAdjacentOption('end');
    };

    _this._focusNextOption = function () {
      _this._focusAdjacentOption('next');
    };

    _this._focusOption = function (option) {
      _this.setState({
        focusedOption: option
      });
    };

    _this._focusPageDownOption = function () {
      _this._focusAdjacentOption('page_down');
    };

    _this._focusPageUpOption = function () {
      _this._focusAdjacentOption('page_up');
    };

    _this._focusPreviousOption = function () {
      _this._focusAdjacentOption('previous');
    };

    _this._focusStartOption = function () {
      _this._focusAdjacentOption('start');
    };

    _this._getFocusableOptionIndex = function (selectedOption) {
      var options = _this._visibleOptions;
      if (!options.length) return null;
      var valueKey = _this.props.valueKey;
      var focusedOption = _this.state.focusedOption || selectedOption;

      if (focusedOption && !focusedOption.disabled) {
        var focusedOptionIndex = -1;
        options.some(function (option, index) {
          var isOptionEqual = option[valueKey] === focusedOption[valueKey];

          if (isOptionEqual) {
            focusedOptionIndex = index;
          }

          return isOptionEqual;
        });

        if (focusedOptionIndex !== -1) {
          return focusedOptionIndex;
        }
      }

      for (var i = 0; i < options.length; i++) {
        if (!options[i].disabled) return i;
      }

      return null;
    };

    _this._getOptionFromValue = function (value) {
      var valueType = typeof value;
      if (valueType !== 'string' && valueType !== 'number') return null;
      var _this$props2 = _this.props,
          options = _this$props2.options,
          valueKey = _this$props2.valueKey;
      if (!options) return null;

      for (var i = 0; i < options.length; i++) {
        if (options[i][valueKey] === value) return options[i];
      }

      return null;
    };

    _this._getOptionLabel = function (option) {
      return option[_this.props.labelKey];
    };

    _this._getSelectedOptions = function () {
      var value = _this.props.value;
      var valueArray;

      if (Array.isArray(value)) {
        valueArray = value;
      } else {
        valueArray = [value];
      }

      return valueArray.map(_this._getOptionFromValue).filter(Boolean);
    };

    _this._getSelectState = function () {
      var _this$props3 = _this.props,
          clearable = _this$props3.clearable,
          isLoading = _this$props3.isLoading,
          multi = _this$props3.multi,
          readOnly = _this$props3.readOnly,
          searchable = _this$props3.searchable;

      var selectedOptions = _this._getSelectedOptions();

      var visibleOptions = _this._visibleOptions = _this._filterOptions();

      var isOpen = _this.state.isOpen;

      if (multi && !visibleOptions.length && selectedOptions.length && !_this.state.inputValue) {
        isOpen = false;
      }

      return {
        hasValue: selectedOptions.length > 0,
        isMulti: multi,
        isSingle: !multi,
        isClearable: clearable,
        isDisabled: readOnly,
        isFocused: _this.state.isFocused,
        isLoading: isLoading,
        isOpen: isOpen,
        isPseudoFocused: _this.state.isPseudoFocused,
        isSearchable: searchable,
        selectedOptions: selectedOptions,
        visibleOptions: visibleOptions
      };
    };

    _this._handleInputValueChange = function (newValue, triggeredByUser) {
      var onInputChange = _this.props.onInputChange;
      onInputChange && onInputChange(newValue, triggeredByUser);
    };

    _this._onClearButtonClick = function (event) {
      event.stopPropagation();
      event.preventDefault();

      _this._clearValue();
    };

    _this._onControlClick = function (event) {
      // if the event was triggered by a click and not the primary
      // button, or if the component is read-only, ignore it.
      // $FlowFixMe
      if (_this.props.readOnly || event.type === 'click' && event.button !== 0) {
        return;
      } // $FlowFixMe


      if (event.target.tagName === 'INPUT') {
        return;
      } // prevent default event handlers


      event.stopPropagation();
      event.preventDefault();

      if (_this.state.isFocused) {
        // On iOS, we can get into a state where we think the input is focused but it isn't really,
        // since iOS ignores programmatic calls to input.focus() that weren't triggered by a click
        // event.
        // Call focus() again here to be safe.
        _this.focus();

        var input = _this._input; // clears the value so that the cursor will be at the end of input when the component
        // re-renders

        if (input) {
          if (typeof input.getInput === 'function') {
            // Get the actual DOM input if the ref is an <TextInputAutoSize /> component
            input = input.getInput();
          }

          input.value = '';
        } // if the input is focused, ensure the menu is open


        _this.setState({
          isOpen: true,
          isPseudoFocused: false
        });
      } else {
        // otherwise, focus the input and open the menu
        _this.focus();
      }
    };

    _this._onControlKeyDown = function (event) {
      if (_this.props.readOnly) return;

      switch (event.keyCode) {
        case 8:
          // backspace
          if (!_this.state.inputValue) {
            event.preventDefault();

            _this._popValue();
          }

          return;

        case 13:
          // enter
          if (!_this.state.isOpen) return;
          event.stopPropagation();

          if (_this.props.multi) {
            _this._toggleFocusedOption();
          } else {
            _this._selectFocusedOption();
          }

          break;

        case 27:
          // escape
          if (_this.state.isOpen) {
            _this._closeMenu();

            event.stopPropagation();
          }

          break;

        case 38:
          // up
          _this._focusPreviousOption();

          break;

        case 40:
          // down
          _this._focusNextOption();

          break;

        case 33:
          // page up
          _this._focusPageUpOption();

          break;

        case 34:
          // page down
          _this._focusPageDownOption();

          break;

        case 35:
          // end key
          if (event.shiftKey) {
            return;
          }

          _this._focusEndOption();

          break;

        case 36:
          // home key
          if (event.shiftKey) {
            return;
          }

          _this._focusStartOption();

          break;

        case 46:
          // delete
          if (!_this.state.inputValue) {
            event.preventDefault();

            _this._popValue();
          }

          return;

        default:
          return;
      }

      event.preventDefault();
    };

    _this._onControlMouseDown = function (event) {
      // $FlowFixMe
      if (event.target.tagName !== 'INPUT') {
        event.stopPropagation();
        event.preventDefault();
      }
    };

    _this._onDropdownIconClick = function (event) {
      // if the event was triggered by a click and not the primary
      // button, or if the component is read-only, ignore it.
      if (_this.props.readOnly || event.type === 'click' && event.button !== 0) {
        return;
      } // If the menu isn't open, let the event bubble to the main handleClick


      if (!_this.state.isOpen) {
        return;
      } // prevent default event handlers


      event.stopPropagation();
      event.preventDefault(); // close the menu

      _this._closeMenu();
    };

    _this._onInputBlur = function () {
      // The check for menu.contains(activeElement) is necessary to prevent IE11's scrollbar from
      // closing the menu in certain contexts.
      if (_this._menu && (_this._menu === document.activeElement || _this._menu.contains(document.activeElement))) {
        _this.focus();

        return;
      }

      if (_this.props.onBlur) {
        _this.props.onBlur();
      }

      var onBlurredState = {
        isFocused: false,
        isOpen: false,
        isPseudoFocused: false
      };

      _this.setState(onBlurredState);
    };

    _this._onInputChange = function (event) {
      var newInputValue = event.target.value;

      if (_this.state.inputValue !== newInputValue) {
        _this._handleInputValueChange(newInputValue, true);
      }

      _this.setState({
        isOpen: true,
        isPseudoFocused: false,
        inputValue: newInputValue
      });
    };

    _this._onInputFocus = function () {
      if (_this.props.readOnly) return;

      if (_this.props.onFocus) {
        _this.props.onFocus();
      }

      _this.setState({
        isFocused: true,
        isOpen: true
      });
    };

    _this._onMenuMouseDown = function (event) {
      // if the event was triggered by a mousedown and not the primary
      // button, or if the component is read-only, ignore it.
      if (_this.props.readOnly || event.type === 'mousedown' && event.button !== 0) {
        return;
      }

      event.stopPropagation();
      event.preventDefault();

      _this.focus();
    };

    _this._onTouchEnd = function (event) {
      // Check if the view is being dragged, In this case
      // we don't want to fire the click event (because the user only wants to scroll)
      if (_this._dragging) return; // Fire the mouse events

      _this._onControlClick(event);
    };

    _this._onTouchEndClearValue = function (event) {
      // Check if the view is being dragged, In this case
      // we don't want to fire the click event (because the user only wants to scroll)
      if (_this._dragging) return; // Clear the value

      _this._onClearButtonClick(event);
    };

    _this._onTouchMove = function () {
      // Set a flag that the view is being dragged
      _this._dragging = true;
    };

    _this._onTouchOutside = function (event) {
      if (!(event.target instanceof Node)) return; // handle touch outside on ios to dismiss menu

      if (_this._wrapper && !_this._wrapper.contains(event.target)) {
        _this._closeMenu();
      }
    };

    _this._onTouchStart = function () {
      // Set a flag that the view is not being dragged
      _this._dragging = false;
    };

    _this._popValue = function () {
      var selectedOptions = _this._getSelectedOptions();

      if (!selectedOptions.length) return;

      _this._setValue(_this.props.multi ? selectedOptions.slice(0, selectedOptions.length - 1) : []);
    };

    _this._removeValue = function (option) {
      var selectedOptions = _this._getSelectedOptions();

      _this._setValue(selectedOptions.filter(function (i) {
        return i !== option;
      }));

      _this.focus();
    };

    _this._selectFocusedOption = function () {
      if (_this._focusedOption) {
        _this._selectOption(_this._focusedOption);
      }
    };

    _this._selectOption = function (option) {
      // NOTE: we actually add/set the value in a callback to make sure the
      // input value is empty to avoid styling issues in Chrome
      _this._hasScrolledToOption = false;

      _this._handleInputValueChange('', false);

      if (_this.props.multi) {
        _this.setState({
          focusedIndex: null,
          inputValue: ''
        }, function () {
          _this._addValue(option);
        });
      } else {
        _this.setState(function (prevState) {
          return {
            inputValue: '',
            isPseudoFocused: prevState.isFocused
          };
        }, function () {
          _this._setValue([option]);
        });
      }
    };

    _this._setValue = function (options) {
      var _this$props4 = _this.props,
          multi = _this$props4.multi,
          onValueChange = _this$props4.onValueChange,
          valueKey = _this$props4.valueKey;

      if (!multi) {
        _this.blur();
      }

      if (onValueChange) {
        var valueArray = options.map(function (option) {
          return option[valueKey];
        });

        var _value = multi ? valueArray : valueArray.length > 0 ? valueArray[0] : null;

        onValueChange(_value);
      }
    };

    _this._toggleFocusedOption = function () {
      if (_this._focusedOption) {
        _this._toggleOption(_this._focusedOption);
      }
    };

    _this._toggleOption = function (option) {
      var valueKey = _this.props.valueKey;

      var selectedOptions = _this._getSelectedOptions();

      if (selectedOptions.find(function (op) {
        return op[valueKey] === option[valueKey];
      })) {
        _this._setValue(selectedOptions.filter(function (op) {
          return op[valueKey] !== option[valueKey];
        }));
      } else {
        _this._selectOption(option);
      }
    };

    _this._toggleTouchOutsideEvent = function (enabled) {
      if (enabled) {
        // $FlowFixMe
        document.addEventListener('touchstart', _this._onTouchOutside);
      } else {
        // $FlowFixMe
        document.removeEventListener('touchstart', _this._onTouchOutside);
      }
    };

    _this._renderClear = function () {
      var _this$props5 = _this.props,
          clearable = _this$props5.clearable,
          clearAllText = _this$props5.clearAllText,
          clearValueText = _this$props5.clearValueText,
          isLoading = _this$props5.isLoading,
          multi = _this$props5.multi,
          readOnly = _this$props5.readOnly,
          value = _this$props5.value;

      if (!clearable || value === undefined || value === null || multi && !value.length || readOnly || isLoading) {
        return null;
      }

      var label = multi ? clearAllText : clearValueText;
      return /*#__PURE__*/_jsx(ClearZone, {
        "aria-label": label,
        onClick: _this._onClearButtonClick,
        onTouchStart: _this._onTouchStart,
        onTouchMove: _this._onTouchMove,
        onTouchEnd: _this._onTouchEndClearValue,
        title: label,
        children: /*#__PURE__*/_jsx(Clear, {
          children: "\xD7"
        })
      });
    };

    _this._renderDropdownIcon = function () {
      var renderDropdownIcon = _this.props.renderDropdownIcon;
      return /*#__PURE__*/_jsx(ArrowZone, _objectSpread(_objectSpread({}, _this._getSelectState()), {}, {
        onClick: _this._onDropdownIconClick,
        children: renderDropdownIcon ? renderDropdownIcon() : /*#__PURE__*/_jsx(Arrow, {
          $isOpen: _this.state.isOpen
        })
      }));
    };

    _this._renderInput = function () {
      var isOpen = !!_this.state.isOpen;
      var _this$props6 = _this.props,
          readOnly = _this$props6.readOnly,
          searchable = _this$props6.searchable;

      var inputProps = _objectSpread(_objectSpread({}, _this._getSelectState()), {}, {
        'aria-expanded': isOpen,
        ref: function ref(_ref) {
          _this._input = _ref;
        },
        role: 'combobox',
        onBlur: _this._onInputBlur,
        onFocus: _this._onInputFocus
      });

      if (readOnly || !searchable) {
        return /*#__PURE__*/_jsx(FakeInput, _objectSpread(_objectSpread({}, inputProps), {}, {
          "aria-readonly": !!readOnly,
          tabIndex: 0
        }));
      }

      var value = _this.state.isFocused ? _this.state.inputValue : '';
      return /*#__PURE__*/_jsx(Input, _objectSpread(_objectSpread({}, inputProps), {}, {
        "aria-haspopup": isOpen,
        onChange: _this._onInputChange,
        value: value
      }));
    };

    _this._renderLoading = function () {
      if (!_this.props.isLoading) return null;
      return /*#__PURE__*/_jsx(LoadingZone, {
        "aria-hidden": "true",
        "data-testid": "select-spinner",
        children: /*#__PURE__*/_jsx(Loading, {})
      });
    };

    _this._renderMenu = function (options, selectedOptions, focusedOption) {
      var _this$props7 = _this.props,
          labelKey = _this$props7.labelKey,
          multi = _this$props7.multi,
          noResultsText = _this$props7.noResultsText,
          onDropdownEndReached = _this$props7.onDropdownEndReached,
          onDropdownEndReachedThreshold = _this$props7.onDropdownEndReachedThreshold,
          renderOption = _this$props7.renderOption,
          valueKey = _this$props7.valueKey;
      var handleSelect = multi ? _this._toggleOption : _this._selectOption;
      return /*#__PURE__*/_jsx(Menu, {
        focusedOption: focusedOption,
        focusedOptionRef: _this._captureOptionRef,
        labelKey: labelKey,
        listRef: function listRef(ref) {
          _this._list = ref;
        },
        noResults: /*#__PURE__*/_jsx(NoResults, {
          children: noResultsText
        }),
        onEndReached: onDropdownEndReached,
        onEndReachedThreshold: onDropdownEndReachedThreshold,
        onItemFocus: _this._focusOption,
        onItemSelect: handleSelect,
        options: options,
        renderOption: renderOption,
        selectedOptions: selectedOptions,
        valueKey: valueKey
      });
    };

    _this._renderOuter = function (options, selectedOptions, focusedOption) {
      var menu = _this._renderMenu(options, selectedOptions, focusedOption);

      if (!menu) {
        return null;
      }

      return /*#__PURE__*/_jsx(MenuOuter, {
        ref: function ref(_ref3) {
          _this._menuContainer = _ref3;
        },
        children: /*#__PURE__*/_jsx(MenuInner, {
          ref: function ref(_ref2) {
            _this._menu = _ref2;
          },
          onMouseDown: _this._onMenuMouseDown,
          role: "listbox",
          tabIndex: -1,
          children: menu
        })
      });
    };

    _this._renderSelectedValue = function (selectedOptions) {
      var _this$props8 = _this.props,
          labelKey = _this$props8.labelKey,
          multi = _this$props8.multi,
          placeholder = _this$props8.placeholder,
          valueKey = _this$props8.valueKey;

      var selectState = _this._getSelectState();

      if (selectedOptions.length === 0 && !selectState.isOpen) {
        return !_this.state.inputValue && /*#__PURE__*/_jsx(Placeholder, {
          children: placeholder
        });
      }

      if (multi) {
        return selectedOptions.map(function (option) {
          return /*#__PURE__*/_createElement(SelectedOption, _objectSpread(_objectSpread({}, selectState), {}, {
            key: "value-".concat(option[valueKey]),
            labelKey: labelKey,
            onRemove: _this._removeValue,
            option: option
          }));
        });
      } else if (!_this.state.inputValue) {
        var _option = selectedOptions[0];
        if (!_option) return null;
        return /*#__PURE__*/_jsx(SelectedOption, _objectSpread(_objectSpread({}, selectState), {}, {
          labelKey: labelKey,
          option: _option
        }));
      }

      return null;
    };

    _this._renderSingleSelectedValues = function (selectedOptions) {
      return /*#__PURE__*/_jsxs(ValueWrapper, {
        children: [_this._renderSelectedValue(selectedOptions), _this._renderInput()]
      });
    };

    _this._renderMultiSelectedValues = function (selectedOptions) {
      return /*#__PURE__*/_jsxs(MultiValueWrapper, {
        children: [_this._renderSelectedValue(selectedOptions), _this._renderInput()]
      });
    };

    return _this;
  }

  _createClass(Select, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      if (this.props.autoFocus) {
        this.focus();
      }
    }
  }, {
    key: "UNSAFE_componentWillUpdate",
    value: function UNSAFE_componentWillUpdate(nextProps, nextState) {
      if (nextState.isOpen !== this.state.isOpen) {
        this._toggleTouchOutsideEvent(nextState.isOpen);
      }
    }
  }, {
    key: "componentDidUpdate",
    value: function componentDidUpdate(prevProps) {
      // focus to the selected option
      if (this._list && this._focusedOptionIndex != null && this.state.isOpen && !this._hasScrolledToOption) {
        this._list.scrollToIndex({
          index: this._focusedOptionIndex
        });

        this._hasScrolledToOption = true;
      } else if (!this.state.isOpen) {
        this._hasScrolledToOption = false;
      }

      if (this.props.scrollMenuIntoView && this._menuContainer) {
        var menuContainerRect = this._menuContainer.getBoundingClientRect();

        if (window.innerHeight < menuContainerRect.bottom + this.props.menuBuffer) {
          window.scrollBy(0, menuContainerRect.bottom + this.props.menuBuffer - window.innerHeight);
        }
      }

      if (prevProps.readOnly !== this.props.readOnly) {
        this.setState({
          isFocused: false
        }); // eslint-disable-line react/no-did-update-set-state

        this._closeMenu();
      }
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      // $FlowFixMe
      document.removeEventListener('touchstart', this._onTouchOutside);
    }
  }, {
    key: "render",
    value: function render() {
      var _this2 = this;

      var _this$props9 = this.props,
          accessibilityLabel = _this$props9.accessibilityLabel,
          className = _this$props9.className,
          style = _this$props9.style,
          testID = _this$props9.testID,
          multi = _this$props9.multi;

      var selectState = this._getSelectState();

      var isOpen = selectState.isOpen,
          selectedOptions = selectState.selectedOptions,
          visibleOptions = selectState.visibleOptions;
      this._focusedOptionIndex = this._getFocusableOptionIndex(selectedOptions[0]);
      var focusedOption = this._focusedOptionIndex === null ? null : visibleOptions[this._focusedOptionIndex];
      this._focusedOption = focusedOption;
      return /*#__PURE__*/_jsxs(Container, _objectSpread(_objectSpread({}, selectState), {}, {
        "aria-label": accessibilityLabel,
        className: className,
        "data-testid": testID,
        ref: function ref(_ref4) {
          _this2._wrapper = _ref4;
        },
        style: style,
        children: [/*#__PURE__*/_jsxs(Control, _objectSpread(_objectSpread({}, selectState), {}, {
          onClick: this._onControlClick,
          onKeyDown: this._onControlKeyDown,
          onMouseDown: this._onControlMouseDown,
          onTouchEnd: this._onTouchEnd,
          onTouchStart: this._onTouchStart,
          onTouchMove: this._onTouchMove,
          children: [multi ? this._renderMultiSelectedValues(selectedOptions) : this._renderSingleSelectedValues(selectedOptions), this._renderLoading(), this._renderClear(), this._renderDropdownIcon()]
        })), isOpen ? this._renderOuter(visibleOptions, selectedOptions, focusedOption) : null]
      }));
    }
  }]);

  return Select;
}(React.Component);

Select.defaultProps = {
  autoFocus: false,
  clearable: true,
  clearAllText: 'Clear all',
  clearValueText: 'Clear value',
  isLoading: false,
  labelKey: 'label',
  menuBuffer: 0,
  multi: false,
  noResultsText: 'No results found',
  pageSize: 5,
  placeholder: '',
  readOnly: false,
  scrollMenuIntoView: true,
  searchable: true,
  valueKey: 'value'
};
Select.displayName = 'Select';
export default Select;