import React from 'react';
import Menu from '../../components/Menu';
import { Container, MainButton, MenuButton, Separator } from './StyledComponents.native';
import { jsx as _jsx } from "react/jsx-runtime";
import { jsxs as _jsxs } from "react/jsx-runtime";
export default function SplitButton(_ref) {
  var children = _ref.children,
      className = _ref.className,
      onButtonPress = _ref.onButtonPress,
      style = _ref.style,
      testID = _ref.testID,
      text = _ref.text,
      icon = _ref.icon,
      _ref$type = _ref.type,
      type = _ref$type === void 0 ? 'primary' : _ref$type;
  return /*#__PURE__*/_jsxs(Container, {
    className: className,
    style: style,
    children: [/*#__PURE__*/_jsx(MainButton, {
      "data-testid": "".concat(testID, "-main"),
      onPress: onButtonPress,
      icon: icon,
      text: text,
      type: type
    }), /*#__PURE__*/_jsx(Separator, {}), /*#__PURE__*/_jsx(Menu, {
      align: "right",
      testID: "".concat(testID, "-arrow"),
      trigger: function trigger(open, _close, _active) {
        return MenuTrigger(open, type, testID);
      },
      children: children
    })]
  });
}

var MenuTrigger = function MenuTrigger(open, type, testID) {
  return /*#__PURE__*/_jsx(MenuButton, {
    onPress: function onPress() {
      return open();
    },
    "data-testid": "".concat(testID, "-menu-button"),
    icon: "arrow-drop-down",
    type: type
  });
};

SplitButton.Item = Menu.Item;