function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

import React from 'react';
import { Form } from '../../primitives/Form';
import { useFormStateStrict } from '../../primitives/Form/FormState';
import createButton from '../Button/createButton';
import { jsx as _jsx } from "react/jsx-runtime";
var Button = createButton(Form.SubmitButton);

var SubmitButton = function SubmitButton(_ref) {
  var className = _ref.className,
      disabled = _ref.disabled,
      icon = _ref.icon,
      iconStyle = _ref.iconStyle,
      style = _ref.style,
      textStyle = _ref.textStyle,
      testID = _ref.testID,
      text = _ref.text,
      type = _ref.type;

  var _useFormStateStrict = useFormStateStrict(),
      submitting = _useFormStateStrict.submitting;

  var props = {
    className: className,
    disabled: disabled,
    icon: icon,
    iconStyle: iconStyle,
    style: style,
    textStyle: textStyle,
    testID: testID,
    text: text,
    type: type
  };
  return /*#__PURE__*/_jsx(Button, _objectSpread(_objectSpread({}, props), {}, {
    loading: submitting
  }));
};

export default SubmitButton;