var _templateObject, _templateObject2;

function _taggedTemplateLiteral(strings, raw) { if (!raw) { raw = strings.slice(0); } return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _iterableToArray(iter) { if (typeof Symbol !== "undefined" && Symbol.iterator in Object(iter)) return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) return _arrayLikeToArray(arr); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

import * as React from 'react';
import { styled } from '../../apis/Style';
import Text from '../../primitives/Text';
import TouchableView from '../../primitives/TouchableView';
import View from '../../primitives/View';
import { ButtonCSS } from './styles';
import { jsx as _jsx } from "react/jsx-runtime";
export default function Picker(_ref) {
  var options = _ref.options,
      _ref$selected = _ref.selected,
      selected = _ref$selected === void 0 ? [] : _ref$selected,
      onChange = _ref.onChange,
      optionToString = _ref.optionToString,
      _ref$multi = _ref.multi,
      multi = _ref$multi === void 0 ? false : _ref$multi,
      testID = _ref.testID;
  return /*#__PURE__*/_jsx(StyledView, {
    testID: testID,
    children: options.map(function (option, i) {
      var isSelected;
      if (multi) isSelected = selected.includes(option);else isSelected = selected === option;
      return /*#__PURE__*/_jsx(TabButton, {
        $isSelected: isSelected,
        $position: getPosition(i, options.length),
        onPress: function onPress() {
          var output;

          if (!multi) {
            output = option;
          } else {
            if (selected.includes(option)) {
              output = selected.filter(function (item) {
                return item !== option;
              });
            } else {
              output = [].concat(_toConsumableArray(selected), [option]);
            }
          }

          onChange(output);
        },
        children: /*#__PURE__*/_jsx(Text, {
          children: optionToString(option)
        }, option.value)
      }, i);
    })
  });
}
var StyledView = styled(View)(_templateObject || (_templateObject = _taggedTemplateLiteral(["\n  flex-direction: column;\n  max-width: 400px;\n"])));
var TabButton = styled(TouchableView)(_templateObject2 || (_templateObject2 = _taggedTemplateLiteral(["\n  min-width: 50px;\n  height: 40px;\n  padding-left: 10px;\n  padding-right: 10px;\n  background-color: ", ";\n  border-top-left-radius: ", ";\n  border-top-right-radius: ", ";\n  border-bottom-left-radius: ", ";\n  border-bottom-right-radius: ", ";\n  margin-bottom: 1px;\n  align-items: center;\n  justify-content: center;\n  ", ";\n"])), function (_ref2) {
  var $isSelected = _ref2.$isSelected;
  return $isSelected ? 'orange' : '#f8f8f8';
}, function (_ref3) {
  var $position = _ref3.$position;
  return $position === 'first' ? '4px' : '0px';
}, function (_ref4) {
  var $position = _ref4.$position;
  return $position === 'first' ? '4px' : '0px';
}, function (_ref5) {
  var $position = _ref5.$position;
  return $position === 'last' ? '4px' : '0px';
}, function (_ref6) {
  var $position = _ref6.$position;
  return $position === 'last' ? '4px' : '0px';
}, function (props) {
  return ButtonCSS(props);
});

var getPosition = function getPosition(pos, length) {
  if (pos === 0) {
    return 'first';
  }

  if (pos === length - 1) {
    return 'last';
  }

  return 'middle';
};