import 'jest-styled-components';
import 'react-testing-library/cleanup-after-each';
import userEvent from '@testing-library/user-event';
import React from 'react';
import { act, render } from 'react-testing-library';
import TabPicker from '..';
import { jsx as _jsx } from "react/jsx-runtime";
var options = [{
  label: 'Mon',
  value: 'mon'
}, {
  label: 'Tue',
  value: 'tue'
}, {
  label: 'Wed',
  value: 'wed'
}, {
  label: 'Thu',
  value: 'thu'
}, {
  label: 'Fri',
  value: 'fri'
}, {
  label: 'Sat',
  value: 'sat'
}, {
  label: 'Sun',
  value: 'sun'
}];
test('should render a tab picker with two options selected', function () {
  var selected;

  var _render = render( /*#__PURE__*/_jsx(TabPicker, {
    options: options,
    multi: true,
    selected: selected,
    optionToString: function optionToString(option) {
      return "".concat(option.label);
    },
    onChange: function onChange(value) {
      return selected = value;
    },
    testID: "test"
  })),
      getByTestId = _render.getByTestId; //Simulate mouse click to select options


  act(function () {
    userEvent.click(getByTestId('test').querySelector('[data-text-as-pseudo-element="Mon"]'));
    userEvent.click(getByTestId('test').querySelector('[data-text-as-pseudo-element="Fri"]'));
  });
  expect(getByTestId('test')).toMatchInlineSnapshot("\n    .c5 {\n      box-sizing: border-box;\n      color: #191E26;\n      display: inline;\n      -webkit-box-flex: 0;\n      -webkit-flex-grow: 0;\n      -ms-flex-positive: 0;\n      flex-grow: 0;\n      -webkit-flex-shrink: 0;\n      -ms-flex-negative: 0;\n      flex-shrink: 0;\n      font-family: \"Helvetica Neue\",Helvetica,Arial,sans-serif;\n      font-size: 14px;\n      position: relative;\n      white-space: pre-wrap;\n      word-wrap: break-word;\n      -ms-hyphens: auto;\n      cursor: inherit;\n    }\n\n    .c0 {\n      -webkit-align-items: stretch;\n      -webkit-box-align: stretch;\n      -ms-flex-align: stretch;\n      align-items: stretch;\n      border-color: #191E26;\n      border-style: solid;\n      border-width: 0;\n      box-sizing: border-box;\n      display: -webkit-box;\n      display: -webkit-flex;\n      display: -ms-flexbox;\n      display: flex;\n      -webkit-flex-direction: column;\n      -ms-flex-direction: column;\n      flex-direction: column;\n      -webkit-box-flex: 0;\n      -webkit-flex-grow: 0;\n      -ms-flex-positive: 0;\n      flex-grow: 0;\n      -webkit-flex-shrink: 0;\n      -ms-flex-negative: 0;\n      flex-shrink: 0;\n      position: relative;\n      min-height: 0;\n      min-width: 0;\n    }\n\n    .c2 {\n      -webkit-align-items: stretch;\n      -webkit-box-align: stretch;\n      -ms-flex-align: stretch;\n      align-items: stretch;\n      border-color: #191E26;\n      border-style: solid;\n      border-width: 0;\n      box-sizing: border-box;\n      display: -webkit-box;\n      display: -webkit-flex;\n      display: -ms-flexbox;\n      display: flex;\n      -webkit-flex-direction: column;\n      -ms-flex-direction: column;\n      flex-direction: column;\n      -webkit-box-flex: 0;\n      -webkit-flex-grow: 0;\n      -ms-flex-positive: 0;\n      flex-grow: 0;\n      -webkit-flex-shrink: 0;\n      -ms-flex-negative: 0;\n      flex-shrink: 0;\n      position: relative;\n      min-height: 0;\n      min-width: 0;\n    }\n\n    .c3 {\n      -webkit-align-items: stretch;\n      -webkit-box-align: stretch;\n      -ms-flex-align: stretch;\n      align-items: stretch;\n      border-color: #191E26;\n      border-style: solid;\n      border-width: 0;\n      box-sizing: border-box;\n      display: -webkit-box;\n      display: -webkit-flex;\n      display: -ms-flexbox;\n      display: flex;\n      -webkit-flex-direction: column;\n      -ms-flex-direction: column;\n      flex-direction: column;\n      -webkit-box-flex: 0;\n      -webkit-flex-grow: 0;\n      -ms-flex-positive: 0;\n      flex-grow: 0;\n      -webkit-flex-shrink: 0;\n      -ms-flex-negative: 0;\n      flex-shrink: 0;\n      position: relative;\n      min-height: 0;\n      min-width: 0;\n      background-color: transparent;\n      border-color: transparent;\n      border-width: 0;\n      padding: 0;\n      text-align: left;\n      outline: none;\n      cursor: pointer;\n    }\n\n    .c3 * {\n      cursor: pointer;\n    }\n\n    .c1 {\n      -webkit-flex-direction: column;\n      -ms-flex-direction: column;\n      flex-direction: column;\n      max-width: 400px;\n    }\n\n    .c4 {\n      min-width: 50px;\n      height: 40px;\n      padding-left: 10px;\n      padding-right: 10px;\n      background-color: #f8f8f8;\n      border-top-left-radius: 4px;\n      border-top-right-radius: 4px;\n      border-bottom-left-radius: 0px;\n      border-bottom-right-radius: 0px;\n      margin-bottom: 1px;\n      -webkit-align-items: center;\n      -webkit-box-align: center;\n      -ms-flex-align: center;\n      align-items: center;\n      -webkit-box-pack: center;\n      -webkit-justify-content: center;\n      -ms-flex-pack: center;\n      justify-content: center;\n    }\n\n    .c4:hover {\n      background-color: #eee;\n    }\n\n    .c6 {\n      min-width: 50px;\n      height: 40px;\n      padding-left: 10px;\n      padding-right: 10px;\n      background-color: #f8f8f8;\n      border-top-left-radius: 0px;\n      border-top-right-radius: 0px;\n      border-bottom-left-radius: 0px;\n      border-bottom-right-radius: 0px;\n      margin-bottom: 1px;\n      -webkit-align-items: center;\n      -webkit-box-align: center;\n      -ms-flex-align: center;\n      align-items: center;\n      -webkit-box-pack: center;\n      -webkit-justify-content: center;\n      -ms-flex-pack: center;\n      justify-content: center;\n    }\n\n    .c6:hover {\n      background-color: #eee;\n    }\n\n    .c7 {\n      min-width: 50px;\n      height: 40px;\n      padding-left: 10px;\n      padding-right: 10px;\n      background-color: #f8f8f8;\n      border-top-left-radius: 0px;\n      border-top-right-radius: 0px;\n      border-bottom-left-radius: 4px;\n      border-bottom-right-radius: 4px;\n      margin-bottom: 1px;\n      -webkit-align-items: center;\n      -webkit-box-align: center;\n      -ms-flex-align: center;\n      align-items: center;\n      -webkit-box-pack: center;\n      -webkit-justify-content: center;\n      -ms-flex-pack: center;\n      justify-content: center;\n    }\n\n    .c7:hover {\n      background-color: #eee;\n    }\n\n    <div\n      class=\"c0 c1\"\n      data-testid=\"test\"\n    >\n      <div\n        class=\"c2 c3 c4\"\n        role=\"button\"\n        style=\"transition-duration: 0.25s; opacity: 1;\"\n        tabindex=\"0\"\n      >\n        <div\n          class=\"c5\"\n          data-text-as-pseudo-element=\"Mon\"\n        />\n      </div>\n      <div\n        class=\"c2 c3 c6\"\n        role=\"button\"\n        tabindex=\"0\"\n      >\n        <div\n          class=\"c5\"\n          data-text-as-pseudo-element=\"Tue\"\n        />\n      </div>\n      <div\n        class=\"c2 c3 c6\"\n        role=\"button\"\n        tabindex=\"0\"\n      >\n        <div\n          class=\"c5\"\n          data-text-as-pseudo-element=\"Wed\"\n        />\n      </div>\n      <div\n        class=\"c2 c3 c6\"\n        role=\"button\"\n        tabindex=\"0\"\n      >\n        <div\n          class=\"c5\"\n          data-text-as-pseudo-element=\"Thu\"\n        />\n      </div>\n      <div\n        class=\"c2 c3 c6\"\n        role=\"button\"\n        style=\"transition-duration: 0.25s; opacity: 1;\"\n        tabindex=\"0\"\n      >\n        <div\n          class=\"c5\"\n          data-text-as-pseudo-element=\"Fri\"\n        />\n      </div>\n      <div\n        class=\"c2 c3 c6\"\n        role=\"button\"\n        tabindex=\"0\"\n      >\n        <div\n          class=\"c5\"\n          data-text-as-pseudo-element=\"Sat\"\n        />\n      </div>\n      <div\n        class=\"c2 c3 c7\"\n        role=\"button\"\n        tabindex=\"0\"\n      >\n        <div\n          class=\"c5\"\n          data-text-as-pseudo-element=\"Sun\"\n        />\n      </div>\n    </div>\n  ");
});