function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { if (typeof Symbol === "undefined" || !(Symbol.iterator in Object(arr))) return; var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

import DateTimePicker from '@react-native-community/datetimepicker';
import moment from 'moment';
import React from 'react';
import PickerNative from '../../../internals/Picker.native';
import { DEFAULT_TIME_DISPLAY_FORMAT, DEFAULT_TIME_VALUE_FORMAT } from '../constants';
import { PlaceholderText, ValueText } from '../StyledComponents';
import { jsx as _jsx } from "react/jsx-runtime";
import { jsxs as _jsxs } from "react/jsx-runtime";

function TimePicker(_ref) {
  var _ref$clearable = _ref.clearable,
      clearable = _ref$clearable === void 0 ? true : _ref$clearable,
      _ref$clearValueText = _ref.clearValueText,
      clearValueText = _ref$clearValueText === void 0 ? 'Clear value' : _ref$clearValueText,
      _ref$displayFormat = _ref.displayFormat,
      displayFormat = _ref$displayFormat === void 0 ? DEFAULT_TIME_DISPLAY_FORMAT : _ref$displayFormat,
      _ref$readOnly = _ref.readOnly,
      readOnly = _ref$readOnly === void 0 ? false : _ref$readOnly,
      _ref$valueFormat = _ref.valueFormat,
      valueFormat = _ref$valueFormat === void 0 ? DEFAULT_TIME_VALUE_FORMAT : _ref$valueFormat,
      accessibilityLabel = _ref.accessibilityLabel,
      autoFocus = _ref.autoFocus,
      _onBlur = _ref.onBlur,
      _onFocus = _ref.onFocus,
      onValueChange = _ref.onValueChange,
      renderDropdownIcon = _ref.renderDropdownIcon,
      style = _ref.style,
      testID = _ref.testID,
      value = _ref.value,
      placeholder = _ref.placeholder;

  var _React$useState = React.useState(false),
      _React$useState2 = _slicedToArray(_React$useState, 2),
      showPicker = _React$useState2[0],
      setShowPicker = _React$useState2[1];

  var pickerRef = React.useRef();
  var styleProps = {
    style: style
  };

  var _time;

  var _timeStr = '';

  if (value) {
    _time = moment(value, valueFormat);
    _timeStr = _time.format(displayFormat);
  } else {
    _time = moment();
    _timeStr = '';
  }

  function renderValue() {
    if (!_timeStr) {
      return /*#__PURE__*/_jsx(PlaceholderText, {
        children: placeholder
      });
    }

    return /*#__PURE__*/_jsx(ValueText, {
      children: _timeStr
    });
  }

  function blur() {
    pickerRef.current && pickerRef.current.blur();
  }

  function focus() {
    pickerRef.current && pickerRef.current.focus();
  }

  var props = {
    accessibilityLabel: accessibilityLabel,
    autoFocus: autoFocus,
    clearable: clearable,
    clearValueText: clearValueText,
    onBlur: function onBlur() {
      setShowPicker(false);
      _onBlur && _onBlur();
    },
    onFocus: function onFocus() {
      setShowPicker(true);
      _onFocus && _onFocus();
    },
    readOnly: readOnly,
    ref: pickerRef,
    renderDropdownIcon: renderDropdownIcon,
    renderValue: renderValue,
    testID: testID
  };
  return /*#__PURE__*/_jsxs(React.Fragment, {
    children: [/*#__PURE__*/_jsx(PickerNative, _objectSpread(_objectSpread({}, styleProps), props)), showPicker && /*#__PURE__*/_jsx(DateTimePicker, {
      mode: "time",
      value: _time.toDate(),
      onChange: function onChange(event, newTime) {
        blur();

        if (newTime && onValueChange) {
          onValueChange(moment(newTime).format(valueFormat));
        }
      }
    })]
  });
}

export default TimePicker;