function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (typeof call === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

import moment from 'moment';
import * as React from 'react';
import PickerWeb from '../../../internals/Picker.web';
import { DEFAULT_TIME_DISPLAY_FORMAT, DEFAULT_TIME_VALUE_FORMAT } from '../constants';
import { PlaceholderText, ValueText } from './StyledComponents';
import WheelPicker from './WheelPicker';
import { jsx as _jsx } from "react/jsx-runtime";

var TimePicker = /*#__PURE__*/function (_React$Component) {
  _inherits(TimePicker, _React$Component);

  var _super = _createSuper(TimePicker);

  function TimePicker() {
    var _this;

    _classCallCheck(this, TimePicker);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _super.call.apply(_super, [this].concat(args));

    _this._capturePickerRef = function (ref) {
      _this._picker = ref;
    };

    _this._renderPopover = function () {
      return /*#__PURE__*/_jsx(WheelPicker, {
        displayRight: _this.props.displayRight,
        initialTime: _this._time,
        onSelect: _this._selectTime
      });
    };

    _this._renderValue = function () {
      var placeholder = _this.props.placeholder;

      if (!_this._timeStr) {
        return /*#__PURE__*/_jsx(PlaceholderText, {
          children: placeholder
        });
      }

      return /*#__PURE__*/_jsx(ValueText, {
        children: _this._timeStr
      });
    };

    _this._selectTime = function (time) {
      var _this$props = _this.props,
          onValueChange = _this$props.onValueChange,
          valueFormat = _this$props.valueFormat;

      _this.blur();

      onValueChange && onValueChange(time.format(valueFormat));
    };

    return _this;
  }

  _createClass(TimePicker, [{
    key: "blur",
    value: function blur() {
      var picker = this._picker;
      picker && setTimeout(function () {
        return picker.blur();
      }, 10); // the timeout is to counter some focus event that occurs after setting the value
      // not an elegant fix, will need to fix this properly, Hernus
    }
  }, {
    key: "focus",
    value: function focus() {
      this._picker && this._picker.focus();
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props2 = this.props,
          accessibilityLabel = _this$props2.accessibilityLabel,
          autoFocus = _this$props2.autoFocus,
          className = _this$props2.className,
          clearable = _this$props2.clearable,
          clearValueText = _this$props2.clearValueText,
          displayFormat = _this$props2.displayFormat,
          modal = _this$props2.modal,
          onBlur = _this$props2.onBlur,
          onFocus = _this$props2.onFocus,
          onValueChange = _this$props2.onValueChange,
          readOnly = _this$props2.readOnly,
          renderDropdownIcon = _this$props2.renderDropdownIcon,
          style = _this$props2.style,
          testID = _this$props2.testID,
          value = _this$props2.value,
          valueFormat = _this$props2.valueFormat;
      var styleProps = {
        className: className,
        style: style
      };

      if (value) {
        this._time = moment(value, valueFormat);
        this._timeStr = this._time.format(displayFormat);
      } else {
        this._time = moment();
        this._timeStr = '';
      }

      var props = {
        accessibilityLabel: accessibilityLabel,
        autoFocus: autoFocus,
        clearable: clearable,
        clearValueText: clearValueText,
        modal: modal,
        onBlur: onBlur,
        onFocus: onFocus,
        onValueChange: onValueChange,
        readOnly: readOnly,
        ref: this._capturePickerRef,
        renderDropdownIcon: renderDropdownIcon,
        renderPopover: this._renderPopover,
        renderValue: this._renderValue,
        testID: testID
      };
      return /*#__PURE__*/_jsx(PickerWeb, _objectSpread(_objectSpread({}, styleProps), props));
    }
  }]);

  return TimePicker;
}(React.Component);

TimePicker.defaultProps = {
  clearable: true,
  clearValueText: 'Clear value',
  displayFormat: DEFAULT_TIME_DISPLAY_FORMAT,
  readOnly: false,
  valueFormat: DEFAULT_TIME_VALUE_FORMAT,
  displayRight: undefined
};
TimePicker.displayName = 'TimePicker';
export default TimePicker;