function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

import React from 'react';
import warning from 'warning';
import { useFieldState } from '../../../primitives/Form';
import OldSelect from '../../OldSelect';
import Select from '../../Select';
import { InputFieldWrapper } from '../wrappers';
import { jsx as _jsx } from "react/jsx-runtime";

function SelectField(props, ref) {
  var passedFieldState = props.fieldState,
      label = props.label,
      modal = props.modal,
      options = props.options,
      required = props.required,
      reserveErrorSpace = props.reserveErrorSpace,
      testID = props.testID,
      validate = props.validate,
      rest = _objectWithoutProperties(props, ["fieldState", "label", "modal", "options", "required", "reserveErrorSpace", "testID", "validate"]);

  warning(!(validate && !reserveErrorSpace), "Prop \"reserveErrorSpace\" is set to false while \"validate\" is supplied. You will not see the validation error.");
  var SelectComponent = modal ? Select : OldSelect;
  var inputRef = React.useRef(null);
  var focusInput = React.useCallback(function () {
    return inputRef.current && inputRef.current.focus();
  }, []);
  var blurInput = React.useCallback(function () {
    return inputRef.current && inputRef.current.blur();
  }, []);
  React.useImperativeHandle(ref, function () {
    return {
      focus: focusInput,
      blur: blurInput
    };
  });

  var _useFieldState = useFieldState(props),
      fieldState = _useFieldState.fieldState,
      onBlur = _useFieldState.onBlur,
      onFocus = _useFieldState.onFocus,
      onValueChange = _useFieldState.onValueChange;

  return /*#__PURE__*/_jsx(InputFieldWrapper, {
    fieldState: fieldState,
    focusInput: focusInput,
    label: label,
    onValueChange: onValueChange,
    required: required,
    reserveErrorSpace: reserveErrorSpace,
    testID: testID,
    children: /*#__PURE__*/_jsx(SelectComponent, _objectSpread(_objectSpread({}, rest), {}, {
      ref: inputRef,
      onBlur: onBlur,
      onFocus: onFocus,
      onValueChange: onValueChange,
      options: options,
      value: fieldState.value
    }))
  });
}

var ForwardRefSelectField = /*#__PURE__*/React.forwardRef(SelectField); // Cast to NamedExoticComponent to remove `propTypes` which causes problems when
// type checking.

export default ForwardRefSelectField;