import React from 'react';
import Paragraph from '../../Paragraph';
import FieldContainer from '../FieldContainer';
import FieldLabel from '../FieldLabel';
import { FieldInputContainer, FieldLabelAsterisk, FieldLabelContainer } from '../StyledComponents';
import TouchToFocusArea from '../TouchToFocusArea';
import { jsx as _jsx } from "react/jsx-runtime";
import { jsxs as _jsxs } from "react/jsx-runtime";

function InputFieldWrapper(props) {
  var children = props.children,
      className = props.className,
      fieldState = props.fieldState,
      focusInput = props.focusInput,
      label = props.label,
      required = props.required,
      style = props.style,
      testID = props.testID,
      _props$reserveErrorSp = props.reserveErrorSpace,
      reserveErrorSpace = _props$reserveErrorSp === void 0 ? true : _props$reserveErrorSp;
  return /*#__PURE__*/_jsxs(FieldContainer, {
    className: className,
    style: style,
    testID: testID,
    children: [/*#__PURE__*/_jsxs(TouchToFocusArea, {
      onPress: focusInput,
      testID: testID && "".concat(testID, "-control"),
      children: [label && /*#__PURE__*/_jsxs(FieldLabelContainer, {
        children: [/*#__PURE__*/_jsx(FieldLabel, {
          testID: testID && "".concat(testID, "-label"),
          children: label
        }), required && /*#__PURE__*/_jsx(FieldLabelAsterisk, {})]
      }), /*#__PURE__*/_jsx(FieldInputContainer, {
        $hasError: fieldState.touched && fieldState.error,
        children: children
      })]
    }), reserveErrorSpace && /*#__PURE__*/_jsx(Paragraph, {
      type: "error",
      children: fieldState.touched ? fieldState.error : ''
    })]
  });
}

export default InputFieldWrapper;