import React from 'react';
import styled from 'styled-components';
import TouchableView from '../../../primitives/TouchableView';
import View from '../../../primitives/View';
import { contrastingColor } from '../utils';
import { jsx as _jsx } from "react/jsx-runtime";

var Swatch = function Swatch(_ref) {
  var color = _ref.color,
      onClick = _ref.onClick,
      _ref$title = _ref.title,
      title = _ref$title === void 0 ? color.hex : _ref$title,
      _ref$active = _ref.active,
      active = _ref$active === void 0 ? false : _ref$active;

  var handleClick = function handleClick(e) {
    return onClick === null || onClick === void 0 ? void 0 : onClick(color, e);
  };

  var swatchStyle = {
    backgroundColor: color.hex,
    outline: 'none',
    width: 28,
    height: 28,
    marginRight: 4,
    marginBottom: 4
  };
  return /*#__PURE__*/_jsx(TouchableView, {
    style: swatchStyle,
    onPress: handleClick,
    title: title,
    children: active ? /*#__PURE__*/_jsx(Dot, {
      $color: contrastingColor(color)
    }) : null
  });
};

export default Swatch;
var Dot = styled(View).withConfig({
  displayName: "Swatch__Dot",
  componentId: "llcyqw-0"
})(["position:absolute;background-color:", ";border-radius:10px;top:8px;left:8px;bottom:8px;right:8px;"], function (_ref2) {
  var $color = _ref2.$color;
  return "".concat($color);
});