import React from 'react';
import styled from 'styled-components';
import View from '../../../primitives/View';
import Swatch from './Swatch';
import { jsx as _jsx } from "react/jsx-runtime";

var SwatchCollection = function SwatchCollection(_ref) {
  var colors = _ref.colors,
      onClick = _ref.onClick,
      activeColor = _ref.activeColor,
      className = _ref.className;
  return /*#__PURE__*/_jsx(CollectionContainer, {
    className: className,
    children: colors.map(function (color) {
      var active = color.r === (activeColor === null || activeColor === void 0 ? void 0 : activeColor.r) && color.g === (activeColor === null || activeColor === void 0 ? void 0 : activeColor.g) && color.b === (activeColor === null || activeColor === void 0 ? void 0 : activeColor.b) && color.a === (activeColor === null || activeColor === void 0 ? void 0 : activeColor.a);
      return /*#__PURE__*/_jsx(Swatch, {
        onClick: onClick,
        color: color,
        active: active
      }, color.hex);
    })
  });
};

var CollectionContainer = styled(View).withConfig({
  displayName: "SwatchCollection__CollectionContainer",
  componentId: "sc-1pe2xvv-0"
})(["width:100%;flex-wrap:wrap;display:flex;flex-direction:row;"]);
export default SwatchCollection;