import React from 'react';
import styled from 'styled-components';
import { contrastingColor } from '../utils';
import { jsx as _jsx } from "react/jsx-runtime";
var ENTER = 13;

var Swatch = function Swatch(_ref) {
  var color = _ref.color,
      onClick = _ref.onClick,
      _ref$title = _ref.title,
      title = _ref$title === void 0 ? color.hex : _ref$title,
      _ref$active = _ref.active,
      active = _ref$active === void 0 ? false : _ref$active;

  var handleClick = function handleClick(e) {
    return onClick === null || onClick === void 0 ? void 0 : onClick(color, e);
  };

  var handleKeyDown = function handleKeyDown(e) {
    return e.keyCode === ENTER && (onClick === null || onClick === void 0 ? void 0 : onClick(color, e));
  };

  return /*#__PURE__*/_jsx(SwatchControl, {
    onClick: handleClick,
    title: title,
    tabIndex: 0,
    onKeyDown: handleKeyDown,
    $color: color.hex,
    children: active ? /*#__PURE__*/_jsx(Dot, {
      $color: contrastingColor(color)
    }) : null
  });
};

export default Swatch;
var Dot = styled.div.withConfig({
  displayName: "Swatch__Dot",
  componentId: "sc-1os8bg0-0"
})(["position:absolute;background-color:", ";border-radius:50%;top:8px;left:8px;bottom:8px;right:8px;"], function (_ref2) {
  var $color = _ref2.$color;
  return "".concat($color);
});
var SwatchControl = styled.div.withConfig({
  displayName: "Swatch__SwatchControl",
  componentId: "sc-1os8bg0-1"
})(["", " outline:none;width:24px;height:24px;float:left;margin-right:4px;margin-bottom:4px;position:relative;cursor:pointer;box-shadow:inset 2px 2px 1px -1px rgba(0,0,0,0.2);"], function (_ref3) {
  var $color = _ref3.$color;
  return $color ? "background-color: ".concat($color, ";") : "";
});