function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { if (typeof Symbol === "undefined" || !(Symbol.iterator in Object(arr))) return; var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

import * as React from 'react';
import styled from 'styled-components';
import TextInput from '../../../primitives/TextInput';
import TouchableView from '../../../primitives/TouchableView';
import View from '../../../primitives/View';
import { DefaultColors } from '../types';
import { RGBAToHexA, hexAToRGBA } from '../utils';
import SwatchCollection from './SwatchCollection';
import { jsx as _jsx } from "react/jsx-runtime";
import { jsxs as _jsxs } from "react/jsx-runtime";

var ColorPicker = function ColorPicker(_ref) {
  var _color$r$toString, _color$r, _color$g$toString, _color$g, _color$b$toString, _color$b, _color$a$toString, _color$a;

  var colors = _ref.colors,
      color = _ref.color,
      onChange = _ref.onChange;

  var _React$useState = React.useState(color !== null && color !== void 0 ? color : {}),
      _React$useState2 = _slicedToArray(_React$useState, 2),
      _color = _React$useState2[0],
      setColor = _React$useState2[1];

  var _React$useState3 = React.useState(color === null || color === void 0 ? void 0 : color.hex),
      _React$useState4 = _slicedToArray(_React$useState3, 2),
      hex = _React$useState4[0],
      setHex = _React$useState4[1];

  React.useEffect(function () {
    setHex(_color.hex);
    onChange === null || onChange === void 0 ? void 0 : onChange(_color);
  }, [onChange, _color]);
  colors = colors || DefaultColors;
  var convertedColors = React.useMemo(function () {
    return colors.map(function (c) {
      return hexAToRGBA(c);
    }).filter(Boolean);
  }, [colors]);

  var handleSwatchClick = function handleSwatchClick(value, _event) {
    return setColor(value);
  };

  var handleColorChange = function handleColorChange(value) {
    var getComponent = function getComponent(component) {
      var _value$component;

      return Math.max(0, Math.min(255, value.hasOwnProperty(component) ? (_value$component = value[component]) !== null && _value$component !== void 0 ? _value$component : 0 : _color[component] || 0));
    };

    if (value.hasOwnProperty('r') || value.hasOwnProperty('g') || value.hasOwnProperty('b') || value.hasOwnProperty('a')) {
      var newColor = RGBAToHexA(getComponent('r'), getComponent('g'), getComponent('b'), getComponent('a'));
      newColor && setColor(newColor);
    } else if (value.hex) {
      var _value$hex;

      value.hex = (_value$hex = value.hex) === null || _value$hex === void 0 ? void 0 : _value$hex.replace(/[^#A-Fa-f0-9]/g, '');

      var _newColor = hexAToRGBA(value.hex);

      _newColor && setColor(_newColor);
      setHex(value.hex);
    }
  };

  return /*#__PURE__*/_jsx(Container, {
    children: /*#__PURE__*/_jsxs(InputContainer, {
      children: [/*#__PURE__*/_jsx(SwatchCollection, {
        colors: convertedColors,
        onClick: handleSwatchClick,
        activeColor: color
      }), /*#__PURE__*/_jsx(TransparentSwatch, {
        onPress: function onPress() {
          return handleColorChange({
            hex: '#0000'
          });
        },
        children: "transparent"
      }), /*#__PURE__*/_jsxs(Row, {
        children: [/*#__PURE__*/_jsxs(ColorInputContainer, {
          children: [/*#__PURE__*/_jsx("span", {
            children: "Hex"
          }), /*#__PURE__*/_jsx("br", {}), /*#__PURE__*/_jsx(HexInput, {
            maxLength: 9,
            value: hex,
            onValueChange: function onValueChange(value) {
              handleColorChange({
                hex: value
              });
            }
          })]
        }), /*#__PURE__*/_jsxs(Row, {
          children: [/*#__PURE__*/_jsxs(ColorInputContainer, {
            children: [/*#__PURE__*/_jsx("span", {
              children: "R"
            }), /*#__PURE__*/_jsx("br", {}), /*#__PURE__*/_jsx(ColorInput, {
              maxLength: 3,
              value: (_color$r$toString = (_color$r = color.r) === null || _color$r === void 0 ? void 0 : _color$r.toString()) !== null && _color$r$toString !== void 0 ? _color$r$toString : '0',
              onValueChange: function onValueChange(value) {
                handleColorChange({
                  r: +value
                });
              },
              type: "number"
            })]
          }), /*#__PURE__*/_jsxs(ColorInputContainer, {
            children: [/*#__PURE__*/_jsx("span", {
              children: "G"
            }), /*#__PURE__*/_jsx("br", {}), /*#__PURE__*/_jsx(ColorInput, {
              maxLength: 3,
              value: (_color$g$toString = (_color$g = color.g) === null || _color$g === void 0 ? void 0 : _color$g.toString()) !== null && _color$g$toString !== void 0 ? _color$g$toString : '0',
              onValueChange: function onValueChange(value) {
                handleColorChange({
                  g: +value
                });
              },
              type: "number"
            })]
          }), /*#__PURE__*/_jsxs(ColorInputContainer, {
            children: [/*#__PURE__*/_jsx("span", {
              children: "B"
            }), /*#__PURE__*/_jsx("br", {}), /*#__PURE__*/_jsx(ColorInput, {
              maxLength: 3,
              value: (_color$b$toString = (_color$b = color.b) === null || _color$b === void 0 ? void 0 : _color$b.toString()) !== null && _color$b$toString !== void 0 ? _color$b$toString : '0',
              onValueChange: function onValueChange(value) {
                handleColorChange({
                  b: +value
                });
              },
              type: "number"
            })]
          }), /*#__PURE__*/_jsxs(ColorInputContainer, {
            children: [/*#__PURE__*/_jsx("span", {
              children: "A"
            }), /*#__PURE__*/_jsx("br", {}), /*#__PURE__*/_jsx(ColorInput, {
              maxLength: 3,
              value: (_color$a$toString = (_color$a = color.a) === null || _color$a === void 0 ? void 0 : _color$a.toString()) !== null && _color$a$toString !== void 0 ? _color$a$toString : '255',
              onValueChange: function onValueChange(value) {
                handleColorChange({
                  a: +value
                });
              },
              type: "number"
            })]
          })]
        })]
      })]
    })
  });
};

var InputContainer = styled(View).withConfig({
  displayName: "ColorPickerweb__InputContainer",
  componentId: "sc-1sg9uj4-0"
})(["display:flex;flex-direction:column;"]);
var Row = styled(View).withConfig({
  displayName: "ColorPickerweb__Row",
  componentId: "sc-1sg9uj4-1"
})(["display:flex;flex-direction:row;"]);
var Container = styled(View).withConfig({
  displayName: "ColorPickerweb__Container",
  componentId: "sc-1sg9uj4-2"
})(["display:flex;flex-direction:row;padding:8px 8px 4px 8px;"]);
var ColorInput = styled(TextInput).withConfig({
  displayName: "ColorPickerweb__ColorInput",
  componentId: "sc-1sg9uj4-3"
})(["width:30px;"]);
var TransparentSwatch = styled(TouchableView).withConfig({
  displayName: "ColorPickerweb__TransparentSwatch",
  componentId: "sc-1sg9uj4-4"
})(["width:100%;font-size:12px;color:gray;height:24px;cursor:pointer;box-shadow:inset 2px 2px 1px -1px rgba(0,0,0,0.2);line-height:24px;align-items:center;background-position:0px 0px,10px 10px;background-size:20px 20px;background-image:linear-gradient( 45deg,#eee 25%,transparent 25%,transparent 75%,#eee 75%,#eee 100% ),linear-gradient(45deg,#eee 25%,white 25%,white 75%,#eee 75%,#eee 100%);"]);
var HexInput = styled(TextInput).withConfig({
  displayName: "ColorPickerweb__HexInput",
  componentId: "sc-1sg9uj4-5"
})(["width:80px;"]);
var ColorInputContainer = styled.span.withConfig({
  displayName: "ColorPickerweb__ColorInputContainer",
  componentId: "sc-1sg9uj4-6"
})(["& span{font-size:10px;color:gray;}"]);
export default ColorPicker;