function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (typeof call === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

import * as React from 'react';
import { Animated, Modal, StyleSheet, TouchableHighlight } from 'react-native';
import { jsx as _jsx } from "react/jsx-runtime";

var Popup = /*#__PURE__*/function (_React$Component) {
  _inherits(Popup, _React$Component);

  var _super = _createSuper(Popup);

  function Popup() {
    var _this;

    _classCallCheck(this, Popup);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _super.call.apply(_super, [this].concat(args));
    _this.state = {
      animatedHeight: new Animated.Value(0),
      showModal: !!_this.props.show
    };

    _this._setModalVisible = function (visible) {
      _this.setState({
        showModal: visible
      }); // slide animation


      if (visible) {
        Animated.timing(_this.state.animatedHeight, {
          toValue: _this.props.height,
          duration: 300
        }).start();
      } else {
        _this.setState({
          animatedHeight: new Animated.Value(0)
        });
      }
    };

    return _this;
  }

  _createClass(Popup, [{
    key: "UNSAFE_componentWillReceiveProps",
    value: function UNSAFE_componentWillReceiveProps(nextProps) {
      if (nextProps.show !== this.props.show) {
        this._setModalVisible(!!nextProps.show);
      }
    }
  }, {
    key: "render",
    value: function render() {
      return /*#__PURE__*/_jsx(Modal, {
        onRequestClose: this.props.onRequestClose,
        transparent: true,
        visible: this.state.showModal,
        children: /*#__PURE__*/_jsx(TouchableHighlight, {
          activeOpacity: 1,
          onPress: this.props.onRequestClose,
          style: styles.modalBackdrop,
          underlayColor: "#00000075",
          children: /*#__PURE__*/_jsx(TouchableHighlight, {
            underlayColor: "#fff",
            testID: this.props.testID,
            children: /*#__PURE__*/_jsx(Animated.View, {
              style: [styles.container, {
                height: this.state.animatedHeight
              }],
              children: this.props.children
            })
          })
        })
      });
    }
  }]);

  return Popup;
}(React.Component);

Popup.defaultProps = {
  height: 259,
  show: false
};
var styles = StyleSheet.create({
  modalBackdrop: {
    backgroundColor: '#00000075',
    flex: 1,
    justifyContent: 'flex-end'
  },
  container: {
    backgroundColor: '#fff',
    height: 0,
    overflow: 'hidden'
  }
});
export default Popup;