function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (typeof call === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

import * as React from 'react';
import { Platform, TouchableOpacity, View } from 'react-native';
import Popup from './Popup';
import { Container, Control, IconText, IconTextContainer, OKText, PopupContentContainer, PopupText, PopupTopBar, ValueContainer } from './StyledComponents';
import { jsx as _jsx } from "react/jsx-runtime";
import { jsxs as _jsxs } from "react/jsx-runtime";

var PickerNative = /*#__PURE__*/function (_React$Component) {
  _inherits(PickerNative, _React$Component);

  var _super = _createSuper(PickerNative);

  function PickerNative() {
    var _this;

    _classCallCheck(this, PickerNative);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _super.call.apply(_super, [this].concat(args));

    _this.blur = function () {
      var onBlur = _this.props.onBlur;
      onBlur && onBlur();

      _this.setState({
        isOpen: false
      });
    };

    _this.focus = function () {
      var _this$props = _this.props,
          onFocus = _this$props.onFocus,
          readOnly = _this$props.readOnly;
      if (readOnly) return;
      onFocus && onFocus();

      _this.setState({
        isOpen: true
      });
    };

    _this.state = {
      isOpen: false
    };

    _this._onControlPress = function (event) {
      if (_this.props.readOnly) {
        return;
      } // prevent default event handlers


      event.stopPropagation();
      event.preventDefault();

      _this.focus();
    };

    _this._renderClear = function () {
      var _this$props2 = _this.props,
          clearable = _this$props2.clearable,
          clearValueText = _this$props2.clearValueText,
          onClear = _this$props2.onClear,
          readOnly = _this$props2.readOnly;

      if (!clearable || readOnly) {
        return null;
      }

      return /*#__PURE__*/_jsx(TouchableOpacity, {
        onPress: onClear,
        children: /*#__PURE__*/_jsx(PopupText, {
          children: clearValueText
        })
      });
    };

    _this._renderConfirmButton = function () {
      return /*#__PURE__*/_jsx(TouchableOpacity, {
        onPress: _this.props.onConfirm,
        children: /*#__PURE__*/_jsx(OKText, {
          children: "Done"
        })
      });
    };

    _this._renderDropdownIcon = function () {
      var renderDropdownIcon = _this.props.renderDropdownIcon;
      return renderDropdownIcon ? renderDropdownIcon(_this.state) : /*#__PURE__*/_jsx(IconTextContainer, {
        children: /*#__PURE__*/_jsx(IconText, {
          children: "\u2304"
        })
      });
    };

    _this._renderPopup = function () {
      var renderPopup = _this.props.renderPopup;
      return /*#__PURE__*/_jsx(Popup, {
        onRequestClose: _this.blur,
        show: _this.state.isOpen,
        children: /*#__PURE__*/_jsxs(PopupContentContainer, {
          children: [/*#__PURE__*/_jsxs(PopupTopBar, {
            children: [/*#__PURE__*/_jsx(TouchableOpacity, {
              onPress: _this.blur,
              children: /*#__PURE__*/_jsx(PopupText, {
                children: "Cancel"
              })
            }), /*#__PURE__*/_jsx(View, {
              style: {
                flex: 1
              }
            }), _this._renderClear(), _this._renderConfirmButton()]
          }), renderPopup && renderPopup()]
        })
      });
    };

    _this._renderValue = function () {
      var renderValue = _this.props.renderValue;
      return /*#__PURE__*/_jsx(ValueContainer, {
        children: renderValue && renderValue(_this.state)
      });
    };

    return _this;
  }

  _createClass(PickerNative, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      if (this.props.autoFocus) {
        this.focus();
      }
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props3 = this.props,
          accessibilityLabel = _this$props3.accessibilityLabel,
          readOnly = _this$props3.readOnly,
          style = _this$props3.style,
          testID = _this$props3.testID;
      var styleProps = {
        style: style
      };
      return /*#__PURE__*/_jsxs(Container, _objectSpread(_objectSpread({}, styleProps), {}, {
        accessibilityLabel: accessibilityLabel,
        testID: testID,
        children: [/*#__PURE__*/_jsxs(Control, {
          onPress: this._onControlPress,
          children: [this._renderValue(), this._renderDropdownIcon()]
        }), Platform.OS === 'ios' && !readOnly && this._renderPopup()]
      }));
    }
  }]);

  return PickerNative;
}(React.Component);

PickerNative.defaultProps = {
  autoFocus: false,
  clearable: true,
  clearValueText: 'Clear value',
  readOnly: false
};
export default PickerNative;