function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

// Implementation based on https://github.com/necolas/react-native-web/blob/0.15.0/packages/react-native-web/src/exports/View/index.js
import React, { useRef } from 'react';
import useElementLayout from 'react-native-web/dist/cjs/modules/useElementLayout';
import useMergeRefs from 'react-native-web/dist/cjs/modules/useMergeRefs';
import useResponderEvents from 'react-native-web/dist/cjs/modules/useResponderEvents';
import styled from 'styled-components';
import { flex } from './styles';
export function createViewBase(component) {
  var ViewBase = /*#__PURE__*/React.forwardRef(function ViewBase(_ref, forwardedRef) {
    var accessibilityLabel = _ref.accessibilityLabel,
        children = _ref.children,
        onLayout = _ref.onLayout,
        onMoveShouldSetResponder = _ref.onMoveShouldSetResponder,
        onMoveShouldSetResponderCapture = _ref.onMoveShouldSetResponderCapture,
        onResponderEnd = _ref.onResponderEnd,
        onResponderGrant = _ref.onResponderGrant,
        onResponderMove = _ref.onResponderMove,
        onResponderReject = _ref.onResponderReject,
        onResponderRelease = _ref.onResponderRelease,
        onResponderStart = _ref.onResponderStart,
        onResponderTerminate = _ref.onResponderTerminate,
        onResponderTerminationRequest = _ref.onResponderTerminationRequest,
        onScrollShouldSetResponder = _ref.onScrollShouldSetResponder,
        onScrollShouldSetResponderCapture = _ref.onScrollShouldSetResponderCapture,
        onSelectionChangeShouldSetResponder = _ref.onSelectionChangeShouldSetResponder,
        onSelectionChangeShouldSetResponderCapture = _ref.onSelectionChangeShouldSetResponderCapture,
        onStartShouldSetResponder = _ref.onStartShouldSetResponder,
        onStartShouldSetResponderCapture = _ref.onStartShouldSetResponderCapture,
        testID = _ref.testID,
        rest = _objectWithoutProperties(_ref, ["accessibilityLabel", "children", "onLayout", "onMoveShouldSetResponder", "onMoveShouldSetResponderCapture", "onResponderEnd", "onResponderGrant", "onResponderMove", "onResponderReject", "onResponderRelease", "onResponderStart", "onResponderTerminate", "onResponderTerminationRequest", "onScrollShouldSetResponder", "onScrollShouldSetResponderCapture", "onSelectionChangeShouldSetResponder", "onSelectionChangeShouldSetResponderCapture", "onStartShouldSetResponder", "onStartShouldSetResponderCapture", "testID"]);

    var hostRef = useRef(null);
    useElementLayout(hostRef, onLayout);
    useResponderEvents(hostRef, {
      onMoveShouldSetResponder: onMoveShouldSetResponder,
      onMoveShouldSetResponderCapture: onMoveShouldSetResponderCapture,
      onResponderEnd: onResponderEnd,
      onResponderGrant: onResponderGrant,
      onResponderMove: onResponderMove,
      onResponderReject: onResponderReject,
      onResponderRelease: onResponderRelease,
      onResponderStart: onResponderStart,
      onResponderTerminate: onResponderTerminate,
      onResponderTerminationRequest: onResponderTerminationRequest,
      onScrollShouldSetResponder: onScrollShouldSetResponder,
      onScrollShouldSetResponderCapture: onScrollShouldSetResponderCapture,
      onSelectionChangeShouldSetResponder: onSelectionChangeShouldSetResponder,
      onSelectionChangeShouldSetResponderCapture: onSelectionChangeShouldSetResponderCapture,
      onStartShouldSetResponder: onStartShouldSetResponder,
      onStartShouldSetResponderCapture: onStartShouldSetResponderCapture
    });
    var setRef = useMergeRefs(hostRef, forwardedRef);

    var supportedProps = _objectSpread(_objectSpread({}, rest), {}, {
      'aria-label': accessibilityLabel,
      'data-testid': testID,
      ref: setRef
    });

    return /*#__PURE__*/React.createElement(component, supportedProps, children);
  });
  var StyledViewBase = styled(ViewBase).withConfig({
    displayName: "ViewBase__StyledViewBase",
    componentId: "sc-66ckm-0"
  })(["", ";"], flex);
  return StyledViewBase;
}
export var DivViewBase = createViewBase('div');