import debounce from 'lodash/debounce';
var registry = new Map();

var triggerAll = function triggerAll() {
  registry.forEach(function (instance) {
    instance._onLayout();
  });
};

window.addEventListener('resize', debounce(triggerAll, 16), false);
export var register = function register(id, instance) {
  registry.set(id, instance);
};
export var unregister = function unregister(id) {
  registry["delete"](id);
};