function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

import * as React from 'react';
import styled, { css, keyframes } from 'styled-components';
import { DivViewBase } from '../../internals/web/ViewBase';
import { jsx as _jsx } from "react/jsx-runtime";
var sizeMap = {
  small: 20,
  large: 36
};
export default function ActivityIndicator(_ref) {
  var _ref$animating = _ref.animating,
      animating = _ref$animating === void 0 ? true : _ref$animating,
      _ref$color = _ref.color,
      color = _ref$color === void 0 ? '#999' : _ref$color,
      _ref$size = _ref.size,
      size = _ref$size === void 0 ? 'small' : _ref$size,
      style = _ref.style,
      className = _ref.className,
      testID = _ref.testID;
  var containerStyleProps = {
    className: className,
    style: style
  };
  var spinnerContainerStyleProps = {
    $size: sizeMap[size]
  };
  var spinnerStyleProps = {
    $color: color
  };
  var containerStyle = {};
  if (!animating) containerStyle.visibility = 'hidden';
  return /*#__PURE__*/_jsx(Container, _objectSpread(_objectSpread({}, containerStyleProps), {}, {
    style: containerStyle,
    testID: testID,
    children: /*#__PURE__*/_jsx(SpinnerContainer, _objectSpread(_objectSpread({}, spinnerContainerStyleProps), {}, {
      children: /*#__PURE__*/_jsx(Svg, {
        height: "100%",
        viewBox: "25 25 50 50",
        width: "100%",
        children: /*#__PURE__*/_jsx(Circle, _objectSpread(_objectSpread({}, spinnerStyleProps), {}, {
          cx: 50,
          cy: 50,
          fill: "none",
          r: 20,
          strokeMiterlimit: 10,
          strokeWidth: 4
        }))
      })
    }))
  }));
}
var Container = styled(DivViewBase).withConfig({
  displayName: "ActivityIndicatorweb__Container",
  componentId: "sc-15erzdi-0"
})(["align-items:center;justify-content:center;"]);
var SpinnerContainer = styled(DivViewBase).withConfig({
  displayName: "ActivityIndicatorweb__SpinnerContainer",
  componentId: "sc-15erzdi-1"
})(["width:", "px;height:", "px;"], function (_ref2) {
  var $size = _ref2.$size;
  return $size;
}, function (_ref3) {
  var $size = _ref3.$size;
  return $size;
});
var spin = keyframes(["100%{transform:rotate(360deg);}"]);
var spinRule = css(["", " 2s infinite linear;"], spin);
var dash = keyframes(["0%{stroke-dasharray:1,200;stroke-dashoffset:0;}50%{stroke-dasharray:89,200;stroke-dashoffset:-35px;}100%{stroke-dasharray:89,200;stroke-dashoffset:-124px;}"]);
var Svg = styled.svg.withConfig({
  displayName: "ActivityIndicatorweb__Svg",
  componentId: "sc-15erzdi-2"
})(["animation:", ";"], spinRule);
var Circle = styled.circle.withConfig({
  displayName: "ActivityIndicatorweb__Circle",
  componentId: "sc-15erzdi-3"
})(["animation:", " 1.5s infinite ease-in-out;stroke:", ";stroke-dasharray:1,200;stroke-dashoffset:0;transform-origin:center;"], dash, function (_ref4) {
  var $color = _ref4.$color;
  return $color;
});