function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

import React from 'react';
import { TouchableOpacity } from 'react-native';
import styled from 'styled-components';
import Icon from '../../../components/Icon';
import { jsx as _jsx } from "react/jsx-runtime";
var Checkbox = /*#__PURE__*/React.forwardRef(function (_ref, ref) {
  var accessibilityLabel = _ref.accessibilityLabel,
      _ref$value = _ref.value,
      value = _ref$value === void 0 ? false : _ref$value,
      _ref$colorChecked = _ref.colorChecked,
      colorChecked = _ref$colorChecked === void 0 ? '#FF7800' : _ref$colorChecked,
      _ref$colorUnchecked = _ref.colorUnchecked,
      colorUnchecked = _ref$colorUnchecked === void 0 ? '#B0ADAB' : _ref$colorUnchecked,
      _ref$size = _ref.size,
      size = _ref$size === void 0 ? 'medium' : _ref$size,
      _ref$disabled = _ref.disabled,
      disabled = _ref$disabled === void 0 ? false : _ref$disabled,
      style = _ref.style,
      onBlur = _ref.onBlur,
      onFocus = _ref.onFocus,
      onValueChange = _ref.onValueChange,
      testID = _ref.testID;
  var containerRef = React.useRef(null);
  React.useImperativeHandle(ref, function () {
    return {
      focus: function focus() {
        var _containerRef$current;

        return (_containerRef$current = containerRef.current) === null || _containerRef$current === void 0 ? void 0 : _containerRef$current.focus();
      },
      blur: function blur() {
        var _containerRef$current2;

        return (_containerRef$current2 = containerRef.current) === null || _containerRef$current2 === void 0 ? void 0 : _containerRef$current2.blur();
      }
    };
  });
  var sizes = {
    small: 16,
    medium: 24,
    large: 32
  };

  var _onBlur = function _onBlur(_event) {
    onBlur === null || onBlur === void 0 ? void 0 : onBlur({
      nativeEvent: {
        value: value
      }
    });
  };

  var _onFocus = function _onFocus(_event) {
    onFocus === null || onFocus === void 0 ? void 0 : onFocus({
      nativeEvent: {
        value: value
      }
    });
  };

  var _toggle = function _toggle() {
    return !disabled && (onValueChange === null || onValueChange === void 0 ? void 0 : onValueChange(!value));
  };

  var containerprops = {
    accessibilityLabel: accessibilityLabel,
    onBlur: _onBlur,
    onPress: _toggle,
    onFocus: _onFocus,
    testID: testID,
    $checked: !!value,
    $disabled: disabled
  };
  var styleProps = {
    style: style
  };
  var icon = value ? 'check-box' : 'check-box-outline-blank';
  var color = disabled ? 'gray' : value ? colorChecked : colorUnchecked;
  return /*#__PURE__*/_jsx(CheckboxContainer, _objectSpread(_objectSpread(_objectSpread({
    ref: containerRef,
    $size: sizes[size]
  }, containerprops), styleProps), {}, {
    children: /*#__PURE__*/_jsx(CheckIcon, {
      name: icon,
      color: color,
      size: sizes[size],
      $disabled: disabled
    })
  }));
});
export default Checkbox;
var CheckboxContainer = styled(TouchableOpacity).attrs(function (_props) {
  return {
    activeOpacity: 1
  };
}).withConfig({
  displayName: "Checkbox__CheckboxContainer",
  componentId: "mffv5g-0"
})(["flex:none;flex-direction:row;border-radius:3px;width:", "px;height:", "px;"], function (_ref2) {
  var $size = _ref2.$size;
  return "".concat($size);
}, function (_ref3) {
  var $size = _ref3.$size;
  return "".concat($size);
});
var CheckIcon = styled(Icon).withConfig({
  displayName: "Checkbox__CheckIcon",
  componentId: "mffv5g-1"
})(["border-radius:3px;", ""], function (_ref4) {
  var $disabled = _ref4.$disabled;
  return $disabled ? "background-color: #00000029;" : "";
});