function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

import React from 'react';
import styled from 'styled-components';
import Icon from '../../../components/Icon';
import { DivViewBase } from '../../../internals/web/ViewBase';
import { jsx as _jsx } from "react/jsx-runtime";
var Checkbox = /*#__PURE__*/React.forwardRef(function (_ref, ref) {
  var accessibilityLabel = _ref.accessibilityLabel,
      className = _ref.className,
      _ref$value = _ref.value,
      value = _ref$value === void 0 ? false : _ref$value,
      _ref$colorChecked = _ref.colorChecked,
      colorChecked = _ref$colorChecked === void 0 ? '#FF7800' : _ref$colorChecked,
      _ref$colorUnchecked = _ref.colorUnchecked,
      colorUnchecked = _ref$colorUnchecked === void 0 ? '#B0ADAB' : _ref$colorUnchecked,
      _ref$size = _ref.size,
      size = _ref$size === void 0 ? 'medium' : _ref$size,
      _ref$disabled = _ref.disabled,
      disabled = _ref$disabled === void 0 ? false : _ref$disabled,
      style = _ref.style,
      onBlur = _ref.onBlur,
      onFocus = _ref.onFocus,
      onValueChange = _ref.onValueChange,
      testID = _ref.testID;
  var containerRef = React.useRef(null);
  React.useImperativeHandle(ref, function () {
    return {
      focus: function focus() {
        var _containerRef$current;

        return (_containerRef$current = containerRef.current) === null || _containerRef$current === void 0 ? void 0 : _containerRef$current.focus();
      },
      blur: function blur() {
        var _containerRef$current2;

        return (_containerRef$current2 = containerRef.current) === null || _containerRef$current2 === void 0 ? void 0 : _containerRef$current2.blur();
      }
    };
  });
  var sizes = {
    small: 16,
    medium: 24,
    large: 32
  };

  var _onBlur = function _onBlur(_event) {
    onBlur === null || onBlur === void 0 ? void 0 : onBlur({
      nativeEvent: {
        value: value
      }
    });
  };

  var _onFocus = function _onFocus(_event) {
    onFocus === null || onFocus === void 0 ? void 0 : onFocus({
      nativeEvent: {
        value: value
      }
    });
  };

  var _onKeyPress = function _onKeyPress(event) {
    var ENTER = 13;
    var SPACE = 32;

    if (event.which === ENTER || event.which === SPACE) {
      event.preventDefault();
      event.stopPropagation();

      _toggle();
    }
  };

  var _toggle = function _toggle() {
    return !disabled && (onValueChange === null || onValueChange === void 0 ? void 0 : onValueChange(!value));
  };

  var containerprops = {
    accessibilityLabel: accessibilityLabel,
    onBlur: _onBlur,
    onClick: _toggle,
    onFocus: _onFocus,
    onKeyPress: _onKeyPress,
    testID: testID,
    $checked: !!value,
    $disabled: disabled
  };
  var styleProps = {
    className: className,
    style: style
  };
  var icon = value ? 'check-box' : 'check-box-outline-blank';
  var color = disabled ? 'gray' : value ? colorChecked : colorUnchecked;
  return /*#__PURE__*/_jsx(Container, _objectSpread(_objectSpread(_objectSpread({
    className: className,
    $size: sizes[size]
  }, containerprops), styleProps), {}, {
    ref: containerRef,
    children: /*#__PURE__*/_jsx(CheckIcon, {
      name: icon,
      color: color,
      size: sizes[size],
      $disabled: disabled
    })
  }));
});
export default Checkbox;
var Container = styled(DivViewBase).attrs(function (_ref2) {
  var $checked = _ref2.$checked;
  return {
    'aria-checked': $checked ? 'true' : 'false',
    role: 'checkbox',
    tabIndex: 0
  };
}).withConfig({
  displayName: "Checkbox__Container",
  componentId: "akuihl-0"
})(["vertical-align:middle;outline:none;display:inline-flex;flex:none;cursor:", ";width:", "px;height:", "px;border-radius:3px;"], function (_ref3) {
  var $disabled = _ref3.$disabled;
  return "".concat(!$disabled ? 'pointer' : 'not-allowed');
}, function (_ref4) {
  var $size = _ref4.$size;
  return "".concat($size);
}, function (_ref5) {
  var $size = _ref5.$size;
  return "".concat($size);
});
var CheckIcon = styled(Icon).withConfig({
  displayName: "Checkbox__CheckIcon",
  componentId: "akuihl-1"
})(["transition:box-shadow 0.2s;border-radius:3px;", " ", ""], function (_ref6) {
  var $disabled = _ref6.$disabled;
  return !$disabled ? "".concat(Container, ":hover &, ").concat(Container, ":focus &  {\n          box-shadow: inset 0 0 0 3px #00000029;\n        },") : "";
}, function (_ref7) {
  var $disabled = _ref7.$disabled;
  return $disabled ? "background-color: #00000029;" : "";
});