import 'jest-styled-components';
import 'react-testing-library/cleanup-after-each';
import React from 'react';
import { render } from 'react-testing-library';
import Checkbox from '..';
import { jsx as _jsx } from "react/jsx-runtime";
test('should render a checkbox with value set to true', function () {
  var _render = render( /*#__PURE__*/_jsx(Checkbox, {
    testID: "test",
    value: true
  })),
      getByTestId = _render.getByTestId;

  expect(getByTestId('test')).toMatchInlineSnapshot("\n    .c3 {\n      box-sizing: border-box;\n      color: #191E26;\n      display: inline;\n      -webkit-box-flex: 0;\n      -webkit-flex-grow: 0;\n      -ms-flex-positive: 0;\n      flex-grow: 0;\n      -webkit-flex-shrink: 0;\n      -ms-flex-negative: 0;\n      flex-shrink: 0;\n      font-family: \"Helvetica Neue\",Helvetica,Arial,sans-serif;\n      font-size: 14px;\n      position: relative;\n      white-space: pre-wrap;\n      word-wrap: break-word;\n      -ms-hyphens: auto;\n      cursor: inherit;\n    }\n\n    .c4 {\n      font-family: Material Icons;\n      font-size: 16px;\n      text-align: center;\n    }\n\n    .c0 {\n      -webkit-align-items: stretch;\n      -webkit-box-align: stretch;\n      -ms-flex-align: stretch;\n      align-items: stretch;\n      border-color: #191E26;\n      border-style: solid;\n      border-width: 0;\n      box-sizing: border-box;\n      display: -webkit-box;\n      display: -webkit-flex;\n      display: -ms-flexbox;\n      display: flex;\n      -webkit-flex-direction: column;\n      -ms-flex-direction: column;\n      flex-direction: column;\n      -webkit-box-flex: 0;\n      -webkit-flex-grow: 0;\n      -ms-flex-positive: 0;\n      flex-grow: 0;\n      -webkit-flex-shrink: 0;\n      -ms-flex-negative: 0;\n      flex-shrink: 0;\n      position: relative;\n      min-height: 0;\n      min-width: 0;\n    }\n\n    .c2 {\n      vertical-align: middle;\n      outline: none;\n      display: -webkit-inline-box;\n      display: -webkit-inline-flex;\n      display: -ms-inline-flexbox;\n      display: inline-flex;\n      -webkit-flex: none;\n      -ms-flex: none;\n      flex: none;\n      cursor: pointer;\n      width: 24px;\n      height: 24px;\n      border-radius: 3px;\n    }\n\n    .c5 {\n      -webkit-flex: none;\n      -ms-flex: none;\n      flex: none;\n      -webkit-align-items: center;\n      -webkit-box-align: center;\n      -ms-flex-align: center;\n      align-items: center;\n      color: #FF7800;\n      height: 24px;\n      line-height: 24px;\n      width: 24px;\n      font-size: 24px;\n      -webkit-transition: box-shadow 0.2s;\n      transition: box-shadow 0.2s;\n      border-radius: 3px;\n    }\n\n    .c1:hover .c5,\n    .c1:focus .c5 {\n      box-shadow: inset 0 0 0 3px #00000029;\n    }\n\n    <div\n      aria-checked=\"true\"\n      class=\"c0 c1 c2\"\n      data-testid=\"test\"\n      role=\"checkbox\"\n      tabindex=\"0\"\n    >\n      <div\n        class=\"c3 c4 sc-AxhCb c5\"\n        data-text-as-pseudo-element=\"\uE834\"\n      />\n    </div>\n  ");
});
test('should render a checkbox with value set to false', function () {
  var _render2 = render( /*#__PURE__*/_jsx(Checkbox, {
    testID: "test",
    value: false
  })),
      getByTestId = _render2.getByTestId;

  expect(getByTestId('test')).toMatchInlineSnapshot("\n    .c3 {\n      box-sizing: border-box;\n      color: #191E26;\n      display: inline;\n      -webkit-box-flex: 0;\n      -webkit-flex-grow: 0;\n      -ms-flex-positive: 0;\n      flex-grow: 0;\n      -webkit-flex-shrink: 0;\n      -ms-flex-negative: 0;\n      flex-shrink: 0;\n      font-family: \"Helvetica Neue\",Helvetica,Arial,sans-serif;\n      font-size: 14px;\n      position: relative;\n      white-space: pre-wrap;\n      word-wrap: break-word;\n      -ms-hyphens: auto;\n      cursor: inherit;\n    }\n\n    .c4 {\n      font-family: Material Icons;\n      font-size: 16px;\n      text-align: center;\n    }\n\n    .c0 {\n      -webkit-align-items: stretch;\n      -webkit-box-align: stretch;\n      -ms-flex-align: stretch;\n      align-items: stretch;\n      border-color: #191E26;\n      border-style: solid;\n      border-width: 0;\n      box-sizing: border-box;\n      display: -webkit-box;\n      display: -webkit-flex;\n      display: -ms-flexbox;\n      display: flex;\n      -webkit-flex-direction: column;\n      -ms-flex-direction: column;\n      flex-direction: column;\n      -webkit-box-flex: 0;\n      -webkit-flex-grow: 0;\n      -ms-flex-positive: 0;\n      flex-grow: 0;\n      -webkit-flex-shrink: 0;\n      -ms-flex-negative: 0;\n      flex-shrink: 0;\n      position: relative;\n      min-height: 0;\n      min-width: 0;\n    }\n\n    .c2 {\n      vertical-align: middle;\n      outline: none;\n      display: -webkit-inline-box;\n      display: -webkit-inline-flex;\n      display: -ms-inline-flexbox;\n      display: inline-flex;\n      -webkit-flex: none;\n      -ms-flex: none;\n      flex: none;\n      cursor: pointer;\n      width: 24px;\n      height: 24px;\n      border-radius: 3px;\n    }\n\n    .c5 {\n      -webkit-flex: none;\n      -ms-flex: none;\n      flex: none;\n      -webkit-align-items: center;\n      -webkit-box-align: center;\n      -ms-flex-align: center;\n      align-items: center;\n      color: #B0ADAB;\n      height: 24px;\n      line-height: 24px;\n      width: 24px;\n      font-size: 24px;\n      -webkit-transition: box-shadow 0.2s;\n      transition: box-shadow 0.2s;\n      border-radius: 3px;\n    }\n\n    .c1:hover .c5,\n    .c1:focus .c5 {\n      box-shadow: inset 0 0 0 3px #00000029;\n    }\n\n    <div\n      aria-checked=\"false\"\n      class=\"c0 c1 c2\"\n      data-testid=\"test\"\n      role=\"checkbox\"\n      tabindex=\"0\"\n    >\n      <div\n        class=\"c3 c4 sc-AxhCb c5\"\n        data-text-as-pseudo-element=\"\uE835\"\n      />\n    </div>\n  ");
});
test('should render a checkbox that is disabled', function () {
  var _render3 = render( /*#__PURE__*/_jsx(Checkbox, {
    testID: "test",
    disabled: true
  })),
      getByTestId = _render3.getByTestId;

  expect(getByTestId('test')).toMatchInlineSnapshot("\n    .c2 {\n      box-sizing: border-box;\n      color: #191E26;\n      display: inline;\n      -webkit-box-flex: 0;\n      -webkit-flex-grow: 0;\n      -ms-flex-positive: 0;\n      flex-grow: 0;\n      -webkit-flex-shrink: 0;\n      -ms-flex-negative: 0;\n      flex-shrink: 0;\n      font-family: \"Helvetica Neue\",Helvetica,Arial,sans-serif;\n      font-size: 14px;\n      position: relative;\n      white-space: pre-wrap;\n      word-wrap: break-word;\n      -ms-hyphens: auto;\n      cursor: inherit;\n    }\n\n    .c3 {\n      font-family: Material Icons;\n      font-size: 16px;\n      text-align: center;\n    }\n\n    .c0 {\n      -webkit-align-items: stretch;\n      -webkit-box-align: stretch;\n      -ms-flex-align: stretch;\n      align-items: stretch;\n      border-color: #191E26;\n      border-style: solid;\n      border-width: 0;\n      box-sizing: border-box;\n      display: -webkit-box;\n      display: -webkit-flex;\n      display: -ms-flexbox;\n      display: flex;\n      -webkit-flex-direction: column;\n      -ms-flex-direction: column;\n      flex-direction: column;\n      -webkit-box-flex: 0;\n      -webkit-flex-grow: 0;\n      -ms-flex-positive: 0;\n      flex-grow: 0;\n      -webkit-flex-shrink: 0;\n      -ms-flex-negative: 0;\n      flex-shrink: 0;\n      position: relative;\n      min-height: 0;\n      min-width: 0;\n    }\n\n    .c1 {\n      vertical-align: middle;\n      outline: none;\n      display: -webkit-inline-box;\n      display: -webkit-inline-flex;\n      display: -ms-inline-flexbox;\n      display: inline-flex;\n      -webkit-flex: none;\n      -ms-flex: none;\n      flex: none;\n      cursor: not-allowed;\n      width: 24px;\n      height: 24px;\n      border-radius: 3px;\n    }\n\n    .c4 {\n      -webkit-flex: none;\n      -ms-flex: none;\n      flex: none;\n      -webkit-align-items: center;\n      -webkit-box-align: center;\n      -ms-flex-align: center;\n      align-items: center;\n      color: gray;\n      height: 24px;\n      line-height: 24px;\n      width: 24px;\n      font-size: 24px;\n      -webkit-transition: box-shadow 0.2s;\n      transition: box-shadow 0.2s;\n      border-radius: 3px;\n      background-color: #00000029;\n    }\n\n    <div\n      aria-checked=\"false\"\n      class=\"c0 c1\"\n      data-testid=\"test\"\n      role=\"checkbox\"\n      tabindex=\"0\"\n    >\n      <div\n        class=\"c2 c3 sc-AxhCb c4\"\n        data-text-as-pseudo-element=\"\uE835\"\n      />\n    </div>\n  ");
});