var _templateObject;

function _taggedTemplateLiteral(strings, raw) { if (!raw) { raw = strings.slice(0); } return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }

import 'jest-styled-components';
import 'react-testing-library/cleanup-after-each';
import React from 'react';
import { render } from 'react-testing-library';
import { styled } from '../../../apis/Style';
import Text from '../../Text';
import Font from '..';
import { jsx as _jsx } from "react/jsx-runtime";
test('texts without a parent Font should use default font', function () {
  var _render = render( /*#__PURE__*/_jsx(Text, {
    testID: "test",
    children: "hello"
  })),
      getByTestId = _render.getByTestId;

  expect(getByTestId('test')).toMatchInlineSnapshot("\n    .c0 {\n      box-sizing: border-box;\n      color: #191E26;\n      display: inline;\n      -webkit-box-flex: 0;\n      -webkit-flex-grow: 0;\n      -ms-flex-positive: 0;\n      flex-grow: 0;\n      -webkit-flex-shrink: 0;\n      -ms-flex-negative: 0;\n      flex-shrink: 0;\n      font-family: \"Helvetica Neue\",Helvetica,Arial,sans-serif;\n      font-size: 14px;\n      position: relative;\n      white-space: pre-wrap;\n      word-wrap: break-word;\n      -ms-hyphens: auto;\n      cursor: inherit;\n    }\n\n    <div\n      class=\"c0\"\n      data-testid=\"test\"\n      data-text-as-pseudo-element=\"hello\"\n    />\n  ");
});
test('texts rendered inside Font should inherit font', function () {
  var _render2 = render( /*#__PURE__*/_jsx(Font, {
    fontFamily: "Times",
    fontSize: 10,
    children: /*#__PURE__*/_jsx(Text, {
      testID: "test",
      children: "hello"
    })
  })),
      getByTestId = _render2.getByTestId;

  expect(getByTestId('test')).toMatchInlineSnapshot("\n    .c0 {\n      box-sizing: border-box;\n      color: #191E26;\n      display: inline;\n      -webkit-box-flex: 0;\n      -webkit-flex-grow: 0;\n      -ms-flex-positive: 0;\n      flex-grow: 0;\n      -webkit-flex-shrink: 0;\n      -ms-flex-negative: 0;\n      flex-shrink: 0;\n      font-family: Times;\n      font-size: 10px;\n      position: relative;\n      white-space: pre-wrap;\n      word-wrap: break-word;\n      -ms-hyphens: auto;\n      cursor: inherit;\n    }\n\n    <div\n      class=\"c0\"\n      data-testid=\"test\"\n      data-text-as-pseudo-element=\"hello\"\n    />\n  ");
});
test('texts can override inherited font', function () {
  var StyledText = styled(Text)(_templateObject || (_templateObject = _taggedTemplateLiteral(["\n    font-size: 20px;\n  "])));

  var _render3 = render( /*#__PURE__*/_jsx(Font, {
    fontFamily: "Times",
    fontSize: 10,
    children: /*#__PURE__*/_jsx(StyledText, {
      testID: "test",
      children: "hello"
    })
  })),
      getByTestId = _render3.getByTestId;

  expect(getByTestId('test')).toMatchInlineSnapshot("\n.c0 {\n  box-sizing: border-box;\n  color: #191E26;\n  display: inline;\n  -webkit-box-flex: 0;\n  -webkit-flex-grow: 0;\n  -ms-flex-positive: 0;\n  flex-grow: 0;\n  -webkit-flex-shrink: 0;\n  -ms-flex-negative: 0;\n  flex-shrink: 0;\n  font-family: Times;\n  font-size: 10px;\n  position: relative;\n  white-space: pre-wrap;\n  word-wrap: break-word;\n  -ms-hyphens: auto;\n  cursor: inherit;\n}\n\n.c1 {\n  font-size: 20px;\n}\n\n<div\n  class=\"c0 c1\"\n  data-testid=\"test\"\n  data-text-as-pseudo-element=\"hello\"\n/>\n");
});