function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

import React from 'react';
import { useFieldState } from './useFieldState';
import { jsx as _jsx } from "react/jsx-runtime";

function InternalField(props) {
  var component = props.component,
      inputRef = props.inputRef,
      label = props.label,
      name = props.name,
      inputProps = props.props,
      testID = props.testID,
      validate = props.validate;

  var _useFieldState = useFieldState({
    name: name,
    validate: validate
  }),
      fieldState = _useFieldState.fieldState,
      onBlur = _useFieldState.onBlur,
      onFocus = _useFieldState.onFocus,
      onValueChange = _useFieldState.onValueChange;

  return /*#__PURE__*/React.createElement(component, _objectSpread(_objectSpread({
    fieldState: fieldState,
    label: label,
    testID: testID || "".concat(name, "-field"),
    value: fieldState.value
  }, inputProps), {}, {
    onBlur: onBlur,
    onFocus: onFocus,
    onValueChange: onValueChange,
    ref: inputRef
  }));
}

export var Field = /*#__PURE__*/React.forwardRef(function (props, ref) {
  return (
    /*#__PURE__*/
    // @ts-ignore
    _jsx(InternalField, _objectSpread(_objectSpread({}, props), {}, {
      inputRef: ref,
      props: props.props || {}
    }))
  );
});