import invariant from 'invariant';
import React from 'react';
import { jsx as _jsx } from "react/jsx-runtime";
var Context = /*#__PURE__*/React.createContext(undefined);
export function FormStateProvider(_ref) {
  var children = _ref.children,
      value = _ref.value;
  return /*#__PURE__*/_jsx(Context.Provider, {
    value: value,
    children: children
  });
}
export function useFormState() {
  return React.useContext(Context);
}
export function useFormStateStrict() {
  var formState = useFormState();
  invariant(formState, "Please put the component inside a Form or ModalForm.");
  return formState;
}