import _isEqualWith from "lodash/fp/isEqualWith";
export function isEmpty(value) {
  return value == null || value === '';
}
export function deepEqual(a, b) {
  return _isEqualWith(function (obj, other) {
    if (obj === other) return true;

    if (!obj && !other) {
      return isEmpty(obj) === isEmpty(other);
    }
  }, a, b);
}
export function unwrapChildren(children) {
  return Array.isArray(children) ? children[0] : children;
}