import React from 'react';
import { TouchableOpacity } from 'react-native';
import { FormConfigContext } from '../Form.native/FormConfigContext';
import { useFormStateStrict } from '../FormState';
import { jsx as _jsx } from "react/jsx-runtime";

var SubmitButton = function SubmitButton(_ref) {
  var children = _ref.children,
      style = _ref.style,
      testID = _ref.testID;
  var formState = useFormStateStrict();

  var _ref2 = React.useContext(FormConfigContext),
      onSubmit = _ref2.onSubmit;

  var fieldErrors = formState.fieldErrors,
      values = formState.values,
      actions = formState.actions;

  var handleSubmit = function handleSubmit() {
    actions.touchAll();

    if (Object.keys(fieldErrors).length === 0) {
      actions.submit(function () {
        return onSubmit && onSubmit(values);
      });
    }
  };

  return /*#__PURE__*/_jsx(TouchableOpacity, {
    onPress: handleSubmit,
    style: style,
    testID: testID,
    children: typeof children === 'function' ? children(formState) : children
  });
};

export default SubmitButton;