function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (typeof call === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

import ExecutionEnvironment from 'exenv';
import * as React from 'react';
import ReactDOM from 'react-dom';
import OverlayDefaultProps from '../defaultProps';
import CloseButton from './CloseButton';
import OverlayContainer from './OverlayContainer';
import { jsx as _jsx } from "react/jsx-runtime";
import { jsxs as _jsxs } from "react/jsx-runtime";

var Overlay = /*#__PURE__*/function (_React$Component) {
  _inherits(Overlay, _React$Component);

  var _super = _createSuper(Overlay);

  function Overlay(props) {
    var _this;

    _classCallCheck(this, Overlay);

    _this = _super.call(this, props);
    _this._parent = document.body;

    _this._onClick = function (event) {
      if (event.target === event.currentTarget) {
        var onPress = _this.props.onPress;
        onPress && onPress();
      }
    };

    if (ExecutionEnvironment.canUseDOM) {
      _this._el = document.createElement('div');
    }

    return _this;
  }

  _createClass(Overlay, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      if (!this._parent || !this._el) return;

      this._parent.appendChild(this._el);
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      if (!this._parent || !this._el) return;

      this._parent.removeChild(this._el);
    }
  }, {
    key: "render",
    value: function render() {
      if (!this._el) {
        return null;
      }

      var _this$props = this.props,
          children = _this$props.children,
          color = _this$props.color,
          onLayout = _this$props.onLayout,
          visible = _this$props.visible,
          _this$props$showClose = _this$props.showCloseButton,
          showCloseButton = _this$props$showClose === void 0 ? false : _this$props$showClose,
          closeButtonStyle = _this$props.closeButtonStyle,
          onClose = _this$props.onClose,
          testID = _this$props.testID;
      var portalChild = visible ? /*#__PURE__*/_jsxs(OverlayContainer, {
        onClick: this._onClick,
        onLayout: onLayout,
        testID: testID || 'overlay-container',
        $color: color,
        children: [children, showCloseButton && /*#__PURE__*/_jsx(CloseButton, {
          onPress: onClose,
          closeButtonStyle: closeButtonStyle
        })]
      }) : null;
      return /*#__PURE__*/ReactDOM.createPortal(portalChild, this._el);
    }
  }]);

  return Overlay;
}(React.Component);

Overlay.defaultProps = OverlayDefaultProps;
export default Overlay;