function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

import React from 'react';
import FlexIframe from '../../../internals/web/FlexIframe';
import { createDataUrlFromDefinition, initializePdfFonts } from '../helpers/pdfmake';
import { useUri } from '../helpers/useUri';
import { validateSource } from '../helpers/validateSource';
import Loading from './Loading';
import { jsx as _jsx } from "react/jsx-runtime";
// start loading fonts as soon as this module gets imported
initializePdfFonts();
export default function Pdf(props) {
  var accessibilityLabel = props.accessibilityLabel,
      className = props.className,
      source = props.source,
      style = props.style,
      testID = props.testID;
  validateSource(source);
  var uri = useUri(source);

  if (!uri) {
    return /*#__PURE__*/_jsx(Loading, _objectSpread({}, props));
  }

  var iframeProps = {
    'aria-label': accessibilityLabel,
    'data-testid': testID,
    className: className,
    src: uri,
    style: style
  };
  return /*#__PURE__*/_jsx(FlexIframe, _objectSpread({}, iframeProps));
}
Pdf.createDataUrlFromDefinition = createDataUrlFromDefinition;