function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

import * as React from 'react';
import { ScrollViewBase } from '../../internals/web/ScrollViewBase';
import { jsx as _jsx } from "react/jsx-runtime";
var ScrollView = /*#__PURE__*/React.forwardRef(function (_ref, ref) {
  var accessibilityLabel = _ref.accessibilityLabel,
      children = _ref.children,
      className = _ref.className,
      horizontal = _ref.horizontal,
      onLayout = _ref.onLayout,
      style = _ref.style,
      contentContainerStyle = _ref.contentContainerStyle,
      testID = _ref.testID,
      onScroll = _ref.onScroll,
      onContentSizeChange = _ref.onContentSizeChange,
      _ref$scrollEventThrot = _ref.scrollEventThrottle,
      scrollEventThrottle = _ref$scrollEventThrot === void 0 ? 16 : _ref$scrollEventThrot;
  var scrollableNodeRef = React.useRef(null);
  React.useImperativeHandle(ref, function () {
    return {
      scrollTo: function scrollTo(options) {
        var x = options.x,
            y = options.y;

        if (scrollableNodeRef.current) {
          if (typeof x === 'number') {
            scrollableNodeRef.current.scrollLeft = x;
          }

          if (typeof y === 'number') {
            scrollableNodeRef.current.scrollTop = y;
          }
        }
      },
      scrollToEnd: function scrollToEnd() {
        if (scrollableNodeRef.current) {
          if (horizontal) {
            scrollableNodeRef.current.scrollLeft = scrollableNodeRef.current.scrollWidth;
          } else {
            scrollableNodeRef.current.scrollTop = scrollableNodeRef.current.scrollHeight;
          }
        }
      }
    };
  });
  var props = {
    accessibilityLabel: accessibilityLabel,
    className: className,
    horizontal: horizontal,
    onContentSizeChange: onContentSizeChange,
    onLayout: onLayout,
    onScroll: onScroll,
    scrollEventThrottle: scrollEventThrottle,
    style: style,
    contentContainerStyle: contentContainerStyle,
    testID: testID
  };
  return /*#__PURE__*/_jsx(ScrollViewBase, _objectSpread(_objectSpread({}, props), {}, {
    ref: scrollableNodeRef,
    children: children
  }));
});
export default ScrollView;