var _templateObject;

function _taggedTemplateLiteral(strings, raw) { if (!raw) { raw = strings.slice(0); } return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }

import 'jest-styled-components';
import 'react-testing-library/cleanup-after-each';
import React from 'react';
import { render } from 'react-testing-library';
import { styled } from '../../../apis/Style';
import Text from '..';
import { jsx as _jsx } from "react/jsx-runtime";
test('should render a div with text as a data attribute by default', function () {
  var _render = render( /*#__PURE__*/_jsx(Text, {
    testID: "test",
    children: "hello"
  })),
      getByTestId = _render.getByTestId;

  expect(getByTestId('test')).toMatchInlineSnapshot("\n    .c0 {\n      box-sizing: border-box;\n      color: #191E26;\n      display: inline;\n      -webkit-box-flex: 0;\n      -webkit-flex-grow: 0;\n      -ms-flex-positive: 0;\n      flex-grow: 0;\n      -webkit-flex-shrink: 0;\n      -ms-flex-negative: 0;\n      flex-shrink: 0;\n      font-family: \"Helvetica Neue\",Helvetica,Arial,sans-serif;\n      font-size: 14px;\n      position: relative;\n      white-space: pre-wrap;\n      word-wrap: break-word;\n      -ms-hyphens: auto;\n      cursor: inherit;\n    }\n\n    <div\n      class=\"c0\"\n      data-testid=\"test\"\n      data-text-as-pseudo-element=\"hello\"\n    />\n  ");
});
test('should render a div with text content if selectable', function () {
  var _render2 = render( /*#__PURE__*/_jsx(Text, {
    selectable: true,
    testID: "test",
    children: "hello"
  })),
      getByTestId = _render2.getByTestId;

  expect(getByTestId('test')).toMatchInlineSnapshot("\n    .c0 {\n      box-sizing: border-box;\n      color: #191E26;\n      display: inline;\n      -webkit-box-flex: 0;\n      -webkit-flex-grow: 0;\n      -ms-flex-positive: 0;\n      flex-grow: 0;\n      -webkit-flex-shrink: 0;\n      -ms-flex-negative: 0;\n      flex-shrink: 0;\n      font-family: \"Helvetica Neue\",Helvetica,Arial,sans-serif;\n      font-size: 14px;\n      position: relative;\n      white-space: pre-wrap;\n      word-wrap: break-word;\n      -ms-hyphens: auto;\n      cursor: text;\n      -webkit-user-select: text;\n      -moz-user-select: text;\n      -ms-user-select: text;\n      user-select: text;\n    }\n\n    <div\n      class=\"c0\"\n      data-testid=\"test\"\n    >\n      hello\n    </div>\n  ");
});
test('can render unicode characters', function () {
  // eslint-disable-next-line jsx-a11y/accessible-emoji
  var _render3 = render( /*#__PURE__*/_jsx(Text, {
    testID: "test",
    children: "\u4F60\u597D\uD83D\uDE00"
  })),
      getByTestId = _render3.getByTestId;

  expect(getByTestId('test')).toMatchInlineSnapshot("\n    .c0 {\n      box-sizing: border-box;\n      color: #191E26;\n      display: inline;\n      -webkit-box-flex: 0;\n      -webkit-flex-grow: 0;\n      -ms-flex-positive: 0;\n      flex-grow: 0;\n      -webkit-flex-shrink: 0;\n      -ms-flex-negative: 0;\n      flex-shrink: 0;\n      font-family: \"Helvetica Neue\",Helvetica,Arial,sans-serif;\n      font-size: 14px;\n      position: relative;\n      white-space: pre-wrap;\n      word-wrap: break-word;\n      -ms-hyphens: auto;\n      cursor: inherit;\n    }\n\n    <div\n      class=\"c0\"\n      data-testid=\"test\"\n      data-text-as-pseudo-element=\"\u4F60\u597D\uD83D\uDE00\"\n    />\n  ");
});
test('can override styles using `styled`', function () {
  var StyledText = styled(Text)(_templateObject || (_templateObject = _taggedTemplateLiteral(["\n    font-family: Times;\n  "])));

  var _render4 = render( /*#__PURE__*/_jsx(StyledText, {
    testID: "test",
    children: "hello"
  })),
      getByTestId = _render4.getByTestId;

  expect(getByTestId('test')).toMatchInlineSnapshot("\n.c0 {\n  box-sizing: border-box;\n  color: #191E26;\n  display: inline;\n  -webkit-box-flex: 0;\n  -webkit-flex-grow: 0;\n  -ms-flex-positive: 0;\n  flex-grow: 0;\n  -webkit-flex-shrink: 0;\n  -ms-flex-negative: 0;\n  flex-shrink: 0;\n  font-family: \"Helvetica Neue\",Helvetica,Arial,sans-serif;\n  font-size: 14px;\n  position: relative;\n  white-space: pre-wrap;\n  word-wrap: break-word;\n  -ms-hyphens: auto;\n  cursor: inherit;\n}\n\n.c1 {\n  font-family: Times;\n}\n\n<div\n  class=\"c0 c1\"\n  data-testid=\"test\"\n  data-text-as-pseudo-element=\"hello\"\n/>\n");
});