"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.AlertContentContainer = exports["default"] = void 0;

var React = _interopRequireWildcard(require("react"));

var _styledComponents = _interopRequireDefault(require("styled-components"));

var _Button = _interopRequireDefault(require("../../../components/Button"));

var _StyledComponents = require("../../../components/ModalForm/StyledComponents");

var _Paragraph = _interopRequireDefault(require("../../../components/Paragraph"));

var _breakpoint = require("../../../internals/web/breakpoint");

var _FlexDiv = _interopRequireDefault(require("../../../internals/web/FlexDiv"));

var _ViewBase = require("../../../internals/web/ViewBase");

var _Text = _interopRequireDefault(require("../../../primitives/Text"));

var _View = _interopRequireDefault(require("../../../primitives/View"));

var _defaultProps = _interopRequireDefault(require("../defaultProps"));

var _jsxRuntime = require("react/jsx-runtime");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (typeof call === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

var AlertDialog = /*#__PURE__*/function (_React$Component) {
  _inherits(AlertDialog, _React$Component);

  var _super = _createSuper(AlertDialog);

  function AlertDialog() {
    var _this;

    _classCallCheck(this, AlertDialog);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _super.call.apply(_super, [this].concat(args));

    _this.createActionButtonHandler = function (onPress) {
      return function (value) {
        var onDismiss = _this.props.onDismiss;
        onDismiss(value);
        onPress && onPress();
      };
    };

    _this.confirmButton = function () {
      var actions = _this.props.actions;

      var _onPress = _this.createActionButtonHandler(actions.confirm && actions.confirm.onPress);

      return /*#__PURE__*/(0, _jsxRuntime.jsx)(_Button["default"], {
        text: actions.confirm && actions.confirm.text || 'Ok',
        onPress: function onPress() {
          return _onPress('confirm');
        },
        type: actions.confirm && actions.confirm.destructive ? 'destructive' : 'primary'
      });
    };

    _this.cancelButton = function () {
      var actions = _this.props.actions;

      var _onPress2 = _this.createActionButtonHandler(actions.cancel && actions.cancel.onPress);

      return actions.confirm && actions.cancel && /*#__PURE__*/(0, _jsxRuntime.jsx)(_Button["default"], {
        type: "secondary",
        onPress: function onPress() {
          return _onPress2('cancel');
        },
        text: actions.cancel && actions.cancel.text || 'Cancel',
        style: {
          marginRight: 8
        }
      });
    };

    _this.neutralButton = function () {
      var actions = _this.props.actions;

      var _onPress3 = _this.createActionButtonHandler(actions.neutral && actions.neutral.onPress);

      return actions.confirm && actions.cancel && actions.neutral && /*#__PURE__*/(0, _jsxRuntime.jsx)(_Button["default"], {
        type: "tertiary",
        onPress: function onPress() {
          return _onPress3('neutral');
        },
        text: actions.neutral && actions.neutral.text || 'Ask Me Later'
      });
    };

    return _this;
  }

  _createClass(AlertDialog, [{
    key: "render",
    value: function render() {
      var _this$props = this.props,
          message = _this$props.message,
          title = _this$props.title;
      return /*#__PURE__*/(0, _jsxRuntime.jsx)(AlertContentContainer, {
        children: /*#__PURE__*/(0, _jsxRuntime.jsxs)(StyledView, {
          children: [title && /*#__PURE__*/(0, _jsxRuntime.jsx)(AlertFormHeader, {
            children: /*#__PURE__*/(0, _jsxRuntime.jsx)(AlertFormTitleText, {
              children: title
            })
          }), /*#__PURE__*/(0, _jsxRuntime.jsx)(AlertFormContent, {
            children: /*#__PURE__*/(0, _jsxRuntime.jsx)(_Paragraph["default"], {
              children: message
            })
          }), /*#__PURE__*/(0, _jsxRuntime.jsxs)(AlertFormFooter, {
            children: [/*#__PURE__*/(0, _jsxRuntime.jsx)(AlertFormRow, {
              children: this.neutralButton()
            }), /*#__PURE__*/(0, _jsxRuntime.jsxs)(AlertFormRow, {
              children: [this.cancelButton(), this.confirmButton()]
            })]
          })]
        })
      });
    }
  }]);

  return AlertDialog;
}(React.Component);

AlertDialog.defaultProps = _defaultProps["default"];
var _default = AlertDialog;
exports["default"] = _default;
var AlertContentContainer = (0, _styledComponents["default"])(_ViewBase.DivViewBase).attrs(function (props) {
  return {
    tabIndex: -1
  };
}).withConfig({
  displayName: "AlertDialog__AlertContentContainer",
  componentId: "sc-1q916i1-0"
})(["background-color:white;border-radius:4px;overflow:hidden;margin:auto;max-height:576px;min-height:140px;outline:none;@media (max-width:", "px){width:calc(100% - 40px);}@media (min-width:", "px){width:400px;}"], _breakpoint.breakpoint.max, _breakpoint.breakpoint.min);
exports.AlertContentContainer = AlertContentContainer;
var StyledView = (0, _styledComponents["default"])(_View["default"]).withConfig({
  displayName: "AlertDialog__StyledView",
  componentId: "sc-1q916i1-1"
})(["flex:1;align-items:stretch;box-sizing:border-box;display:flex;flex-direction:column;flex-shrink:0;position:relative;min-height:0;min-width:0;"]);
var AlertFormTitleText = (0, _styledComponents["default"])(_Text["default"]).withConfig({
  displayName: "AlertDialog__AlertFormTitleText",
  componentId: "sc-1q916i1-2"
})(["font-size:20px;color:#2b2826;line-height:20px;"]);
var AlertFormHeader = (0, _styledComponents["default"])(_FlexDiv["default"]).withConfig({
  displayName: "AlertDialog__AlertFormHeader",
  componentId: "sc-1q916i1-3"
})(["flex:none;flex-direction:row;background-color:white;border-bottom:1px solid #dddbda;height:55px;align-items:center;justify-content:center;"]);
var AlertFormContent = (0, _styledComponents["default"])(_FlexDiv["default"]).withConfig({
  displayName: "AlertDialog__AlertFormContent",
  componentId: "sc-1q916i1-4"
})(["flex:1;background-color:white;padding:24px;@media (max-width:", "px){", ";}"], _breakpoint.breakpoint.max, _StyledComponents.modalFormContentStyle);
var AlertFormFooter = (0, _styledComponents["default"])(_FlexDiv["default"]).withConfig({
  displayName: "AlertDialog__AlertFormFooter",
  componentId: "sc-1q916i1-5"
})(["flex:none;flex-direction:row;justify-content:space-between;background-color:#fbfbfb;border-top:1px solid #eee;height:64px;padding:16px;@media (max-width:", "px){height:48px;padding:8px;}"], _breakpoint.breakpoint.max);
var AlertFormRow = (0, _styledComponents["default"])(_FlexDiv["default"]).withConfig({
  displayName: "AlertDialog__AlertFormRow",
  componentId: "sc-1q916i1-6"
})(["display:flex;flex-direction:row;"]);