"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.convertOptions = exports.validateOptions = void 0;

var _invariant = _interopRequireDefault(require("fbjs/lib/invariant"));

var _isPlainObject = _interopRequireDefault(require("lodash/isPlainObject"));

var _isString = _interopRequireDefault(require("lodash/isString"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

var validateOptions = function validateOptions(options) {
  (0, _invariant["default"])(!!options, 'Alert: options is required');
  (0, _invariant["default"])(!options.actions || (0, _isPlainObject["default"])(options.actions), 'Alert: options.actions must be an object with confirm, cancel and neutral buttons');
};

exports.validateOptions = validateOptions;

var convertOptions = function convertOptions(options) {
  if ((0, _isString["default"])(options)) {
    return {
      message: options,
      actions: {
        confirm: {
          text: 'OK'
        }
      }
    };
  }

  return options;
}; ///


exports.convertOptions = convertOptions;