"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.getDeviceKindByWidth = getDeviceKindByWidth;
exports.DeviceKindProvider = DeviceKindProvider;
exports.useDeviceKind = useDeviceKind;

var _react = _interopRequireDefault(require("react"));

var _jsxRuntime = require("react/jsx-runtime");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

// 240-479 pixels
function getDeviceKindByWidth(width) {
  if (width >= 992) return 'desktop';
  if (width >= 768) return 'tablet';
  if (width >= 480) return 'large-phone';
  return 'phone';
}

var DeviceKindContext = /*#__PURE__*/_react["default"].createContext(undefined);

function DeviceKindProvider(_ref) {
  var children = _ref.children,
      value = _ref.value;
  return /*#__PURE__*/(0, _jsxRuntime.jsx)(DeviceKindContext.Provider, {
    value: value,
    children: children
  });
}

function useDeviceKind() {
  var deviceKind = _react["default"].useContext(DeviceKindContext);

  return deviceKind;
}