"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = Avatar;

var React = _interopRequireWildcard(require("react"));

var _Colors = _interopRequireDefault(require("../../apis/Colors"));

var _Style = require("../../apis/Style");

var _Text = _interopRequireDefault(require("../../primitives/Text"));

var _View = _interopRequireDefault(require("../../primitives/View"));

var _Badge = _interopRequireDefault(require("../Badge"));

var _Icon = _interopRequireDefault(require("../Icon"));

var _helpers = require("./helpers");

var _jsxRuntime = require("react/jsx-runtime");

var _templateObject, _templateObject2;

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _taggedTemplateLiteral(strings, raw) { if (!raw) { raw = strings.slice(0); } return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }

function Avatar(_ref) {
  var _ref$backgroundColor = _ref.backgroundColor,
      backgroundColor = _ref$backgroundColor === void 0 ? _Colors["default"].GREY : _ref$backgroundColor,
      className = _ref.className,
      icon = _ref.icon,
      style = _ref.style,
      badge = _ref.badge,
      testID = _ref.testID,
      _ref$name = _ref.name,
      name = _ref$name === void 0 ? '?' : _ref$name,
      _ref$size = _ref.size,
      size = _ref$size === void 0 ? 'medium' : _ref$size;
  return /*#__PURE__*/(0, _jsxRuntime.jsxs)(AvatarContainer, {
    $avatarBgColor: backgroundColor,
    className: className,
    $size: size,
    style: style,
    testID: testID,
    children: [icon ? /*#__PURE__*/(0, _jsxRuntime.jsx)(_Icon["default"], {
      name: icon,
      color: "white",
      size: size
    }) : /*#__PURE__*/(0, _jsxRuntime.jsx)(StyledText, {
      $size: size,
      children: (0, _helpers.getInitials)(name)
    }), badge && /*#__PURE__*/(0, _jsxRuntime.jsx)(_Badge["default"], {
      number: badge
    })]
  });
}

var AvatarContainer = (0, _Style.styled)(_View["default"])(_templateObject || (_templateObject = _taggedTemplateLiteral(["\n  align-items: center;\n  justify-content: center;\n  background-color: ", ";\n  border-radius: ", "px;\n  height: ", "px;\n  width: ", "px;\n"])), function (_ref2) {
  var $avatarBgColor = _ref2.$avatarBgColor;
  return $avatarBgColor;
}, function (_ref3) {
  var $size = _ref3.$size;
  return _helpers.SizeToRadius[$size];
}, function (_ref4) {
  var $size = _ref4.$size;
  return 2 * _helpers.SizeToRadius[$size];
}, function (_ref5) {
  var $size = _ref5.$size;
  return 2 * _helpers.SizeToRadius[$size];
});
var StyledText = (0, _Style.styled)(_Text["default"])(_templateObject2 || (_templateObject2 = _taggedTemplateLiteral(["\n  font-size: ", "px;\n  color: white;\n"])), function (_ref6) {
  var $size = _ref6.$size;
  return _helpers.SizeToRadius[$size];
});