"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.StyledIcon = exports.SpinnerContainer = exports.ButtonLabel = exports.buttonTextStyle = exports.buttonContainerStyle = void 0;

var _styledComponents = _interopRequireWildcard(require("styled-components"));

var _Text = _interopRequireDefault(require("../../primitives/Text"));

var _View = _interopRequireDefault(require("../../primitives/View"));

var _Icon = _interopRequireDefault(require("../Icon"));

var _helpers = require("./helpers");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var buttonContainerStyle = (0, _styledComponents.css)(["flex-direction:row;align-items:center;justify-content:center;border-radius:4px;height:32px;background-color:", ";border-color:", ";border-style:solid;border-width:1px;padding-left:", "px;padding-right:", "px;"], function (props) {
  return (0, _helpers.getBackgroundColor)(props);
}, function (props) {
  return (0, _helpers.getBorderColor)(props);
}, function (_ref) {
  var icon = _ref.icon,
      text = _ref.text;
  return icon && text ? 8 : text ? 16 : 0;
}, function (_ref2) {
  var text = _ref2.text;
  return text ? 16 : 0;
});
exports.buttonContainerStyle = buttonContainerStyle;
var buttonTextStyle = (0, _styledComponents.css)(["font-size:14px;color:", ";"], function (props) {
  return props.loading ? 'transparent' : (0, _helpers.getTextColor)(props);
});
exports.buttonTextStyle = buttonTextStyle;
var ButtonLabel = (0, _styledComponents["default"])(_Text["default"]).withConfig({
  displayName: "common-styles__ButtonLabel",
  componentId: "sc-5635y3-0"
})(["", ";"], buttonTextStyle);
exports.ButtonLabel = ButtonLabel;
var SpinnerContainer = (0, _styledComponents["default"])(_View["default"]).withConfig({
  displayName: "common-styles__SpinnerContainer",
  componentId: "sc-5635y3-1"
})(["position:absolute;top:0;bottom:0;left:0;right:0;align-items:center;justify-content:center;border-radius:4px;"]);
exports.SpinnerContainer = SpinnerContainer;
var StyledIcon = (0, _styledComponents["default"])(_Icon["default"]).withConfig({
  displayName: "common-styles__StyledIcon",
  componentId: "sc-5635y3-2"
})(["", ";"], buttonTextStyle);
exports.StyledIcon = StyledIcon;