"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
Object.defineProperty(exports, "ButtonLabel", {
  enumerable: true,
  get: function get() {
    return _commonStyles.ButtonLabel;
  }
});
Object.defineProperty(exports, "SpinnerContainer", {
  enumerable: true,
  get: function get() {
    return _commonStyles.SpinnerContainer;
  }
});
Object.defineProperty(exports, "StyledIcon", {
  enumerable: true,
  get: function get() {
    return _commonStyles.StyledIcon;
  }
});
Object.defineProperty(exports, "buttonTextStyle", {
  enumerable: true,
  get: function get() {
    return _commonStyles.buttonTextStyle;
  }
});
exports.buttonContainerStyle = void 0;

var _Style = require("../../apis/Style");

var _commonStyles = require("./common-styles");

var _helpers = require("./helpers");

var _templateObject;

function _taggedTemplateLiteral(strings, raw) { if (!raw) { raw = strings.slice(0); } return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }

var webButtonContainerStyle = (0, _Style.css)(_templateObject || (_templateObject = _taggedTemplateLiteral(["\n  ", ";\n\n  ", ";\n"])), _commonStyles.buttonContainerStyle, function (_ref) {
  var disabled = _ref.disabled,
      type = _ref.type;
  return !disabled && "\n    &:hover,\n    &:focus {\n      background-color: ".concat((0, _helpers.getFocusedBackgroundColor)({
    type: type
  }), ";\n      border-color: ").concat((0, _helpers.getFocusedBorderColor)({
    type: type
  }), ";\n      * {\n        color: ").concat((0, _helpers.getFocusedTextColor)({
    type: type
  }), ";\n      }\n    }\n\n    &:active {\n      background-color: ").concat((0, _helpers.getActiveBackgroundColor)({
    type: type
  }), ";\n      border-color: ").concat((0, _helpers.getActiveBorderColor)({
    type: type
  }), ";\n      * {\n        color: ").concat((0, _helpers.getActiveTextColor)({
    type: type
  }), ";\n      }\n    }\n  ");
});
exports.buttonContainerStyle = webButtonContainerStyle;