"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var React = _interopRequireWildcard(require("react"));

var _styledComponents = _interopRequireDefault(require("styled-components"));

var _ColorPicker = _interopRequireDefault(require("../../../internals/ColorPicker"));

var _utils = require("../../../internals/ColorPicker/utils");

var _Popover = require("../../../internals/Popover.web");

var _TouchableViewBase = require("../../../internals/web/TouchableViewBase");

var _View = _interopRequireDefault(require("../../../primitives/View"));

var _Button = _interopRequireDefault(require("../../Button"));

var _Icon = _interopRequireDefault(require("../../Icon"));

var _jsxRuntime = require("react/jsx-runtime");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { if (typeof Symbol === "undefined" || !(Symbol.iterator in Object(arr))) return; var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

var ColorPicker = function ColorPicker(_ref) {
  var _hexAToRGBA, _color$hex, _color$hex2;

  var _ref$hex = _ref.hex,
      hex = _ref$hex === void 0 ? '#0000' : _ref$hex,
      onClose = _ref.onClose,
      className = _ref.className,
      testID = _ref.testID;

  var _React$useState = React.useState(false),
      _React$useState2 = _slicedToArray(_React$useState, 2),
      active = _React$useState2[0],
      setActive = _React$useState2[1];

  var containerRef = React.useRef(null);

  var _React$useState3 = React.useState((_hexAToRGBA = (0, _utils.hexAToRGBA)(hex)) !== null && _hexAToRGBA !== void 0 ? _hexAToRGBA : {}),
      _React$useState4 = _slicedToArray(_React$useState3, 2),
      color = _React$useState4[0],
      setColor = _React$useState4[1];

  return /*#__PURE__*/(0, _jsxRuntime.jsxs)(React.Fragment, {
    children: [/*#__PURE__*/(0, _jsxRuntime.jsx)(TriggerContainer, {
      ref: containerRef,
      className: className,
      onClick: function onClick() {
        return setActive(true);
      },
      testID: testID,
      children: /*#__PURE__*/(0, _jsxRuntime.jsx)(_Icon["default"], {
        name: "color-lens",
        color: (_color$hex = color === null || color === void 0 ? void 0 : color.hex) !== null && _color$hex !== void 0 ? _color$hex : '#000'
      })
    }), active ? /*#__PURE__*/(0, _jsxRuntime.jsxs)(_Popover.Popover, {
      anchorEl: containerRef.current,
      onRequestClose: function onRequestClose() {
        return setActive(false);
      },
      visible: true,
      children: [/*#__PURE__*/(0, _jsxRuntime.jsx)(_ColorPicker["default"], {
        color: color,
        onChange: function onChange(value) {
          return setColor(value);
        }
      }), /*#__PURE__*/(0, _jsxRuntime.jsxs)(Footer, {
        children: [/*#__PURE__*/(0, _jsxRuntime.jsxs)(Preview, {
          children: [/*#__PURE__*/(0, _jsxRuntime.jsx)(Checkerboard, {}), /*#__PURE__*/(0, _jsxRuntime.jsx)(PreviewColor, {
            $color: (_color$hex2 = color === null || color === void 0 ? void 0 : color.hex) !== null && _color$hex2 !== void 0 ? _color$hex2 : '#0000'
          })]
        }), /*#__PURE__*/(0, _jsxRuntime.jsx)(FooterButton, {
          type: "tertiary",
          text: "Cancel",
          onPress: function onPress() {
            return setActive(false);
          }
        }), /*#__PURE__*/(0, _jsxRuntime.jsx)(FooterButton, {
          type: "primary",
          text: "OK",
          onPress: function onPress() {
            onClose === null || onClose === void 0 ? void 0 : onClose(color);
            setActive(false);
          }
        })]
      })]
    }) : null]
  });
};

var TriggerContainer = (0, _styledComponents["default"])(_TouchableViewBase.DivTouchableViewBase).withConfig({
  displayName: "ColorPickerweb__TriggerContainer",
  componentId: "dvd2sk-0"
})([""]);
var _default = ColorPicker;
exports["default"] = _default;
var Footer = (0, _styledComponents["default"])(_View["default"]).withConfig({
  displayName: "ColorPickerweb__Footer",
  componentId: "dvd2sk-1"
})(["background-color:#fafafa;align-items:center;flex-direction:row;justify-content:flex-end;padding:32px 8px 8px 8px;"]);
var FooterButton = (0, _styledComponents["default"])(_Button["default"]).withConfig({
  displayName: "ColorPickerweb__FooterButton",
  componentId: "dvd2sk-2"
})(["margin-left:8px;"]);
var Preview = (0, _styledComponents["default"])(_View["default"]).withConfig({
  displayName: "ColorPickerweb__Preview",
  componentId: "dvd2sk-3"
})(["flex-grow:1;height:30px;"]);
var PreviewColor = (0, _styledComponents["default"])(_View["default"]).withConfig({
  displayName: "ColorPickerweb__PreviewColor",
  componentId: "dvd2sk-4"
})(["background-color:", ";position:absolute;top:0px;left:0px;right:0px;bottom:0px;transition:background-color 0.2s;box-shadow:inset 0px 2px 1px -1px rgba(0,0,0,0.2),inset 0px 1px 1px 0px rgba(0,0,0,0.14),inset 0px 1px 3px 0px rgba(0,0,0,0.12);"], function (_ref2) {
  var $color = _ref2.$color;
  return "".concat($color);
});

var Checkerboard = _styledComponents["default"].div.withConfig({
  displayName: "ColorPickerweb__Checkerboard",
  componentId: "dvd2sk-5"
})(["background-position:0px 0px,10px 10px;background-size:20px 20px;background-image:linear-gradient( 45deg,#eee 25%,transparent 25%,transparent 75%,#eee 75%,#eee 100% ),linear-gradient(45deg,#eee 25%,white 25%,white 75%,#eee 75%,#eee 100%);position:absolute;top:0px;left:0px;right:0px;bottom:0px;"]);