"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = Dropdown;

var React = _interopRequireWildcard(require("react"));

var _Icon = _interopRequireDefault(require("../Icon"));

var _Modal = _interopRequireDefault(require("./Modal"));

var _StyledComponents = require("./StyledComponents.web");

var _jsxRuntime = require("react/jsx-runtime");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { if (typeof Symbol === "undefined" || !(Symbol.iterator in Object(arr))) return; var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function Dropdown(_ref) {
  var actions = _ref.actions,
      _ref$icon = _ref.icon,
      icon = _ref$icon === void 0 ? 'more-vert' : _ref$icon,
      align = _ref.align,
      _ref$width = _ref.width,
      width = _ref$width === void 0 ? 300 : _ref$width,
      children = _ref.children,
      _ref$iconColor = _ref.iconColor,
      iconColor = _ref$iconColor === void 0 ? 'black' : _ref$iconColor,
      testID = _ref.testID;

  var _React$useState = React.useState(false),
      _React$useState2 = _slicedToArray(_React$useState, 2),
      active = _React$useState2[0],
      setActive = _React$useState2[1];

  var _React$useState3 = React.useState({}),
      _React$useState4 = _slicedToArray(_React$useState3, 2),
      modalPlacement = _React$useState4[0],
      setModalPlacement = _React$useState4[1];

  var containerRef = React.useRef(null);

  var updatePlacement = function updatePlacement() {
    if (containerRef && containerRef.current) {
      var dims = containerRef.current.getBoundingClientRect();
      var left = Math.max(dims.left, 5);
      var right = Math.max(window.innerWidth - (dims.left + dims.width), 5);

      var _align = align || (left < right * 2 ? 'left' : 'right');

      if (_align === 'left') {
        right = null;

        if (left + width > window.innerWidth) {
          // the left position cannot be too high, it should not push the dropdown over the edge of the screen
          left = window.innerWidth - (width + 5);
        }
      } else {
        left = null;

        if (right + width > window.innerWidth) {
          // the right position cannot be too high, it should not push the dropdown over the edge of the screen
          right = window.innerWidth - (width + 5);
        }
      }

      var top = dims.bottom + 3;
      var height = actions.length * 40;

      if (top + height + 10 > window.innerHeight) {
        top = window.innerHeight - height - 10;
      }

      setModalPlacement({
        type: 'dropdown',
        top: top,
        height: height,
        width: width,
        align: _align,
        left: left,
        right: right
      });
    }
  };

  React.useEffect(function () {
    updatePlacement();
  }, [active]);

  var close = function close() {
    return setActive(false);
  };

  var renderAction = function renderAction(action) {
    return /*#__PURE__*/(0, _jsxRuntime.jsxs)(_StyledComponents.ActionRow, {
      onPress: function onPress() {
        close();
        action.onPress();
      },
      children: [action.icon && /*#__PURE__*/(0, _jsxRuntime.jsx)(_Icon["default"], {
        name: action.icon
      }), /*#__PURE__*/(0, _jsxRuntime.jsx)(_StyledComponents.Label, {
        children: action.label
      })]
    }, action.label);
  };

  return /*#__PURE__*/(0, _jsxRuntime.jsxs)(_StyledComponents.WebContainer, {
    "data-testid": testID,
    children: [/*#__PURE__*/(0, _jsxRuntime.jsx)("div", {
      style: {
        display: 'inline-block',
        cursor: 'pointer',
        padding: '0px 5px'
      },
      onClick: function onClick() {
        return setActive(true);
      },
      ref: containerRef,
      children: children || /*#__PURE__*/(0, _jsxRuntime.jsx)(_Icon["default"], {
        name: icon,
        color: iconColor
      })
    }), active ? /*#__PURE__*/(0, _jsxRuntime.jsxs)(_Modal["default"], {
      onRequestClose: close,
      placement: modalPlacement,
      visible: true,
      hideHeader: true,
      children: [/*#__PURE__*/(0, _jsxRuntime.jsx)(BackButton, {
        onPress: close
      }), actions.map(renderAction)]
    }) : null]
  });
}

var BackButton = function BackButton(_ref2) {
  var onPress = _ref2.onPress;
  return /*#__PURE__*/(0, _jsxRuntime.jsx)(_StyledComponents.BackLink, {
    onPress: onPress,
    children: /*#__PURE__*/(0, _jsxRuntime.jsx)(_Icon["default"], {
      name: "arrow-back-ios"
    })
  });
};