"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.BackLink = exports.WebContainer = exports.Label = exports.ActionRow = void 0;

var _Style = require("../../apis/Style");

var _breakpoint = require("../../internals/web/breakpoint");

var _Text = _interopRequireDefault(require("../../primitives/Text"));

var _TouchableView = _interopRequireDefault(require("../../primitives/TouchableView"));

var _templateObject, _templateObject2, _templateObject3, _templateObject4;

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _taggedTemplateLiteral(strings, raw) { if (!raw) { raw = strings.slice(0); } return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }

var ActionRow = (0, _Style.styled)(_TouchableView["default"])(_templateObject || (_templateObject = _taggedTemplateLiteral(["\n  flex-direction: row;\n  border-bottom: 1px solid #ddd;\n  height: 40px;\n  align-items: center;\n  padding-left: 8px;\n  &:hover {\n    background-color: #fafafa;\n  }\n"])));
exports.ActionRow = ActionRow;
var Label = (0, _Style.styled)(_Text["default"])(_templateObject2 || (_templateObject2 = _taggedTemplateLiteral(["\n  padding-left: 4px;\n"])));
exports.Label = Label;

var WebContainer = _Style.styled.div(_templateObject3 || (_templateObject3 = _taggedTemplateLiteral(["\n  display: inline-block;\n  &:hover {\n    opacity: 0.8;\n  }\n"])));

exports.WebContainer = WebContainer;
var BackLink = (0, _Style.styled)(_TouchableView["default"])(_templateObject4 || (_templateObject4 = _taggedTemplateLiteral(["\n  background-color: #eee;\n  flex-direction: row;\n  height: 40px;\n  align-items: center;\n  padding-left: 8px;\n  display: none;\n\n  @media (max-width: ", "px) {\n    display: flex;\n  }\n"])), _breakpoint.breakpoint.max);
exports.BackLink = BackLink;