"use strict";

require("jest-styled-components");

require("react-testing-library/cleanup-after-each");

var _react = _interopRequireDefault(require("react"));

var _reactTestingLibrary = require("react-testing-library");

var _ = _interopRequireDefault(require(".."));

var _jsxRuntime = require("react/jsx-runtime");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

var actions = [{
  icon: 'home',
  label: 'menu1',
  onPress: function onPress() {
    return console.log('menu1 pressed');
  }
}, {
  label: 'menu2',
  onPress: function onPress() {
    return console.log('menu2 pressed');
  }
}];
test('should render a dropdown menu icon', function () {
  var _render = (0, _reactTestingLibrary.render)( /*#__PURE__*/(0, _jsxRuntime.jsx)(_["default"], {
    actions: actions,
    icon: "cloud",
    testID: "test"
  })),
      getByTestId = _render.getByTestId;

  expect(getByTestId('test')).toMatchInlineSnapshot("\n      .c1 {\n        box-sizing: border-box;\n        color: #191E26;\n        display: inline;\n        -webkit-box-flex: 0;\n        -webkit-flex-grow: 0;\n        -ms-flex-positive: 0;\n        flex-grow: 0;\n        -webkit-flex-shrink: 0;\n        -ms-flex-negative: 0;\n        flex-shrink: 0;\n        font-family: \"Helvetica Neue\",Helvetica,Arial,sans-serif;\n        font-size: 14px;\n        position: relative;\n        white-space: pre-wrap;\n        word-wrap: break-word;\n        -ms-hyphens: auto;\n        cursor: inherit;\n      }\n      \n      .c2 {\n        font-family: Material Icons;\n        font-size: 16px;\n        text-align: center;\n      }\n      \n      .c3 {\n        -webkit-flex: none;\n        -ms-flex: none;\n        flex: none;\n        -webkit-align-items: center;\n        -webkit-box-align: center;\n        -ms-flex-align: center;\n        align-items: center;\n        color: black;\n        height: 24px;\n        line-height: 24px;\n        width: 24px;\n        font-size: 16px;\n      }\n      \n      .c0 {\n        display: inline-block;\n      }\n      \n      .c0:hover {\n        opacity: 0.8;\n      }\n      \n      <div\n        class=\"c0\"\n        data-testid=\"test\"\n      >\n        <div\n          style=\"display: inline-block; cursor: pointer; padding: 0px 5px;\"\n        >\n          <div\n            class=\"c1 c2 c3\"\n            data-text-as-pseudo-element=\"\uE2BD\"\n          />\n        </div>\n      </div>\n    ");
});
test('should render a dropdown menu icon using the default icon', function () {
  var _render2 = (0, _reactTestingLibrary.render)( /*#__PURE__*/(0, _jsxRuntime.jsx)(_["default"], {
    actions: actions,
    testID: "test"
  })),
      getByTestId = _render2.getByTestId;

  expect(getByTestId('test')).toMatchInlineSnapshot("\n.c1 {\n  box-sizing: border-box;\n  color: #191E26;\n  display: inline;\n  -webkit-box-flex: 0;\n  -webkit-flex-grow: 0;\n  -ms-flex-positive: 0;\n  flex-grow: 0;\n  -webkit-flex-shrink: 0;\n  -ms-flex-negative: 0;\n  flex-shrink: 0;\n  font-family: \"Helvetica Neue\",Helvetica,Arial,sans-serif;\n  font-size: 14px;\n  position: relative;\n  white-space: pre-wrap;\n  word-wrap: break-word;\n  -ms-hyphens: auto;\n  cursor: inherit;\n}\n\n.c2 {\n  font-family: Material Icons;\n  font-size: 16px;\n  text-align: center;\n}\n\n.c3 {\n  -webkit-flex: none;\n  -ms-flex: none;\n  flex: none;\n  -webkit-align-items: center;\n  -webkit-box-align: center;\n  -ms-flex-align: center;\n  align-items: center;\n  color: black;\n  height: 24px;\n  line-height: 24px;\n  width: 24px;\n  font-size: 16px;\n}\n\n.c0 {\n  display: inline-block;\n}\n\n.c0:hover {\n  opacity: 0.8;\n}\n\n<div\n  class=\"c0\"\n  data-testid=\"test\"\n>\n  <div\n    style=\"display: inline-block; cursor: pointer; padding: 0px 5px;\"\n  >\n    <div\n      class=\"c1 c2 c3\"\n      data-text-as-pseudo-element=\"\uE5D4\"\n    />\n  </div>\n</div>\n");
});