"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _Style = require("../../apis/Style");

var _IconMaterial = _interopRequireDefault(require("./IconMaterial"));

var _templateObject;

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _taggedTemplateLiteral(strings, raw) { if (!raw) { raw = strings.slice(0); } return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }

var Icon = (0, _Style.styled)(_IconMaterial["default"])(_templateObject || (_templateObject = _taggedTemplateLiteral(["\n  flex: none;\n  align-items: center;\n  ", ";\n  ", ";\n"])), function (_ref) {
  var color = _ref.color;
  return color && "color: ".concat(color);
}, function (_ref2) {
  var size = _ref2.size;
  var fontSizeString;
  var sizes = {
    small: 16,
    medium: 32,
    large: 48
  }; // If use input is number then use number
  // Else if use input is nothing return default 16
  // If user input small, medium or large then return the relevent one

  if (typeof size === 'number' && Number.isFinite(size) && size > 0) {
    fontSizeString = size;
  } else if (size === 'small' || size === 'medium' || size === 'large') {
    fontSizeString = sizes[size];
  } else {
    fontSizeString = 16;
    return "height: 24px;\n              line-height: 24px;\n              width: 24px;\n              font-size: ".concat(fontSizeString, "px");
  }

  return "height: ".concat(fontSizeString, "px;\n            line-height: ").concat(fontSizeString, "px;\n            width: ").concat(fontSizeString, "px;\n            font-size: ").concat(fontSizeString, "px");
});
Icon.displayName = 'Icon';
var _default = Icon;
exports["default"] = _default;