"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var React = _interopRequireWildcard(require("react"));

var _Style = require("../../apis/Style");

var _TouchableView = _interopRequireDefault(require("../../primitives/TouchableView"));

var _View = _interopRequireDefault(require("../../primitives/View"));

var _Badge = _interopRequireDefault(require("../Badge"));

var _Icon = _interopRequireDefault(require("../Icon"));

var _SubHeading = _interopRequireDefault(require("../SubHeading"));

var _jsxRuntime = require("react/jsx-runtime");

var _templateObject, _templateObject2, _templateObject3, _templateObject4;

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _taggedTemplateLiteral(strings, raw) { if (!raw) { raw = strings.slice(0); } return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }

var IconCard = function IconCard(_ref) {
  var icon = _ref.icon,
      color = _ref.color,
      badge = _ref.badge,
      _ref$size = _ref.size,
      size = _ref$size === void 0 ? 'small' : _ref$size,
      testID = _ref.testID,
      text = _ref.text,
      onPress = _ref.onPress,
      style = _ref.style;
  var sizes = {
    small: 40,
    medium: 80,
    large: 120
  };
  return /*#__PURE__*/(0, _jsxRuntime.jsxs)(Container, {
    $size: sizes[size],
    onPress: onPress,
    style: style,
    testID: testID,
    children: [/*#__PURE__*/(0, _jsxRuntime.jsxs)(StyledView, {
      $color: color,
      $size: sizes[size],
      children: [badge && /*#__PURE__*/(0, _jsxRuntime.jsx)(_Badge["default"], {
        number: badge
      }), /*#__PURE__*/(0, _jsxRuntime.jsx)(StyledIcon, {
        name: icon !== null && icon !== void 0 ? icon : '',
        color: color && 'white',
        $size: sizes[size]
      })]
    }), text && /*#__PURE__*/(0, _jsxRuntime.jsx)(StyledSubHeading, {
      children: text
    })]
  });
};

var _default = IconCard;
exports["default"] = _default;
var Container = (0, _Style.styled)(_TouchableView["default"])(_templateObject || (_templateObject = _taggedTemplateLiteral(["\n  align-items: center;\n  width: ", ";\n  margin: ", ";\n"])), function (_ref2) {
  var $size = _ref2.$size;
  return $size ? "".concat($size, "px") : '40px';
}, function (_ref3) {
  var $size = _ref3.$size;
  return $size ? "".concat($size / 10, "px") : '8px';
});
var StyledSubHeading = (0, _Style.styled)(_SubHeading["default"])(_templateObject2 || (_templateObject2 = _taggedTemplateLiteral([""])));
var StyledView = (0, _Style.styled)(_View["default"])(_templateObject3 || (_templateObject3 = _taggedTemplateLiteral(["\n  padding: 8px;\n  border-radius: 3px;\n  width: 100%;\n  height: ", ";\n  background: ", ";\n  display: flex;\n  align-items: center;\n  justify-content: center;\n  margin: 8px;\n"])), function (_ref4) {
  var $size = _ref4.$size;
  return "".concat($size, "px");
}, function (_ref5) {
  var $color = _ref5.$color;
  return $color || '#D8D8D8';
});
var StyledIcon = (0, _Style.styled)(_Icon["default"])(_templateObject4 || (_templateObject4 = _taggedTemplateLiteral(["\n  width: ", ";\n  font-size: ", ";\n"])), function (_ref6) {
  var $size = _ref6.$size;
  return $size ? "".concat($size * 2 / 5, "px") : '16px';
}, function (_ref7) {
  var $size = _ref7.$size;
  return $size ? "".concat($size / 3, "px") : '14px';
});