"use strict";

require("jest-styled-components");

require("react-testing-library/cleanup-after-each");

var _react = _interopRequireDefault(require("react"));

var _reactTestingLibrary = require("react-testing-library");

var _Colors = _interopRequireDefault(require("../../../apis/Colors"));

var _ = _interopRequireDefault(require(".."));

var _jsxRuntime = require("react/jsx-runtime");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

test('should render an IconCard', function () {
  var _render = (0, _reactTestingLibrary.render)( /*#__PURE__*/(0, _jsxRuntime.jsx)(_["default"], {
    icon: "airport-shuttle",
    color: _Colors["default"].BLUE,
    badge: 46,
    size: "large",
    text: "Riders",
    onPress: function onPress() {
      return console.log('test click');
    },
    testID: "test"
  })),
      getByTestId = _render.getByTestId;

  expect(getByTestId('test')).toMatchInlineSnapshot("\n    .c3 {\n      -webkit-align-items: stretch;\n      -webkit-box-align: stretch;\n      -ms-flex-align: stretch;\n      align-items: stretch;\n      border-color: #191E26;\n      border-style: solid;\n      border-width: 0;\n      box-sizing: border-box;\n      display: -webkit-box;\n      display: -webkit-flex;\n      display: -ms-flexbox;\n      display: flex;\n      -webkit-flex-direction: column;\n      -ms-flex-direction: column;\n      flex-direction: column;\n      -webkit-box-flex: 0;\n      -webkit-flex-grow: 0;\n      -ms-flex-positive: 0;\n      flex-grow: 0;\n      -webkit-flex-shrink: 0;\n      -ms-flex-negative: 0;\n      flex-shrink: 0;\n      position: relative;\n      min-height: 0;\n      min-width: 0;\n    }\n\n    .c0 {\n      -webkit-align-items: stretch;\n      -webkit-box-align: stretch;\n      -ms-flex-align: stretch;\n      align-items: stretch;\n      border-color: #191E26;\n      border-style: solid;\n      border-width: 0;\n      box-sizing: border-box;\n      display: -webkit-box;\n      display: -webkit-flex;\n      display: -ms-flexbox;\n      display: flex;\n      -webkit-flex-direction: column;\n      -ms-flex-direction: column;\n      flex-direction: column;\n      -webkit-box-flex: 0;\n      -webkit-flex-grow: 0;\n      -ms-flex-positive: 0;\n      flex-grow: 0;\n      -webkit-flex-shrink: 0;\n      -ms-flex-negative: 0;\n      flex-shrink: 0;\n      position: relative;\n      min-height: 0;\n      min-width: 0;\n    }\n\n    .c1 {\n      -webkit-align-items: stretch;\n      -webkit-box-align: stretch;\n      -ms-flex-align: stretch;\n      align-items: stretch;\n      border-color: #191E26;\n      border-style: solid;\n      border-width: 0;\n      box-sizing: border-box;\n      display: -webkit-box;\n      display: -webkit-flex;\n      display: -ms-flexbox;\n      display: flex;\n      -webkit-flex-direction: column;\n      -ms-flex-direction: column;\n      flex-direction: column;\n      -webkit-box-flex: 0;\n      -webkit-flex-grow: 0;\n      -ms-flex-positive: 0;\n      flex-grow: 0;\n      -webkit-flex-shrink: 0;\n      -ms-flex-negative: 0;\n      flex-shrink: 0;\n      position: relative;\n      min-height: 0;\n      min-width: 0;\n      background-color: transparent;\n      border-color: transparent;\n      border-width: 0;\n      padding: 0;\n      text-align: left;\n      outline: none;\n      cursor: pointer;\n    }\n\n    .c1 * {\n      cursor: pointer;\n    }\n\n    .c6 {\n      box-sizing: border-box;\n      color: #191E26;\n      display: inline;\n      -webkit-box-flex: 0;\n      -webkit-flex-grow: 0;\n      -ms-flex-positive: 0;\n      flex-grow: 0;\n      -webkit-flex-shrink: 0;\n      -ms-flex-negative: 0;\n      flex-shrink: 0;\n      font-family: \"Helvetica Neue\",Helvetica,Arial,sans-serif;\n      font-size: 14px;\n      position: relative;\n      white-space: pre-wrap;\n      word-wrap: break-word;\n      -ms-hyphens: auto;\n      cursor: inherit;\n    }\n\n    .c10 {\n      box-sizing: border-box;\n      color: #191E26;\n      display: inline;\n      -webkit-box-flex: 0;\n      -webkit-flex-grow: 0;\n      -ms-flex-positive: 0;\n      flex-grow: 0;\n      -webkit-flex-shrink: 0;\n      -ms-flex-negative: 0;\n      flex-shrink: 0;\n      font-family: \"Helvetica Neue\",Helvetica,Arial,sans-serif;\n      font-size: 14px;\n      position: relative;\n      white-space: pre-wrap;\n      word-wrap: break-word;\n      -ms-hyphens: auto;\n      cursor: text;\n      -webkit-user-select: text;\n      -moz-user-select: text;\n      -ms-user-select: text;\n      user-select: text;\n    }\n\n    .c5 {\n      padding: 2px;\n      border-radius: 20px;\n      background: #c23934;\n      position: absolute;\n      top: -5px;\n      right: -5px;\n      display: -webkit-box;\n      display: -webkit-flex;\n      display: -ms-flexbox;\n      display: flex;\n      -webkit-align-items: center;\n      -webkit-box-align: center;\n      -ms-flex-align: center;\n      align-items: center;\n      -webkit-box-pack: center;\n      -webkit-justify-content: center;\n      -ms-flex-pack: center;\n      justify-content: center;\n      min-width: 20px;\n      height: 20px;\n    }\n\n    .c7 {\n      color: white;\n      font-size: 12px;\n    }\n\n    .c8 {\n      font-family: Material Icons;\n      font-size: 16px;\n      text-align: center;\n    }\n\n    .c11 {\n      height: 24px;\n      line-height: 24px;\n      font-size: 16px;\n    }\n\n    .c2 {\n      -webkit-align-items: center;\n      -webkit-box-align: center;\n      -ms-flex-align: center;\n      align-items: center;\n      width: 120px;\n      margin: 12px;\n    }\n\n    .c4 {\n      padding: 8px;\n      border-radius: 3px;\n      width: 100%;\n      height: 120px;\n      background: #0070D2;\n      display: -webkit-box;\n      display: -webkit-flex;\n      display: -ms-flexbox;\n      display: flex;\n      -webkit-align-items: center;\n      -webkit-box-align: center;\n      -ms-flex-align: center;\n      align-items: center;\n      -webkit-box-pack: center;\n      -webkit-justify-content: center;\n      -ms-flex-pack: center;\n      justify-content: center;\n      margin: 8px;\n    }\n\n    .c9 {\n      -webkit-flex: none;\n      -ms-flex: none;\n      flex: none;\n      -webkit-align-items: center;\n      -webkit-box-align: center;\n      -ms-flex-align: center;\n      align-items: center;\n      color: white;\n      height: 24px;\n      line-height: 24px;\n      width: 24px;\n      font-size: 16px;\n      width: 48px;\n      font-size: 40px;\n    }\n\n    <div\n      class=\"c0 c1 c2\"\n      data-testid=\"test\"\n      role=\"button\"\n      tabindex=\"0\"\n    >\n      <div\n        class=\"c3 c4\"\n      >\n        <div\n          class=\"c3 c5\"\n        >\n          <div\n            class=\"c6 c7\"\n            data-text-as-pseudo-element=\"46\"\n          />\n        </div>\n        <div\n          class=\"c6 c8 sc-AxmLO c9\"\n          data-text-as-pseudo-element=\"\uEB3C\"\n        />\n      </div>\n      <div\n        class=\"c10 c11 \"\n      >\n        Riders\n      </div>\n    </div>\n  ");
});