"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _chunk = _interopRequireDefault(require("lodash/chunk"));

var _react = _interopRequireWildcard(require("react"));

var _styledComponents = _interopRequireDefault(require("styled-components"));

var _MaterialIcons = _interopRequireDefault(require("../../../../../glyphmaps/MaterialIcons.json"));

var _TextField = _interopRequireDefault(require("../../../../components/input-fields/TextField"));

var _FlatList = _interopRequireDefault(require("../../../../primitives/FlatList"));

var _View = _interopRequireDefault(require("../../../../primitives/View"));

var _IconButton = _interopRequireDefault(require("../../../IconButton"));

var _Modal = _interopRequireDefault(require("../../../Modal"));

var _jsxRuntime = require("react/jsx-runtime");

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { if (typeof Symbol === "undefined" || !(Symbol.iterator in Object(arr))) return; var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

var iconList = Object.keys(_MaterialIcons["default"]);

var IconModal = function IconModal(_ref) {
  var modalVisable = _ref.modalVisable,
      setModalVisable = _ref.setModalVisable,
      setIconName = _ref.setIconName;
  var ARRAY_SIZE = 23;

  var _useState = (0, _react.useState)(''),
      _useState2 = _slicedToArray(_useState, 2),
      input = _useState2[0],
      setInput = _useState2[1]; // filter the list and generate 2D array for flatList


  var resultArray = (0, _react.useMemo)(function () {
    return (0, _chunk["default"])(iconList.filter(function (icon) {
      return input ? icon.includes(input) : true;
    }), ARRAY_SIZE);
  }, [input]);
  return /*#__PURE__*/(0, _jsxRuntime.jsx)(_Modal["default"], {
    onRequestClose: function onRequestClose() {
      return setModalVisable(false);
    },
    visible: modalVisable,
    title: "Please choose your Icon",
    children: /*#__PURE__*/(0, _jsxRuntime.jsxs)(IconsContainer, {
      children: [/*#__PURE__*/(0, _jsxRuntime.jsx)(_TextField["default"], {
        value: input,
        onValueChange: setInput,
        placeholder: "Type to search Icon",
        reserveErrorSpace: false
      }), /*#__PURE__*/(0, _jsxRuntime.jsx)(FlatListContainer, {
        children: /*#__PURE__*/(0, _jsxRuntime.jsx)(_FlatList["default"], {
          horizontal: false,
          data: resultArray,
          renderItem: function renderItem(_ref2) {
            var item = _ref2.item;
            return /*#__PURE__*/(0, _jsxRuntime.jsx)(FlatListRow, {
              children: item.map(function (icon) {
                return /*#__PURE__*/(0, _jsxRuntime.jsx)(_IconButton["default"], {
                  name: icon,
                  onPress: function onPress() {
                    setIconName(icon);
                    setModalVisable(false);
                  },
                  tooltip: icon
                }, icon);
              })
            }, item[0]);
          }
        })
      })]
    })
  });
};

var IconsContainer = (0, _styledComponents["default"])(_View["default"]).withConfig({
  displayName: "IconModal__IconsContainer",
  componentId: "sc-1qhr86a-0"
})(["padding:0px 8px;"]);
var FlatListContainer = (0, _styledComponents["default"])(_View["default"]).withConfig({
  displayName: "IconModal__FlatListContainer",
  componentId: "sc-1qhr86a-1"
})(["align-items:center;height:145px;"]);
var FlatListRow = (0, _styledComponents["default"])(_View["default"]).withConfig({
  displayName: "IconModal__FlatListRow",
  componentId: "sc-1qhr86a-2"
})(["flex-direction:row;"]);
var _default = IconModal;
exports["default"] = _default;