"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.IconList = IconList;

var _react = _interopRequireWildcard(require("react"));

var _styledComponents = _interopRequireDefault(require("styled-components"));

var _Icon = _interopRequireDefault(require("../../../Icon"));

var _jsxRuntime = require("react/jsx-runtime");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { if (typeof Symbol === "undefined" || !(Symbol.iterator in Object(arr))) return; var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function IconList(_ref) {
  var onSelect = _ref.onSelect,
      selectedIcons = _ref.selectedIcons;

  var _useState = (0, _react.useState)(144),
      _useState2 = _slicedToArray(_useState, 2),
      count = _useState2[0],
      setCount = _useState2[1]; // render 144 items only for super fast response time
  // then trigger second round of rendering for all itmes, that happens during thinking time


  (0, _react.useEffect)(function () {
    var timeoutId = window.setTimeout(function () {
      return setCount(999999);
    }, 0);
    return function () {
      window.clearTimeout(timeoutId);
    };
  }, []);
  return /*#__PURE__*/(0, _jsxRuntime.jsx)("div", {
    style: {
      width: '100%',
      height: 145,
      overflowY: 'scroll'
    },
    children: selectedIcons.slice(0, count).map(function (icon) {
      return /*#__PURE__*/(0, _jsxRuntime.jsx)(LinkOuter, {
        children: /*#__PURE__*/(0, _jsxRuntime.jsx)(Link, {
          onClick: function onClick() {
            return onSelect(icon);
          },
          children: /*#__PURE__*/(0, _jsxRuntime.jsx)(_Icon["default"], {
            name: icon
          })
        }, icon)
      });
    })
  });
}

var LinkOuter = _styledComponents["default"].div.withConfig({
  displayName: "IconList__LinkOuter",
  componentId: "sc-1exslmc-0"
})(["display:inline-block;width:24px;height:24px;"]);

var Link = _styledComponents["default"].div.withConfig({
  displayName: "IconList__Link",
  componentId: "sc-1exslmc-1"
})(["display:flex;justify-content:center;align-items:center;width:24px;height:24px;cursor:pointer;&:hover{background-color:#ddd;}"]);