"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = Menu;

var React = _interopRequireWildcard(require("react"));

var _Colors = _interopRequireDefault(require("../../apis/Colors"));

var _DeviceKind = require("../../apis/DeviceKind");

var _Popover = require("../../internals/Popover.web");

var _Icon = _interopRequireDefault(require("../Icon"));

var _MenuContext = require("./MenuContext");

var _StyledComponents = require("./StyledComponents.web");

var _jsxRuntime = require("react/jsx-runtime");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { if (typeof Symbol === "undefined" || !(Symbol.iterator in Object(arr))) return; var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function Menu(_ref) {
  var align = _ref.align,
      children = _ref.children,
      className = _ref.className,
      _ref$icon = _ref.icon,
      icon = _ref$icon === void 0 ? 'menu' : _ref$icon,
      _ref$iconColor = _ref.iconColor,
      iconColor = _ref$iconColor === void 0 ? _Colors["default"].BLACK : _ref$iconColor,
      _ref$maxHeight = _ref.maxHeight,
      maxHeight = _ref$maxHeight === void 0 ? 150 : _ref$maxHeight,
      maxWidth = _ref.maxWidth,
      _ref$minWidth = _ref.minWidth,
      minWidth = _ref$minWidth === void 0 ? 120 : _ref$minWidth,
      testID = _ref.testID,
      trigger = _ref.trigger,
      triggerStyle = _ref.triggerStyle;

  var _React$useState = React.useState(false),
      _React$useState2 = _slicedToArray(_React$useState, 2),
      active = _React$useState2[0],
      setActive = _React$useState2[1];

  var containerRef = React.useRef(null);
  var deviceKind = (0, _DeviceKind.useDeviceKind)();

  var close = function close() {
    return setActive(false);
  };

  var open = function open() {
    return setActive(false);
  };

  var getPopoverPlacement = function getPopoverPlacement(anchorRect, popupContentRect) {
    var right = anchorRect.left - popupContentRect.width + anchorRect.width;
    var distanceFromRight = window.innerWidth - anchorRect.left - anchorRect.width;

    var _align = align || (anchorRect.left < distanceFromRight * 2 ? 'left' : 'right');

    return {
      top: anchorRect.bottom,
      left: _align === 'left' ? anchorRect.left : right
    };
  };

  return /*#__PURE__*/(0, _jsxRuntime.jsxs)(_MenuContext.Context.Provider, {
    value: {
      open: open,
      close: close,
      active: active
    },
    children: [/*#__PURE__*/(0, _jsxRuntime.jsx)(_StyledComponents.TriggerContainer, {
      ref: containerRef,
      className: className,
      onClick: function onClick() {
        return setActive(true);
      },
      testID: testID,
      style: triggerStyle,
      children: typeof trigger === 'function' ? trigger(open, close, active) : trigger || /*#__PURE__*/(0, _jsxRuntime.jsx)(_Icon["default"], {
        name: icon,
        color: iconColor
      })
    }), active ? /*#__PURE__*/(0, _jsxRuntime.jsx)(_Popover.Popover, {
      anchorEl: containerRef.current,
      onRequestClose: function onRequestClose() {
        return setActive(false);
      },
      placement: getPopoverPlacement,
      visible: true,
      children: /*#__PURE__*/(0, _jsxRuntime.jsx)(_StyledComponents.PopoverContentContainer, {
        $minWidth: minWidth,
        $maxWidth: maxWidth,
        $maxHeight: maxHeight,
        $deviceKind: deviceKind,
        children: children
      })
    }) : null]
  });
}

var Item = function Item(_ref2) {
  var children = _ref2.children,
      icon = _ref2.icon,
      numberOfLines = _ref2.numberOfLines,
      _onPress = _ref2.onPress;
  var context = (0, _MenuContext.useMenuContext)();
  return /*#__PURE__*/(0, _jsxRuntime.jsx)(_StyledComponents.ActionRow, {
    onPress: function onPress() {
      context.close();
      _onPress === null || _onPress === void 0 ? void 0 : _onPress();
    },
    children: typeof children === 'string' ? /*#__PURE__*/(0, _jsxRuntime.jsxs)(React.Fragment, {
      children: [icon ? /*#__PURE__*/(0, _jsxRuntime.jsx)(_StyledComponents.MenuItemIcon, {
        name: icon
      }) : null, /*#__PURE__*/(0, _jsxRuntime.jsx)(_StyledComponents.MenuItemLabel, {
        numberOfLines: numberOfLines,
        $hasIcon: !!icon,
        children: children
      })]
    }) : children
  });
};

Menu.Item = Item;