"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.MenuItemLabel = exports.MenuItemIcon = exports.PopoverContentContainer = exports.TriggerContainer = exports.ActionRow = void 0;

var _styledComponents = _interopRequireDefault(require("styled-components"));

var _TouchableViewBase = require("../../internals/web/TouchableViewBase");

var _ScrollView = _interopRequireDefault(require("../../primitives/ScrollView"));

var _Text = _interopRequireDefault(require("../../primitives/Text"));

var _TouchableView = _interopRequireDefault(require("../../primitives/TouchableView"));

var _Icon = _interopRequireDefault(require("../Icon"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

var ActionRow = (0, _styledComponents["default"])(_TouchableView["default"]).withConfig({
  displayName: "StyledComponentsweb__ActionRow",
  componentId: "sc-1912se6-0"
})(["flex-direction:row;border-bottom:1px solid #ddd;height:40px;align-items:center;&:hover{background-color:#fafafa;}"]);
exports.ActionRow = ActionRow;
var TriggerContainer = (0, _styledComponents["default"])(_TouchableViewBase.DivTouchableViewBase).withConfig({
  displayName: "StyledComponentsweb__TriggerContainer",
  componentId: "sc-1912se6-1"
})([""]);
exports.TriggerContainer = TriggerContainer;
var PopoverContentContainer = (0, _styledComponents["default"])(_ScrollView["default"]).withConfig({
  displayName: "StyledComponentsweb__PopoverContentContainer",
  componentId: "sc-1912se6-2"
})(["", ""], function (_ref) {
  var $deviceKind = _ref.$deviceKind,
      $maxWidth = _ref.$maxWidth,
      $minWidth = _ref.$minWidth,
      $maxHeight = _ref.$maxHeight;

  if ($deviceKind === 'desktop' || $deviceKind === 'tablet') {
    return "".concat($maxWidth ? "max-width: ".concat($maxWidth, "px; ") : '', "\n        ").concat($minWidth ? "min-width: ".concat($minWidth, "px; ") : '', "\n        ").concat($maxHeight ? "max-height: ".concat($maxHeight, "px; ") : '');
  } else {
    return "max-height: 50vh;";
  }
});
exports.PopoverContentContainer = PopoverContentContainer;
var MenuItemIcon = (0, _styledComponents["default"])(_Icon["default"]).withConfig({
  displayName: "StyledComponentsweb__MenuItemIcon",
  componentId: "sc-1912se6-3"
})(["margin-left:8px;"]);
exports.MenuItemIcon = MenuItemIcon;
var MenuItemLabel = (0, _styledComponents["default"])(_Text["default"]).withConfig({
  displayName: "StyledComponentsweb__MenuItemLabel",
  componentId: "sc-1912se6-4"
})(["padding-right:8px;", ";"], function (_ref2) {
  var $hasIcon = _ref2.$hasIcon;
  return $hasIcon ? '' : "padding-left: 8px;";
});
exports.MenuItemLabel = MenuItemLabel;