"use strict";

require("jest-styled-components");

require("react-testing-library/cleanup-after-each");

var _userEvent = _interopRequireDefault(require("@testing-library/user-event"));

var _react = _interopRequireDefault(require("react"));

var _reactTestingLibrary = require("react-testing-library");

var _ = _interopRequireDefault(require(".."));

var _jsxRuntime = require("react/jsx-runtime");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

test('should render a menu with two menu items', function () {
  var _render = (0, _reactTestingLibrary.render)( /*#__PURE__*/(0, _jsxRuntime.jsxs)(_["default"], {
    icon: "cloud",
    testID: "test",
    children: [/*#__PURE__*/(0, _jsxRuntime.jsx)(_["default"].Item, {
      icon: "home",
      onPress: function onPress() {
        return console.log('menu1 pressed');
      },
      children: "menu1"
    }), /*#__PURE__*/(0, _jsxRuntime.jsx)(_["default"].Item, {
      onPress: function onPress() {
        return console.log('menu2 pressed');
      },
      children: "menu2"
    })]
  })),
      getByTestId = _render.getByTestId; //Simulate mouse click to expand menu


  _userEvent["default"].click(getByTestId('test').querySelector('div'));

  expect(getByTestId('overlay-container')).toMatchInlineSnapshot("\n    .c9 {\n      box-sizing: border-box;\n      color: #191E26;\n      display: inline;\n      -webkit-box-flex: 0;\n      -webkit-flex-grow: 0;\n      -ms-flex-positive: 0;\n      flex-grow: 0;\n      -webkit-flex-shrink: 0;\n      -ms-flex-negative: 0;\n      flex-shrink: 0;\n      font-family: \"Helvetica Neue\",Helvetica,Arial,sans-serif;\n      font-size: 14px;\n      position: relative;\n      white-space: pre-wrap;\n      word-wrap: break-word;\n      -ms-hyphens: auto;\n      cursor: inherit;\n    }\n\n    .c10 {\n      font-family: Material Icons;\n      font-size: 16px;\n      text-align: center;\n    }\n\n    .c0 {\n      -webkit-align-items: stretch;\n      -webkit-box-align: stretch;\n      -ms-flex-align: stretch;\n      align-items: stretch;\n      border-color: #191E26;\n      border-style: solid;\n      border-width: 0;\n      box-sizing: border-box;\n      display: -webkit-box;\n      display: -webkit-flex;\n      display: -ms-flexbox;\n      display: flex;\n      -webkit-flex-direction: column;\n      -ms-flex-direction: column;\n      flex-direction: column;\n      -webkit-box-flex: 0;\n      -webkit-flex-grow: 0;\n      -ms-flex-positive: 0;\n      flex-grow: 0;\n      -webkit-flex-shrink: 0;\n      -ms-flex-negative: 0;\n      flex-shrink: 0;\n      position: relative;\n      min-height: 0;\n      min-width: 0;\n    }\n\n    .c6 {\n      -webkit-align-items: stretch;\n      -webkit-box-align: stretch;\n      -ms-flex-align: stretch;\n      align-items: stretch;\n      border-color: #191E26;\n      border-style: solid;\n      border-width: 0;\n      box-sizing: border-box;\n      display: -webkit-box;\n      display: -webkit-flex;\n      display: -ms-flexbox;\n      display: flex;\n      -webkit-flex-direction: column;\n      -ms-flex-direction: column;\n      flex-direction: column;\n      -webkit-box-flex: 0;\n      -webkit-flex-grow: 0;\n      -ms-flex-positive: 0;\n      flex-grow: 0;\n      -webkit-flex-shrink: 0;\n      -ms-flex-negative: 0;\n      flex-shrink: 0;\n      position: relative;\n      min-height: 0;\n      min-width: 0;\n    }\n\n    .c7 {\n      -webkit-align-items: stretch;\n      -webkit-box-align: stretch;\n      -ms-flex-align: stretch;\n      align-items: stretch;\n      border-color: #191E26;\n      border-style: solid;\n      border-width: 0;\n      box-sizing: border-box;\n      display: -webkit-box;\n      display: -webkit-flex;\n      display: -ms-flexbox;\n      display: flex;\n      -webkit-flex-direction: column;\n      -ms-flex-direction: column;\n      flex-direction: column;\n      -webkit-box-flex: 0;\n      -webkit-flex-grow: 0;\n      -ms-flex-positive: 0;\n      flex-grow: 0;\n      -webkit-flex-shrink: 0;\n      -ms-flex-negative: 0;\n      flex-shrink: 0;\n      position: relative;\n      min-height: 0;\n      min-width: 0;\n      background-color: transparent;\n      border-color: transparent;\n      border-width: 0;\n      padding: 0;\n      text-align: left;\n      outline: none;\n      cursor: pointer;\n    }\n\n    .c7 * {\n      cursor: pointer;\n    }\n\n    .c1 {\n      position: fixed;\n      top: 0;\n      bottom: 0;\n      left: 0;\n      right: 0;\n      background-color: rgba(0,0,0,0.5);\n    }\n\n    .c2 {\n      position: absolute;\n      background-color: white;\n      border-top: 1px solid #ccc;\n      box-shadow: 0 -1px 0 rgba(0,0,0,0.06);\n      bottom: 0;\n      left: 0;\n      right: 0;\n    }\n\n    .c3 {\n      -webkit-flex: 1;\n      -ms-flex: 1;\n      flex: 1;\n      overflow-x: hidden;\n      overflow-y: auto;\n      -webkit-overflow-scrolling: touch;\n      -webkit-transform: translateZ(0);\n      -ms-transform: translateZ(0);\n      transform: translateZ(0);\n    }\n\n    .c5 {\n      min-height: 100%;\n    }\n\n    .c8 {\n      -webkit-flex-direction: row;\n      -ms-flex-direction: row;\n      flex-direction: row;\n      border-bottom: 1px solid #ddd;\n      height: 40px;\n      -webkit-align-items: center;\n      -webkit-box-align: center;\n      -ms-flex-align: center;\n      align-items: center;\n    }\n\n    .c8:hover {\n      background-color: #fafafa;\n    }\n\n    .c4 {\n      max-height: 50vh;\n    }\n\n    .c11 {\n      -webkit-flex: none;\n      -ms-flex: none;\n      flex: none;\n      -webkit-align-items: center;\n      -webkit-box-align: center;\n      -ms-flex-align: center;\n      align-items: center;\n      height: 24px;\n      line-height: 24px;\n      width: 24px;\n      font-size: 16px;\n      margin-left: 8px;\n    }\n\n    .c12 {\n      padding-right: 8px;\n    }\n\n    .c13 {\n      padding-right: 8px;\n      padding-left: 8px;\n    }\n\n    <div\n      aria-modal=\"true\"\n      class=\"c0 c1\"\n      data-testid=\"overlay-container\"\n    >\n      <div\n        class=\"c0 c2\"\n      >\n        <div\n          class=\"c0 c3 c4\"\n        >\n          <div\n            class=\"c0 c5\"\n          >\n            <div\n              class=\"c6 c7 c8\"\n              role=\"button\"\n              tabindex=\"0\"\n            >\n              <div\n                class=\"c9 c10 c11\"\n                data-text-as-pseudo-element=\"\uE88A\"\n              />\n              <div\n                class=\"c9 c12\"\n                data-text-as-pseudo-element=\"menu1\"\n              />\n            </div>\n            <div\n              class=\"c6 c7 c8\"\n              role=\"button\"\n              tabindex=\"0\"\n            >\n              <div\n                class=\"c9 c13\"\n                data-text-as-pseudo-element=\"menu2\"\n              />\n            </div>\n          </div>\n        </div>\n      </div>\n    </div>\n  ");
});