"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var React = _interopRequireWildcard(require("react"));

var _reactNative = require("react-native");

var _styledComponents = _interopRequireDefault(require("styled-components"));

var _Overlay = _interopRequireDefault(require("../../../primitives/Overlay"));

var _Text = _interopRequireDefault(require("../../../primitives/Text"));

var _FormBody = require("../../ModalForm/FormBody/FormBody.native");

var _StyledComponents = require("../../ModalForm/StyledComponents");

var _jsxRuntime = require("react/jsx-runtime");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (typeof call === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

var Modal = /*#__PURE__*/function (_React$Component) {
  _inherits(Modal, _React$Component);

  var _super = _createSuper(Modal);

  function Modal() {
    _classCallCheck(this, Modal);

    return _super.apply(this, arguments);
  }

  _createClass(Modal, [{
    key: "render",
    value: function render() {
      var _this$props = this.props,
          children = _this$props.children,
          onRequestClose = _this$props.onRequestClose,
          visible = _this$props.visible,
          title = _this$props.title,
          hideHeader = _this$props.hideHeader;
      return /*#__PURE__*/(0, _jsxRuntime.jsx)(_Overlay["default"], {
        onPress: onRequestClose,
        visible: visible,
        children: /*#__PURE__*/(0, _jsxRuntime.jsxs)(ModalOuterContainer, {
          children: [title || !hideHeader ? /*#__PURE__*/(0, _jsxRuntime.jsxs)(_FormBody.ModalFormHeader, {
            children: [/*#__PURE__*/(0, _jsxRuntime.jsx)(_StyledComponents.ModalFormHeaderCancelButton, {
              onPress: onRequestClose
            }), /*#__PURE__*/(0, _jsxRuntime.jsx)(_StyledComponents.ModalFormTitleContainer, {
              children: /*#__PURE__*/(0, _jsxRuntime.jsx)(_FormBody.ModalFormTitleText, {
                children: title
              })
            })]
          }) : null, /*#__PURE__*/(0, _jsxRuntime.jsx)(ModalSafeArea, {
            children: /*#__PURE__*/(0, _jsxRuntime.jsx)(ModalContentContainer, {
              children: children
            })
          })]
        })
      });
    }
  }]);

  return Modal;
}(React.Component);

Modal.defaultProps = {
  hideHeader: false
};
var _default = Modal;
exports["default"] = _default;

var ModalOuterContainer = _styledComponents["default"].SafeAreaView.withConfig({
  displayName: "Modal__ModalOuterContainer",
  componentId: "xqv4ld-0"
})(["flex:1;"]);

var ModalSafeArea = _styledComponents["default"].View.withConfig({
  displayName: "Modal__ModalSafeArea",
  componentId: "xqv4ld-1"
})(["flex:1;"]);

var ModalContentContainer = _styledComponents["default"].View.withConfig({
  displayName: "Modal__ModalContentContainer",
  componentId: "xqv4ld-2"
})(["background-color:white;position:absolute;top:0;bottom:0;left:0;right:0;"]);