"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.ModalFormHeader = exports.ModalFormTitleText = exports["default"] = void 0;

var _react = _interopRequireDefault(require("react"));

var _reactNative = require("react-native");

var _reactNativeKeyboardAwareScrollView = require("react-native-keyboard-aware-scroll-view");

var _styledComponents = _interopRequireDefault(require("styled-components"));

var _FormConfigContext = require("../../../primitives/Form/Form.native/FormConfigContext");

var _Text = _interopRequireDefault(require("../../../primitives/Text"));

var _Button = _interopRequireDefault(require("../../Button"));

var _StyledComponents = require("../StyledComponents");

var _jsxRuntime = require("react/jsx-runtime");

var _templateObject, _templateObject2;

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _taggedTemplateLiteral(strings, raw) { if (!raw) { raw = strings.slice(0); } return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }

var FormBody = function FormBody(_ref) {
  var children = _ref.children,
      contentContainerStyle = _ref.contentContainerStyle,
      onCancel = _ref.onCancel,
      onDelete = _ref.onDelete,
      onSubmit = _ref.onSubmit,
      _ref$submitButtonText = _ref.submitButtonText,
      submitButtonText = _ref$submitButtonText === void 0 ? 'Submit' : _ref$submitButtonText,
      testID = _ref.testID,
      title = _ref.title;
  return /*#__PURE__*/(0, _jsxRuntime.jsx)(_FormConfigContext.FormConfigContext.Provider, {
    value: {
      onSubmit: onSubmit
    },
    children: /*#__PURE__*/(0, _jsxRuntime.jsxs)(StyledForm, {
      testID: testID,
      children: [/*#__PURE__*/(0, _jsxRuntime.jsxs)(ModalFormHeader, {
        children: [/*#__PURE__*/(0, _jsxRuntime.jsx)(_StyledComponents.ModalFormHeaderCancelButton, {
          onPress: onCancel
        }), /*#__PURE__*/(0, _jsxRuntime.jsx)(_StyledComponents.ModalFormHeaderSubmitButton, {
          text: submitButtonText
        }), /*#__PURE__*/(0, _jsxRuntime.jsx)(_StyledComponents.ModalFormTitleContainer, {
          children: /*#__PURE__*/(0, _jsxRuntime.jsx)(ModalFormTitleText, {
            children: title
          })
        })]
      }), /*#__PURE__*/(0, _jsxRuntime.jsxs)(ModalFormContent, {
        contentContainerStyle: contentContainerStyle,
        extraScrollHeight: 100,
        children: [children, onDelete && /*#__PURE__*/(0, _jsxRuntime.jsx)(ModalFormDeleteButton, {
          onPress: onDelete,
          text: "Delete"
        })]
      })]
    })
  });
};

var _default = FormBody;
exports["default"] = _default;
var StyledForm = (0, _styledComponents["default"])(_reactNative.View).withConfig({
  displayName: "FormBodynative__StyledForm",
  componentId: "sc-1c0pb26-0"
})(["flex:1;"]);
var ModalFormTitleText = (0, _styledComponents["default"])(_Text["default"]).attrs(function (props) {
  return {
    numberOfLines: 2
  };
}).withConfig({
  displayName: "FormBodynative__ModalFormTitleText",
  componentId: "sc-1c0pb26-1"
})(["", ";"], _StyledComponents.modalFormMobileTitleTextStyle);
exports.ModalFormTitleText = ModalFormTitleText;

var ModalFormHeaderContainer = _styledComponents["default"].SafeAreaView(_templateObject || (_templateObject = _taggedTemplateLiteral(["\n  ", ";\n"])), _StyledComponents.modalFormMobileHeaderContainerStyle);

var ModalFormHeaderInnerContainer = _styledComponents["default"].View(_templateObject2 || (_templateObject2 = _taggedTemplateLiteral(["\n  ", ";\n"])), _StyledComponents.modalFormMobileHeaderStyle);

var ModalFormHeader = function ModalFormHeader(_ref2) {
  var children = _ref2.children;
  return /*#__PURE__*/(0, _jsxRuntime.jsx)(ModalFormHeaderContainer, {
    children: /*#__PURE__*/(0, _jsxRuntime.jsx)(ModalFormHeaderInnerContainer, {
      children: children
    })
  });
};

exports.ModalFormHeader = ModalFormHeader;
var ModalFormContent = (0, _styledComponents["default"])(_reactNativeKeyboardAwareScrollView.KeyboardAwareScrollView).withConfig({
  displayName: "FormBodynative__ModalFormContent",
  componentId: "sc-1c0pb26-2"
})(["", ";"], _StyledComponents.modalFormContentStyle);
var ModalFormDeleteButton = (0, _styledComponents["default"])(_Button["default"]).attrs(function (props) {
  return {
    type: 'destructive'
  };
}).withConfig({
  displayName: "FormBodynative__ModalFormDeleteButton",
  componentId: "sc-1c0pb26-3"
})([""]);