"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var React = _interopRequireWildcard(require("react"));

var _useMountedState = _interopRequireDefault(require("react-use/lib/useMountedState"));

var _styledComponents = _interopRequireDefault(require("styled-components"));

var _DeviceKind = require("../../../apis/DeviceKind");

var _Icon = _interopRequireDefault(require("../../../components/Icon"));

var _FlexDiv = _interopRequireDefault(require("../../../internals/web/FlexDiv"));

var _FlexForm = _interopRequireDefault(require("../../../internals/web/FlexForm"));

var _Text = _interopRequireDefault(require("../../../primitives/Text"));

var _TouchableView = _interopRequireDefault(require("../../../primitives/TouchableView"));

var _Button = _interopRequireDefault(require("../../Button"));

var _SubmitButton = _interopRequireDefault(require("../../SubmitButton"));

var _StyledComponents = require("../StyledComponents");

var _jsxRuntime = require("react/jsx-runtime");

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { if (typeof Symbol === "undefined" || !(Symbol.iterator in Object(arr))) return; var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function FormBody(_ref) {
  var children = _ref.children,
      contentContainerStyle = _ref.contentContainerStyle,
      onCancel = _ref.onCancel,
      onDelete = _ref.onDelete,
      onSubmit = _ref.onSubmit,
      _ref$submitButtonText = _ref.submitButtonText,
      submitButtonText = _ref$submitButtonText === void 0 ? 'Submit' : _ref$submitButtonText,
      testID = _ref.testID,
      title = _ref.title;
  var deviceKind = (0, _DeviceKind.useDeviceKind)();
  var isMounted = (0, _useMountedState["default"])();

  var _React$useState = React.useState(false),
      _React$useState2 = _slicedToArray(_React$useState, 2),
      deleting = _React$useState2[0],
      setDeleting = _React$useState2[1];

  var handleDelete = /*#__PURE__*/function () {
    var _ref2 = _asyncToGenerator( /*#__PURE__*/_regenerator["default"].mark(function _callee() {
      return _regenerator["default"].wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              if (!onDelete) {
                _context.next = 8;
                break;
              }

              setDeleting(true);
              _context.prev = 2;
              _context.next = 5;
              return onDelete();

            case 5:
              _context.prev = 5;

              if (isMounted()) {
                setDeleting(false);
              }

              return _context.finish(5);

            case 8:
            case "end":
              return _context.stop();
          }
        }
      }, _callee, null, [[2,, 5, 8]]);
    }));

    return function handleDelete() {
      return _ref2.apply(this, arguments);
    };
  }();

  var handleSubmit = function handleSubmit(event) {
    event.preventDefault();
    event.stopPropagation();
    onSubmit && onSubmit();
  };

  return /*#__PURE__*/(0, _jsxRuntime.jsxs)(StyledForm, {
    "data-testid": testID,
    onSubmit: handleSubmit,
    children: [/*#__PURE__*/(0, _jsxRuntime.jsxs)(ModalFormHeader, {
      $deviceKind: deviceKind,
      children: [deviceKind === 'tablet' || deviceKind === 'desktop' ? /*#__PURE__*/(0, _jsxRuntime.jsx)(ModalFormCloseButton, {
        onPress: onCancel
      }) : /*#__PURE__*/(0, _jsxRuntime.jsxs)(ModalFormHeaderMobileContainer, {
        children: [/*#__PURE__*/(0, _jsxRuntime.jsx)(_StyledComponents.ModalFormHeaderCancelButton, {
          onPress: onCancel
        }), /*#__PURE__*/(0, _jsxRuntime.jsx)(_StyledComponents.ModalFormHeaderSubmitButton, {
          text: submitButtonText
        })]
      }), /*#__PURE__*/(0, _jsxRuntime.jsx)(_StyledComponents.ModalFormTitleContainer, {
        children: /*#__PURE__*/(0, _jsxRuntime.jsx)(ModalFormTitleText, {
          $deviceKind: deviceKind,
          children: title
        })
      })]
    }), /*#__PURE__*/(0, _jsxRuntime.jsxs)(ModalFormContent, {
      $deviceKind: deviceKind,
      style: contentContainerStyle,
      children: [children, (deviceKind === 'phone' || deviceKind === 'large-phone') && onDelete ? /*#__PURE__*/(0, _jsxRuntime.jsx)(ModalFormMobileDeleteButton, {
        loading: deleting,
        onPress: handleDelete,
        text: "Delete"
      }) : null]
    }), deviceKind === 'tablet' || deviceKind === 'desktop' ? /*#__PURE__*/(0, _jsxRuntime.jsxs)(ModalFormFooter, {
      children: [/*#__PURE__*/(0, _jsxRuntime.jsx)(ModalFormRow, {
        children: onDelete && /*#__PURE__*/(0, _jsxRuntime.jsx)(ModalFormFooterDeleteButton, {
          loading: deleting,
          onPress: handleDelete,
          text: "Delete"
        })
      }), /*#__PURE__*/(0, _jsxRuntime.jsxs)(ModalFormRow, {
        children: [/*#__PURE__*/(0, _jsxRuntime.jsx)(ModalFormFooterCancelButton, {
          onPress: onCancel,
          text: "Cancel",
          testID: "modalForm-footer-cancel-button"
        }), /*#__PURE__*/(0, _jsxRuntime.jsx)(_SubmitButton["default"], {
          text: submitButtonText,
          testID: "modalForm-footer-submit-button"
        })]
      })]
    }) : null]
  });
}

var _default = FormBody;
exports["default"] = _default;
var StyledForm = (0, _styledComponents["default"])(_FlexForm["default"]).withConfig({
  displayName: "FormBodyweb__StyledForm",
  componentId: "sc-1ohi38h-0"
})(["flex:1;"]);
var ModalFormTitleText = (0, _styledComponents["default"])(_Text["default"]).attrs(function (props) {
  return {
    numberOfLines: 2
  };
}).withConfig({
  displayName: "FormBodyweb__ModalFormTitleText",
  componentId: "sc-1ohi38h-1"
})(["font-size:20px;color:#2b2826;", ""], function (props) {
  return props.$deviceKind === 'phone' || props.$deviceKind === 'large-phone' ? _StyledComponents.modalFormMobileTitleTextStyle : '';
});
var ModalFormHeader = (0, _styledComponents["default"])(_FlexDiv["default"]).withConfig({
  displayName: "FormBodyweb__ModalFormHeader",
  componentId: "sc-1ohi38h-2"
})(["flex:none;flex-direction:row;justify-content:space-between;background-color:white;border-bottom:1px solid #dddbda;height:55px;", ""], function (props) {
  return props.$deviceKind === 'phone' || props.$deviceKind === 'large-phone' ? "".concat(_StyledComponents.modalFormMobileHeaderStyle, ";\n      ").concat(_StyledComponents.modalFormMobileHeaderContainerStyle, ";\n      ") : '';
});
var ModalFormCloseButtonContainer = (0, _styledComponents["default"])(_TouchableView["default"]).withConfig({
  displayName: "FormBodyweb__ModalFormCloseButtonContainer",
  componentId: "sc-1ohi38h-3"
})(["align-items:center;justify-content:center;margin-left:auto;padding:20px;"]);

var ModalFormCloseButton = function ModalFormCloseButton(props) {
  return /*#__PURE__*/(0, _jsxRuntime.jsx)(ModalFormCloseButtonContainer, _objectSpread(_objectSpread({}, props), {}, {
    children: /*#__PURE__*/(0, _jsxRuntime.jsx)(_Icon["default"], {
      name: "clear"
    })
  }));
};

var ModalFormHeaderMobileContainer = (0, _styledComponents["default"])(_FlexDiv["default"]).withConfig({
  displayName: "FormBodyweb__ModalFormHeaderMobileContainer",
  componentId: "sc-1ohi38h-4"
})(["display:flex;flex:1;flex-direction:row;justify-content:space-between;"]);
var ModalFormMobileDeleteButton = (0, _styledComponents["default"])(_Button["default"]).attrs(function (props) {
  return {
    type: 'destructive'
  };
}).withConfig({
  displayName: "FormBodyweb__ModalFormMobileDeleteButton",
  componentId: "sc-1ohi38h-5"
})([""]);
var ModalFormContent = (0, _styledComponents["default"])(_FlexDiv["default"]).withConfig({
  displayName: "FormBodyweb__ModalFormContent",
  componentId: "sc-1ohi38h-6"
})(["flex:1;background-color:white;overflow-y:auto;padding:38px 38px 20px 38px;", ""], function (props) {
  return props.$deviceKind === 'phone' || props.$deviceKind === 'large-phone' ? _StyledComponents.modalFormContentStyle : '';
});
var ModalFormFooter = (0, _styledComponents["default"])(_FlexDiv["default"]).withConfig({
  displayName: "FormBodyweb__ModalFormFooter",
  componentId: "sc-1ohi38h-7"
})(["flex:none;flex-direction:row;justify-content:space-between;background-color:#f1f1f0;border-top:1px solid #dddbda;height:64px;padding:16px;"]);
var ModalFormRow = (0, _styledComponents["default"])(_FlexDiv["default"]).withConfig({
  displayName: "FormBodyweb__ModalFormRow",
  componentId: "sc-1ohi38h-8"
})(["display:flex;flex-direction:row;"]);
var ModalFormFooterCancelButton = (0, _styledComponents["default"])(_Button["default"]).attrs(function (props) {
  return {
    type: 'tertiary'
  };
}).withConfig({
  displayName: "FormBodyweb__ModalFormFooterCancelButton",
  componentId: "sc-1ohi38h-9"
})(["margin-right:16px;"]);
var ModalFormFooterDeleteButton = (0, _styledComponents["default"])(_Button["default"]).attrs(function (props) {
  return {
    type: 'destructive'
  };
}).withConfig({
  displayName: "FormBodyweb__ModalFormFooterDeleteButton",
  componentId: "sc-1ohi38h-10"
})([""]);