"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _react = _interopRequireDefault(require("react"));

var _Alert = _interopRequireDefault(require("../../apis/Alert"));

var _Form = require("../../primitives/Form");

var _FormBody = _interopRequireDefault(require("./FormBody"));

var _Modal = _interopRequireDefault(require("./Modal"));

var _jsxRuntime = require("react/jsx-runtime");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

function ModalForm(_ref) {
  var _children = _ref.children,
      contentContainerStyle = _ref.contentContainerStyle,
      initialValues = _ref.initialValues,
      onDelete = _ref.onDelete,
      onRequestClose = _ref.onRequestClose,
      onSubmit = _ref.onSubmit,
      placement = _ref.placement,
      submitButtonText = _ref.submitButtonText,
      testID = _ref.testID,
      title = _ref.title,
      visible = _ref.visible,
      onCancel = _ref.onCancel;

  var handleCancel = /*#__PURE__*/function () {
    var _ref3 = _asyncToGenerator( /*#__PURE__*/_regenerator["default"].mark(function _callee2(_ref2) {
      var dirty, values, handleCancelClose, _handleCancelClose;

      return _regenerator["default"].wrap(function _callee2$(_context2) {
        while (1) {
          switch (_context2.prev = _context2.next) {
            case 0:
              _handleCancelClose = function _handleCancelClose3() {
                _handleCancelClose = _asyncToGenerator( /*#__PURE__*/_regenerator["default"].mark(function _callee() {
                  return _regenerator["default"].wrap(function _callee$(_context) {
                    while (1) {
                      switch (_context.prev = _context.next) {
                        case 0:
                          if (!onCancel) {
                            _context.next = 3;
                            break;
                          }

                          _context.next = 3;
                          return onCancel(values);

                        case 3:
                          onRequestClose();

                        case 4:
                        case "end":
                          return _context.stop();
                      }
                    }
                  }, _callee);
                }));
                return _handleCancelClose.apply(this, arguments);
              };

              handleCancelClose = function _handleCancelClose2() {
                return _handleCancelClose.apply(this, arguments);
              };

              dirty = _ref2.dirty, values = _ref2.values;

              if (dirty) {
                _Alert["default"].alert({
                  title: 'You have unsaved changes',
                  actions: {
                    confirm: {
                      text: 'Discard',
                      destructive: true,
                      onPress: function onPress() {
                        return handleCancelClose();
                      }
                    },
                    cancel: {
                      text: 'Keep'
                    }
                  }
                });
              } else {
                handleCancelClose();
              }

            case 4:
            case "end":
              return _context2.stop();
          }
        }
      }, _callee2);
    }));

    return function handleCancel(_x) {
      return _ref3.apply(this, arguments);
    };
  }();

  var handleDelete = /*#__PURE__*/function () {
    var _ref5 = _asyncToGenerator( /*#__PURE__*/_regenerator["default"].mark(function _callee3(_ref4) {
      var values, res;
      return _regenerator["default"].wrap(function _callee3$(_context3) {
        while (1) {
          switch (_context3.prev = _context3.next) {
            case 0:
              values = _ref4.values;
              _context3.t0 = onDelete;

              if (!_context3.t0) {
                _context3.next = 6;
                break;
              }

              _context3.next = 5;
              return onDelete(values);

            case 5:
              _context3.t0 = _context3.sent;

            case 6:
              res = _context3.t0;
              onRequestClose();
              return _context3.abrupt("return", res);

            case 9:
            case "end":
              return _context3.stop();
          }
        }
      }, _callee3);
    }));

    return function handleDelete(_x2) {
      return _ref5.apply(this, arguments);
    };
  }();

  var handleSubmit = /*#__PURE__*/function () {
    var _ref7 = _asyncToGenerator( /*#__PURE__*/_regenerator["default"].mark(function _callee5(_ref6) {
      var actions, fieldErrors, values;
      return _regenerator["default"].wrap(function _callee5$(_context5) {
        while (1) {
          switch (_context5.prev = _context5.next) {
            case 0:
              actions = _ref6.actions, fieldErrors = _ref6.fieldErrors, values = _ref6.values;
              actions.touchAll();

              if (!(Object.keys(fieldErrors).length === 0)) {
                _context5.next = 5;
                break;
              }

              _context5.next = 5;
              return actions.submit( /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regenerator["default"].mark(function _callee4() {
                return _regenerator["default"].wrap(function _callee4$(_context4) {
                  while (1) {
                    switch (_context4.prev = _context4.next) {
                      case 0:
                        if (!onSubmit) {
                          _context4.next = 3;
                          break;
                        }

                        _context4.next = 3;
                        return onSubmit(values);

                      case 3:
                        onRequestClose();

                      case 4:
                      case "end":
                        return _context4.stop();
                    }
                  }
                }, _callee4);
              })));

            case 5:
            case "end":
              return _context5.stop();
          }
        }
      }, _callee5);
    }));

    return function handleSubmit(_x3) {
      return _ref7.apply(this, arguments);
    };
  }();

  return /*#__PURE__*/(0, _jsxRuntime.jsx)(_Form.FormState, {
    initialValues: initialValues,
    children: function children(formStateAndActions) {
      var actions = formStateAndActions.actions,
          formState = _objectWithoutProperties(formStateAndActions, ["actions"]);

      var formContent = typeof _children === 'function' ? _children(formStateAndActions) : _children;
      return /*#__PURE__*/(0, _jsxRuntime.jsx)(_Modal["default"], {
        hideHeader: true,
        onRequestClose: function onRequestClose() {
          return handleCancel(formStateAndActions);
        },
        placement: placement,
        visible: visible,
        children: /*#__PURE__*/(0, _jsxRuntime.jsx)(_FormBody["default"], {
          contentContainerStyle: contentContainerStyle,
          onCancel: function onCancel() {
            return handleCancel(formStateAndActions);
          },
          onDelete: onDelete && function () {
            return handleDelete(formStateAndActions);
          },
          onSubmit: function onSubmit() {
            return handleSubmit(formStateAndActions);
          },
          submitButtonText: typeof submitButtonText === 'function' ? submitButtonText(formState) : submitButtonText,
          submitting: formState.submitting,
          testID: testID,
          title: title,
          children: formContent
        })
      });
    }
  });
}

var _default = ModalForm;
exports["default"] = _default;