"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.modalFormContentStyle = exports.ModalFormHeaderSubmitButton = exports.ModalFormHeaderCancelButton = exports.modalFormMobileHeaderStyle = exports.modalFormMobileHeaderContainerStyle = exports.modalFormMobileTitleTextStyle = exports.ModalFormTitleContainer = void 0;

var React = _interopRequireWildcard(require("react"));

var _Style = require("../../apis/Style");

var _ActivityIndicator = _interopRequireDefault(require("../../primitives/ActivityIndicator"));

var _Form = require("../../primitives/Form");

var _Text = _interopRequireDefault(require("../../primitives/Text"));

var _TouchableView = _interopRequireDefault(require("../../primitives/TouchableView"));

var _View = _interopRequireDefault(require("../../primitives/View"));

var _jsxRuntime = require("react/jsx-runtime");

var _templateObject, _templateObject2, _templateObject3, _templateObject4, _templateObject5, _templateObject6, _templateObject7, _templateObject8, _templateObject9;

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _taggedTemplateLiteral(strings, raw) { if (!raw) { raw = strings.slice(0); } return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }

var ModalFormTitleContainer = (0, _Style.styled)(_View["default"])(_templateObject || (_templateObject = _taggedTemplateLiteral(["\n  align-items: center;\n  justify-content: center;\n  position: absolute;\n  top: 0;\n  bottom: 0;\n  left: 70px;\n  right: 70px;\n"])));
exports.ModalFormTitleContainer = ModalFormTitleContainer;
var modalFormMobileTitleTextStyle = (0, _Style.css)(_templateObject2 || (_templateObject2 = _taggedTemplateLiteral(["\n  font-size: 16px;\n  color: #2b2826;\n  text-align: center;\n"])));
exports.modalFormMobileTitleTextStyle = modalFormMobileTitleTextStyle;
var modalFormMobileHeaderContainerStyle = (0, _Style.css)(_templateObject3 || (_templateObject3 = _taggedTemplateLiteral(["\n  flex: none;\n  background-color: white;\n  border-width: 0;\n  border-top-width: 1px;\n  border-bottom-width: 1px;\n  border-style: solid;\n  border-color: #dddbda;\n"])));
exports.modalFormMobileHeaderContainerStyle = modalFormMobileHeaderContainerStyle;
var modalFormMobileHeaderStyle = (0, _Style.css)(_templateObject4 || (_templateObject4 = _taggedTemplateLiteral(["\n  flex-direction: row;\n  justify-content: space-between;\n  height: 45px;\n"])));
exports.modalFormMobileHeaderStyle = modalFormMobileHeaderStyle;
var buttonStyle = (0, _Style.css)(_templateObject5 || (_templateObject5 = _taggedTemplateLiteral(["\n  align-items: center;\n  justify-content: center;\n  margin: 0 16px;\n"])));
var CancelButton = (0, _Style.styled)(_TouchableView["default"])(_templateObject6 || (_templateObject6 = _taggedTemplateLiteral(["\n  ", ";\n"])), buttonStyle);

var ModalFormHeaderCancelButton = function ModalFormHeaderCancelButton(_ref) {
  var onPress = _ref.onPress,
      _ref$text = _ref.text,
      text = _ref$text === void 0 ? 'Cancel' : _ref$text;
  return /*#__PURE__*/(0, _jsxRuntime.jsx)(CancelButton, {
    onPress: onPress,
    testID: "modalForm-cancel-button",
    children: /*#__PURE__*/(0, _jsxRuntime.jsx)(_Text["default"], {
      children: text
    })
  });
};

exports.ModalFormHeaderCancelButton = ModalFormHeaderCancelButton;
var StyledSubmitButton = (0, _Style.styled)(_Form.Form.SubmitButton)(_templateObject7 || (_templateObject7 = _taggedTemplateLiteral(["\n  ", ";\n"])), buttonStyle);
var SubmitButtonText = (0, _Style.styled)(_Text["default"])(_templateObject8 || (_templateObject8 = _taggedTemplateLiteral(["\n  color: #ff7800;\n"])));

var ModalFormHeaderSubmitButton = function ModalFormHeaderSubmitButton(_ref2) {
  var text = _ref2.text;
  return /*#__PURE__*/(0, _jsxRuntime.jsx)(StyledSubmitButton, {
    testID: "modalForm-submit-button",
    children: function children(_ref3) {
      var submitting = _ref3.submitting;
      return submitting ? /*#__PURE__*/(0, _jsxRuntime.jsx)(_ActivityIndicator["default"], {}) : /*#__PURE__*/(0, _jsxRuntime.jsx)(SubmitButtonText, {
        children: text
      });
    }
  });
};

exports.ModalFormHeaderSubmitButton = ModalFormHeaderSubmitButton;
var modalFormContentStyle = (0, _Style.css)(_templateObject9 || (_templateObject9 = _taggedTemplateLiteral(["\n  flex: 1;\n  background-color: #f7f7f7;\n  padding-left: 16px;\n  padding-right: 16px;\n"])));
exports.modalFormContentStyle = modalFormContentStyle;