"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = ModalWizardTest;

var _react = _interopRequireDefault(require("react"));

var _Form = _interopRequireDefault(require("../../../primitives/Form/Form.web"));

var _Text = _interopRequireDefault(require("../../../primitives/Text"));

var _View = _interopRequireDefault(require("../../../primitives/View"));

var _Button = _interopRequireDefault(require("../../Button"));

var _SelectField = _interopRequireDefault(require("../../input-fields/SelectField"));

var _TextField = _interopRequireDefault(require("../../input-fields/TextField"));

var _ = _interopRequireDefault(require(".."));

var _jsxRuntime = require("react/jsx-runtime");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { if (typeof Symbol === "undefined" || !(Symbol.iterator in Object(arr))) return; var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function ModalWizardTest() {
  var _React$useState = _react["default"].useState({
    showModal: false,
    formValues: {}
  }),
      _React$useState2 = _slicedToArray(_React$useState, 2),
      state = _React$useState2[0],
      setState = _React$useState2[1];

  var renderFirstScreen = function renderFirstScreen() {
    return /*#__PURE__*/(0, _jsxRuntime.jsx)(_Form["default"], {
      onSubmit: function onSubmit(formValues) {
        return setState(_objectSpread(_objectSpread({}, state), {}, {
          formValues: formValues
        }));
      },
      children: function children(_ref) {
        var getFieldValue = _ref.getFieldValue;
        var requireAge = getFieldValue('requireAge');
        return /*#__PURE__*/(0, _jsxRuntime.jsxs)(_react["default"].Fragment, {
          children: [/*#__PURE__*/(0, _jsxRuntime.jsx)(_Form["default"].Field, {
            name: "name",
            label: "Name",
            component: _TextField["default"],
            validate: function validate(value) {
              return value ? undefined : 'Required';
            }
          }), /*#__PURE__*/(0, _jsxRuntime.jsx)(_Form["default"].Field, {
            name: "requireAge",
            label: "Require Age",
            component: _SelectField["default"],
            props: {
              options: [{
                value: 'yes',
                label: 'Yes'
              }, {
                value: 'no',
                label: 'No'
              }]
            }
          }), requireAge === 'yes' && /*#__PURE__*/(0, _jsxRuntime.jsx)(_Form["default"].Field, {
            name: "age",
            label: "Age",
            component: _TextField["default"]
          })]
        });
      }
    });
  };

  var renderSecondScreen = function renderSecondScreen() {
    var formValues = state.formValues;
    return /*#__PURE__*/(0, _jsxRuntime.jsxs)(_View["default"], {
      children: [/*#__PURE__*/(0, _jsxRuntime.jsx)(_Text["default"], {
        children: "Summary"
      }), /*#__PURE__*/(0, _jsxRuntime.jsx)(_Text["default"], {
        children: "Selected values are:"
      }), /*#__PURE__*/(0, _jsxRuntime.jsxs)(_Text["default"], {
        children: ["Name: ", formValues.name]
      }), /*#__PURE__*/(0, _jsxRuntime.jsxs)(_Text["default"], {
        children: ["Age: ", formValues.age]
      })]
    });
  };

  return /*#__PURE__*/(0, _jsxRuntime.jsxs)(_View["default"], {
    children: [/*#__PURE__*/(0, _jsxRuntime.jsx)(_Button["default"], {
      onPress: function onPress() {
        return setState(_objectSpread(_objectSpread({}, state), {}, {
          showModal: true
        }));
      },
      text: "Open Wizard"
    }), state.showModal && /*#__PURE__*/(0, _jsxRuntime.jsx)(_["default"], {
      testID: "test",
      visible: true,
      onRequestClose: function onRequestClose() {
        return setState(_objectSpread(_objectSpread({}, state), {}, {
          showModal: false
        }));
      },
      screens: [{
        title: 'First Step',
        render: renderFirstScreen,
        isForm: true
      }, {
        title: 'Second Step',
        render: renderSecondScreen
      }],
      onFinish: function onFinish() {
        return console.log('Submitting the wizard, values are: ', state.formValues);
      }
    })]
  });
}