"use strict";

require("jest-styled-components");

require("react-testing-library/cleanup-after-each");

var _userEvent = _interopRequireDefault(require("@testing-library/user-event"));

var _react = _interopRequireDefault(require("react"));

var _reactTestingLibrary = require("react-testing-library");

var _ModalWizardTest = _interopRequireDefault(require("./ModalWizardTest"));

var _jsxRuntime = require("react/jsx-runtime");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

test('should render a modal wizard', function () {
  var _render = (0, _reactTestingLibrary.render)( /*#__PURE__*/(0, _jsxRuntime.jsx)(_ModalWizardTest["default"], {})),
      getByTestId = _render.getByTestId,
      container = _render.container; //Simulate mouse click to open wizard


  (0, _reactTestingLibrary.act)(function () {
    return _userEvent["default"].click(container.querySelector('[data-text-as-pseudo-element="Open Wizard"]'));
  }); //Set Name field to 'Test'

  (0, _reactTestingLibrary.act)(function () {
    _userEvent["default"].type(getByTestId('name-field-control').querySelector('input'), 'Test');

    _userEvent["default"].click(getByTestId('requireAge-field-control').querySelector('input'));
  }); //Set Age Required field to 'Yes'

  (0, _reactTestingLibrary.act)(function () {
    _userEvent["default"].click(getByTestId('undefined-list').querySelector('[data-text-as-pseudo-element="Yes"]'));
  }); //Set Age field to '55' and click Next

  (0, _reactTestingLibrary.act)(function () {
    _userEvent["default"].type(getByTestId('age-field-control').querySelector('input'), '55');

    _userEvent["default"].click(getByTestId('overlay-container').querySelector('[data-text-as-pseudo-element="Next"]'));
  }); //TODO: Test Submit
  // act(() =>
  //    userEvent.click(getByTestId("overlay-container").querySelector('[data-text-as-pseudo-element="Submit"]')!));

  expect(getByTestId('overlay-container')).toMatchInlineSnapshot("\n    .c0 {\n      -webkit-align-items: stretch;\n      -webkit-box-align: stretch;\n      -ms-flex-align: stretch;\n      align-items: stretch;\n      border-color: #191E26;\n      border-style: solid;\n      border-width: 0;\n      box-sizing: border-box;\n      display: -webkit-box;\n      display: -webkit-flex;\n      display: -ms-flexbox;\n      display: flex;\n      -webkit-flex-direction: column;\n      -ms-flex-direction: column;\n      flex-direction: column;\n      -webkit-box-flex: 0;\n      -webkit-flex-grow: 0;\n      -ms-flex-positive: 0;\n      flex-grow: 0;\n      -webkit-flex-shrink: 0;\n      -ms-flex-negative: 0;\n      flex-shrink: 0;\n      position: relative;\n      min-height: 0;\n      min-width: 0;\n    }\n\n    .c9 {\n      -webkit-align-items: stretch;\n      -webkit-box-align: stretch;\n      -ms-flex-align: stretch;\n      align-items: stretch;\n      border-color: #191E26;\n      border-style: solid;\n      border-width: 0;\n      box-sizing: border-box;\n      display: -webkit-box;\n      display: -webkit-flex;\n      display: -ms-flexbox;\n      display: flex;\n      -webkit-flex-direction: column;\n      -ms-flex-direction: column;\n      flex-direction: column;\n      -webkit-box-flex: 0;\n      -webkit-flex-grow: 0;\n      -ms-flex-positive: 0;\n      flex-grow: 0;\n      -webkit-flex-shrink: 0;\n      -ms-flex-negative: 0;\n      flex-shrink: 0;\n      position: relative;\n      min-height: 0;\n      min-width: 0;\n    }\n\n    .c10 {\n      -webkit-align-items: stretch;\n      -webkit-box-align: stretch;\n      -ms-flex-align: stretch;\n      align-items: stretch;\n      border-color: #191E26;\n      border-style: solid;\n      border-width: 0;\n      box-sizing: border-box;\n      display: -webkit-box;\n      display: -webkit-flex;\n      display: -ms-flexbox;\n      display: flex;\n      -webkit-flex-direction: column;\n      -ms-flex-direction: column;\n      flex-direction: column;\n      -webkit-box-flex: 0;\n      -webkit-flex-grow: 0;\n      -ms-flex-positive: 0;\n      flex-grow: 0;\n      -webkit-flex-shrink: 0;\n      -ms-flex-negative: 0;\n      flex-shrink: 0;\n      position: relative;\n      min-height: 0;\n      min-width: 0;\n      background-color: transparent;\n      border-color: transparent;\n      border-width: 0;\n      padding: 0;\n      text-align: left;\n      outline: none;\n      cursor: pointer;\n    }\n\n    .c10 * {\n      cursor: pointer;\n    }\n\n    .c7 {\n      box-sizing: border-box;\n      color: #191E26;\n      display: inline;\n      -webkit-box-flex: 0;\n      -webkit-flex-grow: 0;\n      -ms-flex-positive: 0;\n      flex-grow: 0;\n      -webkit-flex-shrink: 0;\n      -ms-flex-negative: 0;\n      flex-shrink: 0;\n      font-size: px;\n      position: relative;\n      white-space: pre-wrap;\n      word-wrap: break-word;\n      -ms-hyphens: auto;\n      color: inherit;\n      font-family: inherit;\n      font-size: inherit;\n      white-space: inherit;\n      cursor: inherit;\n    }\n\n    .c4 {\n      box-sizing: border-box;\n      color: #191E26;\n      display: inline;\n      -webkit-box-flex: 0;\n      -webkit-flex-grow: 0;\n      -ms-flex-positive: 0;\n      flex-grow: 0;\n      -webkit-flex-shrink: 0;\n      -ms-flex-negative: 0;\n      flex-shrink: 0;\n      font-family: \"Helvetica Neue\",Helvetica,Arial,sans-serif;\n      font-size: 14px;\n      position: relative;\n      white-space: pre-wrap;\n      word-wrap: break-word;\n      -ms-hyphens: auto;\n      cursor: inherit;\n    }\n\n    .c15 {\n      font-size: 14px;\n      color: white;\n    }\n\n    .c13 {\n      font-size: 14px;\n      color: #0070D2;\n    }\n\n    .c14 {\n      -webkit-flex-direction: row;\n      -ms-flex-direction: row;\n      flex-direction: row;\n      -webkit-align-items: center;\n      -webkit-box-align: center;\n      -ms-flex-align: center;\n      align-items: center;\n      -webkit-box-pack: center;\n      -webkit-justify-content: center;\n      -ms-flex-pack: center;\n      justify-content: center;\n      border-radius: 4px;\n      height: 32px;\n      background-color: #FF7800;\n      border-color: #FF7800;\n      border-style: solid;\n      border-width: 1px;\n      padding-left: 16px;\n      padding-right: 16px;\n    }\n\n    .c14:hover,\n    .c14:focus {\n      background-color: #FF9333;\n      border-color: #FF9333;\n    }\n\n    .c14:hover *,\n    .c14:focus * {\n      color: white;\n    }\n\n    .c14:active {\n      background-color: #E36A00;\n      border-color: #E36A00;\n    }\n\n    .c14:active * {\n      color: white;\n    }\n\n    .c11 {\n      -webkit-flex-direction: row;\n      -ms-flex-direction: row;\n      flex-direction: row;\n      -webkit-align-items: center;\n      -webkit-box-align: center;\n      -ms-flex-align: center;\n      align-items: center;\n      -webkit-box-pack: center;\n      -webkit-justify-content: center;\n      -ms-flex-pack: center;\n      justify-content: center;\n      border-radius: 4px;\n      height: 32px;\n      background-color: transparent;\n      border-color: transparent;\n      border-style: solid;\n      border-width: 1px;\n      padding-left: 16px;\n      padding-right: 16px;\n    }\n\n    .c11:hover,\n    .c11:focus {\n      background-color: white;\n      border-color: #DDDBDA;\n    }\n\n    .c11:hover *,\n    .c11:focus * {\n      color: #0070D2;\n    }\n\n    .c11:active {\n      background-color: #0070D2;\n      border-color: #0031AC;\n    }\n\n    .c11:active * {\n      color: white;\n    }\n\n    .c1 {\n      position: fixed;\n      top: 0;\n      bottom: 0;\n      left: 0;\n      right: 0;\n      background-color: rgba(0,0,0,0.2);\n    }\n\n    .c2 {\n      background-color: white;\n      position: absolute;\n      border-radius: 4px;\n      overflow: hidden;\n      left: 0;\n      right: 0;\n      margin: auto;\n      max-height: 768px;\n      min-height: 200px;\n      width: 576px;\n      opacity: 0;\n    }\n\n    .c2:focus {\n      outline: none;\n    }\n\n    .c6 {\n      -webkit-flex: 1;\n      -ms-flex: 1;\n      flex: 1;\n      background-color: #fff;\n      padding: 16px 32px;\n      border-top-width: 1px;\n      border-top-color: #dddbda;\n      border-bottom-width: 1px;\n      border-bottom-color: #dddbda;\n      border-left-width: 0;\n      border-right-width: 0;\n      border-style: solid;\n    }\n\n    .c3 {\n      -webkit-align-items: center;\n      -webkit-box-align: center;\n      -ms-flex-align: center;\n      align-items: center;\n      -webkit-box-pack: center;\n      -webkit-justify-content: center;\n      -ms-flex-pack: center;\n      justify-content: center;\n      padding: 16px;\n    }\n\n    .c5 {\n      font-size: 18px;\n    }\n\n    .c8 {\n      background-color: #fafafa;\n      -webkit-align-items: center;\n      -webkit-box-align: center;\n      -ms-flex-align: center;\n      align-items: center;\n      -webkit-flex-direction: row;\n      -ms-flex-direction: row;\n      flex-direction: row;\n      -webkit-box-pack: end;\n      -webkit-justify-content: flex-end;\n      -ms-flex-pack: end;\n      justify-content: flex-end;\n      background-color: #fafafa;\n      padding: 16px;\n    }\n\n    .c12 {\n      margin-left: 16px;\n    }\n\n    <div\n      aria-modal=\"true\"\n      class=\"c0 c1\"\n      data-testid=\"overlay-container\"\n    >\n      <div\n        class=\"c0 c2\"\n      >\n        <div\n          class=\"c0 c3\"\n        >\n          <div\n            class=\"c4 c5\"\n            data-text-as-pseudo-element=\"Second Step\"\n          />\n        </div>\n        <div\n          class=\"c0 c6\"\n        >\n          <div\n            class=\"c0 \"\n          >\n            <div\n              class=\"c4\"\n              data-text-as-pseudo-element=\"Summary\"\n            />\n            <div\n              class=\"c4\"\n              data-text-as-pseudo-element=\"Selected values are:\"\n            />\n            <div\n              class=\"c4\"\n            >\n              <div\n                class=\"c7\"\n                data-text-as-pseudo-element=\"Name: \"\n              />\n              <div\n                class=\"c7\"\n                data-text-as-pseudo-element=\"Test\"\n              />\n            </div>\n            <div\n              class=\"c4\"\n            >\n              <div\n                class=\"c7\"\n                data-text-as-pseudo-element=\"Age: \"\n              />\n              <div\n                class=\"c7\"\n                data-text-as-pseudo-element=\"55\"\n              />\n            </div>\n          </div>\n        </div>\n        <div\n          class=\"c0 c8\"\n        >\n          <div\n            class=\"c9 c10 c11 c12\"\n            role=\"button\"\n            tabindex=\"0\"\n          >\n            <div\n              class=\"c4 c13\"\n              data-text-as-pseudo-element=\"Back\"\n            />\n          </div>\n          <div\n            class=\"c9 c10 c11 c12\"\n            role=\"button\"\n            tabindex=\"0\"\n          >\n            <div\n              class=\"c4 c13\"\n              data-text-as-pseudo-element=\"Cancel\"\n            />\n          </div>\n          <div\n            class=\"c9 c10 c14 c12\"\n            role=\"button\"\n            tabindex=\"0\"\n          >\n            <div\n              class=\"c4 c15\"\n              data-text-as-pseudo-element=\"Submit\"\n            />\n          </div>\n        </div>\n      </div>\n    </div>\n  ");
});