"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var React = _interopRequireWildcard(require("react"));

var _Style = require("../../../apis/Style");

var _FlatList = _interopRequireDefault(require("../../../primitives/FlatList"));

var _Text = _interopRequireDefault(require("../../../primitives/Text"));

var _TouchableView = _interopRequireDefault(require("../../../primitives/TouchableView"));

var _View = _interopRequireDefault(require("../../../primitives/View"));

var _jsxRuntime = require("react/jsx-runtime");

var _templateObject, _templateObject2, _templateObject3;

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _taggedTemplateLiteral(strings, raw) { if (!raw) { raw = strings.slice(0); } return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (typeof call === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

var ROW_HEIGHT = 50;

var Menu = /*#__PURE__*/function (_React$Component) {
  _inherits(Menu, _React$Component);

  var _super = _createSuper(Menu);

  function Menu() {
    var _this;

    _classCallCheck(this, Menu);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _super.call.apply(_super, [this].concat(args));

    _this._defaultGetItemLayout = function (item, index) {
      return {
        length: ROW_HEIGHT,
        offset: ROW_HEIGHT * index,
        index: index
      };
    };

    _this._defaultRenderOption = function (_ref) {
      var option = _ref.option,
          isSelected = _ref.isSelected;
      var optionLabel = option[_this.props.labelKey];
      return /*#__PURE__*/(0, _jsxRuntime.jsxs)(Row, {
        testID: "select-option-".concat(optionLabel),
        children: [/*#__PURE__*/(0, _jsxRuntime.jsx)(Label, {
          numberOfLines: 2,
          $isDisabled: option.disabled,
          children: optionLabel
        }), /*#__PURE__*/(0, _jsxRuntime.jsx)(SelectedIcon, {
          $show: isSelected,
          children: "\u2713"
        })]
      });
    };

    _this._keyExtractor = function (option) {
      return option[_this.props.valueKey];
    };

    _this._renderItem = function (_ref2) {
      var option = _ref2.item,
          index = _ref2.index;
      var _this$props = _this.props,
          onItemSelect = _this$props.onItemSelect,
          selectedOptions = _this$props.selectedOptions;
      var renderOption = _this.props.renderOption || _this._defaultRenderOption;
      var isSelected = selectedOptions.indexOf(option) > -1;
      return /*#__PURE__*/(0, _jsxRuntime.jsx)(_TouchableView["default"], {
        disabled: option.disabled,
        onPress: function onPress() {
          return onItemSelect(option);
        },
        children: renderOption({
          option: option,
          index: index,
          isSelected: isSelected
        })
      });
    };

    return _this;
  }

  _createClass(Menu, [{
    key: "render",
    value: function render() {
      var _this$props2 = this.props,
          getItemLayout = _this$props2.getItemLayout,
          onEndReached = _this$props2.onEndReached,
          onEndReachedThreshold = _this$props2.onEndReachedThreshold,
          options = _this$props2.options;
      return /*#__PURE__*/(0, _jsxRuntime.jsx)(_FlatList["default"], {
        data: options,
        getItemLayout: getItemLayout || this._defaultGetItemLayout,
        keyExtractor: this._keyExtractor,
        onEndReached: onEndReached,
        onEndReachedThreshold: onEndReachedThreshold,
        renderItem: this._renderItem
      });
    }
  }]);

  return Menu;
}(React.Component);

var _default = Menu;
exports["default"] = _default;
var Label = (0, _Style.styled)(_Text["default"])(_templateObject || (_templateObject = _taggedTemplateLiteral(["\n  flex: 1;\n  ", ";\n"])), function (_ref3) {
  var $isDisabled = _ref3.$isDisabled;
  return $isDisabled && "\n    color: #ccc;\n  ";
});
var Row = (0, _Style.styled)(_View["default"])(_templateObject2 || (_templateObject2 = _taggedTemplateLiteral(["\n  align-items: center;\n  flex-direction: row;\n  height: ", "px;\n  padding: 0 10px;\n"])), ROW_HEIGHT);
var SelectedIcon = (0, _Style.styled)(_Text["default"])(_templateObject3 || (_templateObject3 = _taggedTemplateLiteral(["\n  font-size: 20px;\n  opacity: ", ";\n"])), function (props) {
  return props.$show ? '1' : '0';
});