"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var React = _interopRequireWildcard(require("react"));

var _reactNative = require("react-native");

var _styledComponents = _interopRequireDefault(require("styled-components"));

var _FontContext = _interopRequireDefault(require("../../../primitives/Font/FontContext"));

var _Text = _interopRequireDefault(require("../../../primitives/Text"));

var _jsxRuntime = require("react/jsx-runtime");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (typeof call === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function normalizeSearchText(rawText) {
  if (!rawText) return '';
  return rawText.match(/\w|\s/g).join('').replace(/^\s+|\s+$/g, '').replace(/\s+/g, ' ');
}

var SearchBar = /*#__PURE__*/function (_React$Component) {
  _inherits(SearchBar, _React$Component);

  var _super = _createSuper(SearchBar);

  function SearchBar() {
    var _this;

    _classCallCheck(this, SearchBar);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _super.call.apply(_super, [this].concat(args));

    _this._captureInputRef = function (ref) {
      _this._input = ref;
      var inputRef = _this.props.inputRef;
      inputRef && inputRef(ref);
    };

    _this._onContainerPress = function () {
      _this._input && _this._input.focus();
    };

    _this._onInputSubmit = function (event) {
      var onInputSubmit = _this.props.onInputSubmit;
      onInputSubmit && onInputSubmit(normalizeSearchText(event.nativeEvent.text));
    };

    _this._renderSpinner = function () {
      return /*#__PURE__*/(0, _jsxRuntime.jsx)(SpinnerContainer, {
        children: /*#__PURE__*/(0, _jsxRuntime.jsx)(_reactNative.ActivityIndicator, {
          animating: _this.props.isLoading
        })
      });
    };

    return _this;
  }

  _createClass(SearchBar, [{
    key: "render",
    value: function render() {
      var _this2 = this;

      var _this$props = this.props,
          disabled = _this$props.disabled,
          onInputChange = _this$props.onInputChange,
          searchText = _this$props.searchText,
          style = _this$props.style;
      return /*#__PURE__*/(0, _jsxRuntime.jsx)(_reactNative.TouchableOpacity, {
        activeOpacity: 1,
        onPress: this._onContainerPress,
        children: /*#__PURE__*/(0, _jsxRuntime.jsx)(Container, {
          pointerEvents: "none",
          style: style,
          testID: "select-searchbar-container",
          children: /*#__PURE__*/(0, _jsxRuntime.jsxs)(InnerContainer, {
            children: [/*#__PURE__*/(0, _jsxRuntime.jsx)(IconContainer, {
              children: /*#__PURE__*/(0, _jsxRuntime.jsx)(IconText, {
                children: "\uD83D\uDD0D"
              })
            }), disabled ? /*#__PURE__*/(0, _jsxRuntime.jsx)(SearchText, {
              children: searchText
            }) : /*#__PURE__*/(0, _jsxRuntime.jsx)(_FontContext["default"].Consumer, {
              children: function children(_ref) {
                var fontFamily = _ref.fontFamily;
                return /*#__PURE__*/(0, _jsxRuntime.jsx)(StyledTextInput, {
                  autoCorrect: false,
                  editable: !disabled,
                  ref: _this2._captureInputRef,
                  onChangeText: onInputChange,
                  onSubmitEditing: _this2._onInputSubmit,
                  returnKeyLabel: "Search",
                  returnKeyType: "search",
                  showUnderline: false,
                  value: searchText,
                  testID: "select-searchbar-textinput",
                  $fontFamily: fontFamily
                });
              }
            }), this._renderSpinner()]
          })
        })
      });
    }
  }]);

  return SearchBar;
}(React.Component);

SearchBar.defaultProps = {
  disabled: false,
  isLoading: false
};
var _default = SearchBar;
exports["default"] = _default;

var Container = _styledComponents["default"].View.withConfig({
  displayName: "SearchBar__Container",
  componentId: "aktd7j-0"
})(["background-color:#eee;padding:6px;padding-top:5px;"]);

var InnerContainer = _styledComponents["default"].View.withConfig({
  displayName: "SearchBar__InnerContainer",
  componentId: "aktd7j-1"
})(["flex-direction:row;align-items:center;background-color:#fff;height:31px;border-width:0;border-color:#ddd;border-radius:15px;"]);

var IconContainer = _styledComponents["default"].View.withConfig({
  displayName: "SearchBar__IconContainer",
  componentId: "aktd7j-2"
})(["justify-content:center;background-color:transparent;position:absolute;top:0;bottom:0;left:15px;"]);

var IconText = _styledComponents["default"].Text.withConfig({
  displayName: "SearchBar__IconText",
  componentId: "aktd7j-3"
})([""]);

var SearchText = (0, _styledComponents["default"])(_Text["default"]).attrs(function (props) {
  return {
    numberOfLines: 1
  };
}).withConfig({
  displayName: "SearchBar__SearchText",
  componentId: "aktd7j-4"
})(["margin-left:34px;margin-right:3px;"]);

var SpinnerContainer = _styledComponents["default"].View.withConfig({
  displayName: "SearchBar__SpinnerContainer",
  componentId: "aktd7j-5"
})(["padding-horizontal:10px;"]);

var StyledTextInput = _styledComponents["default"].TextInput.withConfig({
  displayName: "SearchBar__StyledTextInput",
  componentId: "aktd7j-6"
})(["flex:1;font-family:", ";font-size:14px;height:28px;margin-top:2px;margin-bottom:1px;margin-left:38px;"], function (props) {
  return props.$fontFamily;
});