"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireDefault(require("react"));

var _Style = require("../../../apis/Style");

var _ViewBase = require("../../../internals/web/ViewBase");

var _jsxRuntime = require("react/jsx-runtime");

var _templateObject;

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _taggedTemplateLiteral(strings, raw) { if (!raw) { raw = strings.slice(0); } return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (typeof call === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

var blockEvent = function blockEvent(event) {
  event.preventDefault();
  event.stopPropagation();
};

var OptionContainer = /*#__PURE__*/function (_React$Component) {
  _inherits(OptionContainer, _React$Component);

  var _super = _createSuper(OptionContainer);

  function OptionContainer() {
    var _this;

    _classCallCheck(this, OptionContainer);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _super.call.apply(_super, [this].concat(args));
    _this._dragging = void 0;

    _this._onClick = function (event) {
      event.preventDefault();
      event.stopPropagation();
      var _this$props = _this.props,
          index = _this$props.index,
          onSelect = _this$props.onSelect,
          option = _this$props.option;
      onSelect(option, event, index);
    };

    _this._onFocus = function (event) {
      var _this$props2 = _this.props,
          index = _this$props2.index,
          isFocused = _this$props2.isFocused,
          onFocus = _this$props2.onFocus,
          option = _this$props2.option;

      if (!isFocused && onFocus) {
        onFocus(option, event, index);
      }
    };

    _this._onMouseEnter = function (event) {
      _this._onFocus(event);
    };

    _this._onMouseMove = function (event) {
      _this._onFocus(event);
    };

    _this._onTouchEnd = function (event) {
      // Check if the view is being dragged, In this case
      // we don't want to fire the click event (because the user only wants to scroll)
      if (_this._dragging) return;

      _this._onClick(event);
    };

    _this._onTouchMove = function () {
      // Set a flag that the view is being dragged
      _this._dragging = true;
    };

    _this._onTouchStart = function () {
      // Set a flag that the view is not being dragged
      _this._dragging = false;
    };

    return _this;
  }

  _createClass(OptionContainer, [{
    key: "render",
    value: function render() {
      var _this$props3 = this.props,
          children = _this$props3.children,
          innerRef = _this$props3.innerRef,
          isDisabled = _this$props3.isDisabled,
          isFocused = _this$props3.isFocused;
      return isDisabled ? /*#__PURE__*/(0, _jsxRuntime.jsx)(Container, {
        $isDisabled: isDisabled,
        onMouseDown: blockEvent,
        onClick: blockEvent,
        children: children
      }) : /*#__PURE__*/(0, _jsxRuntime.jsx)(Container, {
        ref: innerRef,
        $isFocused: isFocused,
        onClick: this._onClick,
        onMouseEnter: this._onMouseEnter,
        onMouseMove: this._onMouseMove,
        onTouchEnd: this._onTouchEnd,
        onTouchStart: this._onTouchStart,
        onTouchMove: this._onTouchMove,
        role: "option",
        children: children
      });
    }
  }]);

  return OptionContainer;
}(_react["default"].Component);

var _default = OptionContainer;
exports["default"] = _default;
var Container = (0, _Style.styled)(_ViewBase.DivViewBase)(_templateObject || (_templateObject = _taggedTemplateLiteral(["\n  background-color: #fff;\n  cursor: pointer;\n\n  ", " ", ";\n"])), function (props) {
  return props.$isFocused && "\n    background-color: #f9f9f9;\n  ";
}, function (props) {
  return props.$isDisabled && "\n    color: #ccc;\n    cursor: default;\n  ";
});