"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Placeholder = exports.NoResults = exports.MultiValueWrapper = exports.ValueWrapper = exports.MultiValueWrapperOuter = exports.MenuOuter = exports.MenuInner = exports.LoadingZone = exports.Loading = exports.Input = exports.FakeInput = exports.Control = exports.Container = exports.ClearZone = exports.Clear = exports.ArrowZone = exports.Arrow = void 0;

var _styledComponents = _interopRequireWildcard(require("styled-components"));

var _Text = _interopRequireDefault(require("../../../primitives/Text"));

var _TextInputAutoSize = _interopRequireDefault(require("./TextInputAutoSize"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var spin = (0, _styledComponents.keyframes)(["to{transform:rotate(1turn);}"]);
var spinRule = (0, _styledComponents.css)(["", " 400ms infinite linear;"], spin);

var Arrow = _styledComponents["default"].span.withConfig({
  displayName: "StyledComponents__Arrow",
  componentId: "yw2zl5-0"
})(["border-color:#999 transparent transparent;border-style:solid;border-width:5px 5px 2.5px;display:inline-block;height:0;width:0;position:relative;", ";"], function (props) {
  return props.$isOpen && "\n    top: -2px;\n    border-color: transparent transparent #999;\n    border-width: 0 5px 5px;\n  ";
});

exports.Arrow = Arrow;

var ArrowZone = _styledComponents["default"].span.withConfig({
  displayName: "StyledComponents__ArrowZone",
  componentId: "yw2zl5-1"
})(["cursor:pointer;display:table-cell;position:relative;text-align:center;vertical-align:middle;width:25px;&:hover{", "{border-top-color:#666;}}", ";"], Arrow, function (props) {
  return props.isDisabled && "\n    cursor: default;\n    pointer-events: none;\n    opacity: 0.35;\n  ";
});

exports.ArrowZone = ArrowZone;

var Clear = _styledComponents["default"].span.withConfig({
  displayName: "StyledComponents__Clear",
  componentId: "yw2zl5-2"
})(["display:inline-block;font-size:1.15em;line-height:1;"]);

exports.Clear = Clear;

var ClearZone = _styledComponents["default"].span.withConfig({
  displayName: "StyledComponents__ClearZone",
  componentId: "yw2zl5-3"
})(["color:#999;cursor:pointer;display:table-cell;position:relative;text-align:center;vertical-align:middle;width:17px;&:hover{color:#d0021b;}"]);

exports.ClearZone = ClearZone;

var Container = _styledComponents["default"].div.withConfig({
  displayName: "StyledComponents__Container",
  componentId: "yw2zl5-4"
})(["font-size:14px;position:relative;"]);

exports.Container = Container;

var Control = _styledComponents["default"].div.withConfig({
  displayName: "StyledComponents__Control",
  componentId: "yw2zl5-5"
})(["cursor:default;display:table;height:100%;outline:none;overflow:hidden;position:relative;width:100%;&:focus{outline:none;}", " ", ";"], function (_ref) {
  var isOpen = _ref.isOpen;
  return isOpen && "\n    background: #fff;\n  ";
}, function (_ref2) {
  var isFocused = _ref2.isFocused,
      isOpen = _ref2.isOpen,
      isSearchable = _ref2.isSearchable;
  return isSearchable && (isOpen || isFocused) && "\n    cursor: text;\n  ";
});

exports.Control = Control;
var inputStyle = (0, _styledComponents.css)(["height:100%;padding-right:10px;&:focus{outline:none;}"]);

var FakeInput = _styledComponents["default"].div.withConfig({
  displayName: "StyledComponents__FakeInput",
  componentId: "yw2zl5-6"
})(["", " border:0;width:1px;display:inline-block;"], inputStyle);

exports.FakeInput = FakeInput;
var Input = (0, _styledComponents["default"])(_TextInputAutoSize["default"]).withConfig({
  displayName: "StyledComponents__Input",
  componentId: "yw2zl5-7"
})(["input{min-height:26px;width:100%;cursor:", ";font-size:inherit;", ";}", ";"], function (_ref3) {
  var isFocused = _ref3.isFocused;
  return isFocused ? 'text' : 'default';
}, function (_ref4) {
  var hasValue = _ref4.hasValue,
      isPseudoFocused = _ref4.isPseudoFocused;
  return hasValue && isPseudoFocused && "\n      opacity: 0;\n    ";
}, inputStyle);
exports.Input = Input;

var Loading = _styledComponents["default"].span.withConfig({
  displayName: "StyledComponents__Loading",
  componentId: "yw2zl5-8"
})(["animation:", ";width:16px;height:16px;box-sizing:border-box;border-radius:50%;border:2px solid #ccc;border-right-color:#333;display:inline-block;position:relative;vertical-align:middle;"], spinRule);

exports.Loading = Loading;

var LoadingZone = _styledComponents["default"].span.withConfig({
  displayName: "StyledComponents__LoadingZone",
  componentId: "yw2zl5-9"
})(["cursor:pointer;display:table-cell;position:relative;text-align:center;vertical-align:middle;width:16px;"]);

exports.LoadingZone = LoadingZone;

var MenuInner = _styledComponents["default"].div.withConfig({
  displayName: "StyledComponents__MenuInner",
  componentId: "yw2zl5-10"
})(["display:flex;flex-direction:column;max-height:198px;"]);

exports.MenuInner = MenuInner;

var MenuOuter = _styledComponents["default"].div.withConfig({
  displayName: "StyledComponents__MenuOuter",
  componentId: "yw2zl5-11"
})(["background-color:#fff;border:1px solid #ccc;box-sizing:border-box;margin-top:-1px;max-height:200px;position:absolute;top:100%;width:100%;z-index:1;-webkit-overflow-scrolling:touch;"]);

exports.MenuOuter = MenuOuter;

var MultiValueWrapperOuter = _styledComponents["default"].div.withConfig({
  displayName: "StyledComponents__MultiValueWrapperOuter",
  componentId: "yw2zl5-12"
})(["height:100%;"]);

exports.MultiValueWrapperOuter = MultiValueWrapperOuter;

var ValueWrapper = _styledComponents["default"].div.withConfig({
  displayName: "StyledComponents__ValueWrapper",
  componentId: "yw2zl5-13"
})(["height:100%;display:flex;flex-direction:row;align-items:center;"]);

exports.ValueWrapper = ValueWrapper;
var MultiValueWrapper = (0, _styledComponents["default"])(ValueWrapper).withConfig({
  displayName: "StyledComponents__MultiValueWrapper",
  componentId: "yw2zl5-14"
})(["flex-wrap:wrap;padding:6px 0;"]);
exports.MultiValueWrapper = MultiValueWrapper;
var NoResults = (0, _styledComponents["default"])(_Text["default"]).withConfig({
  displayName: "StyledComponents__NoResults",
  componentId: "yw2zl5-15"
})(["color:#999;cursor:default;display:block;padding:8px 10px;"]);
exports.NoResults = NoResults;
var Placeholder = (0, _styledComponents["default"])(_Text["default"]).withConfig({
  displayName: "StyledComponents__Placeholder",
  componentId: "yw2zl5-16"
})(["bottom:0;color:#aaa;height:100%;left:0;padding-right:10px;position:absolute;right:0;top:0;max-width:100%;overflow:hidden;text-overflow:ellipsis;white-space:nowrap;display:flex;align-items:center;"]);
exports.Placeholder = Placeholder;