"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var React = _interopRequireWildcard(require("react"));

var _styledComponents = _interopRequireDefault(require("styled-components"));

var _InputBase = _interopRequireDefault(require("../../../internals/web/InputBase"));

var _Text = _interopRequireDefault(require("../../../primitives/Text"));

var _jsxRuntime = require("react/jsx-runtime");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (typeof call === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

var TextInputAutoSize = /*#__PURE__*/function (_React$Component) {
  _inherits(TextInputAutoSize, _React$Component);

  var _super = _createSuper(TextInputAutoSize);

  function TextInputAutoSize() {
    var _this;

    _classCallCheck(this, TextInputAutoSize);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _super.call.apply(_super, [this].concat(args));
    _this.state = {
      inputWidth: _this.props.minWidth
    };

    _this.inputRef = function (el) {
      _this.input = el;

      if (typeof _this.props.inputRef === 'function') {
        _this.props.inputRef(el);
      }
    };

    _this.placeHolderSizerRef = function (el) {
      _this.placeHolderSizer = el;
    };

    _this.sizerRef = function (el) {
      _this.sizer = el;
    };

    _this.copyInputStyles = function () {
      if (!_this.mounted || !window.getComputedStyle || !_this.sizer) {
        return;
      }

      var inputStyle = _this.input && window.getComputedStyle(_this.input);

      if (!inputStyle) {
        return;
      }

      var widthNode = _this.sizer;
      widthNode.style.fontSize = inputStyle.fontSize;
      widthNode.style.fontFamily = inputStyle.fontFamily;
      widthNode.style.fontWeight = inputStyle.fontWeight;
      widthNode.style.fontStyle = inputStyle.fontStyle;
      widthNode.style.letterSpacing = inputStyle.letterSpacing;
      widthNode.style.textTransform = inputStyle.textTransform;

      if (_this.props.placeholder && _this.placeHolderSizer) {
        var placeholderNode = _this.placeHolderSizer;
        placeholderNode.style.fontSize = inputStyle.fontSize;
        placeholderNode.style.fontFamily = inputStyle.fontFamily;
        placeholderNode.style.fontWeight = inputStyle.fontWeight;
        placeholderNode.style.fontStyle = inputStyle.fontStyle;
        placeholderNode.style.letterSpacing = inputStyle.letterSpacing;
        placeholderNode.style.textTransform = inputStyle.textTransform;
      }
    };

    _this.updateInputWidth = function () {
      if (!_this.mounted || !_this.sizer || typeof _this.sizer.scrollWidth === 'undefined') {
        return;
      }

      var _this$props = _this.props,
          minWidth = _this$props.minWidth,
          placeholder = _this$props.placeholder;
      var newInputWidth = _this.state.inputWidth;

      if (placeholder) {
        if (_this.placeHolderSizer) {
          newInputWidth = Math.max(_this.sizer.scrollWidth, _this.placeHolderSizer.scrollWidth) + 2;
        }
      } else {
        newInputWidth = _this.sizer.scrollWidth + 2;
      }

      if (newInputWidth < minWidth) {
        newInputWidth = minWidth;
      }

      if (newInputWidth !== _this.state.inputWidth) {
        _this.setState({
          inputWidth: newInputWidth
        });
      }
    };

    _this.getInput = function () {
      return _this.input;
    };

    _this.focus = function () {
      _this.input && _this.input.focus();
    };

    _this.blur = function () {
      _this.input && _this.input.blur();
    };

    _this.select = function () {
      _this.input && _this.input.select();
    };

    return _this;
  }

  _createClass(TextInputAutoSize, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      this.mounted = true;
      this.copyInputStyles();
      this.updateInputWidth();
    }
  }, {
    key: "componentDidUpdate",
    value: function componentDidUpdate() {
      this.updateInputWidth();
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      this.mounted = false;
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props2 = this.props,
          className = _this$props2.className,
          defaultValue = _this$props2.defaultValue,
          inputRef = _this$props2.inputRef,
          minWidth = _this$props2.minWidth,
          value = _this$props2.value,
          inputProps = _objectWithoutProperties(_this$props2, ["className", "defaultValue", "inputRef", "minWidth", "value"]);

      var sizerValue = [defaultValue, value, ''].reduce(function (previousValue, currentValue) {
        if (previousValue !== null && previousValue !== undefined) {
          return previousValue;
        }

        return currentValue;
      });
      return /*#__PURE__*/(0, _jsxRuntime.jsxs)(Container, {
        className: className,
        children: [/*#__PURE__*/(0, _jsxRuntime.jsx)(Input, _objectSpread(_objectSpread({}, inputProps), {}, {
          ref: this.inputRef,
          value: value,
          $width: this.state.inputWidth
        })), /*#__PURE__*/(0, _jsxRuntime.jsx)(Sizer, {
          ref: this.sizerRef,
          children: sizerValue
        }), this.props.placeholder ? /*#__PURE__*/(0, _jsxRuntime.jsx)(Sizer, {
          ref: this.placeHolderSizerRef,
          children: /*#__PURE__*/(0, _jsxRuntime.jsx)(_Text["default"], {
            children: this.props.placeholder
          })
        }) : null]
      });
    }
  }]);

  return TextInputAutoSize;
}(React.Component);

TextInputAutoSize.defaultProps = {
  minWidth: 1
};
var _default = TextInputAutoSize;
exports["default"] = _default;

var Container = _styledComponents["default"].div.withConfig({
  displayName: "TextInputAutoSize__Container",
  componentId: "sc-12v07qb-0"
})(["display:inline-block;"]);

var Input = (0, _styledComponents["default"])(_InputBase["default"]).withConfig({
  displayName: "TextInputAutoSize__Input",
  componentId: "sc-12v07qb-1"
})(["box-sizing:content-box;width:", "px;"], function (props) {
  return props.$width;
});

var Sizer = _styledComponents["default"].div.withConfig({
  displayName: "TextInputAutoSize__Sizer",
  componentId: "sc-12v07qb-2"
})(["position:absolute;top:0;left:0;height:0;visibility:hidden;overflow:scroll;white-space:pre;"]);