"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.MenuList = MenuList;

var _react = _interopRequireDefault(require("react"));

var _Menu = _interopRequireDefault(require("../../OldSelect/Select.web/Menu"));

var _StyledComponents = require("../../OldSelect/Select.web/StyledComponents");

var _jsxRuntime = require("react/jsx-runtime");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function MenuList(_ref) {
  var children = _ref.children,
      options = _ref.options,
      selectOption = _ref.selectOption,
      _ref$selectProps = _ref.selectProps,
      filterOption = _ref$selectProps.filterOption,
      getDropdownItemLayout = _ref$selectProps.getDropdownItemLayout,
      inputValue = _ref$selectProps.inputValue,
      noOptionsMessage = _ref$selectProps.noOptionsMessage,
      onBlur = _ref$selectProps.onBlur,
      onDropdownEndReached = _ref$selectProps.onDropdownEndReached,
      onDropdownEndReachedThreshold = _ref$selectProps.onDropdownEndReachedThreshold,
      _onInputChange = _ref$selectProps.onInputChange,
      renderOption = _ref$selectProps.renderOption,
      searchable = _ref$selectProps.searchable,
      selectRef = _ref$selectProps.selectRef,
      _ref$selectProps$test = _ref$selectProps.testID,
      testID = _ref$selectProps$test === void 0 ? 'bappo-select' : _ref$selectProps$test;

  var visibleOptions = _react["default"].useMemo(function () {
    return options.filter(function (option) {
      return (// A default value for `filterOption` must have been set because we set
        // it in the top-level Select component.
        // `inputValue` must have been set because we control it in the
        // top-level Select component.
        filterOption(option, inputValue)
      );
    });
  }, [filterOption, inputValue, options]);

  var focusedOption = _react["default"].useMemo(function () {
    return visibleOptions.find(function (option, index) {
      var _index, _index$props;

      return (_index = children[index]) === null || _index === void 0 ? void 0 : (_index$props = _index.props) === null || _index$props === void 0 ? void 0 : _index$props.isFocused;
    });
  }, [children, visibleOptions]);

  var selectedOptions = _react["default"].useMemo(function () {
    return visibleOptions.filter(function (option, index) {
      var _index2, _index2$props;

      return (_index2 = children[index]) === null || _index2 === void 0 ? void 0 : (_index2$props = _index2.props) === null || _index2$props === void 0 ? void 0 : _index2$props.isSelected;
    });
  }, [children, visibleOptions]);

  return /*#__PURE__*/(0, _jsxRuntime.jsx)(_Menu["default"], {
    focusedOption: focusedOption,
    getItemLayout: getDropdownItemLayout,
    isSearchable: false,
    labelKey: "label",
    noResults: /*#__PURE__*/(0, _jsxRuntime.jsx)(_StyledComponents.NoResults, {
      children: noOptionsMessage({
        inputValue: inputValue
      })
    }),
    onEndReached: onDropdownEndReached,
    onEndReachedThreshold: onDropdownEndReachedThreshold,
    onInputBlur: function onInputBlur() {
      var _selectRef$current;

      // @ts-ignore
      // react-select wants an `onBlur` function that is called with an event
      // but we don't need it. See `SelectProps`.
      onBlur === null || onBlur === void 0 ? void 0 : onBlur();
      _onInputChange === null || _onInputChange === void 0 ? void 0 : _onInputChange('', {
        action: 'input-blur'
      });
      (_selectRef$current = selectRef.current) === null || _selectRef$current === void 0 ? void 0 : _selectRef$current.onMenuClose();
    },
    onInputChange: function onInputChange(newValue) {
      _onInputChange === null || _onInputChange === void 0 ? void 0 : _onInputChange(newValue, {
        action: 'input-change'
      });
    },
    onItemFocus: function onItemFocus(option, event, index) {
      var _index3, _index3$props, _index3$props$innerPr;

      return (_index3 = children[index]) === null || _index3 === void 0 ? void 0 : (_index3$props = _index3.props) === null || _index3$props === void 0 ? void 0 : (_index3$props$innerPr = _index3$props.innerProps) === null || _index3$props$innerPr === void 0 ? void 0 : _index3$props$innerPr.onMouseOver();
    },
    onItemSelect: selectOption,
    options: visibleOptions,
    renderOption: renderOption,
    searchText: inputValue !== null && inputValue !== void 0 ? inputValue : '',
    selectedOptions: selectedOptions,
    testID: "".concat(testID, "-menu"),
    valueKey: "value"
  });
}