"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireDefault(require("react"));

var _reactSelect = _interopRequireWildcard(require("react-select"));

var _FontContext = _interopRequireDefault(require("../../../primitives/Font/FontContext"));

var _ClearIndicator = require("./ClearIndicator");

var _DropdownIndicator = require("./DropdownIndicator");

var _MenuList = require("./MenuList");

var _jsxRuntime = require("react/jsx-runtime");

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { if (typeof Symbol === "undefined" || !(Symbol.iterator in Object(arr))) return; var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

var Select = /*#__PURE__*/_react["default"].forwardRef(function Select(_ref, _ref3) {
  var _ref2, _options$find;

  var accessibilityLabel = _ref.accessibilityLabel,
      autoFocus = _ref.autoFocus,
      className = _ref.className,
      clearable = _ref.clearable,
      filterOption = _ref.filterOption,
      getDropdownItemLayout = _ref.getDropdownItemLayout,
      isLoading = _ref.isLoading,
      multi = _ref.multi,
      noResultsText = _ref.noResultsText,
      onBlur = _ref.onBlur,
      onDropdownEndReached = _ref.onDropdownEndReached,
      onDropdownEndReachedThreshold = _ref.onDropdownEndReachedThreshold,
      onFocus = _ref.onFocus,
      onInputChange = _ref.onInputChange,
      onValueChange = _ref.onValueChange,
      options = _ref.options,
      pageSize = _ref.pageSize,
      placeholder = _ref.placeholder,
      readOnly = _ref.readOnly,
      renderDropdownIcon = _ref.renderDropdownIcon,
      renderOption = _ref.renderOption,
      searchable = _ref.searchable,
      style = _ref.style,
      testID = _ref.testID,
      value = _ref.value;

  var _React$useContext = _react["default"].useContext(_FontContext["default"]),
      fontFamily = _React$useContext.fontFamily,
      fontSize = _React$useContext.fontSize; // control input value as we need it to filter options in the custom MenuList


  var _React$useState = _react["default"].useState(''),
      _React$useState2 = _slicedToArray(_React$useState, 2),
      inputValue = _React$useState2[0],
      setInputValue = _React$useState2[1];

  var handleInputChange = function handleInputChange(newValue, actionMeta) {
    setInputValue(newValue);
    onInputChange === null || onInputChange === void 0 ? void 0 : onInputChange(newValue, actionMeta.action === 'input-change');
  };

  var selectRef = _react["default"].useRef(null);

  var selectedOption = multi ? ((_ref2 = value) !== null && _ref2 !== void 0 ? _ref2 : []).map(function (val) {
    return options === null || options === void 0 ? void 0 : options.find(function (op) {
      return op.value === val;
    });
  }).filter(Boolean) : (_options$find = options === null || options === void 0 ? void 0 : options.find(function (op) {
    return op.value === value;
  })) !== null && _options$find !== void 0 ? _options$find : null;
  return /*#__PURE__*/(0, _jsxRuntime.jsx)(_reactSelect["default"], {
    ref: function ref(select) {
      selectRef.current = select;

      if (_ref3) {
        if (typeof _ref3 === 'function') {
          _ref3(select);
        } else {
          _ref3.current = select;
        }
      }
    },
    "aria-label": accessibilityLabel,
    autoFocus: autoFocus,
    className: className,
    components: {
      ClearIndicator: _ClearIndicator.ClearIndicator,
      DropdownIndicator: _DropdownIndicator.DropdownIndicator,
      MenuList: _MenuList.MenuList
    },
    filterOption: filterOption !== null && filterOption !== void 0 ? filterOption : (0, _reactSelect.createFilter)({}),
    getDropdownItemLayout: getDropdownItemLayout,
    inputValue: inputValue,
    isClearable: clearable !== null && clearable !== void 0 ? clearable : true,
    isDisabled: readOnly,
    isLoading: isLoading,
    isMulti: multi // Always set `isSearchable` to false so that ReactSelect renders a fake
    // input. We pass a custom prop `searchable` down instead. If searchable,
    // we render the input inside the menu.
    ,
    isSearchable: false,
    searchable: searchable,
    menuPortalTarget: document.body,
    noOptionsMessage: noResultsText ? function () {
      return noResultsText;
    } : undefined,
    onBlur: onBlur !== null && onBlur !== void 0 ? onBlur : undefined,
    onChange: function onChange(option) {
      if (multi) {
        onValueChange === null || onValueChange === void 0 ? void 0 : onValueChange(option ? option.map(function (op) {
          return op.value;
        }) : []);
      } else {
        var _option$value;

        onValueChange === null || onValueChange === void 0 ? void 0 : onValueChange((_option$value = option === null || option === void 0 ? void 0 : option.value) !== null && _option$value !== void 0 ? _option$value : null);
      }
    },
    onDropdownEndReached: onDropdownEndReached,
    onDropdownEndReachedThreshold: onDropdownEndReachedThreshold,
    onFocus: onFocus !== null && onFocus !== void 0 ? onFocus : undefined,
    onInputChange: handleInputChange,
    openMenuOnFocus: true,
    options: options,
    pageSize: pageSize,
    placeholder: placeholder !== null && placeholder !== void 0 ? placeholder : '',
    renderDropdownIcon: renderDropdownIcon,
    renderOption: renderOption,
    selectRef: selectRef,
    styles: _objectSpread(_objectSpread({}, styles), {}, {
      container: function container() {
        return _objectSpread({
          fontFamily: fontFamily,
          fontSize: fontSize
        }, style);
      }
    }),
    testID: testID,
    value: selectedOption
  });
});

var _default = Select;
exports["default"] = _default;
var styles = {
  clearIndicator: function clearIndicator(provided) {
    return _objectSpread(_objectSpread({}, provided), {}, {
      padding: 0
    });
  },
  control: function control(provided) {
    return _objectSpread(_objectSpread({}, provided), {}, {
      borderWidth: 0,
      boxShadow: 'none',
      minHeight: 0
    });
  },
  dropdownIndicator: function dropdownIndicator(provided) {
    return _objectSpread(_objectSpread({}, provided), {}, {
      padding: 0
    });
  },
  indicatorsContainer: function indicatorsContainer(provided) {
    return _objectSpread(_objectSpread({}, provided), {}, {
      paddingLeft: 0,
      paddingRight: 0
    });
  },
  indicatorSeparator: function indicatorSeparator(provided) {
    return _objectSpread(_objectSpread({}, provided), {}, {
      backgroundColor: 'transparent'
    });
  },
  input: function input(provided) {
    return _objectSpread(_objectSpread({}, provided), {}, {
      visibility: 'hidden'
    });
  },
  noOptionsMessage: function noOptionsMessage(provided) {
    return _objectSpread(_objectSpread({}, provided), {}, {
      color: '#999'
    });
  },
  placeholder: function placeholder(provided) {
    return _objectSpread(_objectSpread({}, provided), {}, {
      color: '#aaa'
    });
  },
  valueContainer: function valueContainer(provided) {
    return _objectSpread(_objectSpread({}, provided), {}, {
      paddingLeft: 0,
      paddingRight: 0
    });
  }
};