"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = SplitButton;

var _react = _interopRequireDefault(require("react"));

var _Menu = _interopRequireDefault(require("../../components/Menu"));

var _StyledComponents = require("./StyledComponents.native");

var _jsxRuntime = require("react/jsx-runtime");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function SplitButton(_ref) {
  var children = _ref.children,
      className = _ref.className,
      onButtonPress = _ref.onButtonPress,
      style = _ref.style,
      testID = _ref.testID,
      text = _ref.text,
      icon = _ref.icon,
      _ref$type = _ref.type,
      type = _ref$type === void 0 ? 'primary' : _ref$type;
  return /*#__PURE__*/(0, _jsxRuntime.jsxs)(_StyledComponents.Container, {
    className: className,
    style: style,
    children: [/*#__PURE__*/(0, _jsxRuntime.jsx)(_StyledComponents.MainButton, {
      "data-testid": "".concat(testID, "-main"),
      onPress: onButtonPress,
      icon: icon,
      text: text,
      type: type
    }), /*#__PURE__*/(0, _jsxRuntime.jsx)(_StyledComponents.Separator, {}), /*#__PURE__*/(0, _jsxRuntime.jsx)(_Menu["default"], {
      align: "right",
      testID: "".concat(testID, "-arrow"),
      trigger: function trigger(open, _close, _active) {
        return MenuTrigger(open, type, testID);
      },
      children: children
    })]
  });
}

var MenuTrigger = function MenuTrigger(open, type, testID) {
  return /*#__PURE__*/(0, _jsxRuntime.jsx)(_StyledComponents.MenuButton, {
    onPress: function onPress() {
      return open();
    },
    "data-testid": "".concat(testID, "-menu-button"),
    icon: "arrow-drop-down",
    type: type
  });
};

SplitButton.Item = _Menu["default"].Item;