"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = Picker;

var React = _interopRequireWildcard(require("react"));

var _Style = require("../../apis/Style");

var _Text = _interopRequireDefault(require("../../primitives/Text"));

var _TouchableView = _interopRequireDefault(require("../../primitives/TouchableView"));

var _View = _interopRequireDefault(require("../../primitives/View"));

var _styles = require("./styles");

var _jsxRuntime = require("react/jsx-runtime");

var _templateObject, _templateObject2;

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _taggedTemplateLiteral(strings, raw) { if (!raw) { raw = strings.slice(0); } return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _iterableToArray(iter) { if (typeof Symbol !== "undefined" && Symbol.iterator in Object(iter)) return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) return _arrayLikeToArray(arr); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function Picker(_ref) {
  var options = _ref.options,
      _ref$selected = _ref.selected,
      selected = _ref$selected === void 0 ? [] : _ref$selected,
      onChange = _ref.onChange,
      optionToString = _ref.optionToString,
      _ref$multi = _ref.multi,
      multi = _ref$multi === void 0 ? false : _ref$multi,
      testID = _ref.testID;
  return /*#__PURE__*/(0, _jsxRuntime.jsx)(StyledView, {
    testID: testID,
    children: options.map(function (option, i) {
      var isSelected;
      if (multi) isSelected = selected.includes(option);else isSelected = selected === option;
      return /*#__PURE__*/(0, _jsxRuntime.jsx)(TabButton, {
        $isSelected: isSelected,
        $position: getPosition(i, options.length),
        onPress: function onPress() {
          var output;

          if (!multi) {
            output = option;
          } else {
            if (selected.includes(option)) {
              output = selected.filter(function (item) {
                return item !== option;
              });
            } else {
              output = [].concat(_toConsumableArray(selected), [option]);
            }
          }

          onChange(output);
        },
        children: /*#__PURE__*/(0, _jsxRuntime.jsx)(_Text["default"], {
          children: optionToString(option)
        }, option.value)
      }, i);
    })
  });
}

var StyledView = (0, _Style.styled)(_View["default"])(_templateObject || (_templateObject = _taggedTemplateLiteral(["\n  flex-direction: column;\n  max-width: 400px;\n"])));
var TabButton = (0, _Style.styled)(_TouchableView["default"])(_templateObject2 || (_templateObject2 = _taggedTemplateLiteral(["\n  min-width: 50px;\n  height: 40px;\n  padding-left: 10px;\n  padding-right: 10px;\n  background-color: ", ";\n  border-top-left-radius: ", ";\n  border-top-right-radius: ", ";\n  border-bottom-left-radius: ", ";\n  border-bottom-right-radius: ", ";\n  margin-bottom: 1px;\n  align-items: center;\n  justify-content: center;\n  ", ";\n"])), function (_ref2) {
  var $isSelected = _ref2.$isSelected;
  return $isSelected ? 'orange' : '#f8f8f8';
}, function (_ref3) {
  var $position = _ref3.$position;
  return $position === 'first' ? '4px' : '0px';
}, function (_ref4) {
  var $position = _ref4.$position;
  return $position === 'first' ? '4px' : '0px';
}, function (_ref5) {
  var $position = _ref5.$position;
  return $position === 'last' ? '4px' : '0px';
}, function (_ref6) {
  var $position = _ref6.$position;
  return $position === 'last' ? '4px' : '0px';
}, function (props) {
  return (0, _styles.ButtonCSS)(props);
});

var getPosition = function getPosition(pos, length) {
  if (pos === 0) {
    return 'first';
  }

  if (pos === length - 1) {
    return 'last';
  }

  return 'middle';
};