"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _moment = _interopRequireDefault(require("moment"));

var React = _interopRequireWildcard(require("react"));

var _reactNative = require("react-native");

var _Picker = _interopRequireDefault(require("../../../internals/Picker.native"));

var _constants = require("../constants");

var _StyledComponents = require("../StyledComponents");

var _jsxRuntime = require("react/jsx-runtime");

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (typeof call === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

var getDefaultTime = function getDefaultTime() {
  return (0, _moment["default"])().startOf('minute').toDate();
};

var TimePicker = /*#__PURE__*/function (_React$Component) {
  _inherits(TimePicker, _React$Component);

  var _super = _createSuper(TimePicker);

  function TimePicker(props) {
    var _this;

    _classCallCheck(this, TimePicker);

    _this = _super.call(this, props);

    _this._capturePickerRef = function (ref) {
      _this._picker = ref;
    };

    _this._onTimeChange = function (time) {
      _this.setState({
        selectedTime: time
      });
    };

    _this._renderPopup = function () {
      return /*#__PURE__*/(0, _jsxRuntime.jsx)(_reactNative.DatePickerIOS, {
        date: _this.state.selectedTime || getDefaultTime(),
        mode: "time",
        onDateChange: _this._onTimeChange
      });
    };

    _this._renderValue = function () {
      var _this$props = _this.props,
          displayFormat = _this$props.displayFormat,
          placeholder = _this$props.placeholder,
          value = _this$props.value,
          valueFormat = _this$props.valueFormat;
      var time = (0, _moment["default"])(value || '', valueFormat);
      var timeStr = time.isValid() ? time.format(displayFormat) : '';

      if (!timeStr) {
        return /*#__PURE__*/(0, _jsxRuntime.jsx)(_StyledComponents.PlaceholderText, {
          children: placeholder
        });
      }

      return /*#__PURE__*/(0, _jsxRuntime.jsx)(_StyledComponents.ValueText, {
        children: timeStr
      });
    };

    _this._selectTime = function (time) {
      var _this$props2 = _this.props,
          onValueChange = _this$props2.onValueChange,
          valueFormat = _this$props2.valueFormat;

      _this.blur();

      _this.setState({
        selectedTime: time
      });

      if (onValueChange) {
        var timeMoment = (0, _moment["default"])(time);

        if (timeMoment.isValid()) {
          onValueChange(timeMoment.format(valueFormat));
        } else {
          onValueChange(null);
        }
      }
    };

    var _this$props3 = _this.props,
        _value = _this$props3.value,
        _valueFormat = _this$props3.valueFormat;
    var initialTime = (0, _moment["default"])(_value || '', _valueFormat);

    if (!initialTime.isValid()) {
      initialTime = (0, _moment["default"])();
    }

    _this.state = {
      selectedTime: initialTime.toDate()
    };
    return _this;
  }

  _createClass(TimePicker, [{
    key: "blur",
    value: function blur() {
      this._picker && this._picker.blur();
    }
  }, {
    key: "focus",
    value: function focus() {
      this._picker && this._picker.focus();
    }
  }, {
    key: "render",
    value: function render() {
      var _this2 = this;

      var _this$props4 = this.props,
          accessibilityLabel = _this$props4.accessibilityLabel,
          autoFocus = _this$props4.autoFocus,
          clearable = _this$props4.clearable,
          clearValueText = _this$props4.clearValueText,
          onBlur = _this$props4.onBlur,
          onFocus = _this$props4.onFocus,
          readOnly = _this$props4.readOnly,
          renderDropdownIcon = _this$props4.renderDropdownIcon,
          style = _this$props4.style,
          testID = _this$props4.testID;
      var styleProps = {
        style: style
      };
      var props = {
        accessibilityLabel: accessibilityLabel,
        autoFocus: autoFocus,
        clearable: clearable,
        clearValueText: clearValueText,
        onBlur: onBlur,
        onClear: function onClear() {
          return _this2._selectTime(null);
        },
        onConfirm: function onConfirm() {
          return _this2._selectTime(_this2.state.selectedTime || getDefaultTime());
        },
        onFocus: onFocus,
        readOnly: readOnly,
        ref: this._capturePickerRef,
        renderDropdownIcon: renderDropdownIcon,
        renderPopup: this._renderPopup,
        renderValue: this._renderValue,
        testID: testID
      };
      return /*#__PURE__*/(0, _jsxRuntime.jsx)(_Picker["default"], _objectSpread(_objectSpread({}, styleProps), props));
    }
  }]);

  return TimePicker;
}(React.Component);

TimePicker.defaultProps = {
  clearable: true,
  clearValueText: 'Clear value',
  displayFormat: _constants.DEFAULT_TIME_DISPLAY_FORMAT,
  readOnly: false,
  valueFormat: _constants.DEFAULT_TIME_VALUE_FORMAT
};
TimePicker.displayName = 'TimePicker';
var _default = TimePicker;
exports["default"] = _default;