"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireDefault(require("react"));

var _warning = _interopRequireDefault(require("warning"));

var _Form = require("../../../primitives/Form");

var _TimePicker = _interopRequireDefault(require("../../TimePicker"));

var _wrappers = require("../wrappers");

var _jsxRuntime = require("react/jsx-runtime");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function TimeField(props, ref) {
  var passedFieldState = props.fieldState,
      label = props.label,
      required = props.required,
      reserveErrorSpace = props.reserveErrorSpace,
      testID = props.testID,
      validate = props.validate,
      rest = _objectWithoutProperties(props, ["fieldState", "label", "required", "reserveErrorSpace", "testID", "validate"]);

  (0, _warning["default"])(!(validate && !reserveErrorSpace), "Prop \"reserveErrorSpace\" is set to false while \"validate\" is supplied. You will not see the validation error.");

  var inputRef = _react["default"].useRef(null);

  var focusInput = _react["default"].useCallback(function () {
    return inputRef.current && inputRef.current.focus();
  }, []);

  var blurInput = _react["default"].useCallback(function () {
    return inputRef.current && inputRef.current.blur();
  }, []);

  _react["default"].useImperativeHandle(ref, function () {
    return {
      focus: focusInput,
      blur: blurInput
    };
  });

  var _useFieldState = (0, _Form.useFieldState)(props),
      fieldState = _useFieldState.fieldState,
      onBlur = _useFieldState.onBlur,
      onFocus = _useFieldState.onFocus,
      onValueChange = _useFieldState.onValueChange;

  return /*#__PURE__*/(0, _jsxRuntime.jsx)(_wrappers.InputFieldWrapper, {
    fieldState: fieldState,
    focusInput: focusInput,
    label: label,
    onValueChange: onValueChange,
    required: required,
    reserveErrorSpace: reserveErrorSpace,
    testID: testID,
    children: /*#__PURE__*/(0, _jsxRuntime.jsx)(_TimePicker["default"], _objectSpread(_objectSpread({}, rest), {}, {
      ref: inputRef,
      onBlur: onBlur,
      onFocus: onFocus,
      onValueChange: onValueChange,
      value: fieldState.value
    }))
  });
}

var _default = /*#__PURE__*/_react["default"].forwardRef(TimeField);

exports["default"] = _default;