"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireDefault(require("react"));

var _Style = require("../../../apis/Style");

var _View = _interopRequireDefault(require("../../../primitives/View"));

var _Paragraph = _interopRequireDefault(require("../../Paragraph"));

var _FieldContainer = _interopRequireDefault(require("../FieldContainer"));

var _FieldLabel = _interopRequireDefault(require("../FieldLabel"));

var _TouchToFocusArea = _interopRequireDefault(require("../TouchToFocusArea"));

var _jsxRuntime = require("react/jsx-runtime");

var _templateObject, _templateObject2;

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _taggedTemplateLiteral(strings, raw) { if (!raw) { raw = strings.slice(0); } return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }

function CheckboxFieldWrapper(props) {
  var children = props.children,
      className = props.className,
      fieldState = props.fieldState,
      label = props.label,
      onValueChange = props.onValueChange,
      style = props.style,
      testID = props.testID,
      _props$reserveErrorSp = props.reserveErrorSpace,
      reserveErrorSpace = _props$reserveErrorSp === void 0 ? true : _props$reserveErrorSp;
  return /*#__PURE__*/(0, _jsxRuntime.jsxs)(_FieldContainer["default"], {
    className: className,
    style: style,
    testID: testID,
    children: [/*#__PURE__*/(0, _jsxRuntime.jsxs)(CheckboxTouchToFocusArea, {
      onPress: function onPress() {
        return onValueChange && onValueChange(!fieldState.value);
      },
      testID: testID && "".concat(testID, "-control"),
      children: [label && /*#__PURE__*/(0, _jsxRuntime.jsx)(_FieldLabel["default"], {
        testID: testID && "".concat(testID, "-label"),
        children: label
      }), /*#__PURE__*/(0, _jsxRuntime.jsx)(CheckboxContainer, {
        children: children
      })]
    }), reserveErrorSpace && /*#__PURE__*/(0, _jsxRuntime.jsx)(_Paragraph["default"], {
      type: "error",
      children: fieldState.touched ? fieldState.error : ''
    })]
  });
}

var _default = CheckboxFieldWrapper;
exports["default"] = _default;
var CheckboxTouchToFocusArea = (0, _Style.styled)(_TouchToFocusArea["default"])(_templateObject || (_templateObject = _taggedTemplateLiteral(["\n  align-self: stretch;\n  flex-direction: row;\n  justify-content: space-between;\n  align-items: center;\n"])));
var CheckboxContainer = (0, _Style.styled)(_View["default"])(_templateObject2 || (_templateObject2 = _taggedTemplateLiteral(["\n  margin-left: 2px;\n"])));