"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireDefault(require("react"));

var _Paragraph = _interopRequireDefault(require("../../Paragraph"));

var _FieldContainer = _interopRequireDefault(require("../FieldContainer"));

var _FieldLabel = _interopRequireDefault(require("../FieldLabel"));

var _StyledComponents = require("../StyledComponents");

var _TouchToFocusArea = _interopRequireDefault(require("../TouchToFocusArea"));

var _jsxRuntime = require("react/jsx-runtime");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function InputFieldWrapper(props) {
  var children = props.children,
      className = props.className,
      fieldState = props.fieldState,
      focusInput = props.focusInput,
      label = props.label,
      required = props.required,
      style = props.style,
      testID = props.testID,
      _props$reserveErrorSp = props.reserveErrorSpace,
      reserveErrorSpace = _props$reserveErrorSp === void 0 ? true : _props$reserveErrorSp;
  return /*#__PURE__*/(0, _jsxRuntime.jsxs)(_FieldContainer["default"], {
    className: className,
    style: style,
    testID: testID,
    children: [/*#__PURE__*/(0, _jsxRuntime.jsxs)(_TouchToFocusArea["default"], {
      onPress: focusInput,
      testID: testID && "".concat(testID, "-control"),
      children: [label && /*#__PURE__*/(0, _jsxRuntime.jsxs)(_StyledComponents.FieldLabelContainer, {
        children: [/*#__PURE__*/(0, _jsxRuntime.jsx)(_FieldLabel["default"], {
          testID: testID && "".concat(testID, "-label"),
          children: label
        }), required && /*#__PURE__*/(0, _jsxRuntime.jsx)(_StyledComponents.FieldLabelAsterisk, {})]
      }), /*#__PURE__*/(0, _jsxRuntime.jsx)(_StyledComponents.FieldInputContainer, {
        $hasError: fieldState.touched && fieldState.error,
        children: children
      })]
    }), reserveErrorSpace && /*#__PURE__*/(0, _jsxRuntime.jsx)(_Paragraph["default"], {
      type: "error",
      children: fieldState.touched ? fieldState.error : ''
    })]
  });
}

var _default = InputFieldWrapper;
exports["default"] = _default;