"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireDefault(require("react"));

var _styledComponents = _interopRequireDefault(require("styled-components"));

var _TouchableView = _interopRequireDefault(require("../../../primitives/TouchableView"));

var _View = _interopRequireDefault(require("../../../primitives/View"));

var _utils = require("../utils");

var _jsxRuntime = require("react/jsx-runtime");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

var Swatch = function Swatch(_ref) {
  var color = _ref.color,
      onClick = _ref.onClick,
      _ref$title = _ref.title,
      title = _ref$title === void 0 ? color.hex : _ref$title,
      _ref$active = _ref.active,
      active = _ref$active === void 0 ? false : _ref$active;

  var handleClick = function handleClick(e) {
    return onClick === null || onClick === void 0 ? void 0 : onClick(color, e);
  };

  var swatchStyle = {
    backgroundColor: color.hex,
    outline: 'none',
    width: 28,
    height: 28,
    marginRight: 4,
    marginBottom: 4
  };
  return /*#__PURE__*/(0, _jsxRuntime.jsx)(_TouchableView["default"], {
    style: swatchStyle,
    onPress: handleClick,
    title: title,
    children: active ? /*#__PURE__*/(0, _jsxRuntime.jsx)(Dot, {
      $color: (0, _utils.contrastingColor)(color)
    }) : null
  });
};

var _default = Swatch;
exports["default"] = _default;
var Dot = (0, _styledComponents["default"])(_View["default"]).withConfig({
  displayName: "Swatch__Dot",
  componentId: "llcyqw-0"
})(["position:absolute;background-color:", ";border-radius:10px;top:8px;left:8px;bottom:8px;right:8px;"], function (_ref2) {
  var $color = _ref2.$color;
  return "".concat($color);
});