"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireDefault(require("react"));

var _styledComponents = _interopRequireDefault(require("styled-components"));

var _View = _interopRequireDefault(require("../../../primitives/View"));

var _Swatch = _interopRequireDefault(require("./Swatch"));

var _jsxRuntime = require("react/jsx-runtime");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

var SwatchCollection = function SwatchCollection(_ref) {
  var colors = _ref.colors,
      onClick = _ref.onClick,
      activeColor = _ref.activeColor,
      className = _ref.className;
  return /*#__PURE__*/(0, _jsxRuntime.jsx)(CollectionContainer, {
    className: className,
    children: colors.map(function (color) {
      var active = color.r === (activeColor === null || activeColor === void 0 ? void 0 : activeColor.r) && color.g === (activeColor === null || activeColor === void 0 ? void 0 : activeColor.g) && color.b === (activeColor === null || activeColor === void 0 ? void 0 : activeColor.b) && color.a === (activeColor === null || activeColor === void 0 ? void 0 : activeColor.a);
      return /*#__PURE__*/(0, _jsxRuntime.jsx)(_Swatch["default"], {
        onClick: onClick,
        color: color,
        active: active
      }, color.hex);
    })
  });
};

var CollectionContainer = (0, _styledComponents["default"])(_View["default"]).withConfig({
  displayName: "SwatchCollection__CollectionContainer",
  componentId: "sc-1pe2xvv-0"
})(["width:100%;flex-wrap:wrap;display:flex;flex-direction:row;"]);
var _default = SwatchCollection;
exports["default"] = _default;