"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var React = _interopRequireWildcard(require("react"));

var _reactNative = _interopRequireDefault(require("react-native"));

var _styledComponents = _interopRequireDefault(require("styled-components"));

var _Text = _interopRequireDefault(require("../../../primitives/Text"));

var _TextInput = _interopRequireDefault(require("../../../primitives/TextInput"));

var _TouchableView = _interopRequireDefault(require("../../../primitives/TouchableView"));

var _View = _interopRequireDefault(require("../../../primitives/View"));

var _types = require("../types");

var _utils = require("../utils");

var _SwatchCollection = _interopRequireDefault(require("./SwatchCollection"));

var _jsxRuntime = require("react/jsx-runtime");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { if (typeof Symbol === "undefined" || !(Symbol.iterator in Object(arr))) return; var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

var ColorPicker = function ColorPicker(_ref) {
  var _color$r$toString, _color$r, _color$g$toString, _color$g, _color$b$toString, _color$b, _color$a$toString, _color$a;

  var colors = _ref.colors,
      color = _ref.color,
      onChange = _ref.onChange;

  var _React$useState = React.useState(color !== null && color !== void 0 ? color : {}),
      _React$useState2 = _slicedToArray(_React$useState, 2),
      _color = _React$useState2[0],
      setColor = _React$useState2[1];

  var _React$useState3 = React.useState(color === null || color === void 0 ? void 0 : color.hex),
      _React$useState4 = _slicedToArray(_React$useState3, 2),
      hex = _React$useState4[0],
      setHex = _React$useState4[1];

  React.useEffect(function () {
    setHex(_color.hex);
    onChange === null || onChange === void 0 ? void 0 : onChange(_color);
  }, [onChange, _color]);
  colors = colors || _types.DefaultColors;
  var convertedColors = React.useMemo(function () {
    return colors.map(function (c) {
      return (0, _utils.hexAToRGBA)(c);
    }).filter(Boolean);
  }, [colors]);

  var handleSwatchClick = function handleSwatchClick(value, _event) {
    return setColor(value);
  };

  var handleColorChange = function handleColorChange(value) {
    var getComponent = function getComponent(component) {
      var _value$component;

      return Math.max(0, Math.min(255, value.hasOwnProperty(component) ? (_value$component = value[component]) !== null && _value$component !== void 0 ? _value$component : 0 : _color[component] || 0));
    };

    if (value.hasOwnProperty('r') || value.hasOwnProperty('g') || value.hasOwnProperty('b') || value.hasOwnProperty('a')) {
      var newColor = (0, _utils.RGBAToHexA)(getComponent('r'), getComponent('g'), getComponent('b'), getComponent('a'));
      newColor && setColor(newColor);
    } else if (value.hex) {
      var _value$hex;

      value.hex = (_value$hex = value.hex) === null || _value$hex === void 0 ? void 0 : _value$hex.replace(/[^#A-Fa-f0-9]/g, '');

      var _newColor = (0, _utils.hexAToRGBA)(value.hex);

      _newColor && setColor(_newColor);
      setHex(value.hex);
    }
  };

  return /*#__PURE__*/(0, _jsxRuntime.jsx)(Container, {
    children: /*#__PURE__*/(0, _jsxRuntime.jsxs)(InputContainer, {
      children: [/*#__PURE__*/(0, _jsxRuntime.jsx)(_SwatchCollection["default"], {
        colors: convertedColors,
        onClick: handleSwatchClick,
        activeColor: color
      }), /*#__PURE__*/(0, _jsxRuntime.jsx)(TransparentSwatch, {
        onPress: function onPress() {
          return handleColorChange({
            hex: '#0000'
          });
        },
        children: /*#__PURE__*/(0, _jsxRuntime.jsx)(_Text["default"], {
          children: "transparent"
        })
      }), /*#__PURE__*/(0, _jsxRuntime.jsxs)(Row, {
        children: [/*#__PURE__*/(0, _jsxRuntime.jsxs)(ColorInputContainer, {
          children: [/*#__PURE__*/(0, _jsxRuntime.jsx)(Label, {
            children: "Hex"
          }), /*#__PURE__*/(0, _jsxRuntime.jsx)(HexInput, {
            maxLength: 9,
            value: hex,
            onValueChange: function onValueChange(value) {
              handleColorChange({
                hex: value
              });
            }
          })]
        }), /*#__PURE__*/(0, _jsxRuntime.jsxs)(Row, {
          children: [/*#__PURE__*/(0, _jsxRuntime.jsxs)(ColorInputContainer, {
            children: [/*#__PURE__*/(0, _jsxRuntime.jsx)(Label, {
              children: "R"
            }), /*#__PURE__*/(0, _jsxRuntime.jsx)(ColorInput, {
              maxLength: 3,
              value: (_color$r$toString = (_color$r = color.r) === null || _color$r === void 0 ? void 0 : _color$r.toString()) !== null && _color$r$toString !== void 0 ? _color$r$toString : '0',
              onValueChange: function onValueChange(value) {
                handleColorChange({
                  r: +value.replace(/[^0-9]/g, '')
                });
              },
              type: "number"
            })]
          }), /*#__PURE__*/(0, _jsxRuntime.jsxs)(ColorInputContainer, {
            children: [/*#__PURE__*/(0, _jsxRuntime.jsx)(Label, {
              children: "G"
            }), /*#__PURE__*/(0, _jsxRuntime.jsx)(ColorInput, {
              maxLength: 3,
              value: (_color$g$toString = (_color$g = color.g) === null || _color$g === void 0 ? void 0 : _color$g.toString()) !== null && _color$g$toString !== void 0 ? _color$g$toString : '0',
              onValueChange: function onValueChange(value) {
                handleColorChange({
                  g: +value.replace(/[^0-9]/g, '')
                });
              },
              type: "number"
            })]
          }), /*#__PURE__*/(0, _jsxRuntime.jsxs)(ColorInputContainer, {
            children: [/*#__PURE__*/(0, _jsxRuntime.jsx)(Label, {
              children: "B"
            }), /*#__PURE__*/(0, _jsxRuntime.jsx)(ColorInput, {
              maxLength: 3,
              value: (_color$b$toString = (_color$b = color.b) === null || _color$b === void 0 ? void 0 : _color$b.toString()) !== null && _color$b$toString !== void 0 ? _color$b$toString : '0',
              onValueChange: function onValueChange(value) {
                handleColorChange({
                  b: +value.replace(/[^0-9]/g, '')
                });
              },
              type: "number"
            })]
          }), /*#__PURE__*/(0, _jsxRuntime.jsxs)(ColorInputContainer, {
            children: [/*#__PURE__*/(0, _jsxRuntime.jsx)(Label, {
              children: "A"
            }), /*#__PURE__*/(0, _jsxRuntime.jsx)(ColorInput, {
              maxLength: 3,
              value: (_color$a$toString = (_color$a = color.a) === null || _color$a === void 0 ? void 0 : _color$a.toString()) !== null && _color$a$toString !== void 0 ? _color$a$toString : '255',
              onValueChange: function onValueChange(value) {
                handleColorChange({
                  a: +value.replace(/[^0-9]/g, '')
                });
              },
              type: "number"
            })]
          })]
        })]
      })]
    })
  });
};

var InputContainer = (0, _styledComponents["default"])(_View["default"]).withConfig({
  displayName: "ColorPickernative__InputContainer",
  componentId: "gisdjj-0"
})(["display:flex;flex-direction:column;"]);
var Row = (0, _styledComponents["default"])(_View["default"]).withConfig({
  displayName: "ColorPickernative__Row",
  componentId: "gisdjj-1"
})(["display:flex;flex-direction:row;"]);
var Container = (0, _styledComponents["default"])(_View["default"]).withConfig({
  displayName: "ColorPickernative__Container",
  componentId: "gisdjj-2"
})(["display:flex;flex-direction:row;padding:8px 8px 4px 8px;"]);
var ColorInput = (0, _styledComponents["default"])(_TextInput["default"]).withConfig({
  displayName: "ColorPickernative__ColorInput",
  componentId: "gisdjj-3"
})(["width:30px;"]);
var TransparentSwatch = (0, _styledComponents["default"])(_TouchableView["default"]).withConfig({
  displayName: "ColorPickernative__TransparentSwatch",
  componentId: "gisdjj-4"
})(["width:100%;font-size:12px;color:gray;height:24px;line-height:24px;align-items:center;border-width:1px;border-style:solid;border-color:#ddd;border-bottom-width:2px;"]);
var HexInput = (0, _styledComponents["default"])(_TextInput["default"]).withConfig({
  displayName: "ColorPickernative__HexInput",
  componentId: "gisdjj-5"
})(["width:80px;"]);
var ColorInputContainer = (0, _styledComponents["default"])(_View["default"]).withConfig({
  displayName: "ColorPickernative__ColorInputContainer",
  componentId: "gisdjj-6"
})([""]);
var Label = (0, _styledComponents["default"])(_reactNative["default"].Text).withConfig({
  displayName: "ColorPickernative__Label",
  componentId: "gisdjj-7"
})(["font-size:10px;color:gray;"]);
var _default = ColorPicker;
exports["default"] = _default;