"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.RGBAToHexA = RGBAToHexA;
exports.hexAToRGBA = hexAToRGBA;
exports.contrastingColor = void 0;

function RGBAToHexA(r, g, b, a) {
  var hex_r = r.toString(16);
  var hex_g = g.toString(16);
  var hex_b = b.toString(16);
  var hex_a = a.toString(16);
  if (hex_r.length === 1) hex_r = "0".concat(hex_r);
  if (hex_g.length === 1) hex_g = "0".concat(hex_g);
  if (hex_b.length === 1) hex_b = "0".concat(hex_b);
  if (hex_a.length === 1) hex_a = "0".concat(hex_a);
  return {
    r: r,
    g: g,
    b: b,
    a: a,
    hex: "#".concat(hex_r).concat(hex_g).concat(hex_b).concat(hex_a)
  };
}

function hexAToRGBA(h) {
  var r = 0,
      g = 0,
      b = 0,
      a = 255,
      valid = false;

  if (h.length === 4) {
    r = +('0x' + h[1] + h[1]);
    g = +('0x' + h[2] + h[2]);
    b = +('0x' + h[3] + h[3]);
    valid = true;
  } else if (h.length === 5) {
    r = +('0x' + h[1] + h[1]);
    g = +('0x' + h[2] + h[2]);
    b = +('0x' + h[3] + h[3]);
    a = +('0x' + h[4] + h[4]);
    valid = true;
  } else if (h.length === 7) {
    r = +('0x' + h[1] + h[2]);
    g = +('0x' + h[3] + h[4]);
    b = +('0x' + h[5] + h[6]);
    valid = true;
  } else if (h.length === 9) {
    r = +('0x' + h[1] + h[2]);
    g = +('0x' + h[3] + h[4]);
    b = +('0x' + h[5] + h[6]);
    a = +('0x' + h[7] + h[8]);
    valid = true;
  }

  if (!valid) return undefined;
  a = +a;
  return {
    r: r,
    g: g,
    b: b,
    a: a,
    hex: h
  };
}

var contrastingColor = function contrastingColor(color) {
  var _color$r, _color$g, _color$b;

  if (!color) {
    return '#fff';
  }

  if (color.a === 0) {
    return 'rgba(0,0,0,0.4)';
  }

  var intensity = ((_color$r = color.r) !== null && _color$r !== void 0 ? _color$r : 0) * 299 + ((_color$g = color.g) !== null && _color$g !== void 0 ? _color$g : 0) * 587 + ((_color$b = color.b) !== null && _color$b !== void 0 ? _color$b : 0) * 114;
  return intensity >= 128000 ? '#000' : '#fff';
};

exports.contrastingColor = contrastingColor;