"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.ValueContainer = exports.PopoverContainer = exports.FakeInput = exports.Control = exports.Container = exports.ClearZone = exports.Clear = exports.ArrowZone = exports.Arrow = void 0;

var _styledComponents = _interopRequireDefault(require("styled-components"));

var _ViewBase = require("../web/ViewBase");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

// $FlowFixMe typescript
var Arrow = _styledComponents["default"].span.withConfig({
  displayName: "StyledComponents__Arrow",
  componentId: "sc-7ns4cd-0"
})(["border-color:#999 transparent transparent;border-style:solid;border-width:5px 5px 2.5px;height:0;width:0;position:relative;", ";"], function (props) {
  return props.$isOpen && "\n    top: -2px;\n    border-color: transparent transparent #999;\n    border-width: 0 5px 5px;\n  ";
});

exports.Arrow = Arrow;

var ArrowZone = _styledComponents["default"].div.withConfig({
  displayName: "StyledComponents__ArrowZone",
  componentId: "sc-7ns4cd-1"
})(["align-items:center;cursor:pointer;display:flex;justify-content:center;padding-top:2px;position:relative;width:25px;&:hover{", "{border-top-color:#666;}}", ";"], Arrow, function (props) {
  return props.$isDisabled && "\n    cursor: default;\n    pointer-events: none;\n    opacity: 0.35;\n  ";
});

exports.ArrowZone = ArrowZone;

var Clear = _styledComponents["default"].span.withConfig({
  displayName: "StyledComponents__Clear",
  componentId: "sc-7ns4cd-2"
})(["font-size:1.15em;line-height:1;"]);

exports.Clear = Clear;

var ClearZone = _styledComponents["default"].div.withConfig({
  displayName: "StyledComponents__ClearZone",
  componentId: "sc-7ns4cd-3"
})(["align-items:center;color:#999;cursor:pointer;display:flex;justify-content:center;position:relative;width:17px;&:hover{color:#c3c3c3;}"]);

exports.ClearZone = ClearZone;
var Container = (0, _styledComponents["default"])(_ViewBase.DivViewBase).withConfig({
  displayName: "StyledComponents__Container",
  componentId: "sc-7ns4cd-4"
})(["font-size:14px;"]);
exports.Container = Container;

var Control = _styledComponents["default"].div.withConfig({
  displayName: "StyledComponents__Control",
  componentId: "sc-7ns4cd-5"
})(["align-items:center;cursor:default;display:flex;overflow:hidden;position:relative;width:100%;"]);

exports.Control = Control;

var FakeInput = _styledComponents["default"].div.withConfig({
  displayName: "StyledComponents__FakeInput",
  componentId: "sc-7ns4cd-6"
})(["min-height:16px;width:0;&:focus{outline:none;}"]);

exports.FakeInput = FakeInput;
var PopoverContainer = (0, _styledComponents["default"])(_ViewBase.DivViewBase).withConfig({
  displayName: "StyledComponents__PopoverContainer",
  componentId: "sc-7ns4cd-7"
})(["background-color:#fff;border:1px solid #ccc;border-top-color:#e6e6e6;box-shadow:0 1px 0 rgba(0,0,0,0.06);margin-top:-1px;position:absolute;top:100%;z-index:1;-webkit-overflow-scrolling:touch;"]);
exports.PopoverContainer = PopoverContainer;
var ValueContainer = (0, _styledComponents["default"])(_ViewBase.DivViewBase).withConfig({
  displayName: "StyledComponents__ValueContainer",
  componentId: "sc-7ns4cd-8"
})(["flex:1;"]);
exports.ValueContainer = ValueContainer;