"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var React = _interopRequireWildcard(require("react"));

var _Popover = require("../Popover.web");

var _StyledComponents = require("./StyledComponents");

var _jsxRuntime = require("react/jsx-runtime");

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (typeof call === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

var PickerWeb = /*#__PURE__*/function (_React$Component) {
  _inherits(PickerWeb, _React$Component);

  var _super = _createSuper(PickerWeb);

  function PickerWeb() {
    var _this;

    _classCallCheck(this, PickerWeb);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _super.call.apply(_super, [this].concat(args));
    _this.state = {
      isOpen: false
    };
    _this._containerRef = /*#__PURE__*/React.createRef();

    _this._clearValue = function () {
      var onValueChange = _this.props.onValueChange;
      onValueChange && onValueChange(null);
    };

    _this._closePopover = function () {
      return _this.setState({
        isOpen: false
      });
    };

    _this._onClearButtonClick = function (event) {
      event.stopPropagation();
      event.preventDefault();

      _this._clearValue();
    };

    _this._onControlClick = function (event) {
      // if the event was triggered by a click and not the primary button, or if the component is
      // read-only, ignore it.
      // $FlowFixMe
      if (_this.props.readOnly || event.type === 'click' && event.button !== 0) {
        return;
      } // prevent default event handlers


      event.stopPropagation();
      event.preventDefault();

      if (_this.state.isOpen) {
        _this.blur();
      } else {
        _this.focus();
      }
    };

    _this._onControlMouseDown = function (event) {
      event.stopPropagation();
      event.preventDefault();
    };

    _this._onDropdownIconClick = function (event) {
      // if the event was triggered by a click and not the primary
      // button, or if the component is read-only, ignore it.
      // $FlowFixMe
      if (_this.props.readOnly || event.type === 'click' && event.button !== 0) {
        return;
      } // If the menu isn't open, let the event bubble to _onControlClick


      if (!_this.state.isOpen) {
        return;
      } // prevent default event handlers


      event.stopPropagation();
      event.preventDefault(); // close the menu

      _this.blur();
    };

    _this._onInputBlur = function () {
      var onBlur = _this.props.onBlur;
      onBlur && onBlur();

      _this._closePopover();
    };

    _this._onInputFocus = function () {
      var _this$props = _this.props,
          onFocus = _this$props.onFocus,
          readOnly = _this$props.readOnly;
      if (readOnly) return;
      onFocus && onFocus();

      _this.setState({
        isOpen: true
      });
    };

    _this._onPopoverMouseDown = function (event) {
      // if the event was triggered by a mousedown and not the primary
      // button, or if the component is read-only, ignore it.
      if (_this.props.readOnly) {
        return;
      }

      event.stopPropagation();
      event.preventDefault();

      _this.focus();
    };

    _this._renderClear = function () {
      var _this$props2 = _this.props,
          clearable = _this$props2.clearable,
          clearValueText = _this$props2.clearValueText,
          readOnly = _this$props2.readOnly;

      if (!clearable || readOnly) {
        return null;
      }

      return /*#__PURE__*/(0, _jsxRuntime.jsx)(_StyledComponents.ClearZone, {
        "aria-label": clearValueText,
        onClick: _this._onClearButtonClick,
        title: clearValueText,
        children: /*#__PURE__*/(0, _jsxRuntime.jsx)(_StyledComponents.Clear, {
          children: "\xD7"
        })
      });
    };

    _this._renderDropdownIcon = function () {
      var _this$props3 = _this.props,
          readOnly = _this$props3.readOnly,
          renderDropdownIcon = _this$props3.renderDropdownIcon;
      return /*#__PURE__*/(0, _jsxRuntime.jsx)(_StyledComponents.ArrowZone, {
        onClick: _this._onDropdownIconClick,
        $isDisabled: readOnly,
        children: renderDropdownIcon ? renderDropdownIcon(_this.state) : /*#__PURE__*/(0, _jsxRuntime.jsx)(_StyledComponents.Arrow, {
          $isOpen: _this.state.isOpen
        })
      });
    };

    _this._renderInput = function () {
      return /*#__PURE__*/(0, _jsxRuntime.jsx)(_StyledComponents.FakeInput, {
        ref: function ref(_ref) {
          _this._input = _ref;
        },
        onBlur: _this._onInputBlur,
        onFocus: _this._onInputFocus,
        tabIndex: 0
      });
    };

    _this._renderPopover = function () {
      var _this$props4 = _this.props,
          modal = _this$props4.modal,
          renderPopover = _this$props4.renderPopover;
      return modal ? /*#__PURE__*/(0, _jsxRuntime.jsx)(_Popover.Popover, {
        anchorEl: _this._containerRef.current,
        onContentMouseDown: _this._onPopoverMouseDown,
        onRequestClose: _this._closePopover,
        visible: _this.state.isOpen,
        children: renderPopover && renderPopover()
      }) : /*#__PURE__*/(0, _jsxRuntime.jsx)(_StyledComponents.PopoverContainer, {
        onMouseDown: _this._onPopoverMouseDown,
        children: renderPopover && renderPopover()
      });
    };

    _this._renderValue = function () {
      var renderValue = _this.props.renderValue;
      return /*#__PURE__*/(0, _jsxRuntime.jsx)(_StyledComponents.ValueContainer, {
        children: renderValue && renderValue(_this.state)
      });
    };

    return _this;
  }

  _createClass(PickerWeb, [{
    key: "blur",
    value: function blur() {
      this._input && this._input.blur();
    }
  }, {
    key: "focus",
    value: function focus() {
      this._input && this._input.focus();
    }
  }, {
    key: "componentDidMount",
    value: function componentDidMount() {
      if (this.props.autoFocus) {
        this.focus();
      }
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props5 = this.props,
          accessibilityLabel = _this$props5.accessibilityLabel,
          className = _this$props5.className,
          style = _this$props5.style,
          testID = _this$props5.testID;
      var styleProps = {
        className: className,
        style: style
      };
      return /*#__PURE__*/(0, _jsxRuntime.jsxs)(_StyledComponents.Container, _objectSpread(_objectSpread({}, styleProps), {}, {
        ref: this._containerRef,
        accessibilityLabel: accessibilityLabel,
        testID: testID,
        children: [/*#__PURE__*/(0, _jsxRuntime.jsxs)(_StyledComponents.Control, {
          onClick: this._onControlClick,
          onMouseDown: this._onControlMouseDown,
          children: [this._renderInput(), this._renderValue(), this._renderClear(), this._renderDropdownIcon()]
        }), !!this.state.isOpen && this._renderPopover()]
      }));
    }
  }]);

  return PickerWeb;
}(React.Component);

PickerWeb.defaultProps = {
  clearable: true,
  clearValueText: 'Clear value',
  readOnly: false
};
PickerWeb.displayName = 'PickerWeb';
var _default = PickerWeb;
exports["default"] = _default;