"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireDefault(require("react"));

var _styledComponents = _interopRequireDefault(require("styled-components"));

var _FontContext = _interopRequireDefault(require("../../primitives/Font/FontContext"));

var _jsxRuntime = require("react/jsx-runtime");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function InputBase(_ref) {
  var accessibilityLabel = _ref.accessibilityLabel,
      nativeRef = _ref.nativeRef,
      testID = _ref.testID,
      props = _objectWithoutProperties(_ref, ["accessibilityLabel", "nativeRef", "testID"]);

  return /*#__PURE__*/(0, _jsxRuntime.jsx)(_FontContext["default"].Consumer, {
    children: function children(_ref2) {
      var fontFamily = _ref2.fontFamily,
          fontSize = _ref2.fontSize;
      return /*#__PURE__*/(0, _jsxRuntime.jsx)(StyledInput, _objectSpread(_objectSpread({}, props), {}, {
        "aria-label": accessibilityLabel,
        "data-testid": testID,
        ref: nativeRef,
        $fontFamilyValue: fontFamily,
        $fontSizeValue: fontSize
      }));
    }
  });
}

var _default = /*#__PURE__*/_react["default"].forwardRef(function (props, ref) {
  return /*#__PURE__*/(0, _jsxRuntime.jsx)(InputBase, _objectSpread(_objectSpread({}, props), {}, {
    nativeRef: ref
  }));
});

exports["default"] = _default;

var StyledInput = _styledComponents["default"].input.withConfig({
  displayName: "InputBase__StyledInput",
  componentId: "ciondq-0"
})(["appearance:none;background-color:transparent;border-color:black;border-radius:0;border-width:0;box-sizing:border-box;font-family:", ";font-size:", "px;padding:0;outline:none;resize:none;"], function (props) {
  return props.$fontFamilyValue;
}, function (props) {
  return props.$fontSizeValue;
});