"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.createTouchableViewBase = createTouchableViewBase;
exports.DivTouchableViewBase = void 0;

var _tooltip = _interopRequireDefault(require("@reach/tooltip"));

var React = _interopRequireWildcard(require("react"));

var _styledComponents = _interopRequireWildcard(require("styled-components"));

var _styles = require("./styles");

var _ViewBase = require("./ViewBase");

var _jsxRuntime = require("react/jsx-runtime");

var _templateObject;

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _taggedTemplateLiteral(strings, raw) { if (!raw) { raw = strings.slice(0); } return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }

var GlobalStyle = (0, _styledComponents.createGlobalStyle)(_templateObject || (_templateObject = _taggedTemplateLiteral(["\n:root {\n  --reach-tooltip: 1;\n}\n\n[data-reach-tooltip] {\n  z-index: 1;\n  pointer-events: none;\n  position: absolute;\n  padding: 0.5em 1em;\n  box-shadow: 2px 2px 10px hsla(0, 0%, 0%, 0.1);\n  white-space: nowrap;\n  font-size: 85%;\n  background: hsla(0, 0%, 0%, 0.75);\n  color: white;\n  border: none;\n  borderRadius: 4px;\n}\n"])));

function createTouchableViewBase(component) {
  var ViewBase = (0, _ViewBase.createViewBase)(component);
  var StyledViewBase = (0, _styledComponents["default"])(ViewBase).withConfig({
    displayName: "TouchableViewBase__StyledViewBase",
    componentId: "cz83lq-0"
  })(["", ";"], _styles.buttonDefaultStyle);
  var StyledViewBaseWithForwardRef = /*#__PURE__*/React.forwardRef(function (props, ref) {
    return /*#__PURE__*/(0, _jsxRuntime.jsx)(StyledViewBase, _objectSpread(_objectSpread({}, props), {}, {
      ref: ref
    }));
  }); // $FlowFixMe: forwardRef not supported yet

  return /*#__PURE__*/React.forwardRef(function (props, ref) {
    return /*#__PURE__*/(0, _jsxRuntime.jsxs)(_jsxRuntime.Fragment, {
      children: [props.tooltip ? /*#__PURE__*/(0, _jsxRuntime.jsx)(_tooltip["default"], {
        label: props.tooltip,
        children: /*#__PURE__*/(0, _jsxRuntime.jsx)(StyledViewBaseWithForwardRef, _objectSpread(_objectSpread({}, props), {}, {
          ref: ref
        }))
      }) : /*#__PURE__*/(0, _jsxRuntime.jsx)(StyledViewBase, _objectSpread(_objectSpread({}, props), {}, {
        ref: ref
      })), /*#__PURE__*/(0, _jsxRuntime.jsx)(GlobalStyle, {})]
    });
  });
}

var DivTouchableViewBase = createTouchableViewBase('div');
exports.DivTouchableViewBase = DivTouchableViewBase;