"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.createViewBase = createViewBase;
exports.DivViewBase = void 0;

var _react = _interopRequireWildcard(require("react"));

var _useElementLayout = _interopRequireDefault(require("react-native-web/dist/cjs/modules/useElementLayout"));

var _useMergeRefs = _interopRequireDefault(require("react-native-web/dist/cjs/modules/useMergeRefs"));

var _useResponderEvents = _interopRequireDefault(require("react-native-web/dist/cjs/modules/useResponderEvents"));

var _styledComponents = _interopRequireDefault(require("styled-components"));

var _styles = require("./styles");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function createViewBase(component) {
  var ViewBase = /*#__PURE__*/_react["default"].forwardRef(function ViewBase(_ref, forwardedRef) {
    var accessibilityLabel = _ref.accessibilityLabel,
        children = _ref.children,
        onLayout = _ref.onLayout,
        onMoveShouldSetResponder = _ref.onMoveShouldSetResponder,
        onMoveShouldSetResponderCapture = _ref.onMoveShouldSetResponderCapture,
        onResponderEnd = _ref.onResponderEnd,
        onResponderGrant = _ref.onResponderGrant,
        onResponderMove = _ref.onResponderMove,
        onResponderReject = _ref.onResponderReject,
        onResponderRelease = _ref.onResponderRelease,
        onResponderStart = _ref.onResponderStart,
        onResponderTerminate = _ref.onResponderTerminate,
        onResponderTerminationRequest = _ref.onResponderTerminationRequest,
        onScrollShouldSetResponder = _ref.onScrollShouldSetResponder,
        onScrollShouldSetResponderCapture = _ref.onScrollShouldSetResponderCapture,
        onSelectionChangeShouldSetResponder = _ref.onSelectionChangeShouldSetResponder,
        onSelectionChangeShouldSetResponderCapture = _ref.onSelectionChangeShouldSetResponderCapture,
        onStartShouldSetResponder = _ref.onStartShouldSetResponder,
        onStartShouldSetResponderCapture = _ref.onStartShouldSetResponderCapture,
        testID = _ref.testID,
        rest = _objectWithoutProperties(_ref, ["accessibilityLabel", "children", "onLayout", "onMoveShouldSetResponder", "onMoveShouldSetResponderCapture", "onResponderEnd", "onResponderGrant", "onResponderMove", "onResponderReject", "onResponderRelease", "onResponderStart", "onResponderTerminate", "onResponderTerminationRequest", "onScrollShouldSetResponder", "onScrollShouldSetResponderCapture", "onSelectionChangeShouldSetResponder", "onSelectionChangeShouldSetResponderCapture", "onStartShouldSetResponder", "onStartShouldSetResponderCapture", "testID"]);

    var hostRef = (0, _react.useRef)(null);
    (0, _useElementLayout["default"])(hostRef, onLayout);
    (0, _useResponderEvents["default"])(hostRef, {
      onMoveShouldSetResponder: onMoveShouldSetResponder,
      onMoveShouldSetResponderCapture: onMoveShouldSetResponderCapture,
      onResponderEnd: onResponderEnd,
      onResponderGrant: onResponderGrant,
      onResponderMove: onResponderMove,
      onResponderReject: onResponderReject,
      onResponderRelease: onResponderRelease,
      onResponderStart: onResponderStart,
      onResponderTerminate: onResponderTerminate,
      onResponderTerminationRequest: onResponderTerminationRequest,
      onScrollShouldSetResponder: onScrollShouldSetResponder,
      onScrollShouldSetResponderCapture: onScrollShouldSetResponderCapture,
      onSelectionChangeShouldSetResponder: onSelectionChangeShouldSetResponder,
      onSelectionChangeShouldSetResponderCapture: onSelectionChangeShouldSetResponderCapture,
      onStartShouldSetResponder: onStartShouldSetResponder,
      onStartShouldSetResponderCapture: onStartShouldSetResponderCapture
    });
    var setRef = (0, _useMergeRefs["default"])(hostRef, forwardedRef);

    var supportedProps = _objectSpread(_objectSpread({}, rest), {}, {
      'aria-label': accessibilityLabel,
      'data-testid': testID,
      ref: setRef
    });

    return /*#__PURE__*/_react["default"].createElement(component, supportedProps, children);
  });

  var StyledViewBase = (0, _styledComponents["default"])(ViewBase).withConfig({
    displayName: "ViewBase__StyledViewBase",
    componentId: "sc-66ckm-0"
  })(["", ";"], _styles.flex);
  return StyledViewBase;
}

var DivViewBase = createViewBase('div');
exports.DivViewBase = DivViewBase;