"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.unregister = exports.register = void 0;

var _debounce = _interopRequireDefault(require("lodash/debounce"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

var registry = new Map();

var triggerAll = function triggerAll() {
  registry.forEach(function (instance) {
    instance._onLayout();
  });
};

window.addEventListener('resize', (0, _debounce["default"])(triggerAll, 16), false);

var register = function register(id, instance) {
  registry.set(id, instance);
};

exports.register = register;

var unregister = function unregister(id) {
  registry["delete"](id);
};

exports.unregister = unregister;