"use strict";

require("jest-styled-components");

require("react-testing-library/cleanup-after-each");

var _react = _interopRequireDefault(require("react"));

var _reactTestingLibrary = require("react-testing-library");

var _Style = require("../../../apis/Style");

var _Text = _interopRequireDefault(require("../../Text"));

var _ = _interopRequireDefault(require(".."));

var _jsxRuntime = require("react/jsx-runtime");

var _templateObject;

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _taggedTemplateLiteral(strings, raw) { if (!raw) { raw = strings.slice(0); } return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }

test('texts without a parent Font should use default font', function () {
  var _render = (0, _reactTestingLibrary.render)( /*#__PURE__*/(0, _jsxRuntime.jsx)(_Text["default"], {
    testID: "test",
    children: "hello"
  })),
      getByTestId = _render.getByTestId;

  expect(getByTestId('test')).toMatchInlineSnapshot("\n    .c0 {\n      box-sizing: border-box;\n      color: #191E26;\n      display: inline;\n      -webkit-box-flex: 0;\n      -webkit-flex-grow: 0;\n      -ms-flex-positive: 0;\n      flex-grow: 0;\n      -webkit-flex-shrink: 0;\n      -ms-flex-negative: 0;\n      flex-shrink: 0;\n      font-family: \"Helvetica Neue\",Helvetica,Arial,sans-serif;\n      font-size: 14px;\n      position: relative;\n      white-space: pre-wrap;\n      word-wrap: break-word;\n      -ms-hyphens: auto;\n      cursor: inherit;\n    }\n\n    <div\n      class=\"c0\"\n      data-testid=\"test\"\n      data-text-as-pseudo-element=\"hello\"\n    />\n  ");
});
test('texts rendered inside Font should inherit font', function () {
  var _render2 = (0, _reactTestingLibrary.render)( /*#__PURE__*/(0, _jsxRuntime.jsx)(_["default"], {
    fontFamily: "Times",
    fontSize: 10,
    children: /*#__PURE__*/(0, _jsxRuntime.jsx)(_Text["default"], {
      testID: "test",
      children: "hello"
    })
  })),
      getByTestId = _render2.getByTestId;

  expect(getByTestId('test')).toMatchInlineSnapshot("\n    .c0 {\n      box-sizing: border-box;\n      color: #191E26;\n      display: inline;\n      -webkit-box-flex: 0;\n      -webkit-flex-grow: 0;\n      -ms-flex-positive: 0;\n      flex-grow: 0;\n      -webkit-flex-shrink: 0;\n      -ms-flex-negative: 0;\n      flex-shrink: 0;\n      font-family: Times;\n      font-size: 10px;\n      position: relative;\n      white-space: pre-wrap;\n      word-wrap: break-word;\n      -ms-hyphens: auto;\n      cursor: inherit;\n    }\n\n    <div\n      class=\"c0\"\n      data-testid=\"test\"\n      data-text-as-pseudo-element=\"hello\"\n    />\n  ");
});
test('texts can override inherited font', function () {
  var StyledText = (0, _Style.styled)(_Text["default"])(_templateObject || (_templateObject = _taggedTemplateLiteral(["\n    font-size: 20px;\n  "])));

  var _render3 = (0, _reactTestingLibrary.render)( /*#__PURE__*/(0, _jsxRuntime.jsx)(_["default"], {
    fontFamily: "Times",
    fontSize: 10,
    children: /*#__PURE__*/(0, _jsxRuntime.jsx)(StyledText, {
      testID: "test",
      children: "hello"
    })
  })),
      getByTestId = _render3.getByTestId;

  expect(getByTestId('test')).toMatchInlineSnapshot("\n.c0 {\n  box-sizing: border-box;\n  color: #191E26;\n  display: inline;\n  -webkit-box-flex: 0;\n  -webkit-flex-grow: 0;\n  -ms-flex-positive: 0;\n  flex-grow: 0;\n  -webkit-flex-shrink: 0;\n  -ms-flex-negative: 0;\n  flex-shrink: 0;\n  font-family: Times;\n  font-size: 10px;\n  position: relative;\n  white-space: pre-wrap;\n  word-wrap: break-word;\n  -ms-hyphens: auto;\n  cursor: inherit;\n}\n\n.c1 {\n  font-size: 20px;\n}\n\n<div\n  class=\"c0 c1\"\n  data-testid=\"test\"\n  data-text-as-pseudo-element=\"hello\"\n/>\n");
});