"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireDefault(require("react"));

var _FlexForm = _interopRequireDefault(require("../../../internals/web/FlexForm"));

var _Field = require("../Field");

var _FormState = require("../FormState");

var _SubmitButton = _interopRequireDefault(require("../SubmitButton"));

var _jsxRuntime = require("react/jsx-runtime");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (typeof call === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

var Form = /*#__PURE__*/function (_React$Component) {
  _inherits(Form, _React$Component);

  var _super = _createSuper(Form);

  function Form() {
    _classCallCheck(this, Form);

    return _super.apply(this, arguments);
  }

  _createClass(Form, [{
    key: "render",
    value: function render() {
      var _this$props = this.props,
          _children = _this$props.children,
          className = _this$props.className,
          initialValues = _this$props.initialValues,
          onSubmit = _this$props.onSubmit,
          style = _this$props.style,
          testID = _this$props.testID;
      return /*#__PURE__*/(0, _jsxRuntime.jsx)(_FormState.FormState, {
        initialValues: initialValues,
        children: function children(formState) {
          var fieldErrors = formState.fieldErrors,
              values = formState.values,
              actions = formState.actions;

          var handleFormSubmit = function handleFormSubmit(e) {
            e.preventDefault();
            e.stopPropagation();
            actions.touchAll();

            if (Object.keys(fieldErrors).length === 0) {
              actions.submit(function () {
                return onSubmit && onSubmit(values);
              });
            }
          };

          var formBody = typeof _children === 'function' ? _children(formState) : _children;
          return /*#__PURE__*/(0, _jsxRuntime.jsx)(_FlexForm["default"], {
            className: className,
            "data-testid": testID,
            onSubmit: handleFormSubmit,
            style: style,
            children: formBody
          });
        }
      });
    }
  }]);

  return Form;
}(_react["default"].Component);

Form.Field = _Field.Field;
Form.SubmissionError = _FormState.SubmissionError;
Form.SubmitButton = _SubmitButton["default"];
var _default = Form;
exports["default"] = _default;