"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.FormStateProvider = FormStateProvider;
exports.useFormState = useFormState;
exports.useFormStateStrict = useFormStateStrict;

var _invariant = _interopRequireDefault(require("invariant"));

var _react = _interopRequireDefault(require("react"));

var _jsxRuntime = require("react/jsx-runtime");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

var Context = /*#__PURE__*/_react["default"].createContext(undefined);

function FormStateProvider(_ref) {
  var children = _ref.children,
      value = _ref.value;
  return /*#__PURE__*/(0, _jsxRuntime.jsx)(Context.Provider, {
    value: value,
    children: children
  });
}

function useFormState() {
  return _react["default"].useContext(Context);
}

function useFormStateStrict() {
  var formState = useFormState();
  (0, _invariant["default"])(formState, "Please put the component inside a Form or ModalForm.");
  return formState;
}