"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.isEmpty = isEmpty;
exports.deepEqual = deepEqual;
exports.unwrapChildren = unwrapChildren;

var _isEqualWith2 = _interopRequireDefault(require("lodash/fp/isEqualWith"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function isEmpty(value) {
  return value == null || value === '';
}

function deepEqual(a, b) {
  return (0, _isEqualWith2["default"])(function (obj, other) {
    if (obj === other) return true;

    if (!obj && !other) {
      return isEmpty(obj) === isEmpty(other);
    }
  }, a, b);
}

function unwrapChildren(children) {
  return Array.isArray(children) ? children[0] : children;
}