"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireDefault(require("react"));

var _reactNative = require("react-native");

var _FormConfigContext = require("../Form.native/FormConfigContext");

var _FormState = require("../FormState");

var _jsxRuntime = require("react/jsx-runtime");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

var SubmitButton = function SubmitButton(_ref) {
  var children = _ref.children,
      style = _ref.style,
      testID = _ref.testID;
  var formState = (0, _FormState.useFormStateStrict)();

  var _ref2 = _react["default"].useContext(_FormConfigContext.FormConfigContext),
      onSubmit = _ref2.onSubmit;

  var fieldErrors = formState.fieldErrors,
      values = formState.values,
      actions = formState.actions;

  var handleSubmit = function handleSubmit() {
    actions.touchAll();

    if (Object.keys(fieldErrors).length === 0) {
      actions.submit(function () {
        return onSubmit && onSubmit(values);
      });
    }
  };

  return /*#__PURE__*/(0, _jsxRuntime.jsx)(_reactNative.TouchableOpacity, {
    onPress: handleSubmit,
    style: style,
    testID: testID,
    children: typeof children === 'function' ? children(formState) : children
  });
};

var _default = SubmitButton;
exports["default"] = _default;