"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _exenv = _interopRequireDefault(require("exenv"));

var React = _interopRequireWildcard(require("react"));

var _reactDom = _interopRequireDefault(require("react-dom"));

var _defaultProps = _interopRequireDefault(require("../defaultProps"));

var _CloseButton = _interopRequireDefault(require("./CloseButton"));

var _OverlayContainer = _interopRequireDefault(require("./OverlayContainer"));

var _jsxRuntime = require("react/jsx-runtime");

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (typeof call === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

var Overlay = /*#__PURE__*/function (_React$Component) {
  _inherits(Overlay, _React$Component);

  var _super = _createSuper(Overlay);

  function Overlay(props) {
    var _this;

    _classCallCheck(this, Overlay);

    _this = _super.call(this, props);
    _this._parent = document.body;

    _this._onClick = function (event) {
      if (event.target === event.currentTarget) {
        var onPress = _this.props.onPress;
        onPress && onPress();
      }
    };

    if (_exenv["default"].canUseDOM) {
      _this._el = document.createElement('div');
    }

    return _this;
  }

  _createClass(Overlay, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      if (!this._parent || !this._el) return;

      this._parent.appendChild(this._el);
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      if (!this._parent || !this._el) return;

      this._parent.removeChild(this._el);
    }
  }, {
    key: "render",
    value: function render() {
      if (!this._el) {
        return null;
      }

      var _this$props = this.props,
          children = _this$props.children,
          color = _this$props.color,
          onLayout = _this$props.onLayout,
          visible = _this$props.visible,
          _this$props$showClose = _this$props.showCloseButton,
          showCloseButton = _this$props$showClose === void 0 ? false : _this$props$showClose,
          closeButtonStyle = _this$props.closeButtonStyle,
          onClose = _this$props.onClose,
          testID = _this$props.testID;
      var portalChild = visible ? /*#__PURE__*/(0, _jsxRuntime.jsxs)(_OverlayContainer["default"], {
        onClick: this._onClick,
        onLayout: onLayout,
        testID: testID || 'overlay-container',
        $color: color,
        children: [children, showCloseButton && /*#__PURE__*/(0, _jsxRuntime.jsx)(_CloseButton["default"], {
          onPress: onClose,
          closeButtonStyle: closeButtonStyle
        })]
      }) : null;
      return /*#__PURE__*/_reactDom["default"].createPortal(portalChild, this._el);
    }
  }]);

  return Overlay;
}(React.Component);

Overlay.defaultProps = _defaultProps["default"];
var _default = Overlay;
exports["default"] = _default;