"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = Pdf;

var _react = _interopRequireDefault(require("react"));

var _FlexIframe = _interopRequireDefault(require("../../../internals/web/FlexIframe"));

var _pdfmake = require("../helpers/pdfmake");

var _useUri = require("../helpers/useUri");

var _validateSource = require("../helpers/validateSource");

var _Loading = _interopRequireDefault(require("./Loading"));

var _jsxRuntime = require("react/jsx-runtime");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

// start loading fonts as soon as this module gets imported
(0, _pdfmake.initializePdfFonts)();

function Pdf(props) {
  var accessibilityLabel = props.accessibilityLabel,
      className = props.className,
      source = props.source,
      style = props.style,
      testID = props.testID;
  (0, _validateSource.validateSource)(source);
  var uri = (0, _useUri.useUri)(source);

  if (!uri) {
    return /*#__PURE__*/(0, _jsxRuntime.jsx)(_Loading["default"], _objectSpread({}, props));
  }

  var iframeProps = {
    'aria-label': accessibilityLabel,
    'data-testid': testID,
    className: className,
    src: uri,
    style: style
  };
  return /*#__PURE__*/(0, _jsxRuntime.jsx)(_FlexIframe["default"], _objectSpread({}, iframeProps));
}

Pdf.createDataUrlFromDefinition = _pdfmake.createDataUrlFromDefinition;