"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var React = _interopRequireWildcard(require("react"));

var _ScrollViewBase = require("../../internals/web/ScrollViewBase");

var _jsxRuntime = require("react/jsx-runtime");

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var ScrollView = /*#__PURE__*/React.forwardRef(function (_ref, ref) {
  var accessibilityLabel = _ref.accessibilityLabel,
      children = _ref.children,
      className = _ref.className,
      horizontal = _ref.horizontal,
      onLayout = _ref.onLayout,
      style = _ref.style,
      contentContainerStyle = _ref.contentContainerStyle,
      testID = _ref.testID,
      onScroll = _ref.onScroll,
      onContentSizeChange = _ref.onContentSizeChange,
      _ref$scrollEventThrot = _ref.scrollEventThrottle,
      scrollEventThrottle = _ref$scrollEventThrot === void 0 ? 16 : _ref$scrollEventThrot;
  var scrollableNodeRef = React.useRef(null);
  React.useImperativeHandle(ref, function () {
    return {
      scrollTo: function scrollTo(options) {
        var x = options.x,
            y = options.y;

        if (scrollableNodeRef.current) {
          if (typeof x === 'number') {
            scrollableNodeRef.current.scrollLeft = x;
          }

          if (typeof y === 'number') {
            scrollableNodeRef.current.scrollTop = y;
          }
        }
      },
      scrollToEnd: function scrollToEnd() {
        if (scrollableNodeRef.current) {
          if (horizontal) {
            scrollableNodeRef.current.scrollLeft = scrollableNodeRef.current.scrollWidth;
          } else {
            scrollableNodeRef.current.scrollTop = scrollableNodeRef.current.scrollHeight;
          }
        }
      }
    };
  });
  var props = {
    accessibilityLabel: accessibilityLabel,
    className: className,
    horizontal: horizontal,
    onContentSizeChange: onContentSizeChange,
    onLayout: onLayout,
    onScroll: onScroll,
    scrollEventThrottle: scrollEventThrottle,
    style: style,
    contentContainerStyle: contentContainerStyle,
    testID: testID
  };
  return /*#__PURE__*/(0, _jsxRuntime.jsx)(_ScrollViewBase.ScrollViewBase, _objectSpread(_objectSpread({}, props), {}, {
    ref: scrollableNodeRef,
    children: children
  }));
});
var _default = ScrollView;
exports["default"] = _default;