"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var React = _interopRequireWildcard(require("react"));

var _reactNative = require("react-native");

var _styledComponents = _interopRequireDefault(require("styled-components"));

var _jsxRuntime = require("react/jsx-runtime");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { if (typeof Symbol === "undefined" || !(Symbol.iterator in Object(arr))) return; var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

var Switch = /*#__PURE__*/React.forwardRef(function (_ref, ref) {
  var accessibilityLabel = _ref.accessibilityLabel,
      _ref$disabled = _ref.disabled,
      disabled = _ref$disabled === void 0 ? false : _ref$disabled,
      onBlur = _ref.onBlur,
      onFocus = _ref.onFocus,
      onValueChange = _ref.onValueChange,
      style = _ref.style,
      testID = _ref.testID,
      _ref$value = _ref.value,
      value = _ref$value === void 0 ? false : _ref$value;
  var containerRef = React.useRef(null);
  React.useImperativeHandle(ref, function () {
    return {
      focus: function focus() {
        var _containerRef$current;

        return (_containerRef$current = containerRef.current) === null || _containerRef$current === void 0 ? void 0 : _containerRef$current.focus();
      },
      blur: function blur() {
        var _containerRef$current2;

        return (_containerRef$current2 = containerRef.current) === null || _containerRef$current2 === void 0 ? void 0 : _containerRef$current2.blur();
      }
    };
  });
  var toggleHandleLeft = React.useRef(new _reactNative.Animated.Value(2));

  var _React$useState = React.useState(value),
      _React$useState2 = _slicedToArray(_React$useState, 2),
      prevValue = _React$useState2[0],
      setPrevValue = _React$useState2[1];

  React.useEffect(function () {
    if (!!value !== !!prevValue) {
      _reactNative.Animated.timing(toggleHandleLeft.current, {
        toValue: value ? 26 : 2,
        duration: 200
      }).start();

      setPrevValue(value);
    }
  }, [value, prevValue]);

  var _onBlur = function _onBlur(_event) {
    onBlur === null || onBlur === void 0 ? void 0 : onBlur({
      nativeEvent: {
        value: value
      }
    });
  };

  var _onFocus = function _onFocus(_event) {
    onFocus === null || onFocus === void 0 ? void 0 : onFocus({
      nativeEvent: {
        value: value
      }
    });
  };

  var _onKeyPress = function _onKeyPress(event) {
    var ENTER = 13;
    var SPACE = 32;

    if (event.which === ENTER || event.which === SPACE) {
      event.preventDefault();
      event.stopPropagation();

      _toggle();
    }
  };

  var _toggle = function _toggle() {
    return !disabled && (onValueChange === null || onValueChange === void 0 ? void 0 : onValueChange(!value));
  };

  var props = {
    accessibilityLabel: accessibilityLabel,
    onPress: _toggle,
    onBlur: _onBlur,
    onFocus: _onFocus,
    onKeyPress: _onKeyPress,
    testID: testID
  };
  var styleProps = {
    style: style,
    $value: !!value
  };
  return /*#__PURE__*/(0, _jsxRuntime.jsx)(SwitchContainer, _objectSpread(_objectSpread(_objectSpread({
    ref: containerRef
  }, props), styleProps), {}, {
    children: /*#__PURE__*/(0, _jsxRuntime.jsx)(_reactNative.Animated.View, {
      style: [styles.handle, {
        left: toggleHandleLeft.current
      }]
    })
  }));
});
var _default = Switch;
exports["default"] = _default;
var SwitchContainer = (0, _styledComponents["default"])(_reactNative.TouchableOpacity).attrs(function (_props) {
  return {
    activeOpacity: 1
  };
}).withConfig({
  displayName: "Switch__SwitchContainer",
  componentId: "ugqey1-0"
})(["flex:none;flex-direction:row;background-color:", ";border-radius:12px;height:24px;width:48px;"], function (_ref2) {
  var $value = _ref2.$value;
  return $value ? '#FF7800' : '#B0ADAB';
});

var styles = _reactNative.StyleSheet.create({
  handle: {
    backgroundColor: 'white',
    borderRadius: 10,
    height: 20,
    width: 20,
    position: 'absolute',
    top: 2,
    bottom: 2
  }
});