"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = Text;

var _react = _interopRequireDefault(require("react"));

var _reactNative = _interopRequireDefault(require("react-native"));

var _Colors = _interopRequireDefault(require("../../../apis/Colors"));

var _FontContext = _interopRequireDefault(require("../../Font/FontContext"));

var _jsxRuntime = require("react/jsx-runtime");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function Text(_ref) {
  var accessibilityLabel = _ref.accessibilityLabel,
      children = _ref.children,
      numberOfLines = _ref.numberOfLines,
      selectable = _ref.selectable,
      style = _ref.style,
      testID = _ref.testID;

  var _React$useContext = _react["default"].useContext(_FontContext["default"]),
      fontFamily = _React$useContext.fontFamily,
      fontSize = _React$useContext.fontSize;

  var props = {
    accessibilityLabel: accessibilityLabel,
    numberOfLines: numberOfLines,
    selectable: selectable,
    testID: testID
  };
  return /*#__PURE__*/(0, _jsxRuntime.jsx)(_reactNative["default"].Text, _objectSpread(_objectSpread({}, props), {}, {
    style: [styles["default"], {
      fontFamily: fontFamily,
      fontSize: fontSize
    }, style],
    children: children
  }));
}

var styles = _reactNative["default"].StyleSheet.create({
  "default": {
    color: _Colors["default"].BLACK
  }
});