"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireDefault(require("react"));

var _reactNative = _interopRequireDefault(require("react-native"));

var _styledComponents = _interopRequireDefault(require("styled-components"));

var _FontContext = _interopRequireDefault(require("../Font/FontContext"));

var _jsxRuntime = require("react/jsx-runtime");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (typeof call === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

var TextInput = /*#__PURE__*/function (_React$Component) {
  _inherits(TextInput, _React$Component);

  var _super = _createSuper(TextInput);

  function TextInput() {
    var _this;

    _classCallCheck(this, TextInput);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _super.call.apply(_super, [this].concat(args));

    _this.blur = function () {
      _this._input && _this._input.blur();
    };

    _this.clear = function () {
      _this._input && _this._input.clear();
    };

    _this.focus = function () {
      _this._input && _this._input.focus();
    };

    _this._input = null;

    _this._captureInputRef = function (ref) {
      _this._input = ref;
    };

    _this._createBlurEventHandler = function () {
      var onBlur = _this.props.onBlur;

      if (onBlur) {
        return function (event) {
          event.nativeEvent = {
            text: event.nativeEvent.text
          };
          onBlur(event);
        };
      }

      return onBlur || undefined;
    };

    _this._createFocusEventHandler = function () {
      var onFocus = _this.props.onFocus;

      if (onFocus) {
        return function (event) {
          event.nativeEvent = {
            text: event.nativeEvent.text
          };
          onFocus(event);
        };
      }

      return onFocus || undefined;
    };

    return _this;
  }

  _createClass(TextInput, [{
    key: "render",
    value: function render() {
      var _this$props = this.props,
          accessibilityLabel = _this$props.accessibilityLabel,
          autoFocus = _this$props.autoFocus,
          defaultValue = _this$props.defaultValue,
          maxLength = _this$props.maxLength,
          multiline = _this$props.multiline,
          onValueChange = _this$props.onValueChange,
          placeholder = _this$props.placeholder,
          readOnly = _this$props.readOnly,
          style = _this$props.style,
          testID = _this$props.testID,
          type = _this$props.type,
          value = _this$props.value;
      var props = {
        accessibilityLabel: accessibilityLabel,
        autoFocus: autoFocus,
        defaultValue: defaultValue,
        editable: !readOnly,
        ref: this._captureInputRef,
        maxLength: maxLength,
        multiline: multiline,
        onChangeText: onValueChange || undefined,
        onEndEditing: this._createBlurEventHandler(),
        onFocus: this._createFocusEventHandler(),
        placeholder: placeholder,
        style: style,
        testID: testID,
        value: value || '',
        underlineColorAndroid: 'rgba(0, 0, 0, 0)'
      }; // type specific props

      switch (type) {
        case 'email':
          Object.assign(props, {
            autoCapitalize: 'none',
            autoCorrect: false,
            keyboardType: 'email-address'
          });
          break;

        case 'number':
          Object.assign(props, {
            keyboardType: 'numeric'
          });
          break;

        case 'password':
          Object.assign(props, {
            autoCapitalize: 'none',
            autoCorrect: false,
            secureTextEntry: true
          });
          break;

        case 'tel':
          Object.assign(props, {
            keyboardType: 'phone-pad'
          });
          break;

        default:
          break;
      }

      return /*#__PURE__*/(0, _jsxRuntime.jsx)(_FontContext["default"].Consumer, {
        children: function children(_ref) {
          var fontFamily = _ref.fontFamily,
              fontSize = _ref.fontSize;
          return /*#__PURE__*/(0, _jsxRuntime.jsx)(StyledTextInput, _objectSpread(_objectSpread({}, props), {}, {
            $fontFamily: fontFamily,
            $fontSize: fontSize
          }));
        }
      });
    }
  }]);

  return TextInput;
}(_react["default"].Component);

TextInput.defaultProps = {
  autoFocus: false,
  multiline: false,
  placeholder: '',
  readOnly: false,
  type: 'text'
};
TextInput.displayName = 'TextInput';
var _default = TextInput;
exports["default"] = _default;
var StyledTextInput = (0, _styledComponents["default"])(_reactNative["default"].TextInput).withConfig({
  displayName: "TextInputnative__StyledTextInput",
  componentId: "sc-1ycerpo-0"
})(["font-family:", ";font-size:", "px;height:", "px;margin:0;padding:", ";"], function (props) {
  return props.$fontFamily;
}, function (props) {
  return props.$fontSize;
}, function (_ref2) {
  var multiline = _ref2.multiline;
  return multiline ? '36' : '18';
}, function (_ref3) {
  var multiline = _ref3.multiline;
  return multiline ? '8px 0px' : '0';
});