"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _invariant = _interopRequireDefault(require("fbjs/lib/invariant"));

var _react = _interopRequireDefault(require("react"));

var _styledComponents = _interopRequireDefault(require("styled-components"));

var _InputBase = _interopRequireDefault(require("../../internals/web/InputBase"));

var _TextAreaBase = _interopRequireDefault(require("../../internals/web/TextAreaBase"));

var _FontContext = _interopRequireDefault(require("../Font/FontContext"));

var _jsxRuntime = require("react/jsx-runtime");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (typeof call === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

var TextInput = /*#__PURE__*/function (_React$Component) {
  _inherits(TextInput, _React$Component);

  var _super = _createSuper(TextInput);

  function TextInput(props) {
    var _this;

    _classCallCheck(this, TextInput);

    _this = _super.call(this, props);
    _this._input = null;

    _this._captureInputRef = function (ref) {
      _this._input = ref;
    };

    _this._createBlurEventHandler = function () {
      var onBlur = _this.props.onBlur;

      if (onBlur) {
        return function (event) {
          onBlur({
            nativeEvent: {
              text: event.currentTarget.value
            }
          });
        };
      }

      return onBlur;
    };

    _this._createChangeEventHandler = function () {
      var onValueChange = _this.props.onValueChange;

      if (onValueChange) {
        return function (event) {
          onValueChange(event.currentTarget.value);
        };
      }

      return onValueChange;
    };

    _this._createFocusEventHandler = function () {
      var onFocus = _this.props.onFocus;

      if (onFocus) {
        return function (event) {
          onFocus({
            nativeEvent: {
              text: event.currentTarget.value
            }
          });
        };
      }

      return onFocus;
    };

    _this.state = {};
    return _this;
  }

  _createClass(TextInput, [{
    key: "blur",
    value: function blur() {
      this._input && this._input.blur();
    }
  }, {
    key: "clear",
    value: function clear() {
      if (this._input) {
        this._input.value = '';
      }
    }
  }, {
    key: "focus",
    value: function focus() {
      this._input && this._input.focus();
    }
  }, {
    key: "componentDidMount",
    value: function componentDidMount() {
      var _this2 = this;

      if (this.props.autoFocus) {
        setTimeout(function () {
          return _this2.focus();
        });
      }
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props = this.props,
          accessibilityLabel = _this$props.accessibilityLabel,
          className = _this$props.className,
          defaultValue = _this$props.defaultValue,
          placeholder = _this$props.placeholder,
          maxLength = _this$props.maxLength,
          multiline = _this$props.multiline,
          readOnly = _this$props.readOnly,
          style = _this$props.style,
          testID = _this$props.testID,
          type = _this$props.type,
          value = _this$props.value;
      var InputComponent = multiline ? TextArea : Input;
      var props = {
        accessibilityLabel: accessibilityLabel,
        autoComplete: 'off',
        defaultValue: defaultValue,
        dir: 'auto',
        ref: this._captureInputRef,
        maxLength: maxLength,
        onBlur: this._createBlurEventHandler(),
        onChange: this._createChangeEventHandler(),
        onFocus: this._createFocusEventHandler(),
        placeholder: placeholder,
        readOnly: readOnly,
        testID: testID,
        type: type,
        value: value || ''
      };
      return /*#__PURE__*/(0, _jsxRuntime.jsx)(_FontContext["default"].Consumer, {
        children: function children(_ref) {
          var fontFamily = _ref.fontFamily,
              fontSize = _ref.fontSize;
          var styleProps = {
            className: className,
            multiline: multiline,
            style: style,
            $fontFamily: fontFamily,
            $fontSize: fontSize
          }; //@ts-ignore

          return /*#__PURE__*/(0, _jsxRuntime.jsx)(InputComponent, _objectSpread(_objectSpread({}, props), styleProps));
        }
      });
    }
  }], [{
    key: "getDerivedStateFromProps",
    value: function getDerivedStateFromProps(nextProps) {
      TextInput._checkProps(nextProps);

      return null;
    }
  }, {
    key: "_checkProps",
    value: function _checkProps(props) {
      var multiline = props.multiline,
          type = props.type;
      (0, _invariant["default"])(!(multiline && type !== 'text'), 'Only type="text" is supported for multiline TextInput');
    }
  }]);

  return TextInput;
}(_react["default"].Component);

TextInput.defaultProps = {
  autoFocus: false,
  multiline: false,
  placeholder: '',
  readOnly: false,
  type: 'text'
};
TextInput.displayName = 'TextInput';
var _default = TextInput;
exports["default"] = _default;
var Input = (0, _styledComponents["default"])(_InputBase["default"]).withConfig({
  displayName: "TextInputweb__Input",
  componentId: "sc-7svxlh-0"
})(["font-family:", ";font-size:", "px;"], function (props) {
  return props.$fontFamily;
}, function (props) {
  return props.$fontSize;
});
var TextArea = (0, _styledComponents["default"])(_TextAreaBase["default"]).attrs({
  rows: 5
}).withConfig({
  displayName: "TextInputweb__TextArea",
  componentId: "sc-7svxlh-1"
})(["font-family:", ";font-size:", "px;height:18px;padding:8px 0px;"], function (props) {
  return props.$fontFamily;
}, function (props) {
  return props.$fontSize;
});