"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = View;

var React = _interopRequireWildcard(require("react"));

var _styledComponents = _interopRequireDefault(require("styled-components"));

var _ViewBase = require("../../../internals/web/ViewBase");

var _jsxRuntime = require("react/jsx-runtime");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function View(_ref) {
  var accessibilityLabel = _ref.accessibilityLabel,
      children = _ref.children,
      className = _ref.className,
      onLayout = _ref.onLayout,
      pointerEvents = _ref.pointerEvents,
      style = _ref.style,
      testID = _ref.testID;
  var styleProps = {
    className: className,
    $pointerEvents: pointerEvents,
    style: style
  };
  return /*#__PURE__*/(0, _jsxRuntime.jsx)(StyledViewBase, _objectSpread(_objectSpread({}, styleProps), {}, {
    accessibilityLabel: accessibilityLabel,
    onLayout: onLayout,
    testID: testID,
    children: children
  }));
}

var pointerEventsAuto = "\n  pointer-events: auto;\n";
var pointerEventsBoxNone = "\n  pointer-events: none;\n  * {\n    pointer-events: all;\n  }\n";
var pointerEventsBoxOnly = "\n  pointer-events: all;\n  * {\n    pointer-events: none;\n  }\n";
var pointerEventsNone = "\n  pointer-events: none;\n  * {\n    pointer-events: none;\n  }\n";
var StyledViewBase = (0, _styledComponents["default"])(_ViewBase.DivViewBase).withConfig({
  displayName: "Viewweb__StyledViewBase",
  componentId: "sc-1fltyrz-0"
})(["", ";"], function (_ref2) {
  var $pointerEvents = _ref2.$pointerEvents;

  if ($pointerEvents === 'auto') {
    return pointerEventsAuto;
  } else if ($pointerEvents === 'none') {
    return pointerEventsNone;
  } else if ($pointerEvents === 'box-none') {
    return pointerEventsBoxNone;
  } else if ($pointerEvents === 'box-only') {
    return pointerEventsBoxOnly;
  }

  return '';
});