"use strict";

require("jest-styled-components");

require("react-testing-library/cleanup-after-each");

var _userEvent = _interopRequireDefault(require("@testing-library/user-event"));

var _react = _interopRequireDefault(require("react"));

var _reactTestingLibrary = require("react-testing-library");

var _ = _interopRequireDefault(require(".."));

var _jsxRuntime = require("react/jsx-runtime");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

test('should render a color picker with the default colors and #BBB as the current color.', function () {
  var _render = (0, _reactTestingLibrary.render)( /*#__PURE__*/(0, _jsxRuntime.jsx)(_["default"], {
    testID: "test",
    hex: "#BBB"
  })),
      getByTestId = _render.getByTestId,
      debug = _render.debug; //Simulate mouse click to expand the color picker


  _userEvent["default"].click(getByTestId('test').querySelector('div'));

  expect(getByTestId('overlay-container')).toMatchInlineSnapshot("\n    .c44 {\n      -webkit-appearance: none;\n      -moz-appearance: none;\n      appearance: none;\n      background-color: transparent;\n      border-color: black;\n      border-radius: 0;\n      border-width: 0;\n      box-sizing: border-box;\n      font-family: \"Helvetica Neue\",Helvetica,Arial,sans-serif;\n      font-size: 14px;\n      padding: 0;\n      outline: none;\n      resize: none;\n    }\n\n    .c45 {\n      font-family: \"Helvetica Neue\",Helvetica,Arial,sans-serif;\n      font-size: 14px;\n    }\n\n    .c0 {\n      -webkit-align-items: stretch;\n      -webkit-box-align: stretch;\n      -ms-flex-align: stretch;\n      align-items: stretch;\n      border-color: #191E26;\n      border-style: solid;\n      border-width: 0;\n      box-sizing: border-box;\n      display: -webkit-box;\n      display: -webkit-flex;\n      display: -ms-flexbox;\n      display: flex;\n      -webkit-flex-direction: column;\n      -ms-flex-direction: column;\n      flex-direction: column;\n      -webkit-box-flex: 0;\n      -webkit-flex-grow: 0;\n      -ms-flex-positive: 0;\n      flex-grow: 0;\n      -webkit-flex-shrink: 0;\n      -ms-flex-negative: 0;\n      flex-shrink: 0;\n      position: relative;\n      min-height: 0;\n      min-width: 0;\n    }\n\n    .c6 {\n      background-color: #4D4D4D;\n      outline: none;\n      width: 15px;\n      height: 15px;\n      float: right;\n      marginright: 4px;\n      marginbottom: 4px;\n      position: relative;\n      cursor: pointer;\n    }\n\n    .c7 {\n      background-color: #999999;\n      outline: none;\n      width: 15px;\n      height: 15px;\n      float: right;\n      marginright: 4px;\n      marginbottom: 4px;\n      position: relative;\n      cursor: pointer;\n    }\n\n    .c8 {\n      background-color: #FFFFFF;\n      outline: none;\n      width: 15px;\n      height: 15px;\n      float: right;\n      marginright: 4px;\n      marginbottom: 4px;\n      position: relative;\n      cursor: pointer;\n    }\n\n    .c9 {\n      background-color: #F44E3B;\n      outline: none;\n      width: 15px;\n      height: 15px;\n      float: right;\n      marginright: 4px;\n      marginbottom: 4px;\n      position: relative;\n      cursor: pointer;\n    }\n\n    .c10 {\n      background-color: #FE9200;\n      outline: none;\n      width: 15px;\n      height: 15px;\n      float: right;\n      marginright: 4px;\n      marginbottom: 4px;\n      position: relative;\n      cursor: pointer;\n    }\n\n    .c11 {\n      background-color: #FCDC00;\n      outline: none;\n      width: 15px;\n      height: 15px;\n      float: right;\n      marginright: 4px;\n      marginbottom: 4px;\n      position: relative;\n      cursor: pointer;\n    }\n\n    .c12 {\n      background-color: #DBDF00;\n      outline: none;\n      width: 15px;\n      height: 15px;\n      float: right;\n      marginright: 4px;\n      marginbottom: 4px;\n      position: relative;\n      cursor: pointer;\n    }\n\n    .c13 {\n      background-color: #A4DD00;\n      outline: none;\n      width: 15px;\n      height: 15px;\n      float: right;\n      marginright: 4px;\n      marginbottom: 4px;\n      position: relative;\n      cursor: pointer;\n    }\n\n    .c14 {\n      background-color: #68CCCA;\n      outline: none;\n      width: 15px;\n      height: 15px;\n      float: right;\n      marginright: 4px;\n      marginbottom: 4px;\n      position: relative;\n      cursor: pointer;\n    }\n\n    .c15 {\n      background-color: #73D8FF;\n      outline: none;\n      width: 15px;\n      height: 15px;\n      float: right;\n      marginright: 4px;\n      marginbottom: 4px;\n      position: relative;\n      cursor: pointer;\n    }\n\n    .c16 {\n      background-color: #AEA1FF;\n      outline: none;\n      width: 15px;\n      height: 15px;\n      float: right;\n      marginright: 4px;\n      marginbottom: 4px;\n      position: relative;\n      cursor: pointer;\n    }\n\n    .c17 {\n      background-color: #FDA1FF;\n      outline: none;\n      width: 15px;\n      height: 15px;\n      float: right;\n      marginright: 4px;\n      marginbottom: 4px;\n      position: relative;\n      cursor: pointer;\n    }\n\n    .c18 {\n      background-color: #333333;\n      outline: none;\n      width: 15px;\n      height: 15px;\n      float: right;\n      marginright: 4px;\n      marginbottom: 4px;\n      position: relative;\n      cursor: pointer;\n    }\n\n    .c19 {\n      background-color: #808080;\n      outline: none;\n      width: 15px;\n      height: 15px;\n      float: right;\n      marginright: 4px;\n      marginbottom: 4px;\n      position: relative;\n      cursor: pointer;\n    }\n\n    .c20 {\n      background-color: #cccccc;\n      outline: none;\n      width: 15px;\n      height: 15px;\n      float: right;\n      marginright: 4px;\n      marginbottom: 4px;\n      position: relative;\n      cursor: pointer;\n    }\n\n    .c21 {\n      background-color: #D33115;\n      outline: none;\n      width: 15px;\n      height: 15px;\n      float: right;\n      marginright: 4px;\n      marginbottom: 4px;\n      position: relative;\n      cursor: pointer;\n    }\n\n    .c22 {\n      background-color: #E27300;\n      outline: none;\n      width: 15px;\n      height: 15px;\n      float: right;\n      marginright: 4px;\n      marginbottom: 4px;\n      position: relative;\n      cursor: pointer;\n    }\n\n    .c23 {\n      background-color: #FCC400;\n      outline: none;\n      width: 15px;\n      height: 15px;\n      float: right;\n      marginright: 4px;\n      marginbottom: 4px;\n      position: relative;\n      cursor: pointer;\n    }\n\n    .c24 {\n      background-color: #B0BC00;\n      outline: none;\n      width: 15px;\n      height: 15px;\n      float: right;\n      marginright: 4px;\n      marginbottom: 4px;\n      position: relative;\n      cursor: pointer;\n    }\n\n    .c25 {\n      background-color: #68BC00;\n      outline: none;\n      width: 15px;\n      height: 15px;\n      float: right;\n      marginright: 4px;\n      marginbottom: 4px;\n      position: relative;\n      cursor: pointer;\n    }\n\n    .c26 {\n      background-color: #16A5A5;\n      outline: none;\n      width: 15px;\n      height: 15px;\n      float: right;\n      marginright: 4px;\n      marginbottom: 4px;\n      position: relative;\n      cursor: pointer;\n    }\n\n    .c27 {\n      background-color: #009CE0;\n      outline: none;\n      width: 15px;\n      height: 15px;\n      float: right;\n      marginright: 4px;\n      marginbottom: 4px;\n      position: relative;\n      cursor: pointer;\n    }\n\n    .c28 {\n      background-color: #7B64FF;\n      outline: none;\n      width: 15px;\n      height: 15px;\n      float: right;\n      marginright: 4px;\n      marginbottom: 4px;\n      position: relative;\n      cursor: pointer;\n    }\n\n    .c29 {\n      background-color: #FA28FF;\n      outline: none;\n      width: 15px;\n      height: 15px;\n      float: right;\n      marginright: 4px;\n      marginbottom: 4px;\n      position: relative;\n      cursor: pointer;\n    }\n\n    .c30 {\n      background-color: #000000;\n      outline: none;\n      width: 15px;\n      height: 15px;\n      float: right;\n      marginright: 4px;\n      marginbottom: 4px;\n      position: relative;\n      cursor: pointer;\n    }\n\n    .c31 {\n      background-color: #666666;\n      outline: none;\n      width: 15px;\n      height: 15px;\n      float: right;\n      marginright: 4px;\n      marginbottom: 4px;\n      position: relative;\n      cursor: pointer;\n    }\n\n    .c32 {\n      background-color: #B3B3B3;\n      outline: none;\n      width: 15px;\n      height: 15px;\n      float: right;\n      marginright: 4px;\n      marginbottom: 4px;\n      position: relative;\n      cursor: pointer;\n    }\n\n    .c33 {\n      background-color: #9F0500;\n      outline: none;\n      width: 15px;\n      height: 15px;\n      float: right;\n      marginright: 4px;\n      marginbottom: 4px;\n      position: relative;\n      cursor: pointer;\n    }\n\n    .c34 {\n      background-color: #C45100;\n      outline: none;\n      width: 15px;\n      height: 15px;\n      float: right;\n      marginright: 4px;\n      marginbottom: 4px;\n      position: relative;\n      cursor: pointer;\n    }\n\n    .c35 {\n      background-color: #FB9E00;\n      outline: none;\n      width: 15px;\n      height: 15px;\n      float: right;\n      marginright: 4px;\n      marginbottom: 4px;\n      position: relative;\n      cursor: pointer;\n    }\n\n    .c36 {\n      background-color: #808900;\n      outline: none;\n      width: 15px;\n      height: 15px;\n      float: right;\n      marginright: 4px;\n      marginbottom: 4px;\n      position: relative;\n      cursor: pointer;\n    }\n\n    .c37 {\n      background-color: #194D33;\n      outline: none;\n      width: 15px;\n      height: 15px;\n      float: right;\n      marginright: 4px;\n      marginbottom: 4px;\n      position: relative;\n      cursor: pointer;\n    }\n\n    .c38 {\n      background-color: #0C797D;\n      outline: none;\n      width: 15px;\n      height: 15px;\n      float: right;\n      marginright: 4px;\n      marginbottom: 4px;\n      position: relative;\n      cursor: pointer;\n    }\n\n    .c39 {\n      background-color: #0062B1;\n      outline: none;\n      width: 15px;\n      height: 15px;\n      float: right;\n      marginright: 4px;\n      marginbottom: 4px;\n      position: relative;\n      cursor: pointer;\n    }\n\n    .c40 {\n      background-color: #653294;\n      outline: none;\n      width: 15px;\n      height: 15px;\n      float: right;\n      marginright: 4px;\n      marginbottom: 4px;\n      position: relative;\n      cursor: pointer;\n    }\n\n    .c41 {\n      background-color: #AB149E;\n      outline: none;\n      width: 15px;\n      height: 15px;\n      float: right;\n      marginright: 4px;\n      marginbottom: 4px;\n      position: relative;\n      cursor: pointer;\n    }\n\n    .c5 {\n      width: 228px;\n      clear: both;\n    }\n\n    .c4 {\n      display: -webkit-box;\n      display: -webkit-flex;\n      display: -ms-flexbox;\n      display: flex;\n      -webkit-flex-direction: column;\n      -ms-flex-direction: column;\n      flex-direction: column;\n    }\n\n    .c42 {\n      display: -webkit-box;\n      display: -webkit-flex;\n      display: -ms-flexbox;\n      display: flex;\n      -webkit-flex-direction: row;\n      -ms-flex-direction: row;\n      flex-direction: row;\n    }\n\n    .c3 {\n      display: -webkit-box;\n      display: -webkit-flex;\n      display: -ms-flexbox;\n      display: flex;\n      -webkit-flex-direction: row;\n      -ms-flex-direction: row;\n      flex-direction: row;\n      padding: 8px 8px 4px 8px;\n    }\n\n    .c47 {\n      width: 30px;\n    }\n\n    .c46 {\n      width: 80px;\n    }\n\n    .c43 span {\n      font-size: 10px;\n      color: gray;\n    }\n\n    .c56 {\n      box-sizing: border-box;\n      color: #191E26;\n      display: inline;\n      -webkit-box-flex: 0;\n      -webkit-flex-grow: 0;\n      -ms-flex-positive: 0;\n      flex-grow: 0;\n      -webkit-flex-shrink: 0;\n      -ms-flex-negative: 0;\n      flex-shrink: 0;\n      font-family: \"Helvetica Neue\",Helvetica,Arial,sans-serif;\n      font-size: 14px;\n      position: relative;\n      white-space: pre-wrap;\n      word-wrap: break-word;\n      -ms-hyphens: auto;\n      cursor: inherit;\n    }\n\n    .c52 {\n      -webkit-align-items: stretch;\n      -webkit-box-align: stretch;\n      -ms-flex-align: stretch;\n      align-items: stretch;\n      border-color: #191E26;\n      border-style: solid;\n      border-width: 0;\n      box-sizing: border-box;\n      display: -webkit-box;\n      display: -webkit-flex;\n      display: -ms-flexbox;\n      display: flex;\n      -webkit-flex-direction: column;\n      -ms-flex-direction: column;\n      flex-direction: column;\n      -webkit-box-flex: 0;\n      -webkit-flex-grow: 0;\n      -ms-flex-positive: 0;\n      flex-grow: 0;\n      -webkit-flex-shrink: 0;\n      -ms-flex-negative: 0;\n      flex-shrink: 0;\n      position: relative;\n      min-height: 0;\n      min-width: 0;\n    }\n\n    .c53 {\n      -webkit-align-items: stretch;\n      -webkit-box-align: stretch;\n      -ms-flex-align: stretch;\n      align-items: stretch;\n      border-color: #191E26;\n      border-style: solid;\n      border-width: 0;\n      box-sizing: border-box;\n      display: -webkit-box;\n      display: -webkit-flex;\n      display: -ms-flexbox;\n      display: flex;\n      -webkit-flex-direction: column;\n      -ms-flex-direction: column;\n      flex-direction: column;\n      -webkit-box-flex: 0;\n      -webkit-flex-grow: 0;\n      -ms-flex-positive: 0;\n      flex-grow: 0;\n      -webkit-flex-shrink: 0;\n      -ms-flex-negative: 0;\n      flex-shrink: 0;\n      position: relative;\n      min-height: 0;\n      min-width: 0;\n      background-color: transparent;\n      border-color: transparent;\n      border-width: 0;\n      padding: 0;\n      text-align: left;\n      outline: none;\n      cursor: pointer;\n    }\n\n    .c53 * {\n      cursor: pointer;\n    }\n\n    .c1 {\n      position: fixed;\n      top: 0;\n      bottom: 0;\n      left: 0;\n      right: 0;\n      background-color: rgba(0,0,0,0.5);\n    }\n\n    .c2 {\n      position: absolute;\n      background-color: white;\n      border-top: 1px solid #ccc;\n      box-shadow: 0 -1px 0 rgba(0,0,0,0.06);\n      bottom: 0;\n      left: 0;\n      right: 0;\n    }\n\n    .c57 {\n      font-size: 14px;\n      color: #0070D2;\n    }\n\n    .c59 {\n      font-size: 14px;\n      color: white;\n    }\n\n    .c54 {\n      -webkit-flex-direction: row;\n      -ms-flex-direction: row;\n      flex-direction: row;\n      -webkit-align-items: center;\n      -webkit-box-align: center;\n      -ms-flex-align: center;\n      align-items: center;\n      -webkit-box-pack: center;\n      -webkit-justify-content: center;\n      -ms-flex-pack: center;\n      justify-content: center;\n      border-radius: 4px;\n      height: 32px;\n      background-color: transparent;\n      border-color: transparent;\n      border-style: solid;\n      border-width: 1px;\n      padding-left: 16px;\n      padding-right: 16px;\n    }\n\n    .c54:hover,\n    .c54:focus {\n      background-color: white;\n      border-color: #DDDBDA;\n    }\n\n    .c54:hover *,\n    .c54:focus * {\n      color: #0070D2;\n    }\n\n    .c54:active {\n      background-color: #0070D2;\n      border-color: #0031AC;\n    }\n\n    .c54:active * {\n      color: white;\n    }\n\n    .c58 {\n      -webkit-flex-direction: row;\n      -ms-flex-direction: row;\n      flex-direction: row;\n      -webkit-align-items: center;\n      -webkit-box-align: center;\n      -ms-flex-align: center;\n      align-items: center;\n      -webkit-box-pack: center;\n      -webkit-justify-content: center;\n      -ms-flex-pack: center;\n      justify-content: center;\n      border-radius: 4px;\n      height: 32px;\n      background-color: #FF7800;\n      border-color: #FF7800;\n      border-style: solid;\n      border-width: 1px;\n      padding-left: 16px;\n      padding-right: 16px;\n    }\n\n    .c58:hover,\n    .c58:focus {\n      background-color: #FF9333;\n      border-color: #FF9333;\n    }\n\n    .c58:hover *,\n    .c58:focus * {\n      color: white;\n    }\n\n    .c58:active {\n      background-color: #E36A00;\n      border-color: #E36A00;\n    }\n\n    .c58:active * {\n      color: white;\n    }\n\n    .c48 {\n      background-color: #fafafa;\n      -webkit-align-items: center;\n      -webkit-box-align: center;\n      -ms-flex-align: center;\n      align-items: center;\n      -webkit-flex-direction: row;\n      -ms-flex-direction: row;\n      flex-direction: row;\n      -webkit-box-pack: end;\n      -webkit-justify-content: flex-end;\n      -ms-flex-pack: end;\n      justify-content: flex-end;\n      padding: 4px 8px 8px 8px;\n    }\n\n    .c55 {\n      margin-left: 8px;\n    }\n\n    .c49 {\n      -webkit-box-flex: 1;\n      -webkit-flex-grow: 1;\n      -ms-flex-positive: 1;\n      flex-grow: 1;\n      height: 30px;\n    }\n\n    .c51 {\n      background-color: #BBB;\n      position: absolute;\n      top: 0px;\n      left: 0px;\n      right: 0px;\n      bottom: 0px;\n      -webkit-transition: background-color 0.2s;\n      transition: background-color 0.2s;\n      box-shadow: inset 0px 2px 1px -1px rgba(0,0,0,0.2), inset 0px 1px 1px 0px rgba(0,0,0,0.14), inset 0px 1px 3px 0px rgba(0,0,0,0.12);\n    }\n\n    .c50 {\n      background-position: 0px 0px,10px 10px;\n      background-size: 20px 20px;\n      background-image: linear-gradient( 45deg, #eee 25%, transparent 25%, transparent 75%, #eee 75%, #eee 100% ), linear-gradient(45deg,#eee 25%,white 25%,white 75%,#eee 75%,#eee 100%);\n      position: absolute;\n      top: 0px;\n      left: 0px;\n      right: 0px;\n      bottom: 0px;\n    }\n\n    <div\n      aria-modal=\"true\"\n      class=\"c0 c1\"\n      data-testid=\"overlay-container\"\n    >\n      <div\n        class=\"c0 c2\"\n      >\n        <div\n          class=\"c0 c3\"\n        >\n          <div\n            class=\"c0 c4\"\n          >\n            <div\n              class=\"c5\"\n            >\n              <div\n                class=\"c6\"\n                tabindex=\"0\"\n                title=\"#4D4D4D\"\n              />\n              <div\n                class=\"c7\"\n                tabindex=\"0\"\n                title=\"#999999\"\n              />\n              <div\n                class=\"c8\"\n                tabindex=\"0\"\n                title=\"#FFFFFF\"\n              />\n              <div\n                class=\"c9\"\n                tabindex=\"0\"\n                title=\"#F44E3B\"\n              />\n              <div\n                class=\"c10\"\n                tabindex=\"0\"\n                title=\"#FE9200\"\n              />\n              <div\n                class=\"c11\"\n                tabindex=\"0\"\n                title=\"#FCDC00\"\n              />\n              <div\n                class=\"c12\"\n                tabindex=\"0\"\n                title=\"#DBDF00\"\n              />\n              <div\n                class=\"c13\"\n                tabindex=\"0\"\n                title=\"#A4DD00\"\n              />\n              <div\n                class=\"c14\"\n                tabindex=\"0\"\n                title=\"#68CCCA\"\n              />\n              <div\n                class=\"c15\"\n                tabindex=\"0\"\n                title=\"#73D8FF\"\n              />\n              <div\n                class=\"c16\"\n                tabindex=\"0\"\n                title=\"#AEA1FF\"\n              />\n              <div\n                class=\"c17\"\n                tabindex=\"0\"\n                title=\"#FDA1FF\"\n              />\n              <div\n                class=\"c18\"\n                tabindex=\"0\"\n                title=\"#333333\"\n              />\n              <div\n                class=\"c19\"\n                tabindex=\"0\"\n                title=\"#808080\"\n              />\n              <div\n                class=\"c20\"\n                tabindex=\"0\"\n                title=\"#cccccc\"\n              />\n              <div\n                class=\"c21\"\n                tabindex=\"0\"\n                title=\"#D33115\"\n              />\n              <div\n                class=\"c22\"\n                tabindex=\"0\"\n                title=\"#E27300\"\n              />\n              <div\n                class=\"c23\"\n                tabindex=\"0\"\n                title=\"#FCC400\"\n              />\n              <div\n                class=\"c24\"\n                tabindex=\"0\"\n                title=\"#B0BC00\"\n              />\n              <div\n                class=\"c25\"\n                tabindex=\"0\"\n                title=\"#68BC00\"\n              />\n              <div\n                class=\"c26\"\n                tabindex=\"0\"\n                title=\"#16A5A5\"\n              />\n              <div\n                class=\"c27\"\n                tabindex=\"0\"\n                title=\"#009CE0\"\n              />\n              <div\n                class=\"c28\"\n                tabindex=\"0\"\n                title=\"#7B64FF\"\n              />\n              <div\n                class=\"c29\"\n                tabindex=\"0\"\n                title=\"#FA28FF\"\n              />\n              <div\n                class=\"c30\"\n                tabindex=\"0\"\n                title=\"#000000\"\n              />\n              <div\n                class=\"c31\"\n                tabindex=\"0\"\n                title=\"#666666\"\n              />\n              <div\n                class=\"c32\"\n                tabindex=\"0\"\n                title=\"#B3B3B3\"\n              />\n              <div\n                class=\"c33\"\n                tabindex=\"0\"\n                title=\"#9F0500\"\n              />\n              <div\n                class=\"c34\"\n                tabindex=\"0\"\n                title=\"#C45100\"\n              />\n              <div\n                class=\"c35\"\n                tabindex=\"0\"\n                title=\"#FB9E00\"\n              />\n              <div\n                class=\"c36\"\n                tabindex=\"0\"\n                title=\"#808900\"\n              />\n              <div\n                class=\"c37\"\n                tabindex=\"0\"\n                title=\"#194D33\"\n              />\n              <div\n                class=\"c38\"\n                tabindex=\"0\"\n                title=\"#0C797D\"\n              />\n              <div\n                class=\"c39\"\n                tabindex=\"0\"\n                title=\"#0062B1\"\n              />\n              <div\n                class=\"c40\"\n                tabindex=\"0\"\n                title=\"#653294\"\n              />\n              <div\n                class=\"c41\"\n                tabindex=\"0\"\n                title=\"#AB149E\"\n              />\n            </div>\n            <div\n              class=\"c0 c42\"\n            >\n              <span\n                class=\"c43\"\n              >\n                <span>\n                  Hex\n                </span>\n                <br />\n                <input\n                  autocomplete=\"off\"\n                  class=\"c44 c45 c46\"\n                  dir=\"auto\"\n                  maxlength=\"9\"\n                  placeholder=\"\"\n                  type=\"text\"\n                  value=\"#BBB\"\n                />\n              </span>\n              <div\n                class=\"c0 c42\"\n              >\n                <span\n                  class=\"c43\"\n                >\n                  <span>\n                    R\n                  </span>\n                  <br />\n                  <input\n                    autocomplete=\"off\"\n                    class=\"c44 c45 c47\"\n                    dir=\"auto\"\n                    maxlength=\"3\"\n                    placeholder=\"\"\n                    type=\"number\"\n                    value=\"187\"\n                  />\n                </span>\n                <span\n                  class=\"c43\"\n                >\n                  <span>\n                    G\n                  </span>\n                  <br />\n                  <input\n                    autocomplete=\"off\"\n                    class=\"c44 c45 c47\"\n                    dir=\"auto\"\n                    maxlength=\"3\"\n                    placeholder=\"\"\n                    type=\"number\"\n                    value=\"187\"\n                  />\n                </span>\n                <span\n                  class=\"c43\"\n                >\n                  <span>\n                    B\n                  </span>\n                  <br />\n                  <input\n                    autocomplete=\"off\"\n                    class=\"c44 c45 c47\"\n                    dir=\"auto\"\n                    maxlength=\"3\"\n                    placeholder=\"\"\n                    type=\"number\"\n                    value=\"187\"\n                  />\n                </span>\n                <span\n                  class=\"c43\"\n                >\n                  <span>\n                    A\n                  </span>\n                  <br />\n                  <input\n                    autocomplete=\"off\"\n                    class=\"c44 c45 c47\"\n                    dir=\"auto\"\n                    maxlength=\"3\"\n                    placeholder=\"\"\n                    type=\"number\"\n                    value=\"255\"\n                  />\n                </span>\n              </div>\n            </div>\n          </div>\n        </div>\n        <div\n          class=\"c0 c48\"\n        >\n          <div\n            class=\"c0 c49\"\n          >\n            <div\n              class=\"c50\"\n            />\n            <div\n              class=\"c0 c51\"\n            />\n          </div>\n          <div\n            class=\"c52 c53 c54 c55\"\n            role=\"button\"\n            tabindex=\"0\"\n          >\n            <div\n              class=\"c56 c57\"\n              data-text-as-pseudo-element=\"Cancel\"\n            />\n          </div>\n          <div\n            class=\"c52 c53 c58 c55\"\n            role=\"button\"\n            tabindex=\"0\"\n          >\n            <div\n              class=\"c56 c59\"\n              data-text-as-pseudo-element=\"OK\"\n            />\n          </div>\n        </div>\n      </div>\n    </div>\n  "); //Simulate mouse click to select a color

  (0, _reactTestingLibrary.act)(function () {
    return _userEvent["default"].click(getByTestId('overlay-container').querySelector('[title="#E27300"]'));
  });
  expect(getByTestId('overlay-container')).toMatchInlineSnapshot("\n<div\n  aria-modal=\"true\"\n  class=\"sc-AxhUy gJrMSC OverlayContainer-sc-19659zv-0 fmjhYE\"\n  data-testid=\"overlay-container\"\n>\n  <div\n    class=\"sc-AxhUy gJrMSC sc-fzoLag gUPiQ\"\n    style=\"top: 0px; left: 0px; opacity: 1;\"\n  >\n    <div\n      class=\"sc-AxhUy gJrMSC sc-AxgMl cxJYYh sc-fzpans cYLGem\"\n    >\n      <div\n        class=\"sc-AxhUy gJrMSC sc-AxgMl cxJYYh sc-fzozJi fuiiNa\"\n      >\n        <div\n          class=\"sc-AxmLO jOiHod\"\n        >\n          <div\n            class=\"sc-Axmtr eSCgBP\"\n            tabindex=\"0\"\n            title=\"#4D4D4D\"\n          />\n          <div\n            class=\"sc-Axmtr dmIKav\"\n            tabindex=\"0\"\n            title=\"#999999\"\n          />\n          <div\n            class=\"sc-Axmtr jJlzBP\"\n            tabindex=\"0\"\n            title=\"#FFFFFF\"\n          />\n          <div\n            class=\"sc-Axmtr kqFhXd\"\n            tabindex=\"0\"\n            title=\"#F44E3B\"\n          />\n          <div\n            class=\"sc-Axmtr gdzmGD\"\n            tabindex=\"0\"\n            title=\"#FE9200\"\n          />\n          <div\n            class=\"sc-Axmtr JTQCN\"\n            tabindex=\"0\"\n            title=\"#FCDC00\"\n          />\n          <div\n            class=\"sc-Axmtr gTrlxv\"\n            tabindex=\"0\"\n            title=\"#DBDF00\"\n          />\n          <div\n            class=\"sc-Axmtr dexcqa\"\n            tabindex=\"0\"\n            title=\"#A4DD00\"\n          />\n          <div\n            class=\"sc-Axmtr hTUoPf\"\n            tabindex=\"0\"\n            title=\"#68CCCA\"\n          />\n          <div\n            class=\"sc-Axmtr irOclr\"\n            tabindex=\"0\"\n            title=\"#73D8FF\"\n          />\n          <div\n            class=\"sc-Axmtr egvSDD\"\n            tabindex=\"0\"\n            title=\"#AEA1FF\"\n          />\n          <div\n            class=\"sc-Axmtr kBveLJ\"\n            tabindex=\"0\"\n            title=\"#FDA1FF\"\n          />\n          <div\n            class=\"sc-Axmtr lkItgT\"\n            tabindex=\"0\"\n            title=\"#333333\"\n          />\n          <div\n            class=\"sc-Axmtr jQcApr\"\n            tabindex=\"0\"\n            title=\"#808080\"\n          />\n          <div\n            class=\"sc-Axmtr bFgWpj\"\n            tabindex=\"0\"\n            title=\"#cccccc\"\n          />\n          <div\n            class=\"sc-Axmtr hPDkAC\"\n            tabindex=\"0\"\n            title=\"#D33115\"\n          />\n          <div\n            class=\"sc-Axmtr edrkuw\"\n            tabindex=\"0\"\n            title=\"#E27300\"\n          >\n            .c0 {\n  position: absolute;\n  background-color: #000;\n  border-radius: 50%;\n  top: 4px;\n  left: 4px;\n  bottom: 4px;\n  right: 4px;\n}\n\n<div\n              class=\"c0\"\n            />\n          </div>\n          <div\n            class=\"sc-Axmtr kPFXPd\"\n            tabindex=\"0\"\n            title=\"#FCC400\"\n          />\n          <div\n            class=\"sc-Axmtr kmrFHI\"\n            tabindex=\"0\"\n            title=\"#B0BC00\"\n          />\n          <div\n            class=\"sc-Axmtr hfeXjw\"\n            tabindex=\"0\"\n            title=\"#68BC00\"\n          />\n          <div\n            class=\"sc-Axmtr eqaLNw\"\n            tabindex=\"0\"\n            title=\"#16A5A5\"\n          />\n          <div\n            class=\"sc-Axmtr Nbgzg\"\n            tabindex=\"0\"\n            title=\"#009CE0\"\n          />\n          <div\n            class=\"sc-Axmtr dUJosA\"\n            tabindex=\"0\"\n            title=\"#7B64FF\"\n          />\n          <div\n            class=\"sc-Axmtr dcGCwa\"\n            tabindex=\"0\"\n            title=\"#FA28FF\"\n          />\n          <div\n            class=\"sc-Axmtr dMSJwn\"\n            tabindex=\"0\"\n            title=\"#000000\"\n          />\n          <div\n            class=\"sc-Axmtr cEhJaf\"\n            tabindex=\"0\"\n            title=\"#666666\"\n          />\n          <div\n            class=\"sc-Axmtr bGzsPq\"\n            tabindex=\"0\"\n            title=\"#B3B3B3\"\n          />\n          <div\n            class=\"sc-Axmtr gwuQgx\"\n            tabindex=\"0\"\n            title=\"#9F0500\"\n          />\n          <div\n            class=\"sc-Axmtr huvUDc\"\n            tabindex=\"0\"\n            title=\"#C45100\"\n          />\n          <div\n            class=\"sc-Axmtr ezupdH\"\n            tabindex=\"0\"\n            title=\"#FB9E00\"\n          />\n          <div\n            class=\"sc-Axmtr hygZZW\"\n            tabindex=\"0\"\n            title=\"#808900\"\n          />\n          <div\n            class=\"sc-Axmtr czOzHj\"\n            tabindex=\"0\"\n            title=\"#194D33\"\n          />\n          <div\n            class=\"sc-Axmtr dlyeVV\"\n            tabindex=\"0\"\n            title=\"#0C797D\"\n          />\n          <div\n            class=\"sc-Axmtr iVnelg\"\n            tabindex=\"0\"\n            title=\"#0062B1\"\n          />\n          <div\n            class=\"sc-Axmtr eQQyxo\"\n            tabindex=\"0\"\n            title=\"#653294\"\n          />\n          <div\n            class=\"sc-Axmtr leidXl\"\n            tabindex=\"0\"\n            title=\"#AB149E\"\n          />\n        </div>\n        <div\n          class=\"sc-AxhUy gJrMSC sc-AxgMl cxJYYh sc-fzoLsD jODock\"\n        >\n          <span\n            class=\"sc-fznKkj iTIdLa\"\n          >\n            <span>\n              Hex\n            </span>\n            <br />\n            <input\n              autocomplete=\"off\"\n              class=\"sc-AxjAm idPQwB sc-AxiKw lcXyJb sc-fznyAO kOnQRo\"\n              dir=\"auto\"\n              maxlength=\"9\"\n              placeholder=\"\"\n              type=\"text\"\n              value=\"#E27300\"\n            />\n          </span>\n          <div\n            class=\"sc-AxhUy gJrMSC sc-AxgMl cxJYYh sc-fzoLsD jODock\"\n          >\n            <span\n              class=\"sc-fznKkj iTIdLa\"\n            >\n              <span>\n                R\n              </span>\n              <br />\n              <input\n                autocomplete=\"off\"\n                class=\"sc-AxjAm idPQwB sc-AxiKw lcXyJb sc-fzplWN evqxXz\"\n                dir=\"auto\"\n                maxlength=\"3\"\n                placeholder=\"\"\n                type=\"number\"\n                value=\"226\"\n              />\n            </span>\n            <span\n              class=\"sc-fznKkj iTIdLa\"\n            >\n              <span>\n                G\n              </span>\n              <br />\n              <input\n                autocomplete=\"off\"\n                class=\"sc-AxjAm idPQwB sc-AxiKw lcXyJb sc-fzplWN evqxXz\"\n                dir=\"auto\"\n                maxlength=\"3\"\n                placeholder=\"\"\n                type=\"number\"\n                value=\"115\"\n              />\n            </span>\n            <span\n              class=\"sc-fznKkj iTIdLa\"\n            >\n              <span>\n                B\n              </span>\n              <br />\n              <input\n                autocomplete=\"off\"\n                class=\"sc-AxjAm idPQwB sc-AxiKw lcXyJb sc-fzplWN evqxXz\"\n                dir=\"auto\"\n                maxlength=\"3\"\n                placeholder=\"\"\n                type=\"number\"\n                value=\"0\"\n              />\n            </span>\n            <span\n              class=\"sc-fznKkj iTIdLa\"\n            >\n              <span>\n                A\n              </span>\n              <br />\n              <input\n                autocomplete=\"off\"\n                class=\"sc-AxjAm idPQwB sc-AxiKw lcXyJb sc-fzplWN evqxXz\"\n                dir=\"auto\"\n                maxlength=\"3\"\n                placeholder=\"\"\n                type=\"number\"\n                value=\"255\"\n              />\n            </span>\n          </div>\n        </div>\n      </div>\n    </div>\n    <div\n      class=\"sc-AxhUy gJrMSC sc-AxgMl cxJYYh sc-fzoNJl hZcLpw\"\n    >\n      <div\n        class=\"sc-AxhUy gJrMSC sc-AxgMl cxJYYh sc-fzpmMD iGERAG\"\n      >\n        <div\n          class=\"sc-fznMAR hNQGLJ\"\n        />\n        <div\n          class=\"sc-AxhUy gJrMSC sc-AxgMl cxJYYh sc-fznxKY kihiPR\"\n        />\n      </div>\n      <div\n        class=\"sc-fzoyAV cOWgtW TouchableViewBase__StyledViewBase-cz83lq-0 kgslKY sc-fzqNqU gEzwXe sc-fzoXWK bhIavI\"\n        role=\"button\"\n        tabindex=\"0\"\n      >\n        <div\n          class=\"sc-fzokOt fAFgnU sc-fznWqX hAeupC\"\n          data-text-as-pseudo-element=\"Cancel\"\n        />\n      </div>\n      <div\n        class=\"sc-fzoyAV cOWgtW TouchableViewBase__StyledViewBase-cz83lq-0 kgslKY sc-fzqNqU bxOHuB sc-fzoXWK bhIavI\"\n        role=\"button\"\n        tabindex=\"0\"\n      >\n        <div\n          class=\"sc-fzokOt fAFgnU sc-fznWqX bhXBvj\"\n          data-text-as-pseudo-element=\"OK\"\n        />\n      </div>\n    </div>\n  </div>\n</div>\n"); //Simulate mouse click to close the color picker

  (0, _reactTestingLibrary.act)(function () {
    return _userEvent["default"].click(getByTestId('overlay-container').querySelector('[data-text-as-pseudo-element="OK"]'));
  });
  expect(getByTestId('test')).toMatchInlineSnapshot("\n.c2 {\n  box-sizing: border-box;\n  color: #191E26;\n  display: inline;\n  -webkit-box-flex: 0;\n  -webkit-flex-grow: 0;\n  -ms-flex-positive: 0;\n  flex-grow: 0;\n  -webkit-flex-shrink: 0;\n  -ms-flex-negative: 0;\n  flex-shrink: 0;\n  font-family: \"Helvetica Neue\",Helvetica,Arial,sans-serif;\n  font-size: 14px;\n  position: relative;\n  white-space: pre-wrap;\n  word-wrap: break-word;\n  -ms-hyphens: auto;\n  cursor: inherit;\n}\n\n.c3 {\n  font-family: Material Icons;\n  font-size: 16px;\n  text-align: center;\n}\n\n.c4 {\n  -webkit-flex: none;\n  -ms-flex: none;\n  flex: none;\n  -webkit-align-items: center;\n  -webkit-box-align: center;\n  -ms-flex-align: center;\n  align-items: center;\n  color: #E27300;\n  height: 24px;\n  line-height: 24px;\n  width: 24px;\n  font-size: 16px;\n}\n\n.c0 {\n  -webkit-align-items: stretch;\n  -webkit-box-align: stretch;\n  -ms-flex-align: stretch;\n  align-items: stretch;\n  border-color: #191E26;\n  border-style: solid;\n  border-width: 0;\n  box-sizing: border-box;\n  display: -webkit-box;\n  display: -webkit-flex;\n  display: -ms-flexbox;\n  display: flex;\n  -webkit-flex-direction: column;\n  -ms-flex-direction: column;\n  flex-direction: column;\n  -webkit-box-flex: 0;\n  -webkit-flex-grow: 0;\n  -ms-flex-positive: 0;\n  flex-grow: 0;\n  -webkit-flex-shrink: 0;\n  -ms-flex-negative: 0;\n  flex-shrink: 0;\n  position: relative;\n  min-height: 0;\n  min-width: 0;\n}\n\n.c1 {\n  -webkit-align-items: stretch;\n  -webkit-box-align: stretch;\n  -ms-flex-align: stretch;\n  align-items: stretch;\n  border-color: #191E26;\n  border-style: solid;\n  border-width: 0;\n  box-sizing: border-box;\n  display: -webkit-box;\n  display: -webkit-flex;\n  display: -ms-flexbox;\n  display: flex;\n  -webkit-flex-direction: column;\n  -ms-flex-direction: column;\n  flex-direction: column;\n  -webkit-box-flex: 0;\n  -webkit-flex-grow: 0;\n  -ms-flex-positive: 0;\n  flex-grow: 0;\n  -webkit-flex-shrink: 0;\n  -ms-flex-negative: 0;\n  flex-shrink: 0;\n  position: relative;\n  min-height: 0;\n  min-width: 0;\n  background-color: transparent;\n  border-color: transparent;\n  border-width: 0;\n  padding: 0;\n  text-align: left;\n  outline: none;\n  cursor: pointer;\n}\n\n.c1 * {\n  cursor: pointer;\n}\n\n<div\n  class=\"c0 c1 \"\n  data-testid=\"test\"\n>\n  <div\n    class=\"c2 c3 c4\"\n    data-text-as-pseudo-element=\"\uE3B7\"\n  />\n</div>\n");
});